package quests._033_MakeAPairOfDressShoes;

import l2p.extensions.scripts.ScriptFile;
import l2p.gameserver.model.instances.L2NpcInstance;
import l2p.gameserver.model.quest.Quest;
import l2p.gameserver.model.quest.QuestState;
import quests._037_PleaseMakeMeFormalWear._037_PleaseMakeMeFormalWear;

public class _033_MakeAPairOfDressShoes extends Quest implements ScriptFile
{
	int LEATHER = 1882;
	int THREAD = 1868;
	int DRESS_SHOES_BOX = 7113;

	public void onLoad()
	{}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _033_MakeAPairOfDressShoes()
	{
		super(false);

		addStartNpc(30838);
		addTalkId(30838);
		addTalkId(30838);
		addTalkId(30164);
		addTalkId(31520);
	}

	@Override
	public String onEvent(String event, QuestState st, L2NpcInstance npc)
	{
		String htmltext = event;
		if(event.equals("30838-1.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
		}
		else if(event.equals("31520-1.htm"))
			st.set("cond", "2");
		else if(event.equals("30838-3.htm"))
			st.set("cond", "3");
		else if(event.equals("30838-5.htm"))
		{
			if(st.getQuestItemsCount(LEATHER) >= 200 && st.getQuestItemsCount(THREAD) >= 600 && st.getQuestItemsCount(ADENA_ID) >= 200000)
			{
				st.takeItems(LEATHER, 200);
				st.takeItems(THREAD, 600);
				st.takeItems(ADENA_ID, 200000);
				st.set("cond", "4");
			}
			else
				htmltext = "You don't have enough materials";
		}
		else if(event.equals("30164-1.htm"))
		{
			if(st.getQuestItemsCount(ADENA_ID) >= 300000)
			{
				st.takeItems(ADENA_ID, 300000);
				st.set("cond", "5");
			}
			else
				htmltext = "30164-havent.htm";
		}
		else if(event.equals("30838-7.htm"))
		{
			st.giveItems(DRESS_SHOES_BOX, 1);
			st.playSound(SOUND_FINISH);
			st.exitCurrentQuest(true);
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		if(npcId == 30838)
		{
			if(cond == 0 && st.getQuestItemsCount(DRESS_SHOES_BOX) == 0)
			{
				if(st.getPlayer().getLevel() >= 60)
				{
					QuestState fwear = st.getPlayer().getQuestState(_037_PleaseMakeMeFormalWear.class);
					if(fwear != null && fwear.getCond() == 7)
						htmltext = "30838-0.htm";
					else
						st.exitCurrentQuest(true);
				}
				else
					htmltext = "30838-00.htm";
			}
			else if(cond == 1)
				htmltext = "30838-1.htm";
			else if(cond == 2)
				htmltext = "30838-2.htm";
			else if(cond == 3 && st.getQuestItemsCount(LEATHER) >= 200 && st.getQuestItemsCount(THREAD) >= 600 && st.getQuestItemsCount(ADENA_ID) >= 200000)
				htmltext = "30838-4.htm";
			else if(cond == 3 && (st.getQuestItemsCount(LEATHER) < 200 || st.getQuestItemsCount(THREAD) < 600 || st.getQuestItemsCount(ADENA_ID) < 200000))
				htmltext = "30838-4r.htm";
			else if(cond == 4)
				htmltext = "30838-5r.htm";
			else if(cond == 5)
				htmltext = "30838-6.htm";
		}
		else if(npcId == 31520)
		{
			if(cond == 1)
				htmltext = "31520-0.htm";
			else if(cond == 2)
				htmltext = "31520-1r.htm";
		}
		else if(npcId == 30164)
			if(cond == 4)
				htmltext = "30164-0.htm";
			else if(cond == 5)
				htmltext = "30164-2.htm";
		return htmltext;
	}
}