package quests._109_InSearchOfTheNest;

import l2p.extensions.scripts.ScriptFile;
import l2p.gameserver.model.instances.L2NpcInstance;
import l2p.gameserver.model.quest.Quest;
import l2p.gameserver.model.quest.QuestState;

public class _109_InSearchOfTheNest extends Quest implements ScriptFile
{
	public CheckStatus LAST_CHECK_STATUS = CheckStatus.GRACIA_FINAL;

	//NPC
	private static final int PIERCE = 31553;
	private static final int CORPSE = 32015;
	private static final int KAHMAN = 31554;

	//QUEST ITEMS
	private static final int MEMO = 8083;
	private static final int GOLDEN_BADGE_RECRUIT = 7246;
	private static final int GOLDEN_BADGE_SOLDIER = 7247;

	public void onLoad()
	{}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _109_InSearchOfTheNest()
	{
		super(false);
		addStartNpc(PIERCE);
		addTalkId(CORPSE);
		addTalkId(KAHMAN);

		addQuestItem(MEMO);
	}

	@Override
	public String onEvent(String event, QuestState st, L2NpcInstance npc)
	{
		String htmltext = event;
		int cond = st.getInt("cond");
		if(event.equalsIgnoreCase("Memo") && cond == 1)
		{
			st.giveItems(MEMO, 1);
			st.set("cond", "2");
			st.playSound(SOUND_ITEMGET);
			htmltext = "You've find something...";
		}
		else if(event.equalsIgnoreCase("merc_cap_peace_q0109_0301.htm") && cond == 2)
		{
			st.takeItems(MEMO, -1);
			st.set("cond", "3");
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		int id = st.getState();
		if(id == COMPLETED)
			return "completed";
		int cond = st.getInt("cond");
		String htmltext = "noquest";

		if(id == CREATED)
		{
			if(st.getPlayer().getLevel() >= 66 && npcId == PIERCE && (st.getQuestItemsCount(GOLDEN_BADGE_RECRUIT) > 0 || st.getQuestItemsCount(GOLDEN_BADGE_SOLDIER) > 0))
			{
				st.setState(STARTED);
				st.playSound(SOUND_ACCEPT);
				st.set("cond", "1");
				htmltext = "merc_cap_peace_q0109_0105.htm";
			}
			else
			{
				htmltext = "merc_cap_peace_q0109_0103.htm";
				st.exitCurrentQuest(true);
			}
		}
		else if(id == STARTED)
			if(npcId == CORPSE)
			{
				if(cond == 1)
					htmltext = "corpse_of_scout_q0109_0101.htm";
				else if(cond == 2)
					htmltext = "corpse_of_scout_q0109_0203.htm";
			}
			else if(npcId == PIERCE)
			{
				if(cond == 1)
					htmltext = "merc_cap_peace_q0109_0304.htm";
				else if(cond == 2)
					htmltext = "merc_cap_peace_q0109_0201.htm";
				else if(cond == 3)
					htmltext = "merc_cap_peace_q0109_0303.htm";
			}
			else if(npcId == KAHMAN && cond == 3)
			{
				htmltext = "merc_kahmun_q0109_0401.htm";
				st.addExpAndSp(701500, 50000);
				st.giveItems(ADENA_ID, 161500);
				st.exitCurrentQuest(false);
				st.playSound(SOUND_FINISH);
			}
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		return null;
	}
}