DROP TABLE IF EXISTS `armor`;
CREATE TABLE `armor` (
  `item_id` smallint(4) NOT NULL default '0',
  `name` varchar(128) NOT NULL default '',
  `additional_name` varchar(128) NOT NULL default '',
  `bodypart` varchar(16) NOT NULL default '',
  `crystallizable` enum('false','true') NOT NULL default 'false',
  `armor_type` varchar(12) NOT NULL default '',
  `player_class` enum('Bard','BowMaster','DaggerMaster','Enchanter','ForceMaster','Healer','ShieldMaster','Summoner','WeaponMaster','Wizard') default NULL,
  `weight` int(11) NOT NULL default '0',
  `crystal_type` enum('none','d','c','b','a','s','s80','s84') NOT NULL default 'none',
  `avoid_modify` int(11) NOT NULL default '0',
  `durability` int(11) NOT NULL default '-1',
  `temporal` tinyint(1) unsigned NOT NULL default '0',
  `p_def` int(11) NOT NULL default '0',
  `m_def` int(11) NOT NULL default '0',
  `mp_bonus` int(11) NOT NULL default '0',
  `price` int(11) NOT NULL default '0',
  `crystal_count` int(11) NOT NULL default '0',
  `sellable` enum('false','true') NOT NULL default 'true',
  `icon` varchar(128) NOT NULL default '',
  `dropable` tinyint(1) NOT NULL default '1',
  `destroyable` tinyint(1) NOT NULL default '1',
  `tradeable` tinyint(1) NOT NULL default '1',
  `skill_id` varchar(50) NOT NULL default '0',
  `skill_level` varchar(30) NOT NULL default '0',
  `enchant4_skill_id` smallint(4) NOT NULL default '0',
  `enchant4_skill_lvl` smallint(4) NOT NULL default '0',
  PRIMARY KEY  (`item_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `armor` (`item_id`, `name`, `additional_name`, `bodypart`, `crystallizable`, `armor_type`, `player_class`, `weight`, `crystal_type`, `avoid_modify`, `durability`, `temporal`, `p_def`, `m_def`, `mp_bonus`, `price`, `crystal_count`, `sellable`, `icon`, `dropable`, `destroyable`, `tradeable`, `skill_id`, `skill_level`, `enchant4_skill_id`, `enchant4_skill_lvl`) VALUES
	(21,'Shirt','','chest','false','light',NULL,4830,'none',0,-1,0,36,0,0,113,0,'true','armor_t02_u_i00',1,1,1,'0','0',0,0),
	(22,'Leather Shirt','','chest','false','light',NULL,4830,'none',0,-1,0,43,0,0,1870,0,'true','armor_t04_u_i00',1,1,1,'0','0',0,0),
	(23,'Wooden Breastplate','','chest','false','light',NULL,4820,'none',0,-1,0,47,0,0,6120,0,'true','armor_t06_u_i00',1,1,1,'0','0',0,0),
	(24,'Bone Breastplate','','chest','false','light',NULL,4770,'none',0,-1,0,50,0,0,15600,0,'true','armor_t32_u_i00',1,1,1,'0','0',0,0),
	(25,'Piece Bone Breastplate','','chest','false','heavy',NULL,8970,'none',0,-1,0,62,0,0,24480,0,'true','armor_t33_u_i00',1,1,1,'0','0',0,0),
	(26,'Bronze Breastplate','','chest','false','heavy',NULL,8920,'none',0,-1,0,68,0,0,37820,0,'true','armor_t34_u_i00',1,1,1,'0','0',0,0),
	(27,'Hard Leather Shirt','','chest','false','light',NULL,4720,'none',0,-1,0,53,0,0,28400,0,'true','armor_t30_u_i00',1,1,1,'0','0',0,0),
	(28,'Pants','','legs','false','light',NULL,1740,'none',0,-1,0,22,0,0,71,0,'true','armor_t02_l_i00',1,1,1,'0','0',0,0),
	(29,'Leather Pants','','legs','false','light',NULL,1730,'none',0,-1,0,27,0,0,1170,0,'true','armor_t04_l_i00',1,1,1,'0','0',0,0),
	(30,'Hard Leather Pants','','legs','false','light',NULL,1700,'none',0,-1,0,29,0,0,3820,0,'true','armor_t06_l_i00',1,1,1,'0','0',0,0),
	(31,'Bone Gaiters','','legs','false','light',NULL,1680,'none',0,-1,0,32,0,0,9770,0,'true','armor_t32_l_i00',1,1,1,'0','0',0,0),
	(32,'Piece Bone Gaiters','','legs','false','heavy',NULL,4020,'none',0,-1,0,39,0,0,15300,0,'true','armor_t33_l_i00',1,1,1,'0','0',0,0),
	(33,'Hard Leather Gaiters','','legs','false','light',NULL,1610,'none',0,-1,0,33,0,0,17700,0,'true','armor_t30_l_i00',1,1,1,'0','0',0,0),
	(34,'Bronze Gaiters','','legs','false','heavy',NULL,3960,'none',0,-1,0,43,0,0,23600,0,'true','armor_t34_l_i00',1,1,1,'0','0',0,0),
	(35,'Cloth Shoes','','feet','false','none',NULL,1320,'none',0,-1,0,9,0,0,28,0,'true','armor_t02_b_i00',1,1,1,'0','0',0,0),
	(36,'Leather Sandals','','feet','false','none',NULL,1320,'none',0,-1,0,9,0,0,28,0,'true','armor_t03_b_i00',1,1,1,'0','0',0,0),
	(37,'Leather Shoes','','feet','false','none',NULL,1320,'none',0,-1,0,13,0,0,2040,0,'true','armor_t05_b_i00',1,1,1,'0','0',0,0),
	(38,'Low Boots','','feet','false','none',NULL,1320,'none',0,-1,0,15,0,0,5210,0,'true','armor_t32_b_i00',1,1,1,'0','0',0,0),
	(39,'Boots','','feet','false','none',NULL,1310,'none',0,-1,0,17,0,0,9500,0,'true','armor_t30_b_i00',1,1,1,'0','0',0,0),
	(40,'Leather Boots','','feet','true','none',NULL,1300,'d',0,-1,0,19,0,0,16100,30,'true','armor_t09_b_i00',1,1,1,'0','0',0,0),
	(41,'Cloth Cap','','head','false','none',NULL,660,'none',0,-1,0,13,0,0,42,0,'true','armor_cloth_helmet_i00',1,1,1,'0','0',0,0),
	(42,'Leather Cap','','head','false','none',NULL,660,'none',0,-1,0,16,0,0,700,0,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(43,'Wooden Helmet','','head','false','none',NULL,660,'none',0,-1,0,19,0,0,3060,0,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(44,'Leather Helmet','','head','false','none',NULL,650,'none',0,-1,0,23,0,0,7820,0,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(45,'Bone Helmet','','head','true','none',NULL,640,'d',0,-1,0,29,0,0,24100,44,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(46,'Bronze Helmet','','head','true','none',NULL,630,'d',0,-1,0,33,0,0,38400,71,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(47,'Helmet','','head','true','none',NULL,640,'d',0,-1,0,37,0,0,58600,108,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(48,'Short Gloves','','gloves','false','none',NULL,660,'none',0,-1,0,9,0,0,28,0,'true','armor_t02_g_i00',1,1,1,'0','0',0,0),
	(49,'Gloves','','gloves','false','none',NULL,660,'none',0,-1,0,13,0,0,2040,0,'true','armor_t06_g_i00',1,1,1,'0','0',0,0),
	(50,'Leather Gloves','','gloves','false','none',NULL,650,'none',0,-1,0,15,0,0,5210,0,'true','armor_t32_g_i00',1,1,1,'0','0',0,0),
	(51,'Bracer','','gloves','false','none',NULL,650,'none',0,-1,0,17,0,0,9500,0,'true','armor_t30_g_i00',1,1,1,'0','0',0,0),
	(58,'Mithril Breastplate','','chest','true','heavy',NULL,8670,'d',0,-1,0,95,0,0,141100,260,'true','armor_t19_u_i00',1,1,1,'0','0',0,0),
	(59,'Mithril Gaiters','','legs','true','heavy',NULL,3830,'d',0,-1,0,61,0,0,97600,180,'true','armor_t19_l_i00',1,1,1,'0','0',0,0),
	(60,'Composite Armor','','fullarmor','true','heavy',NULL,10980,'c',0,-1,0,224,0,0,1227000,491,'true','armor_t61_ul_i00',1,1,1,'0','0',0,0),
	(61,'Mithril Plate Gloves','','gloves','true','none',NULL,630,'d',0,-1,0,29,0,0,75200,139,'true','armor_t46_g_i00',1,1,1,'0','0',0,0),
	(62,'Mithril Boots','','feet','true','none',NULL,1230,'c',0,-1,0,32,0,0,97100,39,'true','armor_t47_b_i00',1,1,1,'0','0',0,0),
	(63,'Gauntlets','','gloves','true','none',NULL,640,'d',0,-1,0,24,0,0,39100,72,'true','armor_t10_g_i00',1,1,1,'0','0',0,0),
	(64,'Composite Boots','','feet','true','none',NULL,1220,'c',0,-1,0,36,0,0,188800,76,'true','armor_t61_b_i00',1,1,1,'0','0',0,0),
	(112,'Apprentice\'s Earring','','rear,lear','false','none',NULL,150,'none',0,-1,0,0,11,0,38,0,'true','accessary_apprentices_earing_i00',1,1,1,'0','0',0,0),
	(113,'Mystic\'s Earring','','rear,lear','false','none',NULL,150,'none',0,-1,0,0,13,0,620,0,'true','accessary_mage_earing_i00',1,1,1,'0','0',0,0),
	(114,'Earring of Strength','','rear,lear','false','none',NULL,150,'none',0,-1,0,0,16,0,2700,0,'true','accessary_earing_of_strength_i00',1,1,1,'0','0',0,0),
	(115,'Earring of Wisdom','','rear,lear','false','none',NULL,150,'none',0,-1,0,0,16,0,2700,0,'true','accessary_earing_of_wisdom_i00',1,1,1,'0','0',0,0),
	(116,'Magic Ring','','rfinger,lfinger','false','none',NULL,150,'none',0,-1,0,0,7,0,25,0,'true','accessary_magic_ring_i00',1,1,1,'0','0',0,0),
	(117,'Ring of Mana','','rfinger,lfinger','true','none',NULL,150,'b',0,-1,0,0,34,0,310600,53,'true','accessary_ring_of_mana_i00',1,1,1,'0','0',0,0),
	(118,'Necklace of Magic','','neck','false','none',NULL,150,'none',0,-1,0,0,15,0,51,0,'true','accessary_necklace_of_magic_i00',1,1,1,'0','0',0,0),
	(119,'Necklace of Binding','','neck','true','none',NULL,150,'c',0,-1,0,0,64,0,434400,174,'true','accessary_necklace_of_binding_i00',1,1,1,'0','0',0,0),
	(347,'Ring Mail Breastplate','','chest','true','heavy',NULL,8820,'d',0,-1,0,77,0,0,64210,119,'true','armor_t12_u_i00',1,1,1,'0','0',0,0),
	(348,'Scale Mail','','chest','true','heavy',NULL,8720,'d',0,-1,0,87,0,0,102500,189,'true','armor_t08_u_i00',1,1,1,'0','0',0,0),
	(349,'Compound Scale Mail','','chest','true','heavy',NULL,8620,'d',0,-1,0,95,0,0,141100,260,'true','armor_t20_u_i00',1,1,1,'0','0',0,0),
	(350,'Dwarven Scale Mail','','chest','true','heavy',NULL,8540,'d',0,-1,0,95,0,0,141100,260,'true','armor_t15_u_i00',1,1,1,'0','0',0,0),
	(351,'Blast Plate','','chest','true','heavy',NULL,8420,'d',0,-1,0,97,0,0,156200,288,'true','armor_t40_u_i00',1,1,1,'0','0',0,0),
	(352,'Brigandine Tunic','','chest','true','heavy',NULL,8320,'d',0,-1,0,103,0,0,229700,424,'true','armor_t43_u_i00',1,1,1,'0','0',0,0),
	(353,'Half Plate Armor','','chest','true','heavy',NULL,8220,'d',0,-1,0,111,0,0,300800,555,'true','armor_t46_u_i00',1,1,1,'0','0',0,0),
	(354,'Chain Mail Shirt','','chest','true','heavy',NULL,8120,'c',0,-1,0,120,0,0,388600,155,'true','armor_t48_u_i00',1,1,1,'0','0',0,0),
	(355,'Dwarven Chain Mail Shirt','','chest','true','heavy',NULL,8070,'c',0,-1,0,129,0,0,495500,198,'true','armor_t60_u_i00',1,1,1,'0','0',0,0),
	(356,'Full Plate Armor','','fullarmor','true','heavy',NULL,10480,'c',0,-1,0,239,0,0,1788000,715,'true','armor_t62_ul_i00',1,1,1,'0','0',0,0),
	(357,'Zubei\'s Breastplate','','chest','true','heavy',NULL,7970,'b',0,-1,0,157,0,0,1596000,213,'true','armor_t64_u_i00',1,1,1,'0','0',0,0),
	(358,'Blue Wolf Breastplate','','chest','true','heavy',NULL,7820,'b',0,-1,0,166,0,0,2475000,330,'true','armor_t68_u_i00',1,1,1,'0','0',0,0),
	(359,'Shining Dragon Armor','','fullarmor','true','heavy',NULL,6400,'b',0,-1,0,301,0,0,5788000,902,'true','armor_composite_armor_i02',1,1,1,'0','0',0,0),
	(360,'Armor of Victory','','chest','true','heavy',NULL,3360,'b',0,-1,0,175,0,0,2475000,429,'true','armor_dwarven_scale_mail_i00',1,1,1,'0','0',0,0),
	(361,'Breastplate of Valor','','chest','true','heavy',NULL,3360,'b',0,-1,0,185,0,0,3562000,617,'true','armor_dwarven_scale_mail_i00',1,1,1,'0','0',0,0),
	(362,'Glorious Armor','','fullarmor','true','heavy',NULL,6720,'b',0,-1,0,284,0,0,4022000,628,'true','armor_composite_armor_i02',1,1,1,'0','0',0,0),
	(363,'Red Flame Armor','','fullarmor','true','heavy',NULL,6400,'b',0,-1,0,301,0,0,5788000,902,'true','armor_composite_armor_i02',1,1,1,'0','0',0,0),
	(364,'Elven Crystal Breastplate','','chest','true','heavy',NULL,2400,'b',0,-1,0,175,0,0,2475000,429,'true','armor_dwarven_scale_mail_i00',1,1,1,'0','0',0,0),
	(365,'Dark Crystal Breastplate','','chest','true','heavy',NULL,7700,'a',0,-1,0,171,0,0,3562000,285,'true','armor_t74_u_i00',1,1,1,'0','0',0,0),
	(366,'Implosion Armor','','fullarmor','true','heavy',NULL,6080,'b',0,-1,0,284,0,0,4022000,628,'true','armor_composite_armor_i02',1,1,1,'0','0',0,0),
	(367,'Dark Dragon Armor','','fullarmor','true','heavy',NULL,5760,'b',0,-1,0,301,0,0,5788000,902,'true','armor_composite_armor_i02',1,1,1,'0','0',0,0),
	(368,'Elven Vagian Armor','','fullarmor','true','heavy',NULL,2400,'b',0,-1,0,284,0,0,4022000,628,'true','armor_composite_armor_i02',1,1,1,'0','0',0,0),
	(369,'Dark Vagian Armor','','fullarmor','true','heavy',NULL,2400,'b',0,-1,0,301,0,0,5788000,902,'true','armor_composite_armor_i02',1,1,1,'0','0',0,0),
	(370,'Complete Set of Plate Armor','','fullarmor','true','heavy',NULL,6400,'b',0,-1,0,284,0,0,4022000,628,'true','armor_composite_armor_i02',1,1,1,'0','0',0,0),
	(371,'Hell Plate','','fullarmor','true','heavy',NULL,6400,'b',0,-1,0,301,0,0,5788000,902,'true','armor_composite_armor_i02',1,1,1,'0','0',0,0),
	(372,'Art of Plate','','fullarmor','true','heavy',NULL,6720,'b',0,-1,0,284,0,0,4022000,628,'true','armor_composite_armor_i02',1,1,1,'0','0',0,0),
	(373,'Masterpiece Armor','','fullarmor','true','heavy',NULL,5600,'b',0,-1,0,301,0,0,5788000,902,'true','armor_composite_armor_i02',1,1,1,'0','0',0,0),
	(374,'Armor of Nightmare','','fullarmor','true','heavy',NULL,9580,'a',0,-1,0,293,0,0,8804000,704,'true','armor_t80_ul_i00',1,1,1,'0','0',0,0),
	(375,'Dragon Scale Mail','','chest','true','heavy',NULL,7620,'s',0,-1,0,198,0,0,8291000,525,'true','armor_t15_u_i00',1,1,1,'0','0',0,0),
	(376,'Iron Plate Gaiters','','legs','true','heavy',NULL,3820,'d',0,-1,0,48,0,0,40100,74,'true','armor_t12_l_i00',1,1,1,'0','0',0,0),
	(377,'Scale Gaiters','','legs','true','heavy',NULL,3860,'d',0,-1,0,54,0,0,64100,118,'true','armor_t08_l_i00',1,1,1,'0','0',0,0),
	(378,'Compound Scale Gaiters','','legs','true','heavy',NULL,3770,'d',0,-1,0,61,0,0,97600,180,'true','armor_t20_l_i00',1,1,1,'0','0',0,0),
	(379,'Dwarven Scale Gaiters','','legs','true','heavy',NULL,3840,'d',0,-1,0,61,0,0,97600,180,'true','armor_t15_l_i00',1,1,1,'0','0',0,0),
	(380,'Plate Gaiters','','legs','true','heavy',NULL,3770,'d',0,-1,0,70,0,0,188000,347,'true','armor_t46_l_i00',1,1,1,'0','0',0,0),
	(381,'Chain Gaiters','','legs','true','heavy',NULL,3680,'c',0,-1,0,75,0,0,242900,97,'true','armor_t48_l_i00',1,1,1,'0','0',0,0),
	(382,'Dwarven Chain Gaiters','','legs','true','heavy',NULL,3620,'c',0,-1,0,80,0,0,309700,124,'true','armor_t60_l_i00',1,1,1,'0','0',0,0),
	(383,'Zubei\'s Gaiters','','legs','true','heavy',NULL,3570,'b',0,-1,0,98,0,0,997700,133,'true','armor_t64_l_i00',1,1,1,'0','0',0,0),
	(384,'Wolf Gaiters','','legs','true','heavy',NULL,2560,'b',0,-1,0,109,0,0,1547100,268,'true','armor_plate_gaiters_i00',1,1,1,'0','0',0,0),
	(385,'Gaiters of Victory','','legs','true','heavy',NULL,2240,'b',0,-1,0,109,0,0,1547100,268,'true','armor_plate_gaiters_i00',1,1,1,'0','0',0,0),
	(386,'Gaiters of Valor','','legs','true','heavy',NULL,2240,'b',0,-1,0,116,0,0,2226000,385,'true','armor_plate_gaiters_i00',1,1,1,'0','0',0,0),
	(387,'Elven Crystal Gaiters','','legs','true','heavy',NULL,2240,'b',0,-1,0,109,0,0,1547100,268,'true','armor_plate_gaiters_i00',1,1,1,'0','0',0,0),
	(388,'Dark Crystal Gaiters','','legs','true','heavy',NULL,3320,'a',0,-1,0,107,0,0,2226000,178,'true','armor_t74_l_i00',1,1,1,'0','0',0,0),
	(389,'Dragon Scale Gaiters','','legs','true','heavy',NULL,3260,'s',0,-1,0,122,0,0,4640000,299,'true','armor_t15_l_i00',1,1,1,'0','0',0,0),
	(390,'Cotton Shirt','','chest','false','light',NULL,4770,'none',0,-1,0,50,0,0,15600,0,'true','armor_t07_u_i00',1,1,1,'0','0',0,0),
	(391,'Puma Skin Shirt','','chest','true','light',NULL,4700,'d',0,-1,0,58,0,0,48200,89,'true','armor_t09_u_i00',1,1,1,'0','0',0,0),
	(392,'Lion Skin Shirt','','chest','true','light',NULL,4580,'d',0,-1,0,65,0,0,76900,142,'true','armor_t18_u_i00',1,1,1,'0','0',0,0),
	(393,'Mithril Banded Mail','','chest','true','light',NULL,4570,'d',0,-1,0,73,0,0,117000,216,'true','armor_t10_u_i00',1,1,1,'0','0',0,0),
	(394,'Reinforced Leather Shirt','','chest','true','light',NULL,4570,'d',0,-1,0,73,0,0,117000,216,'true','armor_t13_u_i00',1,1,1,'0','0',0,0),
	(395,'Manticore Skin Shirt','','chest','true','light',NULL,4520,'d',0,-1,0,77,0,0,172000,318,'true','armor_t42_u_i00',1,1,1,'0','0',0,0),
	(396,'Salamander Skin Mail','','fullarmor','true','light',NULL,6100,'d',0,-1,0,136,0,0,366600,677,'true','armor_t45_ul_i00',1,1,1,'0','0',0,0),
	(397,'Mithril Shirt','','chest','true','light',NULL,4470,'c',0,-1,0,90,0,0,291000,116,'true','armor_t47_u_i00',1,1,1,'0','0',0,0),
	(398,'Plated Leather','','chest','true','light',NULL,4450,'c',0,-1,0,94,0,0,343000,137,'true','armor_t47_u_i00',1,1,1,'0','0',0,0),
	(399,'Rind Leather Armor','','chest','true','light',NULL,4420,'c',0,-1,0,97,0,0,372000,149,'true','armor_t49_u_i00',1,1,1,'0','0',0,0),
	(400,'Theca Leather Armor','','chest','true','light',NULL,4370,'c',0,-1,0,106,0,0,635000,254,'true','armor_t63_u_i00',1,1,1,'0','0',0,0),
	(401,'Drake Leather Armor','','fullarmor','true','light',NULL,5800,'c',0,-1,0,179,0,0,1341000,536,'true','armor_t21_ul_i00',1,1,1,'0','0',0,0),
	(402,'Chain Mail of Silence','','fullarmor','true','light',NULL,3200,'b',0,-1,0,213,0,0,3017000,470,'true','armor_composite_armor_i02',1,1,1,'0','0',0,0),
	(403,'Gust Chain Mail','','fullarmor','true','light',NULL,2720,'b',0,-1,0,225,0,0,4341000,677,'true','armor_composite_armor_i02',1,1,1,'0','0',0,0),
	(404,'Prairie Leather Armor','','chest','true','light',NULL,8000,'b',0,-1,0,131,0,0,1857000,321,'true','armor_mithril_banded_mail_i00',1,1,1,'0','0',0,0),
	(405,'Leather Armor of the Underworld','','chest','true','light',NULL,8000,'b',0,-1,0,139,0,0,2671000,462,'true','armor_mithril_banded_mail_i00',1,1,1,'0','0',0,0),
	(406,'Leather Suit of Concentration','','fullarmor','true','light',NULL,2400,'b',0,-1,0,213,0,0,3017000,470,'true','armor_composite_armor_i02',1,1,1,'0','0',0,0),
	(407,'Ace\'s Leather Armor','','fullarmor','true','light',NULL,2400,'b',0,-1,0,225,0,0,4341000,677,'true','armor_composite_armor_i02',1,1,1,'0','0',0,0),
	(408,'Guardian\'s Leather Armor','','chest','true','light',NULL,8000,'b',0,-1,0,131,0,0,1857000,321,'true','armor_mithril_banded_mail_i00',1,1,1,'0','0',0,0),
	(409,'Marksman\'s Leather Armor','','chest','true','light',NULL,4300,'b',0,-1,0,139,0,0,2671000,462,'true','armor_mithril_banded_mail_i00',1,1,1,'0','0',0,0),
	(410,'Unicorn Leather Armor','','fullarmor','true','light',NULL,1280,'a',0,-1,0,238,0,0,6603000,618,'true','armor_composite_armor_i02',1,1,1,'0','0',0,0),
	(411,'Dragon Leather Armor','','fullarmor','true','light',NULL,4950,'s',0,-1,0,237,0,0,9047000,525,'true','armor_t45_ul_i00',1,1,1,'0','0',0,0),
	(412,'Cotton Pants','','legs','false','light',NULL,1630,'none',0,-1,0,32,0,0,9770,0,'true','armor_t07_l_i00',1,1,1,'0','0',0,0),
	(413,'Puma Skin Gaiters','','legs','true','light',NULL,1600,'d',0,-1,0,36,0,0,30100,56,'true','armor_t09_l_i00',1,1,1,'0','0',0,0),
	(414,'Lion Skin Gaiters','','legs','true','light',NULL,1570,'d',0,-1,0,41,0,0,48000,89,'true','armor_t18_l_i00',1,1,1,'0','0',0,0),
	(415,'Mithril Banded Gaiters','','legs','true','light',NULL,1580,'d',0,-1,0,46,0,0,73200,135,'true','armor_t10_l_i00',1,1,1,'0','0',0,0),
	(416,'Reinforced Leather Gaiters','','legs','true','light',NULL,1570,'d',0,-1,0,46,0,0,73200,135,'true','armor_t13_l_i00',1,1,1,'0','0',0,0),
	(417,'Manticore Skin Gaiters','','legs','true','light',NULL,1550,'d',0,-1,0,48,0,0,107700,199,'true','armor_t42_l_i00',1,1,1,'0','0',0,0),
	(418,'Plated Leather Gaiters','','legs','true','light',NULL,1560,'c',0,-1,0,59,0,0,214500,86,'true','armor_t47_l_i00',1,1,1,'0','0',0,0),
	(419,'Rind Leather Gaiters','','legs','true','light',NULL,1550,'c',0,-1,0,60,0,0,232300,93,'true','armor_t49_l_i00',1,1,1,'0','0',0,0),
	(420,'Theca Leather Gaiters','','legs','true','light',NULL,1530,'c',0,-1,0,66,0,0,396700,159,'true','armor_t63_l_i00',1,1,1,'0','0',0,0),
	(421,'Prairie Leather Gaiters','','legs','true','light',NULL,4800,'b',0,-1,0,82,0,0,1160300,201,'true','armor_mithril_banded_gaiters_i00',1,1,1,'0','0',0,0),
	(422,'Gaiters of the Underworld','','legs','true','light',NULL,4800,'b',0,-1,0,87,0,0,1670000,289,'true','armor_mithril_banded_gaiters_i00',1,1,1,'0','0',0,0),
	(423,'Guardian\'s Leather Gaiters','','legs','true','light',NULL,4800,'b',0,-1,0,82,0,0,1160300,201,'true','armor_mithril_banded_gaiters_i00',1,1,1,'0','0',0,0),
	(424,'Marksman\'s Leather Gaiters','','legs','true','light',NULL,1490,'b',0,-1,0,87,0,0,1670000,289,'true','armor_mithril_banded_gaiters_i00',1,1,1,'0','0',0,0),
	(425,'Apprentice\'s Tunic','','chest','false','magic',NULL,2150,'none',0,-1,0,17,0,19,20,0,'false','armor_t01_u_i00',0,1,0,'0','0',0,0),
	(426,'Tunic','','chest','false','magic',NULL,2150,'none',0,-1,0,18,0,24,113,0,'true','armor_t03_u_i00',1,1,1,'0','0',0,0),
	(427,'Cotton Robe','','fullarmor','false','magic',NULL,2750,'none',0,-1,0,35,0,61,3040,0,'true','armor_cotton_robe_i02',1,1,1,'0','0',0,0),
	(428,'Feriotic Tunic','','chest','false','magic',NULL,2140,'none',0,-1,0,21,0,38,1870,0,'true','armor_t52_u_i00',1,1,1,'0','0',0,0),
	(429,'Leather Tunic','','chest','false','magic',NULL,2110,'none',0,-1,0,25,0,52,6120,0,'true','armor_t05_u_i00',1,1,1,'0','0',0,0),
	(430,'Robe of Devotion','','fullarmor','false','magic',NULL,2650,'none',0,-1,0,49,0,109,25400,0,'true','armor_cotton_robe_i02',1,1,1,'0','0',0,0),
	(431,'Robe of Magic','','fullarmor','false','magic',NULL,2600,'none',0,-1,0,56,0,140,46090,0,'true','armor_cotton_robe_i02',1,1,1,'0','0',0,0),
	(432,'Cursed Tunic','','chest','true','magic',NULL,2090,'d',0,-1,0,39,0,106,48200,89,'true','armor_t14_u_i00',1,1,1,'0','0',0,0),
	(433,'Elven Tunic','','chest','true','magic',NULL,2080,'d',0,-1,0,43,0,126,76900,142,'true','armor_t11_u_i00',1,1,1,'0','0',0,0),
	(434,'White Tunic','','chest','true','magic',NULL,2040,'d',0,-1,0,43,0,126,76900,142,'true','armor_t16_u_i00',1,1,1,'0','0',0,0),
	(435,'Mystic\'s Tunic','','chest','true','magic',NULL,2030,'d',0,-1,0,43,0,126,76900,142,'true','armor_t17_u_i00',1,1,1,'0','0',0,0),
	(436,'Tunic of Knowledge','','chest','true','magic',NULL,2020,'d',0,-1,0,49,0,147,117000,216,'true','armor_t41_u_i00',1,1,1,'0','0',0,0),
	(437,'Mithril Tunic','','chest','true','magic',NULL,2010,'d',0,-1,0,52,0,169,172000,318,'true','armor_t51_u_i00',1,1,1,'0','0',0,0),
	(438,'Sage\'s Rag','','fullarmor','true','magic',NULL,2580,'d',0,-1,0,90,0,320,366600,677,'true','armor_t44_ul_i00',1,1,1,'0','0',0,0),
	(439,'Karmian Tunic','','chest','true','magic',NULL,1980,'c',0,-1,0,60,0,225,291000,116,'true','armor_t53_u_i00',1,1,1,'0','0',0,0),
	(440,'Robe of Seal','','fullarmor','true','magic',NULL,2500,'c',0,-1,0,105,0,413,603900,242,'true','armor_t44_ul_i00',1,1,1,'0','0',0,0),
	(441,'Demon\'s Tunic','','chest','true','magic',NULL,1990,'c',0,-1,0,69,0,284,566000,226,'true','armor_t54_u_i00',1,1,1,'0','0',0,0),
	(442,'Divine Tunic','','chest','true','magic',NULL,1980,'c',0,-1,0,74,0,314,825000,330,'true','armor_t57_u_i00',1,1,1,'0','0',0,0),
	(443,'Tunic of Mana','','chest','true','magic',NULL,2000,'b',0,-1,0,87,0,377,1857000,321,'true','armor_tunic_of_knowledge_i00',1,1,1,'0','0',0,0),
	(444,'Sage\'s Robe','','fullarmor','true','magic',NULL,1600,'b',0,-1,0,150,0,665,4341000,677,'true','armor_cotton_robe_i02',1,1,1,'0','0',0,0),
	(445,'Paradia Tunic','','chest','true','magic',NULL,1990,'b',0,-1,0,87,0,377,1857000,321,'true','armor_tunic_of_knowledge_i00',1,1,1,'0','0',0,0),
	(446,'Inferno Tunic','','chest','true','magic',NULL,1880,'b',0,-1,0,92,0,409,2671000,462,'true','armor_tunic_of_knowledge_i00',1,1,1,'0','0',0,0),
	(447,'Tunic of Solar Eclipse','','chest','true','magic',NULL,1960,'b',0,-1,0,87,0,377,1857000,321,'true','armor_tunic_of_knowledge_i00',1,1,1,'0','0',0,0),
	(448,'Robe of Black Ore','','fullarmor','true','magic',NULL,1600,'b',0,-1,0,150,0,665,4341000,677,'true','armor_cotton_robe_i02',1,1,1,'0','0',0,0),
	(449,'Tunic of Summoning','','chest','true','magic',NULL,1950,'b',0,-1,0,87,0,377,1857000,321,'true','armor_tunic_of_knowledge_i00',1,1,1,'0','0',0,0),
	(450,'Otherworldly Robe','','fullarmor','true','magic',NULL,1600,'b',0,-1,0,150,0,665,4341000,677,'true','armor_cotton_robe_i02',1,1,1,'0','0',0,0),
	(451,'Elemental Tunic','','chest','true','magic',NULL,1970,'b',0,-1,0,87,0,377,1857000,321,'true','armor_tunic_of_knowledge_i00',1,1,1,'0','0',0,0),
	(452,'Tunic of Phantom','','chest','true','magic',NULL,1890,'b',0,-1,0,92,0,409,2671000,462,'true','armor_tunic_of_knowledge_i00',1,1,1,'0','0',0,0),
	(453,'Tunic of Grace','','chest','true','magic',NULL,1930,'b',0,-1,0,87,0,377,1857000,321,'true','armor_tunic_of_knowledge_i00',1,1,1,'0','0',0,0),
	(454,'Robe of Holy Spirit','','fullarmor','true','magic',NULL,1600,'b',0,-1,0,150,0,665,4341000,677,'true','armor_cotton_robe_i02',1,1,1,'0','0',0,0),
	(455,'Phoenix Tunic','','chest','true','magic',NULL,1950,'b',0,-1,0,87,0,377,1857000,321,'true','armor_tunic_of_knowledge_i00',1,1,1,'0','0',0,0),
	(456,'Cerberus Tunic','','chest','true','magic',NULL,1870,'b',0,-1,0,92,0,409,2671000,462,'true','armor_tunic_of_knowledge_i00',1,1,1,'0','0',0,0),
	(457,'Tunic of Aid','','chest','true','magic',NULL,1910,'b',0,-1,0,87,0,377,1857000,321,'true','armor_tunic_of_knowledge_i00',1,1,1,'0','0',0,0),
	(458,'Robe of Blessing','','fullarmor','true','magic',NULL,1600,'b',0,-1,0,150,0,665,4341000,677,'true','armor_cotton_robe_i02',1,1,1,'0','0',0,0),
	(459,'Dasparion\'s Robe','','fullarmor','true','magic',NULL,1200,'a',0,-1,0,158,0,718,6603000,618,'true','armor_cotton_robe_i02',1,1,1,'0','0',0,0),
	(460,'The Robe','','fullarmor','true','magic',NULL,2300,'s',0,-1,0,158,0,773,9047000,525,'true','armor_t44_ul_i00',1,1,1,'0','0',0,0),
	(461,'Apprentice\'s Stockings','','legs','false','magic',NULL,1100,'none',0,-1,0,10,0,10,4,0,'false','armor_t01_l_i00',0,1,0,'0','0',0,0),
	(462,'Stockings','','legs','false','magic',NULL,1080,'none',0,-1,0,11,0,15,71,0,'true','armor_t03_l_i00',1,1,1,'0','0',0,0),
	(463,'Feriotic Stockings','','legs','false','magic',NULL,1070,'none',0,-1,0,13,0,23,1170,0,'true','armor_t52_l_i00',1,1,1,'0','0',0,0),
	(464,'Leather Stockings','','legs','false','magic',NULL,1020,'none',0,-1,0,16,0,33,3820,0,'true','armor_t05_l_i00',1,1,1,'0','0',0,0),
	(465,'Cursed Stockings','','legs','true','magic',NULL,1020,'d',0,-1,0,24,0,66,30100,56,'true','armor_t14_l_i00',1,1,1,'0','0',0,0),
	(466,'Elven Stockings','','legs','true','magic',NULL,1010,'d',0,-1,0,27,0,79,48000,89,'true','armor_t11_l_i00',1,1,1,'0','0',0,0),
	(467,'Dark Stockings','','legs','true','magic',NULL,1000,'d',0,-1,0,27,0,79,48000,89,'true','armor_t16_l_i00',1,1,1,'0','0',0,0),
	(468,'Mystic\'s Stockings','','legs','true','magic',NULL,990,'d',0,-1,0,27,0,79,48000,89,'true','armor_t17_l_i00',1,1,1,'0','0',0,0),
	(469,'Stockings of Knowledge','','legs','true','magic',NULL,1000,'d',0,-1,0,30,0,92,73200,135,'true','armor_t41_l_i00',1,1,1,'0','0',0,0),
	(470,'Mithril Stockings','','legs','true','magic',NULL,980,'d',0,-1,0,32,0,105,107700,199,'true','armor_t51_l_i00',1,1,1,'0','0',0,0),
	(471,'Karmian Stockings','','legs','true','magic',NULL,970,'c',0,-1,0,37,0,141,182100,73,'true','armor_t53_l_i00',1,1,1,'0','0',0,0),
	(472,'Demon\'s Stockings','','legs','true','magic',NULL,980,'c',0,-1,0,43,0,177,354000,142,'true','armor_t54_l_i00',1,1,1,'0','0',0,0),
	(473,'Divine Stockings','','legs','true','magic',NULL,960,'c',0,-1,0,46,0,196,515800,206,'true','armor_t57_l_i00',1,1,1,'0','0',0,0),
	(474,'Stockings of Mana','','legs','true','magic',NULL,2400,'b',0,-1,0,55,0,236,1160300,201,'true','armor_leather_hose_i00',1,1,1,'0','0',0,0),
	(475,'Paradia Stockings','','legs','true','magic',NULL,1600,'b',0,-1,0,55,0,236,1160300,201,'true','armor_leather_hose_i00',1,1,1,'0','0',0,0),
	(476,'Inferno Stockings','','legs','true','magic',NULL,1600,'b',0,-1,0,58,0,256,1670000,289,'true','armor_leather_hose_i00',1,1,1,'0','0',0,0),
	(477,'Stockings of Solar Eclipse','','legs','true','magic',NULL,2400,'b',0,-1,0,55,0,236,1160300,201,'true','armor_leather_hose_i00',1,1,1,'0','0',0,0),
	(478,'Stockings of Summoning','','legs','true','magic',NULL,2400,'b',0,-1,0,55,0,236,1160300,201,'true','armor_leather_hose_i00',1,1,1,'0','0',0,0),
	(479,'Elemental Stockings','','legs','true','magic',NULL,1600,'b',0,-1,0,55,0,236,1160300,201,'true','armor_leather_hose_i00',1,1,1,'0','0',0,0),
	(480,'Stockings of Phantom','','legs','true','magic',NULL,1600,'b',0,-1,0,58,0,256,1670000,289,'true','armor_leather_hose_i00',1,1,1,'0','0',0,0),
	(481,'Stockings of Grace','','legs','true','magic',NULL,2400,'b',0,-1,0,55,0,236,1160300,201,'true','armor_leather_hose_i00',1,1,1,'0','0',0,0),
	(482,'Phoenix Stockings','','legs','true','magic',NULL,2400,'b',0,-1,0,55,0,236,1160300,201,'true','armor_leather_hose_i00',1,1,1,'0','0',0,0),
	(483,'Cerberus Stockings','','legs','true','magic',NULL,6400,'b',0,-1,0,58,0,256,1670000,289,'true','armor_leather_hose_i00',1,1,1,'0','0',0,0),
	(484,'Stockings of Aid','','legs','true','magic',NULL,2400,'b',0,-1,0,55,0,236,1160300,201,'true','armor_leather_hose_i00',1,1,1,'0','0',0,0),
	(485,'Tattoo of Power','','underwear','false','none',NULL,4200,'none',0,-1,0,53,0,0,28400,0,'true','weapon_voodoo_doll_i00',1,1,1,'0','0',0,0),
	(486,'Tattoo of Fire','','underwear','true','none',NULL,4050,'d',0,-1,0,73,0,0,117000,276,'true','weapon_voodoo_doll_i00',1,1,1,'0','0',0,0),
	(487,'Tattoo of Resolve','','underwear','true','none',NULL,4000,'d',0,-1,0,73,0,0,117000,276,'true','weapon_voodoo_doll_i00',1,1,1,'0','0',0,0),
	(488,'Tattoo of Flame','','underwear','true','none',NULL,800,'b',0,-1,0,139,0,0,2671000,462,'true','weapon_voodoo_doll_i00',1,1,1,'0','0',0,0),
	(489,'Tattoo of Bravery','','underwear','true','none',NULL,4100,'c',0,-1,0,110,0,0,825000,428,'true','weapon_voodoo_doll_i00',1,1,1,'0','0',0,0),
	(490,'Tattoo of Blood','','underwear','true','none',NULL,3800,'a',0,-1,0,132,0,0,2671000,277,'true','weapon_voodoo_doll_i00',1,1,1,'0','0',0,0),
	(491,'Tattoo of Absolute','','underwear','true','none',NULL,800,'a',0,-1,0,146,0,0,4064000,422,'true','weapon_voodoo_doll_i00',1,1,1,'0','0',0,0),
	(492,'Tattoo of Soul','','underwear','true','none',NULL,4150,'d',0,-1,0,65,0,0,76900,181,'true','weapon_voodoo_doll_i00',1,1,1,'0','0',0,0),
	(493,'Tattoo of Avadon','','underwear','true','none',NULL,4000,'b',0,-1,0,117,0,0,1197000,208,'true','weapon_voodoo_doll_i00',1,1,1,'0','0',0,0),
	(494,'Tattoo of Doom','','underwear','true','none',NULL,4100,'b',0,-1,0,125,0,0,1857000,321,'true','weapon_voodoo_doll_i00',1,1,1,'0','0',0,0),
	(495,'Tattoo of Pledge','','underwear','true','none',NULL,4000,'b',0,-1,0,124,0,0,1197000,208,'true','item_normal03',1,1,1,'0','0',0,0),
	(496,'Tattoo of Divine','','underwear','true','none',NULL,4100,'b',0,-1,0,131,0,0,1857000,321,'true','weapon_voodoo_doll_i00',1,1,1,'0','0',0,0),
	(497,'Chain Helmet','','head','true','none',NULL,620,'c',0,-1,0,45,0,0,112800,59,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(498,'Steel Plate Helmet','','head','true','none',NULL,610,'c',0,-1,0,49,0,0,158200,82,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(499,'Mithril Helmet','','head','true','none',NULL,240,'c',0,-1,0,58,0,0,412600,214,'true','armor_circlet_i00',1,1,1,'0','0',0,0),
	(500,'Great Helmet','','head','true','none',NULL,610,'c',0,-1,0,51,0,0,185800,74,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(501,'Armet','','head','true','none',NULL,580,'b',0,-1,0,62,0,0,795800,4,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(502,'Close Helmet','','head','true','none',NULL,570,'a',0,-1,0,64,0,0,1198000,3,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(503,'Zubei\'s Helmet','','head','true','none',NULL,590,'b',0,-1,0,62,0,0,598600,80,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(504,'Dragon Helmet','','head','true','none',NULL,550,'s',0,-1,0,77,0,0,2784000,179,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(505,'Wolf Helmet','','head','true','none',NULL,580,'b',0,-1,0,66,0,0,928300,161,'true','armor_circlet_i00',1,1,1,'0','0',0,0),
	(506,'Shining Dragon Helmet','','head','true','none',NULL,880,'b',0,-1,0,67,0,0,1336000,232,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(507,'Helmet of Victory','','head','true','none',NULL,640,'b',0,-1,0,66,0,0,928300,161,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(508,'Helmet of Valor','','head','true','none',NULL,720,'b',0,-1,0,67,0,0,1336000,232,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(509,'Glorious Helmet','','head','true','none',NULL,800,'a',0,-1,0,65,0,0,1566000,3,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(510,'Red Flame Helmet','','head','true','none',NULL,960,'a',0,-1,0,71,0,0,2032000,3,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(511,'Elven Crystal Helmet','','head','true','none',NULL,580,'b',0,-1,0,66,0,0,928300,161,'true','armor_circlet_i00',1,1,1,'0','0',0,0),
	(512,'Dark Crystal Helmet','','head','true','none',NULL,570,'a',0,-1,0,69,0,0,1336000,107,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(513,'Implosion Helmet','','head','true','none',NULL,480,'b',0,-1,0,66,0,0,928300,161,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(514,'Dark Dragon Helmet','','head','true','none',NULL,400,'b',0,-1,0,67,0,0,1336000,232,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(515,'Elven Vagian Helm','','head','true','none',NULL,560,'a',0,-1,0,65,0,0,1566000,3,'true','armor_circlet_i00',1,1,1,'0','0',0,0),
	(516,'Dark Vagian Helm','','head','true','none',NULL,560,'a',0,-1,0,71,0,0,2032000,3,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(517,'Composite Helmet','','head','true','none',NULL,610,'c',0,-1,0,54,0,0,283200,113,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(518,'Hell Helm','','head','true','none',NULL,320,'a',0,-1,0,71,0,0,2032000,3,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(519,'Art of Helmet','','head','true','none',NULL,400,'b',0,-1,0,66,0,0,928300,161,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(520,'Masterpiece Helm','','head','true','none',NULL,400,'a',0,-1,0,71,0,0,2032000,3,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(521,'Helmet of Silence','','head','true','none',NULL,320,'b',0,-1,0,66,0,0,928300,161,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(522,'Gust Helmet','','head','true','none',NULL,570,'b',0,-1,0,67,0,0,1336000,232,'true','armor_circlet_i00',1,1,1,'0','0',0,0),
	(523,'Prairie Helmet','','head','true','none',NULL,480,'b',0,-1,0,66,0,0,928300,161,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(524,'Helm of the Underworld','','head','true','none',NULL,320,'b',0,-1,0,67,0,0,1336000,232,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(525,'Helmet of Concentration','','head','true','none',NULL,320,'b',0,-1,0,66,0,0,928300,161,'true','armor_circlet_i00',1,1,1,'0','0',0,0),
	(526,'Ace\'s Helmet','','head','true','none',NULL,320,'b',0,-1,0,67,0,0,1336000,232,'true','armor_circlet_i00',1,1,1,'0','0',0,0),
	(527,'Guardian\'s Helmet','','head','true','none',NULL,240,'b',0,-1,0,66,0,0,928300,161,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(528,'Marksman Helmet','','head','true','none',NULL,240,'b',0,-1,0,67,0,0,1336000,232,'true','armor_circlet_i00',1,1,1,'0','0',0,0),
	(529,'Cap of Mana','','head','true','none',NULL,320,'c',0,-1,0,58,0,0,412600,214,'true','armor_cloth_helmet_i00',1,1,1,'0','0',0,0),
	(530,'Sage\'s Cap','','head','true','none',NULL,320,'b',0,-1,0,62,0,0,598600,103,'true','armor_cloth_helmet_i00',1,1,1,'0','0',0,0),
	(531,'Paradia Hood','','head','true','none',NULL,320,'c',0,-1,0,58,0,0,412600,214,'true','armor_cloth_helmet_i00',1,1,1,'0','0',0,0),
	(532,'Inferno Hood','','head','true','none',NULL,320,'b',0,-1,0,62,0,0,598600,103,'true','armor_cloth_helmet_i00',1,1,1,'0','0',0,0),
	(533,'Hood of Solar Eclipse','','head','true','none',NULL,320,'c',0,-1,0,58,0,0,412600,214,'true','armor_cloth_helmet_i00',1,1,1,'0','0',0,0),
	(534,'Hood of Black Ore','','head','true','none',NULL,320,'b',0,-1,0,62,0,0,598600,103,'true','armor_cloth_helmet_i00',1,1,1,'0','0',0,0),
	(535,'Hood of Summoning','','head','true','none',NULL,320,'c',0,-1,0,58,0,0,412600,214,'true','armor_cloth_helmet_i00',1,1,1,'0','0',0,0),
	(536,'Otherworldly Hood','','head','true','none',NULL,320,'b',0,-1,0,62,0,0,598600,103,'true','armor_cloth_helmet_i00',1,1,1,'0','0',0,0),
	(537,'Elemental Hood','','head','true','none',NULL,320,'c',0,-1,0,58,0,0,412600,214,'true','armor_cloth_helmet_i00',1,1,1,'0','0',0,0),
	(538,'Hood of Phantom','','head','true','none',NULL,320,'b',0,-1,0,62,0,0,598600,103,'true','armor_cloth_helmet_i00',1,1,1,'0','0',0,0),
	(539,'Hood of Grace','','head','true','none',NULL,320,'c',0,-1,0,58,0,0,412600,214,'true','armor_cloth_helmet_i00',1,1,1,'0','0',0,0),
	(540,'Hood of Holy Spirit','','head','true','none',NULL,320,'b',0,-1,0,62,0,0,598600,103,'true','armor_cloth_helmet_i00',1,1,1,'0','0',0,0),
	(541,'Phoenix Hood','','head','true','none',NULL,590,'c',0,-1,0,58,0,0,412600,214,'true','armor_cloth_helmet_i00',1,1,1,'0','0',0,0),
	(542,'Cerberus Hood','','head','true','none',NULL,320,'b',0,-1,0,62,0,0,598600,103,'true','armor_cloth_helmet_i00',1,1,1,'0','0',0,0),
	(543,'Hood of Aid','','head','true','none',NULL,320,'c',0,-1,0,58,0,0,412600,214,'true','armor_cloth_helmet_i00',1,1,1,'0','0',0,0),
	(544,'Hood of Blessing','','head','true','none',NULL,320,'b',0,-1,0,62,0,0,598600,103,'true','armor_cloth_helmet_i00',1,1,1,'0','0',0,0),
	(545,'Flame Helm','','head','true','none',NULL,400,'c',0,-1,0,58,0,0,412600,214,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(546,'Helm of Bravery','','head','true','none',NULL,400,'b',0,-1,0,62,0,0,598600,103,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(547,'Tallum Helm','','head','true','none',NULL,570,'a',0,-1,0,69,0,0,1336000,107,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(548,'Absolute Helm','','head','true','none',NULL,400,'b',0,-1,0,62,0,0,598600,103,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(549,'Helm of Avadon','','head','true','none',NULL,400,'c',0,-1,0,58,0,0,412600,214,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(550,'Helm of Doom','','head','true','none',NULL,400,'b',0,-1,0,62,0,0,598600,103,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(551,'Helmet of Pledge','','head','true','none',NULL,400,'c',0,-1,0,58,0,0,412600,214,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(552,'Divine Helm','','head','true','none',NULL,400,'b',0,-1,0,62,0,0,598600,103,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(553,'Iron Boots','','feet','true','none',NULL,1280,'d',0,-1,0,24,0,0,39100,72,'true','armor_t10_b_i00',1,1,1,'0','0',0,0),
	(554,'Zubei\'s Boots','','feet','true','none',NULL,1180,'b',0,-1,0,41,0,0,399100,53,'true','armor_t64_b_i02',1,1,1,'0','0',0,0),
	(555,'Dragon Boots','','feet','true','none',NULL,1110,'a',0,-1,0,48,0,0,1355000,140,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(556,'Wolf Boots','','feet','true','none',NULL,1180,'b',0,-1,0,41,0,0,399100,69,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(557,'Shining Dragon Boots','','feet','true','none',NULL,1150,'b',0,-1,0,44,0,0,618800,107,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(558,'Boots of Victory','','feet','true','none',NULL,1180,'b',0,-1,0,41,0,0,399100,69,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(559,'Boots of Valor','','feet','true','none',NULL,1150,'b',0,-1,0,44,0,0,618800,107,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(560,'Glorious Boots','','feet','true','none',NULL,1180,'b',0,-1,0,41,0,0,399100,69,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(561,'Red Flame Boots','','feet','true','none',NULL,1120,'a',0,-1,0,45,0,0,890000,92,'true','armor_t14_b_i00',1,1,1,'0','0',0,0),
	(562,'Elven Crystal Boots','','feet','true','none',NULL,1180,'b',0,-1,0,41,0,0,399100,69,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(563,'Dark Crystal Boots','','feet','true','none',NULL,1110,'a',0,-1,0,45,0,0,890000,92,'true','armor_t15_b_i00',1,1,1,'0','0',0,0),
	(564,'Implosion Boots','','feet','true','none',NULL,1150,'b',0,-1,0,44,0,0,618800,107,'true','armor_t68_b_i00',1,1,1,'0','0',0,0),
	(565,'Dark Dragon Boots','','feet','true','none',NULL,1130,'b',0,-1,0,44,0,0,618800,107,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(566,'Elven Vagian Boots','','feet','true','none',NULL,1150,'b',0,-1,0,41,0,0,399100,69,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(567,'Dark Vagian Boots','','feet','true','none',NULL,1130,'b',0,-1,0,44,0,0,618800,107,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(568,'Composite Boots','','feet','true','none',NULL,200,'b',0,-1,0,41,0,0,399100,69,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(569,'Hell Boots','','feet','true','none',NULL,1130,'b',0,-1,0,44,0,0,618800,107,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(570,'Art of Boots','','feet','true','none',NULL,1150,'b',0,-1,0,41,0,0,399100,69,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(571,'Masterpiece Boots','','feet','true','none',NULL,1130,'b',0,-1,0,44,0,0,618800,107,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(572,'Boots of Silence','','feet','true','none',NULL,1190,'b',0,-1,0,41,0,0,399100,69,'true','armor_t65_b_i00',1,1,1,'0','0',0,0),
	(573,'Gust Boots','','feet','true','none',NULL,1120,'a',0,-1,0,45,0,0,890000,92,'true','armor_t45_b_i00',1,1,1,'0','0',0,0),
	(574,'Prairie Boots','','feet','true','none',NULL,1140,'b',0,-1,0,41,0,0,399100,69,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(575,'Boots of the Underworld','','feet','true','none',NULL,1110,'a',0,-1,0,45,0,0,890000,92,'true','armor_t10_b_i00',1,1,1,'0','0',0,0),
	(576,'Boots of Concentration','','feet','true','none',NULL,1170,'b',0,-1,0,41,0,0,399100,69,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(577,'Ace\'s Boots','','feet','true','none',NULL,1150,'b',0,-1,0,44,0,0,618800,107,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(578,'Guardian\'s Boots','','feet','true','none',NULL,1180,'b',0,-1,0,41,0,0,399100,69,'true','armor_t67_b_i00',1,1,1,'0','0',0,0),
	(579,'Marksman Boots','','feet','true','none',NULL,1150,'b',0,-1,0,44,0,0,618800,107,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(580,'Boots of Mana','','feet','true','none',NULL,1180,'b',0,-1,0,41,0,0,399100,69,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(581,'Sage\'s Boots','','feet','true','none',NULL,1150,'b',0,-1,0,44,0,0,618800,107,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(582,'Paradia Boots','','feet','true','none',NULL,1140,'b',0,-1,0,44,0,0,618800,107,'true','armor_t68_b_i00',1,1,1,'0','0',0,0),
	(583,'Majestic Boots','','feet','true','none',NULL,1110,'a',0,-1,0,48,0,0,1355000,140,'true','armor_t45_b_i00',1,1,1,'0','0',0,0),
	(584,'Boots of Solar Eclipse','','feet','true','none',NULL,1180,'b',0,-1,0,41,0,0,399100,69,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(585,'Boots of Black Ore','','feet','true','none',NULL,1200,'b',0,-1,0,44,0,0,618800,107,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(586,'Boots of Summoning','','feet','true','none',NULL,1170,'b',0,-1,0,41,0,0,399100,69,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(587,'Otherworldly Boots','','feet','true','none',NULL,1200,'b',0,-1,0,44,0,0,618800,107,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(588,'Elemental Boots','','feet','true','none',NULL,1130,'b',0,-1,0,44,0,0,618800,107,'true','armor_t71_b_i00',1,1,1,'0','0',0,0),
	(589,'Boots of Phantom','','feet','true','none',NULL,1120,'a',0,-1,0,48,0,0,1355000,140,'true','armor_t45_b_i00',1,1,1,'0','0',0,0),
	(590,'Boots of Grace','','feet','true','none',NULL,1130,'b',0,-1,0,44,0,0,618800,107,'true','armor_t71_b_i00',1,1,1,'0','0',0,0),
	(591,'Boots of Holy Spirit','','feet','true','none',NULL,1200,'b',0,-1,0,44,0,0,618800,107,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(592,'Phoenix Boots','','feet','true','none',NULL,1120,'a',0,-1,0,45,0,0,890000,92,'true','armor_t44_b_i00',1,1,1,'0','0',0,0),
	(593,'Cerberus Boots','','feet','true','none',NULL,1120,'a',0,-1,0,48,0,0,1355000,140,'true','armor_t44_b_i00',1,1,1,'0','0',0,0),
	(594,'Boots of Aid','','feet','true','none',NULL,1200,'b',0,-1,0,41,0,0,399100,69,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(595,'Boots of Blessing','','feet','true','none',NULL,1160,'b',0,-1,0,41,0,0,399100,69,'true','armor_t56_b_i00',1,1,1,'0','0',0,0),
	(596,'Flame Boots','','feet','true','none',NULL,1020,'b',0,-1,0,45,0,0,890000,154,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(597,'Boots of Bravery','','feet','true','none',NULL,1050,'b',0,-1,0,45,0,0,890000,154,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(598,'Blood Boots','','feet','true','none',NULL,1130,'a',0,-1,0,45,0,0,890000,92,'true','armor_t45_b_i00',1,1,1,'0','0',0,0),
	(599,'Absolute Boots','','feet','true','none',NULL,1130,'b',0,-1,0,45,0,0,890000,154,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(600,'Avadon Boots','','feet','true','none',NULL,1170,'b',0,-1,0,41,0,0,399100,53,'true','armor_t66_b_i02',1,1,1,'0','0',0,0),
	(601,'Boots of Doom','','feet','true','none',NULL,1130,'b',0,-1,0,44,0,0,618800,83,'true','armor_t71_b_i02',1,1,1,'0','0',0,0),
	(602,'Boots of Pledge','','feet','true','none',NULL,1130,'b',0,-1,0,45,0,0,890000,154,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(603,'Divine Boots','','feet','true','none',NULL,1200,'c',0,-1,0,39,0,0,275100,143,'true','armor_t67_b_i00',1,1,1,'0','0',0,0),
	(604,'Crafted Leather Gloves','','gloves','true','none',NULL,650,'d',0,-1,0,19,0,0,16100,30,'true','armor_t09_g_i00',1,1,1,'0','0',0,0),
	(605,'Leather Gauntlets','','gloves','true','none',NULL,640,'d',0,-1,0,22,0,0,25600,47,'true','armor_t18_g_i00',1,1,1,'0','0',0,0),
	(606,'Rip Gauntlets','','gloves','true','none',NULL,630,'d',0,-1,0,27,0,0,57400,106,'true','armor_t40_g_i00',1,1,1,'0','0',0,0),
	(607,'Ogre Power Gauntlets','','gloves','true','none',NULL,620,'d',0,-1,0,29,0,0,75200,139,'true','armor_t45_g_i00',1,1,1,'0','0',0,0),
	(608,'Mithril Gauntlets','','gloves','true','none',NULL,600,'c',0,-1,0,36,0,0,188800,76,'true','armor_t61_g_i00',1,1,1,'0','0',0,0),
	(609,'Gauntlets of Ghost','','gloves','true','none',NULL,1920,'c',0,-1,0,39,0,0,275100,143,'true','armor_gauntlet_i00',1,1,1,'0','0',0,0),
	(610,'Saint Knight\'s Gauntlets','','gloves','true','none',NULL,6400,'b',0,-1,0,41,0,0,399100,69,'true','armor_gauntlet_i00',1,1,1,'0','0',0,0),
	(611,'Soul Leech Gauntlets','','gloves','true','none',NULL,4800,'b',0,-1,0,44,0,0,618800,107,'true','armor_gauntlet_i00',1,1,1,'0','0',0,0),
	(612,'Zubei\'s Gauntlets','','gloves','true','none',NULL,590,'b',0,-1,0,41,0,0,399100,53,'true','armor_t64_g_i02',1,1,1,'0','0',0,0),
	(613,'Sand Dragon Gloves','','gloves','true','none',NULL,3200,'a',0,-1,0,48,0,0,1355000,140,'true','armor_gauntlet_i00',1,1,1,'0','0',0,0),
	(614,'Knight\'s Cloak','','back','true','none',NULL,240,'d',0,-1,0,7,0,0,20900,38,'true','armor_back04',0,1,0,'0','0',0,0),
	(615,'Cobweb Cloak','','back','true','none',NULL,240,'d',0,-1,0,8,0,0,33300,60,'true','armor_back05',1,1,1,'0','0',0,0),
	(616,'Cloak of Magic','','back','true','none',NULL,240,'d',0,-1,0,11,0,0,74700,135,'true','armor_back06',1,1,1,'0','0',0,0),
	(617,'Mithril Cloak','','back','true','none',NULL,240,'d',0,-1,0,11,0,0,97800,177,'true','armor_back07',1,1,1,'0','0',0,0),
	(618,'Cloak of Self Protection','','back','true','none',NULL,240,'c',0,-1,0,13,0,0,161000,64,'true','armor_back08',1,1,1,'0','0',0,0),
	(619,'(Not In Use) Ancient Cloak','','back','true','none',NULL,230,'c',0,-1,0,15,0,0,245000,98,'true','armor_back09',1,1,1,'0','0',0,0),
	(620,'Cloak of Protection','','back','true','none',NULL,230,'c',0,-1,0,16,0,0,358000,143,'true','armor_back09',1,1,1,'0','0',0,0),
	(621,'Cloak of Hell','','back','true','none',NULL,220,'b',0,-1,0,18,0,0,804000,107,'true','armor_back09',1,1,1,'0','0',0,0),
	(622,'(Not In Use) Holy Spirit\'s Cloak','','back','true','none',NULL,220,'a',0,-1,0,18,0,0,1160000,92,'true','armor_back09',1,1,1,'0','0',0,0),
	(623,'Divine Cloak','','back','true','none',NULL,220,'a',0,-1,0,19,0,0,1760000,140,'true','armor_back09',1,1,1,'0','0',0,0),
	(624,'Cloak of Invisibility','','back','false','none',NULL,260,'none',0,-1,0,2,0,0,37,0,'true','armor_back09',1,1,1,'0','0',0,0),
	(675,'Silk Yarn Undergarment Set','','underwear','false','none',NULL,170,'none',0,-1,0,6,0,0,1330,0,'true','armor_underwear01',1,1,1,'0','0',0,0),
	(676,'Pure White Undergarment Set','','underwear','false','none',NULL,160,'none',0,-1,0,9,0,0,6150,0,'true','armor_underwear01',1,1,1,'0','0',0,0),
	(677,'One-Piece Swimsuit','','underwear','true','none',NULL,150,'d',0,-1,0,10,0,0,10400,18,'true','armor_underwear01',1,1,1,'0','0',0,0),
	(678,'Bikini Set','','underwear','true','none',NULL,150,'d',0,-1,0,11,0,0,16700,30,'true','armor_underwear02',1,1,1,'0','0',0,0),
	(679,'Cursed Undergarment Set','','underwear','true','none',NULL,150,'d',0,-1,0,12,0,0,25400,46,'true','armor_underwear01',1,1,1,'0','0',0,0),
	(680,'Mithril Undergarment Set','','underwear','true','none',NULL,140,'c',0,-1,0,16,0,0,63100,25,'true','armor_underwear01',1,1,1,'0','0',0,0),
	(681,'Fascination Undergarment Set','','underwear','true','none',NULL,140,'c',0,-1,0,17,0,0,80500,32,'true','armor_underwear01',1,1,1,'0','0',0,0),
	(682,'Demon\'s Undergarment Set','','underwear','true','none',NULL,140,'c',0,-1,0,19,0,0,179000,71,'true','armor_underwear01',1,1,1,'0','0',0,0),
	(683,'Holy Undergarment Set','','underwear','true','none',NULL,140,'b',0,-1,0,22,0,0,402000,53,'true','armor_underwear01',1,1,1,'0','0',0,0),
	(684,'Underwear of Rule','','underwear','true','none',NULL,140,'a',0,-1,0,24,0,0,880000,70,'true','armor_underwear02',1,1,1,'0','0',0,0),
	(685,'Crystal Swimsuit Set','','underwear','true','none',NULL,130,'s',0,-1,0,26,0,0,1310000,65,'true','armor_underwear02',1,1,1,'0','0',0,0),
	(845,'Cat\'s Eye Earring','','rear,lear','false','none',NULL,150,'none',0,-1,0,0,19,0,6840,0,'true','accessary_catseye_earing_i00',1,1,1,'0','0',0,0),
	(846,'Coral Earring','','rear,lear','false','none',NULL,150,'none',0,-1,0,0,21,0,12300,0,'true','accessary_coral_earing_i00',1,1,1,'0','0',0,0),
	(847,'Red Crescent Earring','','rear,lear','true','none',NULL,150,'d',0,-1,0,0,24,0,20700,38,'true','accessary_red_cresent_earing_i00',1,1,1,'0','0',0,0),
	(848,'Enchanted Earring','','rear,lear','true','none',NULL,150,'d',0,-1,0,0,27,0,32800,61,'true','accessary_enchanted_earing_i00',1,1,1,'0','0',0,0),
	(849,'Tiger\'s Eye Earring','','rear,lear','true','none',NULL,150,'d',0,-1,0,0,30,0,49400,91,'true','accessary_tigerseye_earing_i00',1,1,1,'0','0',0,0),
	(850,'Elven Earring','','rear,lear','true','none',NULL,150,'d',0,-1,0,0,34,0,71900,133,'true','accessary_elven_earing_i00',1,1,1,'0','0',0,0),
	(851,'Omen Beast\'s Eye Earring','','rear,lear','true','none',NULL,150,'d',0,-1,0,0,36,0,93300,172,'true','accessary_onyxbeastseye_earing_i00',1,1,1,'0','0',0,0),
	(852,'Moonstone Earring','','rear,lear','true','none',NULL,150,'c',0,-1,0,0,39,0,119300,48,'true','accessary_moonstone_earing_i00',1,1,1,'0','0',0,0),
	(853,'Earring of Protection','','rear,lear','true','none',NULL,150,'c',0,-1,0,0,42,0,150500,60,'true','accessary_earing_of_protection_i00',1,1,1,'0','0',0,0),
	(854,'Earring of Binding','','rear,lear','true','none',NULL,150,'c',0,-1,0,0,45,0,226600,91,'true','accessary_earing_of_binding_i00',1,1,1,'0','0',0,0),
	(855,'Nassen\'s Earring','','rear,lear','true','none',NULL,150,'c',0,-1,0,0,48,0,325800,130,'true','accessary_nassens_earing_i00',1,1,1,'0','0',0,0),
	(856,'Adamantite Earring','','rear,lear','true','none',NULL,150,'b',0,-1,0,0,51,0,465900,62,'true','accessary_adamantite_earing_i00',1,1,1,'0','0',0,0),
	(857,'Blessed Earring','','rear,lear','true','none',NULL,150,'c',0,-1,0,0,48,0,325800,169,'true','accessary_blessed_earing_i00',1,1,1,'0','0',0,0),
	(858,'Tateossian Earring','','rear,lear','true','none',NULL,150,'s',0,-1,0,0,71,31,3270000,157,'true','accessory_tateossian_earring_i00',1,1,1,'0','0',0,0),
	(859,'Earring of Mana','','rear,lear','true','none',NULL,150,'b',0,-1,0,0,51,0,465900,80,'true','accessary_earing_of_mana_i00',1,1,1,'0','0',0,0),
	(860,'Sage\'s Earring','','rear,lear','true','none',NULL,150,'b',0,-1,0,0,54,0,711000,123,'true','accessary_sages_earing_i00',1,1,1,'0','0',0,0),
	(861,'Paradia Earring','','rear,lear','true','none',NULL,150,'b',0,-1,0,0,54,0,711000,123,'true','accessary_paradia_earing_i00',1,1,1,'0','0',0,0),
	(862,'Majestic Earring','','rear,lear','true','none',NULL,150,'a',0,-1,0,0,63,25,1498000,120,'true','accessary_inferno_earing_i00',1,1,1,'0','0',0,0),
	(863,'Earring of Solar Eclipse','','rear,lear','true','none',NULL,150,'b',0,-1,0,0,51,0,465900,80,'true','accessary_earing_of_sola_eclipse_i00',1,1,1,'0','0',0,0),
	(864,'Earring of Black Ore','','rear,lear','true','none',NULL,150,'b',0,-1,0,0,54,0,711000,95,'true','accessary_earing_of_black_ore_i00',1,1,1,'0','0',0,0),
	(865,'Earring of Summoning','','rear,lear','true','none',NULL,150,'b',0,-1,0,0,51,0,465900,80,'true','accessary_earing_of_summons_i00',1,1,1,'0','0',0,0),
	(866,'Otherworldly Earring','','rear,lear','true','none',NULL,150,'b',0,-1,0,0,54,0,711000,123,'true','accessary_another_worlds_earing_i00',1,1,1,'0','0',0,0),
	(867,'Elemental Earring','','rear,lear','true','none',NULL,150,'b',0,-1,0,0,54,0,711000,123,'true','accessary_elemental_earing_i00',1,1,1,'0','0',0,0),
	(868,'Earring of Phantom','','rear,lear','true','none',NULL,150,'a',0,-1,0,0,60,0,1498000,156,'true','accessary_earing_of_phantom_i00',1,1,1,'0','0',0,0),
	(869,'Earring of Grace','','rear,lear','true','none',NULL,150,'b',0,-1,0,0,51,0,465900,80,'true','accessary_earing_of_grace_i00',1,1,1,'0','0',0,0),
	(870,'Earring of Holy Spirit','','rear,lear','true','none',NULL,150,'b',0,-1,0,0,54,0,711000,123,'true','accessary_earing_of_holy_spirit_i00',1,1,1,'0','0',0,0),
	(871,'Phoenix Earring','','rear,lear','true','none',NULL,150,'a',0,-1,0,0,60,20,1005000,80,'true','accessary_phoenixs_earing_i00',1,1,1,'0','0',0,0),
	(872,'Cerberus Earring','','rear,lear','true','none',NULL,150,'a',0,-1,0,0,60,0,1498000,156,'true','accessary_cerberuss_earing_i00',1,1,1,'0','0',0,0),
	(873,'Earring of Aid','','rear,lear','true','none',NULL,150,'b',0,-1,0,0,51,0,465900,80,'true','accessary_earing_of_assistance_i00',1,1,1,'0','0',0,0),
	(874,'Earring of Blessing','','rear,lear','true','none',NULL,150,'b',0,-1,0,0,51,0,465900,80,'true','accessary_earing_of_blessing_i00',1,1,1,'0','0',0,0),
	(875,'Ring of Knowledge','','rfinger,lfinger','false','none',NULL,150,'none',0,-1,0,0,9,0,420,0,'true','accessary_ring_of_knowledge_i00',1,1,1,'0','0',0,0),
	(876,'Ring of Anguish','','rfinger,lfinger','false','none',NULL,150,'none',0,-1,0,0,11,0,1800,0,'true','accessary_ring_of_anguish_i00',1,1,1,'0','0',0,0),
	(877,'Ring of Wisdom','','rfinger,lfinger','false','none',NULL,150,'none',0,-1,0,0,12,0,4560,0,'true','accessary_ring_of_wisdom_i00',1,1,1,'0','0',0,0),
	(878,'Blue Coral Ring','','rfinger,lfinger','false','none',NULL,150,'none',0,-1,0,0,14,0,8200,0,'true','accessary_blue_coral_ring_i00',1,1,1,'0','0',0,0),
	(879,'Enchanted Ring','','rfinger,lfinger','true','none',NULL,150,'d',0,-1,0,0,18,0,21800,40,'true','accessary_enchanted_ring_i00',1,1,1,'0','0',0,0),
	(880,'Black Pearl Ring','','rfinger,lfinger','true','none',NULL,150,'d',0,-1,0,0,20,0,33000,61,'true','accessary_black_pearl_ring_i00',1,1,1,'0','0',0,0),
	(881,'Elven Ring','','rfinger,lfinger','true','none',NULL,150,'d',0,-1,0,0,22,0,47900,88,'true','accessary_elven_ring_i00',1,1,1,'0','0',0,0),
	(882,'Mithril Ring','','rfinger,lfinger','true','none',NULL,150,'d',0,-1,0,0,24,0,62200,115,'true','accessary_mithril_ring_i00',1,1,1,'0','0',0,0),
	(883,'Aquastone Ring','','rfinger,lfinger','true','none',NULL,150,'c',0,-1,0,0,26,0,79500,32,'true','accessary_aquastone_ring_i00',1,1,1,'0','0',0,0),
	(884,'Ring of Protection','','rfinger,lfinger','true','none',NULL,150,'c',0,-1,0,0,28,0,100300,40,'true','accessary_ring_of_protection_i00',1,1,1,'0','0',0,0),
	(885,'Ring of Ages','','rfinger,lfinger','true','none',NULL,150,'c',0,-1,0,0,30,0,151100,60,'true','accessary_ring_of_ages_i00',1,1,1,'0','0',0,0),
	(886,'Ring of Binding','','rfinger,lfinger','true','none',NULL,150,'c',0,-1,0,0,32,0,217200,87,'true','accessary_ring_of_binding_i00',1,1,1,'0','0',0,0),
	(887,'Adamantite Ring','','rfinger,lfinger','true','none',NULL,150,'b',0,-1,0,0,34,0,310600,41,'true','accessary_adamantite_ring_i00',1,1,1,'0','0',0,0),
	(888,'Blessed Ring','','rfinger,lfinger','true','none',NULL,150,'c',0,-1,0,0,32,0,217200,112,'true','accessary_blessed_ring_i00',1,1,1,'0','0',0,0),
	(889,'Tateossian Ring','','rfinger,lfinger','true','none',NULL,150,'s',0,-1,0,0,48,21,2180000,105,'true','accessory_tateossian_ring_i00',1,1,1,'0','0',0,0),
	(890,'Ring of Devotion','','rfinger,lfinger','true','none',NULL,150,'d',0,-1,0,0,16,0,13800,25,'true','accessary_ring_of_devotion_i00',1,1,1,'0','0',0,0),
	(891,'Sage\'s Ring','','rfinger,lfinger','true','none',NULL,150,'b',0,-1,0,0,36,0,474000,82,'true','accessary_sages_ring_i00',1,1,1,'0','0',0,0),
	(892,'Paradia Ring','','rfinger,lfinger','true','none',NULL,150,'b',0,-1,0,0,36,0,474000,82,'true','accessary_paradia_ring_i00',1,1,1,'0','0',0,0),
	(893,'Majestic Ring','','rfinger,lfinger','true','none',NULL,150,'a',0,-1,0,0,42,17,999000,80,'true','accessary_inferno_ring_i00',1,1,1,'0','0',0,0),
	(894,'Ring of Solar Eclipse','','rfinger,lfinger','true','none',NULL,150,'b',0,-1,0,0,34,0,310600,53,'true','accessary_ring_of_sola_eclipse_i00',1,1,1,'0','0',0,0),
	(895,'Ring of Black Ore','','rfinger,lfinger','true','none',NULL,150,'b',0,-1,0,0,36,0,474000,63,'true','accessary_ring_of_black_ore_i00',1,1,1,'0','0',0,0),
	(896,'Ring of Summoning','','rfinger,lfinger','true','none',NULL,150,'b',0,-1,0,0,34,0,310600,53,'true','accessary_ring_of_summons_i00',1,1,1,'0','0',0,0),
	(897,'Otherworldly Ring','','rfinger,lfinger','true','none',NULL,150,'b',0,-1,0,0,36,0,474000,82,'true','accessary_another_worlds_ring_i00',1,1,1,'0','0',0,0),
	(898,'Elemental Ring','','rfinger,lfinger','true','none',NULL,150,'b',0,-1,0,0,36,0,474000,82,'true','accessary_elemental_ring_i00',1,1,1,'0','0',0,0),
	(899,'Ring of Phantom','','rfinger,lfinger','true','none',NULL,150,'a',0,-1,0,0,40,0,999000,104,'true','accessary_ring_of_phantom_i00',1,1,1,'0','0',0,0),
	(900,'Ring of Grace','','rfinger,lfinger','true','none',NULL,150,'b',0,-1,0,0,34,0,310600,53,'true','accessary_ring_of_grace_i00',1,1,1,'0','0',0,0),
	(901,'Ring of Holy Spirit','','rfinger,lfinger','true','none',NULL,150,'b',0,-1,0,0,36,0,474000,82,'true','accessary_ring_of_holy_spirit_i00',1,1,1,'0','0',0,0),
	(902,'Phoenix Ring','','rfinger,lfinger','true','none',NULL,150,'a',0,-1,0,0,40,13,670000,54,'true','accessary_phoenixs_ring_i00',1,1,1,'0','0',0,0),
	(903,'Cerberus Ring','','rfinger,lfinger','true','none',NULL,150,'a',0,-1,0,0,40,0,999000,104,'true','accessary_cerberuss_ring_i00',1,1,1,'0','0',0,0),
	(904,'Ring of Aid','','rfinger,lfinger','true','none',NULL,150,'b',0,-1,0,0,34,0,310600,53,'true','accessary_ring_of_assistance_i00',1,1,1,'0','0',0,0),
	(905,'Ring of Blessing','','rfinger,lfinger','true','none',NULL,150,'b',0,-1,0,0,34,0,310600,53,'true','accessary_ring_of_blessing_i00',1,1,1,'0','0',0,0),
	(906,'Necklace of Knowledge','','neck','false','none',NULL,150,'none',0,-1,0,0,18,0,830,0,'true','accessary_necklace_of_knowledge_i00',1,1,1,'0','0',0,0),
	(907,'Necklace of Anguish','','neck','false','none',NULL,150,'none',0,-1,0,0,21,0,3600,0,'true','accessary_necklace_of_anguish_i00',1,1,1,'0','0',0,0),
	(908,'Necklace of Wisdom','','neck','false','none',NULL,150,'none',0,-1,0,0,25,0,9120,0,'true','accessary_necklace_of_wisdom_i00',1,1,1,'0','0',0,0),
	(909,'Blue Diamond Necklace','','neck','false','none',NULL,150,'none',0,-1,0,0,28,0,16400,0,'true','accessary_blue_diamond_necklace_i00',1,1,1,'0','0',0,0),
	(910,'Necklace of Devotion','','neck','true','none',NULL,150,'d',0,-1,0,0,32,0,27600,51,'true','accessary_necklace_of_devotion_i00',1,1,1,'0','0',0,0),
	(911,'Enchanted Necklace','','neck','true','none',NULL,150,'d',0,-1,0,0,36,0,43700,81,'true','accessary_enchanted_necklace_i00',1,1,1,'0','0',0,0),
	(912,'Near Forest Necklace','','neck','true','none',NULL,150,'d',0,-1,0,0,40,0,65900,122,'true','accessary_near_forest_necklace_i00',1,1,1,'0','0',0,0),
	(913,'Elven Necklace','','neck','true','none',NULL,150,'d',0,-1,0,0,45,0,95800,177,'true','accessary_elven_necklace_i00',1,1,1,'0','0',0,0),
	(914,'Necklace of Darkness','','neck','true','none',NULL,150,'d',0,-1,0,0,48,0,124400,230,'true','accessary_necklace_of_darkness_i00',1,1,1,'0','0',0,0),
	(915,'Aquastone Necklace','','neck','true','none',NULL,150,'c',0,-1,0,0,52,0,159000,64,'true','accessary_aquastone_necklace_i00',1,1,1,'0','0',0,0),
	(916,'Necklace of Protection','','neck','true','none',NULL,150,'c',0,-1,0,0,56,0,200600,80,'true','accessary_necklace_of_protection_i00',1,1,1,'0','0',0,0),
	(917,'Necklace of Mermaid','','neck','true','none',NULL,150,'c',0,-1,0,0,60,0,302100,121,'true','accessary_necklace_of_mermaid_i00',1,1,1,'0','0',0,0),
	(918,'Adamantite Necklace','','neck','true','none',NULL,150,'b',0,-1,0,0,68,0,621200,83,'true','accessary_adamantite_necklace_i00',1,1,1,'0','0',0,0),
	(919,'Blessed Necklace','','neck','true','none',NULL,150,'c',0,-1,0,0,64,0,434400,226,'true','accessary_blessed_necklace_i00',1,1,1,'0','0',0,0),
	(920,'Tateossian Necklace','','neck','true','none',NULL,150,'s',0,-1,0,0,95,42,4361000,209,'true','accessory_tateossian_necklace_i00',1,1,1,'0','0',0,0),
	(921,'Necklace of Mana','','neck','true','none',NULL,150,'b',0,-1,0,0,68,0,621200,107,'true','accessary_necklace_of_mana_i00',1,1,1,'0','0',0,0),
	(922,'Sage\'s Necklace','','neck','true','none',NULL,150,'b',0,-1,0,0,72,0,948000,164,'true','accessary_sages_necklace_i00',1,1,1,'0','0',0,0),
	(923,'Paradia Necklace','','neck','true','none',NULL,150,'b',0,-1,0,0,72,0,948000,164,'true','accessary_paradia_necklace_i00',1,1,1,'0','0',0,0),
	(924,'Majestic Necklace','','neck','true','none',NULL,150,'a',0,-1,0,0,85,33,1998000,160,'true','accessary_inferno_necklace_i00',1,1,1,'0','0',0,0),
	(925,'Necklace of Solar Eclipse','','neck','true','none',NULL,150,'b',0,-1,0,0,68,0,621200,107,'true','accessary_necklace_of_sola_eclipse_i00',1,1,1,'0','0',0,0),
	(926,'Necklace of Black Ore','','neck','true','none',NULL,150,'b',0,-1,0,0,72,0,948000,126,'true','accessary_necklace_of_black_ore_i00',1,1,1,'0','0',0,0),
	(927,'Necklace of Summoning','','neck','true','none',NULL,150,'b',0,-1,0,0,68,0,621200,107,'true','accessary_necklace_of_summons_i00',1,1,1,'0','0',0,0),
	(928,'Otherworldly Necklace','','neck','true','none',NULL,150,'b',0,-1,0,0,72,0,948000,164,'true','accessary_another_worlds_necklace_i00',1,1,1,'0','0',0,0),
	(929,'Elemental Necklace','','neck','true','none',NULL,150,'b',0,-1,0,0,72,0,948000,164,'true','accessary_elemental_necklace_i00',1,1,1,'0','0',0,0),
	(930,'Necklace of Phantom','','neck','true','none',NULL,150,'a',0,-1,0,0,80,0,1998000,208,'true','accessary_necklace_of_phantom_i00',1,1,1,'0','0',0,0),
	(931,'Necklace of Grace','','neck','true','none',NULL,150,'b',0,-1,0,0,68,0,621200,83,'true','accessary_necklace_of_grace_i00',1,1,1,'0','0',0,0),
	(932,'Necklace of Holy Spirit','','neck','true','none',NULL,150,'b',0,-1,0,0,72,0,948000,164,'true','accessary_necklace_of_holy_spirit_i00',1,1,1,'0','0',0,0),
	(933,'Phoenix Necklace','','neck','true','none',NULL,150,'a',0,-1,0,0,80,26,1340000,107,'true','accessary_phoenixs_necklace_i00',1,1,1,'0','0',0,0),
	(934,'Cerberus Necklace','','neck','true','none',NULL,150,'a',0,-1,0,0,80,0,1998000,208,'true','accessary_cerberuss_necklace_i00',1,1,1,'0','0',0,0),
	(935,'Necklace of Aid','','neck','true','none',NULL,150,'b',0,-1,0,0,68,0,621200,107,'true','accessary_necklace_of_assistance_i00',1,1,1,'0','0',0,0),
	(936,'Necklace of Blessing','','neck','true','none',NULL,150,'b',0,-1,0,0,68,0,621200,107,'true','accessary_necklace_of_blessing_i00',1,1,1,'0','0',0,0),
	(990,'Mandragora Essence','','gloves','false','none',NULL,60,'none',0,-1,0,9,0,0,28,0,'true','item_canuse27',1,1,1,'0','0',0,0),
	(991,'Royen\'s Key','','gloves','false','none',NULL,60,'none',0,-1,0,9,0,0,28,0,'true','item_normal26',1,1,1,'0','0',0,0),
	(992,'Shilen\'s 1st Mark','','gloves','false','none',NULL,60,'none',0,-1,0,9,0,0,28,0,'true','armor_head15',1,1,1,'0','0',0,0),
	(993,'Shilen\'s 2nd Mark','','gloves','false','none',NULL,60,'none',0,-1,0,9,0,0,28,0,'true','armor_head15',1,1,1,'0','0',0,0),
	(994,'Eye of Abyss','','gloves','false','none',NULL,60,'none',0,-1,0,9,0,0,28,0,'true','item_normal46',1,1,1,'0','0',0,0),
	(995,'Wanted Poster','','gloves','false','none',NULL,60,'none',0,-1,0,9,0,0,28,0,'true','item_normal20',1,1,1,'0','0',0,0),
	(996,'Alex\'s Dagger','','gloves','false','none',NULL,60,'none',0,-1,0,9,0,0,28,0,'true','weapon_ss08',1,1,1,'0','0',0,0),
	(997,'Pinter\'s Bill','','gloves','false','none',NULL,60,'none',0,-1,0,9,0,0,28,0,'true','item_normal50',1,1,1,'0','0',0,0),
	(998,'Book of Aklantoth - Part 1','','gloves','false','none',NULL,60,'none',0,-1,0,9,0,0,28,0,'true','item_normal07',1,1,1,'0','0',0,0),
	(999,'Book of Aklantoth - Part 2','','gloves','false','none',NULL,60,'none',0,-1,0,9,0,0,28,0,'true','item_normal07',1,1,1,'0','0',0,0),
	(1000,'Book of Aklantoth - Part 3','','gloves','false','none',NULL,60,'none',0,-1,0,9,0,0,28,0,'true','item_normal07',1,1,1,'0','0',0,0),
	(1100,'Cotton Tunic','','chest','false','magic',NULL,2120,'none',0,-1,0,21,0,38,1870,0,'true','armor_t50_u_i00',1,1,1,'0','0',0,0),
	(1101,'Tunic of Devotion','','chest','false','magic',NULL,2090,'none',0,-1,0,30,0,67,15600,0,'true','armor_t55_u_i00',1,1,1,'0','0',0,0),
	(1102,'Tunic of Magic','','chest','false','magic',NULL,2080,'none',0,-1,0,34,0,86,28400,0,'true','armor_t58_u_i00',1,1,1,'0','0',0,0),
	(1103,'Cotton Stockings','','legs','false','magic',NULL,1060,'none',0,-1,0,13,0,23,1170,0,'true','armor_t50_l_i00',1,1,1,'0','0',0,0),
	(1104,'Stockings of Devotion','','legs','false','magic',NULL,1040,'none',0,-1,0,19,0,42,9770,0,'true','armor_t55_l_i00',1,1,1,'0','0',0,0),
	(1105,'Stockings of Magic','','legs','false','magic',NULL,1030,'none',0,-1,0,21,0,54,17700,0,'true','armor_t58_l_i00',1,1,1,'0','0',0,0),
	(1119,'Short Leather Gloves','','gloves','false','none',NULL,660,'none',0,-1,0,11,0,0,470,0,'true','armor_t04_g_i00',1,1,1,'0','0',0,0),
	(1120,'Pa\'agrian Hand','','gloves','true','none',NULL,1600,'c',0,-1,0,34,0,0,123900,64,'true','armor_short_leather_gloves_i00',1,1,1,'0','0',0,0),
	(1121,'Apprentice\'s Shoes','','feet','false','none',NULL,1320,'none',0,-1,0,8,0,0,5,0,'true','armor_t01_b_i00',1,1,1,'0','0',0,0),
	(1122,'Cotton Shoes','','feet','false','none',NULL,1320,'none',0,-1,0,11,0,0,470,0,'true','armor_t50_b_i00',1,1,1,'0','0',0,0),
	(1123,'Blue Buckskin Boots','','feet','true','none',NULL,1300,'d',0,-1,0,22,0,0,25600,47,'true','armor_t18_b_i00',1,1,1,'0','0',0,0),
	(1124,'Boots of Power','','feet','true','none',NULL,1250,'d',0,-1,0,27,0,0,57400,106,'true','armor_t40_b_i00',1,1,1,'0','0',0,0),
	(1125,'Assault Boots','','feet','true','none',NULL,1240,'d',0,-1,0,29,0,0,75200,139,'true','armor_t44_b_i00',1,1,1,'0','0',0,0),
	(1126,'Crimson Boots','','feet','true','none',NULL,1210,'c',0,-1,0,34,0,0,123900,50,'true','armor_t57_b_i00',1,1,1,'0','0',0,0),
	(1127,'Forgotten Boots','','feet','true','none',NULL,4000,'c',0,-1,0,36,0,0,188800,98,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(1128,'Adamantite Boots','','feet','true','none',NULL,4000,'c',0,-1,0,39,0,0,275100,143,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(1129,'Crude Leather Shoes','','feet','false','none',NULL,1320,'none',0,-1,0,11,0,0,470,0,'true','armor_t04_b_i00',1,1,1,'0','0',0,0),
	(1146,'Squire\'s Shirt','','chest','false','light',NULL,3301,'none',0,-1,0,33,0,0,20,0,'false','armor_t01_u_i00',0,1,0,'0','0',0,0),
	(1147,'Squire\'s Pants','','legs','false','light',NULL,1750,'none',0,-1,0,20,0,0,4,0,'false','armor_t01_l_i00',0,1,0,'0','0',0,0),
	(1148,'Hard Leather Helmet','','head','false','none',NULL,640,'none',0,-1,0,26,0,0,14200,0,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(1149,'Shining Circlet','','head','true','none',NULL,600,'c',0,-1,0,54,0,0,283200,113,'true','armor_circlet_i00',1,1,1,'0','0',0,0),
	(1308,'Compound Scale Mail','','chest','false','heavy',NULL,1400,'none',0,-1,0,51,0,0,190200,0,'true','weapon_voodoo_doll_i00',1,1,1,'0','0',0,0),
	(1309,'Mithril Breastplate','','chest','false','heavy',NULL,1000,'none',0,-1,0,51,0,0,190200,0,'true','weapon_voodoo_doll_i00',1,1,1,'0','0',0,0),
	(1310,'Tunic of Magic','','chest','false','magic',NULL,150,'none',0,-1,0,51,0,96,37300,0,'true','weapon_voodoo_doll_i00',1,1,1,'0','0',0,0),
	(1311,'Puma Skin Shirt','','chest','false','light',NULL,300,'none',0,-1,0,51,0,0,76900,0,'true','weapon_voodoo_doll_i00',1,1,1,'0','0',0,0),
	(1312,'White Tunic','','chest','false','magic',NULL,150,'none',0,-1,0,51,0,142,106000,0,'true','weapon_voodoo_doll_i00',1,1,1,'0','0',0,0),
	(1313,'Compound Scale Gaiters','','legs','false','heavy',NULL,1000,'none',0,-1,0,32,0,0,130800,0,'true','weapon_voodoo_doll_i00',1,1,1,'0','0',0,0),
	(1314,'Mithril Gaiters','','legs','false','heavy',NULL,600,'none',0,-1,0,32,0,0,130800,0,'true','weapon_voodoo_doll_i00',1,1,1,'0','0',0,0),
	(1315,'Stockings of Magic','','legs','false','magic',NULL,150,'none',0,-1,0,32,0,60,23300,0,'true','weapon_voodoo_doll_i00',1,1,1,'0','0',0,0),
	(1316,'Puma Skin Gaiters','','legs','false','light',NULL,400,'none',0,-1,0,32,0,0,43000,0,'true','weapon_voodoo_doll_i00',1,1,1,'0','0',0,0),
	(1317,'Dark Stockings','','legs','false','magic',NULL,150,'none',0,-1,0,32,0,79,48000,0,'true','weapon_voodoo_doll_i00',1,1,1,'0','0',0,0),
	(1318,'Gloves','','gloves','false','none',NULL,80,'none',0,-1,0,14,0,0,2520,0,'true','armor_gauntlet_i00',1,1,1,'0','0',0,0),
	(1319,'Leather Gloves','','gloves','false','none',NULL,100,'none',0,-1,0,14,0,0,6100,0,'true','armor_gauntlet_i00',1,1,1,'0','0',0,0),
	(1320,'Crafted Leather Gloves','','gloves','false','none',NULL,100,'none',0,-1,0,14,0,0,22900,0,'true','armor_gauntlet_i00',1,1,1,'0','0',0,0),
	(1321,'Rip Gauntlets','','gloves','false','none',NULL,150,'none',0,-1,0,14,0,0,75200,0,'true','armor_gauntlet_i00',1,1,1,'0','0',0,0),
	(1322,'Bracer','','gloves','false','none',NULL,80,'none',0,-1,0,14,0,0,12400,0,'true','armor_gauntlet_i00',1,1,1,'0','0',0,0),
	(1323,'Leather Shoes','','feet','false','none',NULL,120,'none',0,-1,0,14,0,0,2520,0,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(1324,'Low Boots','','feet','false','none',NULL,150,'none',0,-1,0,14,0,0,6100,0,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(1325,'Leather Boots','','feet','false','none',NULL,250,'none',0,-1,0,14,0,0,22900,0,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(1326,'Iron Boots','','feet','false','none',NULL,300,'none',0,-1,0,14,0,0,57400,0,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(1327,'Boots','','feet','false','none',NULL,200,'none',0,-1,0,14,0,0,12400,0,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(1506,'Necklace of Courage','','neck','false','none',NULL,150,'none',0,-1,0,0,15,0,51,0,'true','accessary_necklace_of_courage_i00',1,1,1,'0','0',0,0),
	(1507,'Necklace of Valor','','neck','false','none',NULL,150,'none',0,-1,0,0,21,0,3600,0,'true','accessary_necklace_of_valor_i00',1,1,1,'0','0',0,0),
	(1508,'Ring of Raccoon','','rfinger,lfinger','false','none',NULL,150,'none',0,-1,0,0,11,0,1800,0,'true','accessary_ring_of_raccoon_i00',1,1,1,'0','0',0,0),
	(1509,'Ring of Firefly','','rfinger,lfinger','false','none',NULL,150,'none',0,-1,0,0,11,0,1800,0,'true','accessary_ring_of_firefly_i00',1,1,1,'0','0',0,0),
	(2376,'Avadon Breastplate','','chest','true','heavy',NULL,7920,'b',0,-1,0,157,0,0,1596000,213,'true','armor_t66_u_i00',1,1,1,'0','0',0,0),
	(2377,'Mithril Scale Gaiters','','legs','true','heavy',NULL,3870,'d',0,-1,0,64,0,0,143600,265,'true','armor_t40_l_i00',1,1,1,'0','0',0,0),
	(2378,'Brigandine Gaiters','','legs','true','heavy',NULL,3820,'d',0,-1,0,64,0,0,143600,265,'true','armor_t43_l_i00',1,1,1,'0','0',0,0),
	(2379,'Avadon Gaiters','','legs','true','heavy',NULL,3520,'b',0,-1,0,98,0,0,997700,133,'true','armor_t66_l_i00',1,1,1,'0','0',0,0),
	(2380,'Blue Wolf Gaiters','','legs','true','heavy',NULL,3370,'b',0,-1,0,104,0,0,1547100,206,'true','armor_t68_l_i00',1,1,1,'0','0',0,0),
	(2381,'Doom Plate Armor','','fullarmor','true','heavy',NULL,9980,'b',0,-1,0,270,0,0,4022000,536,'true','armor_t71_ul_i00',1,1,1,'0','0',0,0),
	(2382,'Tallum Plate Armor','','fullarmor','true','heavy',NULL,9780,'a',0,-1,0,278,0,0,5788000,463,'true','armor_t77_ul_i00',1,1,1,'0','0',0,0),
	(2383,'Majestic Plate Armor','','fullarmor','true','heavy',NULL,9200,'a',0,-1,0,293,0,0,8804000,704,'true','armor_t83_ul_i00',1,1,1,'0','0',0,0),
	(2384,'Zubei\'s Leather Shirt','','chest','true','light',NULL,4330,'b',0,-1,0,117,0,0,1197000,160,'true','armor_t65_u_i00',1,1,1,'0','0',0,0),
	(2385,'Dark Crystal Leather Armor','','chest','true','light',NULL,4300,'a',0,-1,0,128,0,0,2671000,214,'true','armor_t75_u_i00',1,1,1,'0','0',0,0),
	(2386,'Wooden Gaiters','','legs','false','light',NULL,1670,'none',0,-1,0,29,0,0,3820,0,'true','armor_t06_l_i00',1,1,1,'0','0',0,0),
	(2387,'Tempered Mithril Gaiters','','legs','true','light',NULL,1530,'c',0,-1,0,56,0,0,182100,73,'true','armor_t47_l_i00',1,1,1,'0','0',0,0),
	(2388,'Zubei\'s Leather Gaiters','','legs','true','light',NULL,1480,'b',0,-1,0,73,0,0,748300,100,'true','armor_t65_l_i00',1,1,1,'0','0',0,0),
	(2389,'Dark Crystal Leggings','','legs','true','light',NULL,1480,'a',0,-1,0,80,0,0,1670000,134,'true','armor_t75_l_i00',1,1,1,'0','0',0,0),
	(2390,'Avadon Leather Armor','','fullarmor','true','light',NULL,5600,'b',0,-1,0,191,0,0,1946000,259,'true','armor_t67_ul_i00',1,1,1,'0','0',0,0),
	(2391,'Blue Wolf Leather Armor','','fullarmor','true','light',NULL,5500,'b',0,-1,0,202,0,0,3017000,402,'true','armor_t69_ul_i00',1,1,1,'0','0',0,0),
	(2392,'Leather Armor of Doom','','fullarmor','true','light',NULL,5500,'b',0,-1,0,202,0,0,3017000,402,'true','armor_t72_ul_i00',1,1,1,'0','0',0,0),
	(2393,'Tallum Leather Armor','','fullarmor','true','light',NULL,5400,'a',0,-1,0,209,0,0,4341000,347,'true','armor_t78_ul_i00',1,1,1,'0','0',0,0),
	(2394,'Nightmarish Leather Armor','','fullarmor','true','light',NULL,5300,'a',0,-1,0,220,0,0,6603000,528,'true','armor_t81_ul_i00',1,1,1,'0','0',0,0),
	(2395,'Majestic Leather Armor','','fullarmor','true','light',NULL,5350,'a',0,-1,0,220,0,0,6603000,528,'true','armor_t84_ul_i00',1,1,1,'0','0',0,0),
	(2396,'Elven Mithril Tunic','','chest','true','magic',NULL,720,'d',0,-1,0,54,0,169,172000,318,'true','armor_elven_tunic_i00',1,1,1,'0','0',0,0),
	(2397,'Tunic of Zubei','','chest','true','magic',NULL,1960,'b',0,-1,0,78,0,345,1197000,160,'true','armor_t56_u_i00',1,1,1,'0','0',0,0),
	(2398,'Blue Wolf Tunic','','chest','true','magic',NULL,1920,'b',0,-1,0,83,0,377,1857000,248,'true','armor_t70_u_i00',1,1,1,'0','0',0,0),
	(2399,'Tunic of Doom','','chest','true','magic',NULL,1900,'b',0,-1,0,83,0,377,1857000,248,'true','armor_t73_u_i00',1,1,1,'0','0',0,0),
	(2400,'Tallum Tunic','','chest','true','magic',NULL,1860,'a',0,-1,0,86,0,409,2671000,214,'true','armor_t79_u_i00',1,1,1,'0','0',0,0),
	(2401,'Elven Mithril Stockings','','legs','true','magic',NULL,2400,'d',0,-1,0,34,0,105,107700,199,'true','armor_elven_hose_i00',1,1,1,'0','0',0,0),
	(2402,'Stockings of Zubei','','legs','true','magic',NULL,940,'b',0,-1,0,49,0,216,748300,100,'true','armor_t56_l_i00',1,1,1,'0','0',0,0),
	(2403,'Blue Wolf Stockings','','legs','true','magic',NULL,920,'b',0,-1,0,52,0,236,1160300,155,'true','armor_t70_l_i00',1,1,1,'0','0',0,0),
	(2404,'Stockings of Doom','','legs','true','magic',NULL,910,'b',0,-1,0,52,0,236,1160300,155,'true','armor_t73_l_i00',1,1,1,'0','0',0,0),
	(2405,'Tallum Stockings','','legs','true','magic',NULL,920,'a',0,-1,0,53,0,256,1670000,134,'true','armor_t79_l_i00',1,1,1,'0','0',0,0),
	(2406,'Avadon Robe','','fullarmor','true','magic',NULL,2540,'b',0,-1,0,127,0,561,1946000,259,'true','armor_t59_ul_i00',1,1,1,'0','0',0,0),
	(2407,'Dark Crystal Robe','','fullarmor','true','magic',NULL,2450,'a',0,-1,0,139,0,665,4341000,347,'true','armor_t76_ul_i00',1,1,1,'0','0',0,0),
	(2408,'Nightmare Robe','','fullarmor','true','magic',NULL,2300,'a',0,-1,0,147,0,718,6603000,528,'true','armor_t82_ul_i00',1,1,1,'0','0',0,0),
	(2409,'Majestic Robe','','fullarmor','true','magic',NULL,2330,'a',0,-1,0,147,0,718,6603000,528,'true','armor_t85_ul_i00',1,1,1,'0','0',0,0),
	(2410,'Nightmarish Tattoo','','underwear','true','none',NULL,3600,'a',0,-1,0,139,0,0,4064000,422,'true','armor_mithril_banded_mail_i00',1,1,1,'0','0',0,0),
	(2411,'Brigandine Helmet','','head','true','none',NULL,630,'d',0,-1,0,41,0,0,86100,159,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(2412,'Plate Helmet','','head','true','none',NULL,630,'d',0,-1,0,44,0,0,112800,208,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(2413,'Chain Hood','','head','true','none',NULL,620,'c',0,-1,0,47,0,0,145700,58,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(2414,'Full Plate Helmet','','head','true','none',NULL,600,'c',0,-1,0,58,0,0,412600,165,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(2415,'Avadon Circlet','','head','true','none',NULL,590,'b',0,-1,0,62,0,0,598600,80,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(2416,'Blue Wolf Helmet','','head','true','none',NULL,580,'b',0,-1,0,66,0,0,928300,124,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(2417,'Doom Helmet','','head','true','none',NULL,580,'b',0,-1,0,66,0,0,928300,124,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(2418,'Helm of Nightmare','','head','true','none',NULL,560,'a',0,-1,0,73,0,0,2032000,163,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(2419,'Majestic Circlet','','head','true','none',NULL,550,'a',0,-1,0,73,0,0,2032000,163,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(2420,'Dragon Headgear','','head','true','none',NULL,540,'s',0,-1,0,77,0,0,2784000,179,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(2421,'The Hood','','head','true','none',NULL,540,'s',0,-1,0,77,0,0,2784000,179,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(2422,'Reinforced Leather Boots','','feet','true','none',NULL,1280,'d',0,-1,0,24,0,0,39100,72,'true','armor_t13_b_i00',1,1,1,'0','0',0,0),
	(2423,'Boots of Knowledge','','feet','true','none',NULL,1270,'d',0,-1,0,24,0,0,39100,72,'true','armor_t41_b_i00',1,1,1,'0','0',0,0),
	(2424,'Manticore Skin Boots','','feet','true','none',NULL,1260,'d',0,-1,0,27,0,0,57400,106,'true','armor_t42_b_i00',1,1,1,'0','0',0,0),
	(2425,'Brigandine Boots','','feet','true','none',NULL,1250,'d',0,-1,0,27,0,0,57400,106,'true','armor_t43_b_i00',1,1,1,'0','0',0,0),
	(2426,'Elven Mithril Boots','','feet','true','none',NULL,1250,'d',0,-1,0,27,0,0,57400,106,'true','armor_t51_b_i00',1,1,1,'0','0',0,0),
	(2427,'Salamander Skin Boots','','feet','true','none',NULL,1230,'d',0,-1,0,29,0,0,75200,139,'true','armor_t45_b_i00',1,1,1,'0','0',0,0),
	(2428,'Plate Boots','','feet','true','none',NULL,1240,'d',0,-1,0,29,0,0,75200,139,'true','armor_t46_b_i00',1,1,1,'0','0',0,0),
	(2429,'Chain Boots','','feet','true','none',NULL,1220,'c',0,-1,0,32,0,0,97100,39,'true','armor_t48_b_i00',1,1,1,'0','0',0,0),
	(2430,'Karmian Boots','','feet','true','none',NULL,1230,'c',0,-1,0,32,0,0,97100,39,'true','armor_t53_b_i00',1,1,1,'0','0',0,0),
	(2431,'Plated Leather Boots','','feet','true','none',NULL,1220,'c',0,-1,0,32,0,0,97100,39,'true','armor_t47_b_i00',1,1,1,'0','0',0,0),
	(2432,'Dwarven Chain Boots','','feet','true','none',NULL,1210,'c',0,-1,0,32,0,0,97100,39,'true','armor_t60_b_i00',1,1,1,'0','0',0,0),
	(2433,'Boots of Seal','','feet','true','none',NULL,1220,'c',0,-1,0,32,0,0,97100,39,'true','armor_t44_b_i00',1,1,1,'0','0',0,0),
	(2434,'Rind Leather Boots','','feet','true','none',NULL,1220,'c',0,-1,0,34,0,0,123900,50,'true','armor_t49_b_i00',1,1,1,'0','0',0,0),
	(2435,'Demon\'s Boots','','feet','true','none',NULL,1220,'c',0,-1,0,36,0,0,188800,76,'true','armor_t54_b_i00',1,1,1,'0','0',0,0),
	(2436,'Theca Leather Boots','','feet','true','none',NULL,1210,'c',0,-1,0,37,0,0,211600,85,'true','armor_t63_b_i00',1,1,1,'0','0',0,0),
	(2437,'Drake Leather Boots','','feet','true','none',NULL,1210,'c',0,-1,0,39,0,0,275100,110,'true','armor_t21_b_i00',1,1,1,'0','0',0,0),
	(2438,'Full Plate Boots','','feet','true','none',NULL,1200,'c',0,-1,0,39,0,0,275100,110,'true','armor_t62_b_i00',1,1,1,'0','0',0,0),
	(2439,'Blue Wolf Boots','','feet','true','none',NULL,1130,'b',0,-1,0,44,0,0,618800,83,'true','armor_t68_b_i02',1,1,1,'0','0',0,0),
	(2440,'Boots of Nightmare','','feet','true','none',NULL,1110,'a',0,-1,0,48,0,0,1355000,140,'true','armor_t45_b_i00',1,1,1,'0','0',0,0),
	(2441,'Dark Legion Boots','','feet','true','none',NULL,1120,'a',0,-1,0,48,0,0,1355000,140,'true','armor_t45_b_i00',1,1,1,'0','0',0,0),
	(2442,'Dasparion\'s Boots','','feet','true','none',NULL,1100,'a',0,-1,0,48,0,0,1355000,140,'true','armor_t44_b_i00',1,1,1,'0','0',0,0),
	(2443,'Dragon Leather Boots','','feet','true','none',NULL,1100,'s',0,-1,0,51,0,0,1856000,119,'true','armor_t45_b_i00',1,1,1,'0','0',0,0),
	(2444,'The Boots','','feet','true','none',NULL,1100,'s',0,-1,0,51,0,0,1856000,119,'true','armor_t44_b_i00',1,1,1,'0','0',0,0),
	(2445,'Dragon Scale Boots','','feet','true','none',NULL,1100,'a',0,-1,0,48,0,0,1355000,140,'true','armor_t15_b_i00',1,1,1,'0','0',0,0),
	(2446,'Reinforced Leather Gloves','','gloves','true','none',NULL,640,'d',0,-1,0,24,0,0,39100,72,'true','armor_t13_g_i00',1,1,1,'0','0',0,0),
	(2447,'Gloves of Knowledge','','gloves','true','none',NULL,640,'d',0,-1,0,24,0,0,39100,72,'true','armor_t41_g_i00',1,1,1,'0','0',0,0),
	(2448,'Manticore Skin Gloves','','gloves','true','none',NULL,630,'d',0,-1,0,27,0,0,57400,106,'true','armor_t42_g_i00',1,1,1,'0','0',0,0),
	(2449,'Brigandine Gauntlets','','gloves','true','none',NULL,630,'d',0,-1,0,27,0,0,57400,106,'true','armor_t43_g_i00',1,1,1,'0','0',0,0),
	(2450,'Mithril Gloves','','gloves','true','none',NULL,640,'d',0,-1,0,27,0,0,57400,106,'true','armor_t51_g_i00',1,1,1,'0','0',0,0),
	(2451,'Sage\'s Worn Gloves','','gloves','true','none',NULL,630,'d',0,-1,0,29,0,0,75200,139,'true','armor_t44_g_i00',1,1,1,'0','0',0,0),
	(2452,'Reinforced Mithril Gloves','','gloves','true','none',NULL,620,'c',0,-1,0,32,0,0,97100,39,'true','armor_t47_g_i00',1,1,1,'0','0',0,0),
	(2453,'Chain Gloves','','gloves','true','none',NULL,620,'c',0,-1,0,32,0,0,97100,39,'true','armor_t48_g_i00',1,1,1,'0','0',0,0),
	(2454,'Karmian Gloves','','gloves','true','none',NULL,620,'c',0,-1,0,32,0,0,97100,39,'true','armor_t53_g_i00',1,1,1,'0','0',0,0),
	(2455,'Plated Leather Gloves','','gloves','true','none',NULL,610,'c',0,-1,0,33,0,0,114400,46,'true','armor_t47_g_i00',1,1,1,'0','0',0,0),
	(2456,'Dwarven Chain Gloves','','gloves','true','none',NULL,600,'c',0,-1,0,34,0,0,123900,50,'true','armor_t60_g_i00',1,1,1,'0','0',0,0),
	(2457,'Gloves of Seal','','gloves','true','none',NULL,620,'c',0,-1,0,34,0,0,123900,50,'true','armor_t44_g_i00',1,1,1,'0','0',0,0),
	(2458,'Rind Leather Gloves','','gloves','true','none',NULL,600,'c',0,-1,0,34,0,0,123900,50,'true','armor_t49_g_i00',1,1,1,'0','0',0,0),
	(2459,'Demon\'s Gloves','','gloves','true','none',NULL,610,'c',0,-1,0,36,0,0,188800,76,'true','armor_t54_g_i00',1,1,1,'0','0',0,0),
	(2460,'Theca Leather Gloves','','gloves','true','none',NULL,600,'c',0,-1,0,37,0,0,211600,85,'true','armor_t63_g_i00',1,1,1,'0','0',0,0),
	(2461,'Drake Leather Gloves','','gloves','true','none',NULL,600,'c',0,-1,0,39,0,0,275100,110,'true','armor_t21_g_i00',1,1,1,'0','0',0,0),
	(2462,'Full Plate Gauntlets','','gloves','true','none',NULL,600,'c',0,-1,0,39,0,0,275100,110,'true','armor_t62_g_i00',1,1,1,'0','0',0,0),
	(2463,'Divine Gloves','','gloves','true','none',NULL,610,'c',0,-1,0,39,0,0,275100,110,'true','armor_t57_g_i00',1,1,1,'0','0',0,0),
	(2464,'Avadon Gloves','','gloves','true','none',NULL,590,'b',0,-1,0,41,0,0,399100,53,'true','armor_t66_g_i02',1,1,1,'0','0',0,0),
	(2465,'Chain Gloves of Silence','','gloves','true','none',NULL,590,'b',0,-1,0,41,0,0,399100,69,'true','armor_t65_g_i00',1,1,1,'0','0',0,0),
	(2466,'Guardian\'s Gloves','','gloves','true','none',NULL,590,'b',0,-1,0,41,0,0,399100,69,'true','armor_t67_g_i00',1,1,1,'0','0',0,0),
	(2467,'Gloves of Blessing','','gloves','true','none',NULL,590,'b',0,-1,0,41,0,0,399100,69,'true','armor_t56_g_i00',1,1,1,'0','0',0,0),
	(2468,'Blessed Gloves','','gloves','true','none',NULL,600,'c',0,-1,0,39,0,0,275100,143,'true','armor_t67_g_i00',1,1,1,'0','0',0,0),
	(2469,'Gloves of the Underworld','','gloves','true','none',NULL,580,'a',0,-1,0,45,0,0,890000,92,'true','armor_t40_g_i00',1,1,1,'0','0',0,0),
	(2470,'Gloves of Phantom','','gloves','true','none',NULL,560,'a',0,-1,0,48,0,0,1355000,140,'true','armor_t45_g_i00',1,1,1,'0','0',0,0),
	(2471,'Dark Legion Gloves','','gloves','true','none',NULL,560,'a',0,-1,0,48,0,0,1355000,140,'true','armor_t45_g_i00',1,1,1,'0','0',0,0),
	(2472,'Dark Crystal Gloves','','gloves','true','none',NULL,580,'a',0,-1,0,45,0,0,890000,92,'true','armor_t15_g_i00',1,1,1,'0','0',0,0),
	(2473,'The Gloves','','gloves','true','none',NULL,540,'s',0,-1,0,51,0,0,1856000,119,'true','armor_t44_g_i00',1,1,1,'0','0',0,0),
	(2474,'Dasparion\'s Gloves','','gloves','true','none',NULL,550,'a',0,-1,0,48,0,0,1355000,140,'true','armor_t44_g_i00',1,1,1,'0','0',0,0),
	(2475,'Doom Gloves','','gloves','true','none',NULL,580,'b',0,-1,0,44,0,0,618800,83,'true','armor_t71_g_i02',1,1,1,'0','0',0,0),
	(2476,'Dragon Gauntlets','','gloves','true','none',NULL,540,'s',0,-1,0,52,0,0,2073000,130,'true','armor_t15_g_i00',1,1,1,'0','0',0,0),
	(2477,'Dragon Leather Gloves','','gloves','true','none',NULL,540,'s',0,-1,0,51,0,0,1856000,119,'true','armor_t45_g_i00',1,1,1,'0','0',0,0),
	(2478,'Tallum Gloves','','gloves','true','none',NULL,580,'a',0,-1,0,45,0,0,890000,92,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(2479,'Gauntlets of Nightmare','','gloves','true','none',NULL,550,'a',0,-1,0,48,0,0,1355000,140,'true','armor_t45_g_i00',1,1,1,'0','0',0,0),
	(2480,'Elemental Gloves','','gloves','true','none',NULL,580,'b',0,-1,0,44,0,0,618800,107,'true','armor_t71_g_i00',1,1,1,'0','0',0,0),
	(2481,'Gloves of Grace','','gloves','true','none',NULL,580,'b',0,-1,0,44,0,0,618800,107,'true','armor_t71_g_i00',1,1,1,'0','0',0,0),
	(2482,'Majestic Gauntlets','','gloves','true','none',NULL,540,'a',0,-1,0,48,0,0,1355000,140,'true','armor_t15_g_i00',1,1,1,'0','0',0,0),
	(2483,'Gust Bracer','','gloves','true','none',NULL,580,'a',0,-1,0,45,0,0,890000,92,'true','armor_t45_g_i00',1,1,1,'0','0',0,0),
	(2484,'Cerberus Gloves','','gloves','true','none',NULL,540,'a',0,-1,0,48,0,0,1355000,140,'true','armor_t44_g_i00',1,1,1,'0','0',0,0),
	(2485,'Implosion Gauntlets','','gloves','true','none',NULL,580,'b',0,-1,0,44,0,0,618800,107,'true','armor_t68_g_i00',1,1,1,'0','0',0,0),
	(2486,'Paradia Gloves','','gloves','true','none',NULL,580,'b',0,-1,0,44,0,0,618800,107,'true','armor_t68_g_i00',1,1,1,'0','0',0,0),
	(2487,'Blue Wolf Gloves','','gloves','true','none',NULL,590,'b',0,-1,0,44,0,0,618800,83,'true','armor_t68_g_i02',1,1,1,'0','0',0,0),
	(2488,'Phoenix Gloves','','gloves','true','none',NULL,570,'a',0,-1,0,45,0,0,890000,92,'true','armor_t44_g_i00',1,1,1,'0','0',0,0),
	(2489,'Gloves of Black Ore','','gloves','true','none',NULL,570,'a',0,-1,0,45,0,0,890000,92,'true','armor_t14_g_i00',1,1,1,'0','0',0,0),
	(2490,'Cloak of Silence','','back','false','none',NULL,250,'none',0,-1,0,5,0,0,6770,0,'true','armor_back01',1,1,1,'0','0',0,0),
	(2491,'Golden Yarn Cloak','','back','false','none',NULL,250,'none',0,-1,0,5,0,0,12300,0,'true','armor_back01',1,1,1,'0','0',0,0),
	(2492,'Shadow Cloak','','back','true','none',NULL,240,'c',0,-1,0,12,0,0,126000,50,'true','armor_back01',1,1,1,'0','0',0,0),
	(2506,'Wolf\'s Leather Armor','','wolf','false','pet',NULL,160,'none',0,-1,0,9,14,0,6120,0,'true','etc_pet_armor_i00',1,1,1,'0','0',0,0),
	(3891,'Wolf\'s Hide Armor','','wolf','false','pet',NULL,160,'none',0,-1,0,13,16,0,15600,0,'true','etc_pet_armor_i00',1,1,1,'0','0',0,0),
	(3892,'Wolf\'s Hard Leather Mail','','wolf','false','pet',NULL,160,'none',0,-1,0,16,18,0,28400,0,'true','etc_pet_armor_i00',1,1,1,'0','0',0,0),
	(3893,'Wolf\'s Wooden Armor','','wolf','false','pet',NULL,160,'none',0,-1,0,19,20,0,48200,0,'true','etc_pet_armor_i01',1,1,1,'0','0',0,0),
	(3894,'Wolf\'s Ring Mail','','wolf','false','pet',NULL,160,'none',0,-1,0,22,23,0,76900,0,'true','etc_pet_armor_i01',1,1,1,'0','0',0,0),
	(3895,'Wolf\'s Bone Armor','','wolf','false','pet',NULL,160,'none',0,-1,0,26,26,0,117000,0,'true','etc_pet_armor_i01',1,1,1,'0','0',0,0),
	(3896,'Wolf\'s Scale Male','','wolf','false','pet',NULL,160,'none',0,-1,0,30,29,0,172000,0,'true','etc_pet_armor_i01',1,1,1,'0','0',0,0),
	(3897,'Wof\'s Bronze Armor','','wolf','false','pet',NULL,160,'none',0,-1,0,33,31,0,226000,0,'true','etc_pet_armor_i01',1,1,1,'0','0',0,0),
	(3898,'Wolf\'s Plate Mail','','wolf','false','pet',NULL,160,'none',0,-1,0,37,33,0,291000,0,'true','etc_pet_armor_i02',1,1,1,'0','0',0,0),
	(3899,'Wolf\'s Steel Armor','','wolf','false','pet',NULL,160,'none',0,-1,0,40,36,0,372000,0,'true','etc_pet_armor_i02',1,1,1,'0','0',0,0),
	(3900,'Wolf\'s Luxury Plate','','wolf','false','pet',NULL,160,'none',0,-1,0,43,38,0,566000,0,'true','etc_pet_armor_i02',1,1,1,'0','0',0,0),
	(3901,'Wolf\'s Mithril Armor','','wolf','false','pet',NULL,160,'none',0,-1,0,47,41,0,825000,0,'true','etc_pet_armor_i02',1,1,1,'0','0',0,0),
	(3912,'Hatchling\'s Soft Leather','','hatchling','false','pet',NULL,160,'none',0,-1,0,26,26,0,117000,0,'true','etc_pet_armor_i03',1,1,1,'0','0',0,0),
	(3913,'Hatchling\'s Scale Mail','','hatchling','false','pet',NULL,160,'none',0,-1,0,29,29,0,172000,0,'true','etc_pet_armor_i03',1,1,1,'0','0',0,0),
	(3914,'Hatchling\'s Brigandine','','hatchling','false','pet',NULL,160,'none',0,-1,0,31,31,0,226000,0,'true','etc_pet_armor_i03',1,1,1,'0','0',0,0),
	(3915,'Hatchling\'s Bronze Coat','','hatchling','false','pet',NULL,160,'none',0,-1,0,33,33,0,291000,0,'true','etc_pet_armor_i04',1,1,1,'0','0',0,0),
	(3916,'Hatchling\'s Steel Coat','','hatchling','false','pet',NULL,160,'none',0,-1,0,36,36,0,372000,0,'true','etc_pet_armor_i04',1,1,1,'0','0',0,0),
	(3917,'Hatchling\'s Shadowplate','','hatchling','false','pet',NULL,160,'none',0,-1,0,38,38,0,566000,0,'true','etc_pet_armor_i04',1,1,1,'0','0',0,0),
	(3918,'Hatchling\'s Mithril Coat','','hatchling','false','pet',NULL,160,'none',0,-1,0,41,41,0,825000,0,'true','etc_pet_armor_i04',1,1,1,'0','0',0,0),
	(4224,'Dream Armor','','chest','true','heavy',NULL,8920,'none',0,-1,0,68,0,0,37820,0,'true','armor_blast_plate_i00',1,1,1,'0','0',0,0),
	(4225,'Dream Stockings','','legs','true','heavy',NULL,3960,'none',0,-1,0,43,0,0,23600,0,'true','armor_mithril_gaiters_i00',1,1,1,'0','0',0,0),
	(4226,'Dream Gloves','','gloves','true','none',NULL,650,'none',0,-1,0,17,0,0,9500,0,'true','armor_gauntlet_i00',1,1,1,'0','0',0,0),
	(4227,'Dream Boots','','feet','true','none',NULL,1310,'none',0,-1,0,17,0,0,9500,0,'true','armor_chain_boots_i00',1,1,1,'0','0',0,0),
	(4228,'Ubiquitous Armor','','chest','true','heavy',NULL,8920,'none',0,-1,0,68,0,0,37820,0,'true','armor_compound_scale_mail_i00',1,1,1,'0','0',0,0),
	(4229,'Ubiquitous Stockings','','legs','true','heavy',NULL,3960,'none',0,-1,0,43,0,0,23600,0,'true','armor_compound_scale_gaiters_i00',1,1,1,'0','0',0,0),
	(4230,'Ubiquitous Gloves','','gloves','true','none',NULL,650,'none',0,-1,0,17,0,0,9500,0,'true','armor_manticor_skin_gloves_i00',1,1,1,'0','0',0,0),
	(4231,'Ubiquitous Boots','','feet','true','none',NULL,1310,'none',0,-1,0,17,0,0,9500,0,'true','armor_iron_boots_i00',1,1,1,'0','0',0,0),
	(4234,'Hatchling\'s Level 65 Armor','','hatchling','false','pet',NULL,160,'none',0,-1,0,50,50,0,3132000,0,'true','etc_pet_armor_i06',1,1,1,'0','0',0,0),
	(4235,'Hatchling\'s Level 75 Armor','','hatchling','false','pet',NULL,160,'none',0,-1,0,58,58,0,9586000,0,'true','etc_pet_armor_i07',1,1,1,'0','0',0,0),
	(4236,'Gara Item','','hatchling','false','pet',NULL,160,'none',0,-1,0,58,58,0,9586000,0,'true','etc_pet_armor_i07',1,1,1,'0','0',0,0),
	(5170,'Mithril Panzer Coat','','strider','false','pet',NULL,160,'none',0,-1,0,41,41,0,825000,0,'true','etc_pet_armor_i08',1,1,1,'0','0',0,0),
	(5171,'Brigadine Panzer Coat','','strider','false','pet',NULL,160,'none',0,-1,0,44,44,0,1197000,0,'true','etc_pet_armor_i09',1,1,1,'0','0',0,0),
	(5172,'Draconic Panzer Coat','','strider','false','pet',NULL,160,'none',0,-1,0,46,46,0,1857000,0,'true','etc_pet_armor_i09',1,1,1,'0','0',0,0),
	(5173,'Blood Panzer Coat','','strider','false','pet',NULL,160,'none',0,-1,0,49,49,0,2671000,0,'true','etc_pet_armor_i10',1,1,1,'0','0',0,0),
	(5174,'Ophidian Panzer Coat','','strider','false','pet',NULL,160,'none',0,-1,0,52,52,0,4064000,0,'true','etc_pet_armor_i10',1,1,1,'0','0',0,0),
	(5175,'Inferno Panzer Coat','','strider','false','pet',NULL,160,'none',0,-1,0,54,54,0,5568000,0,'true','etc_pet_armor_i11',1,1,1,'0','0',0,0),
	(5182,'Hatchling\'s Gorgon Coat','','hatchling','false','pet',NULL,160,'none',0,-1,0,44,44,0,1197000,0,'true','etc_pet_armor_i05',1,1,1,'0','0',0,0),
	(5183,'Hatchling\'s Ophidian Plate','','hatchling','false','pet',NULL,160,'none',0,-1,0,46,46,0,1857000,0,'true','etc_pet_armor_i05',1,1,1,'0','0',0,0),
	(5184,'Hatchling\'s Crimson Plate','','hatchling','false','pet',NULL,160,'none',0,-1,0,49,49,0,2671000,0,'true','etc_pet_armor_i06',1,1,1,'0','0',0,0),
	(5185,'Hatchling\'s Draconic Plate','','hatchling','false','pet',NULL,160,'none',0,-1,0,52,52,0,4064000,0,'true','etc_pet_armor_i06',1,1,1,'0','0',0,0),
	(5186,'Hatchling\'s Inferno Plate','','hatchling','false','pet',NULL,160,'none',0,-1,0,54,54,0,5568000,0,'true','etc_pet_armor_i07',1,1,1,'0','0',0,0),
	(5216,'Wolf Level 75 Armor','','wolf','false','pet',NULL,160,'none',0,-1,0,71,58,0,9586000,0,'true','etc_pet_armor_i02',1,1,1,'0','0',0,0),
	(5287,'Sealed Dark Crystal breastplate','','chest','true','heavy',NULL,7700,'a',0,-1,0,171,0,0,3562000,285,'true','armor_t74_u_i02',1,1,1,'0','0',0,0),
	(5288,'Sealed Dark Crystal Gaiters','','legs','true','heavy',NULL,3320,'a',0,-1,0,107,0,0,2226000,178,'true','armor_t74_l_i02',1,1,1,'0','0',0,0),
	(5289,'Sealed Dark Crystal Helmet','','head','true','none',NULL,570,'a',0,-1,0,69,0,0,1336000,107,'true','armor_helmet_i02',1,1,1,'0','0',0,0),
	(5290,'Sealed Dark Crystal Gloves','','gloves','true','none',NULL,580,'a',0,-1,0,46,0,0,890000,71,'true','armor_t74_g_i02',1,1,1,'0','0',0,0),
	(5291,'Sealed Dark Crystal Boots','','feet','true','none',NULL,1110,'a',0,-1,0,46,0,0,890000,71,'true','armor_t74_b_i02',1,1,1,'0','0',0,0),
	(5293,'Sealed Tallum Plate Armor','','fullarmor','true','heavy',NULL,9780,'a',0,-1,0,278,0,0,5788000,463,'true','armor_t77_ul_i02',1,1,1,'0','0',0,0),
	(5294,'Sealed Tallum Helmet','','head','true','none',NULL,570,'a',0,-1,0,69,0,0,1336000,107,'true','armor_helmet_i02',1,1,1,'0','0',0,0),
	(5295,'Sealed Tallum Gloves','','gloves','true','none',NULL,580,'a',0,-1,0,46,0,0,890000,71,'true','armor_t77_g_i02',1,1,1,'0','0',0,0),
	(5296,'Sealed Tallum Boots','','feet','true','none',NULL,1130,'a',0,-1,0,46,0,0,890000,71,'true','armor_t77_b_i02',1,1,1,'0','0',0,0),
	(5297,'Sealed Dark Crystal Leather Armor','','chest','true','light',NULL,4300,'a',0,-1,0,128,0,0,2671000,214,'true','armor_t75_u_i02',1,1,1,'0','0',0,0),
	(5298,'Sealed Dark Crystal Leggings','','legs','true','light',NULL,1480,'a',0,-1,0,80,0,0,1670000,134,'true','armor_t75_l_i02',1,1,1,'0','0',0,0),
	(5299,'Sealed Gloves of the Underworld','','gloves','true','none',NULL,580,'a',0,-1,0,45,0,0,890000,92,'true','armor_t40_g_i00',1,1,1,'0','0',0,0),
	(5300,'Sealed Boots of the Underworld','','feet','true','none',NULL,1110,'a',0,-1,0,45,0,0,890000,92,'true','armor_t10_b_i00',1,1,1,'0','0',0,0),
	(5301,'Sealed Tallum Leather Armor','','fullarmor','true','light',NULL,5400,'a',0,-1,0,209,0,0,4341000,347,'true','armor_t78_ul_i02',1,1,1,'0','0',0,0),
	(5302,'Sealed Gust Bracer','','gloves','true','none',NULL,580,'a',0,-1,0,45,0,0,890000,92,'true','armor_t45_g_i00',1,1,1,'0','0',0,0),
	(5303,'Sealed Gust Boots','','feet','true','none',NULL,1120,'a',0,-1,0,45,0,0,890000,92,'true','armor_t45_b_i00',1,1,1,'0','0',0,0),
	(5304,'Sealed Tallum Tunic','','chest','true','magic',NULL,1860,'a',0,-1,0,86,0,409,2671000,214,'true','armor_t79_u_i02',1,1,1,'0','0',0,0),
	(5305,'Sealed Tallum Stockings','','legs','true','magic',NULL,920,'a',0,-1,0,53,0,256,1670000,134,'true','armor_t79_l_i02',1,1,1,'0','0',0,0),
	(5306,'Sealed Gloves of Black Ore','','gloves','true','none',NULL,570,'a',0,-1,0,45,0,0,890000,92,'true','armor_t14_g_i00',1,1,1,'0','0',0,0),
	(5307,'Sealed Red Flame Boots','','feet','true','none',NULL,1120,'a',0,-1,0,45,0,0,890000,92,'true','armor_t14_b_i00',1,1,1,'0','0',0,0),
	(5308,'Sealed Dark Crystal Robe','','fullarmor','true','magic',NULL,2450,'a',0,-1,0,139,0,665,4341000,347,'true','armor_t76_ul_i02',1,1,1,'0','0',0,0),
	(5309,'Sealed Phoenix Gloves','','gloves','true','none',NULL,570,'a',0,-1,0,45,0,0,890000,92,'true','armor_t44_g_i00',1,1,1,'0','0',0,0),
	(5310,'Sealed Phoenix Boots','','feet','true','none',NULL,1120,'a',0,-1,0,45,0,0,890000,92,'true','armor_t44_b_i00',1,1,1,'0','0',0,0),
	(5311,'Sealed Armor of Nightmare','','fullarmor','true','heavy',NULL,9580,'a',0,-1,0,293,0,0,8804000,704,'true','armor_t80_ul_i02',1,1,1,'0','0',0,0),
	(5312,'Sealed Helm of Nightmare','','head','true','none',NULL,560,'a',0,-1,0,73,0,0,2032000,163,'true','armor_leather_helmet_i02',1,1,1,'0','0',0,0),
	(5313,'Sealed Gauntlets of Nightmare','','gloves','true','none',NULL,550,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t80_g_i02',1,1,1,'0','0',0,0),
	(5314,'Sealed Boots of Nightmare','','feet','true','none',NULL,1110,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t80_b_i02',1,1,1,'0','0',0,0),
	(5316,'Sealed Majestic Plate Armor','','fullarmor','true','heavy',NULL,9200,'a',0,-1,0,293,0,0,8804000,704,'true','armor_t83_ul_i02',1,1,1,'0','0',0,0),
	(5317,'Sealed Majestic Circlet','','head','true','none',NULL,550,'a',0,-1,0,73,0,0,2032000,163,'true','armor_leather_helmet_i02',1,1,1,'0','0',0,0),
	(5318,'Sealed Majestic Gauntlets','','gloves','true','none',NULL,540,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t83_g_i02',1,1,1,'0','0',0,0),
	(5319,'Sealed Majestic Boots','','feet','true','none',NULL,1110,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t83_b_i02',1,1,1,'0','0',0,0),
	(5320,'Sealed Leather Armor of Nightmare','','fullarmor','true','light',NULL,5300,'a',0,-1,0,220,0,0,6603000,528,'true','armor_t81_ul_i02',1,1,1,'0','0',0,0),
	(5321,'Sealed Dark Legion Gloves','','gloves','true','none',NULL,560,'a',0,-1,0,48,0,0,1355000,140,'true','armor_t45_g_i00',1,1,1,'0','0',0,0),
	(5322,'Sealed Dark Legion Boots','','feet','true','none',NULL,1120,'a',0,-1,0,48,0,0,1355000,140,'true','armor_t45_b_i00',1,1,1,'0','0',0,0),
	(5323,'Sealed Majestic Leather Armor','','fullarmor','true','light',NULL,5350,'a',0,-1,0,220,0,0,6603000,528,'true','armor_t84_ul_i02',1,1,1,'0','0',0,0),
	(5324,'Sealed Gloves of Phantom','','gloves','true','none',NULL,560,'a',0,-1,0,48,0,0,1355000,140,'true','armor_t45_g_i00',1,1,1,'0','0',0,0),
	(5325,'Sealed Boots of Phantom','','feet','true','none',NULL,1120,'a',0,-1,0,48,0,0,1355000,140,'true','armor_t45_b_i00',1,1,1,'0','0',0,0),
	(5326,'Sealed Nightmare Robe','','fullarmor','true','magic',NULL,2300,'a',0,-1,0,147,0,718,6603000,528,'true','armor_t82_ul_i02',1,1,1,'0','0',0,0),
	(5327,'Sealed Cerberus Gloves','','gloves','true','none',NULL,540,'a',0,-1,0,48,0,0,1355000,140,'true','armor_t44_g_i00',1,1,1,'0','0',0,0),
	(5328,'Sealed Cerberus Boots','','feet','true','none',NULL,1120,'a',0,-1,0,48,0,0,1355000,140,'true','armor_t44_b_i00',1,1,1,'0','0',0,0),
	(5329,'Sealed Majestic Robe','','fullarmor','true','magic',NULL,2330,'a',0,-1,0,147,0,718,6603000,528,'true','armor_t85_ul_i02',1,1,1,'0','0',0,0),
	(5330,'Sealed Dasparion\'s Gloves','','gloves','true','none',NULL,550,'a',0,-1,0,48,0,0,1355000,140,'true','armor_t44_g_i00',1,1,1,'0','0',0,0),
	(5331,'Sealed Dasparion\'s Boots','','feet','true','none',NULL,1100,'a',0,-1,0,48,0,0,1355000,140,'true','armor_t44_b_i00',1,1,1,'0','0',0,0),
	(5576,'Sound Test Boots','','feet','false','none',NULL,50,'none',0,-1,0,0,0,0,9500,0,'true','armor_t30_b_i00',1,1,1,'0','0',0,0),
	(5590,'Squeaking Shoes','','feet','false','none',NULL,50,'none',0,-1,0,0,0,0,1,0,'true','armor_t02_b_i00',1,1,1,'0','0',0,0),
	(5709,'Sealed Zubei\'s Gauntlets','','gloves','true','none',NULL,590,'b',0,-1,0,41,0,0,399100,69,'true','armor_t64_g_i02',1,1,1,'0','0',0,0),
	(5710,'Zubei\'s Gauntlets','Heavy Armor','gloves','true','none',NULL,590,'b',0,-1,0,41,0,0,399100,53,'true','armor_t64_g_i00',1,1,1,'0','0',0,0),
	(5711,'Zubei\'s Gauntlets','Light Armor','gloves','true','none',NULL,590,'b',0,-1,0,41,0,0,399100,53,'true','armor_t65_g_i00',1,1,1,'0','0',0,0),
	(5712,'Zubei\'s Gauntlets','Robe','gloves','true','none',NULL,590,'b',0,-1,0,41,0,0,399100,53,'true','armor_t56_g_i00',1,1,1,'0','0',0,0),
	(5713,'Sealed Avadon Gloves','','gloves','true','none',NULL,590,'b',0,-1,0,41,0,0,399100,69,'true','armor_t66_g_i00',1,1,1,'0','0',0,0),
	(5714,'Avadon Gloves','Heavy Armor','gloves','true','none',NULL,590,'b',0,-1,0,41,0,0,399100,53,'true','armor_t66_g_i00',1,1,1,'0','0',0,0),
	(5715,'Avadon Gloves','Light Armor','gloves','true','none',NULL,590,'b',0,-1,0,41,0,0,399100,53,'true','armor_t67_g_i00',1,1,1,'0','0',0,0),
	(5716,'Avadon Gloves','Robe','gloves','true','none',NULL,590,'b',0,-1,0,41,0,0,399100,53,'true','armor_t59_g_i00',1,1,1,'0','0',0,0),
	(5717,'Sealed Blue Wolf Gloves','','gloves','true','none',NULL,590,'b',0,-1,0,44,0,0,618800,107,'true','armor_t68_g_i00',1,1,1,'0','0',0,0),
	(5718,'Blue Wolf Gloves','Heavy Armor','gloves','true','none',NULL,590,'b',0,-1,0,44,0,0,618800,83,'true','armor_t68_g_i00',1,1,1,'0','0',0,0),
	(5719,'Blue Wolf Gloves','Light Armor','gloves','true','none',NULL,590,'b',0,-1,0,44,0,0,618800,83,'true','armor_t69_g_i00',1,1,1,'0','0',0,0),
	(5720,'Blue Wolf Gloves','Robe','gloves','true','none',NULL,590,'b',0,-1,0,44,0,0,618800,83,'true','armor_t70_g_i00',1,1,1,'0','0',0,0),
	(5721,'Sealed Doom Gloves','','gloves','true','none',NULL,580,'b',0,-1,0,44,0,0,618800,107,'true','armor_t71_g_i00',1,1,1,'0','0',0,0),
	(5722,'Doom Gloves','Heavy Armor','gloves','true','none',NULL,580,'b',0,-1,0,44,0,0,618800,83,'true','armor_t71_g_i00',1,1,1,'0','0',0,0),
	(5723,'Doom Gloves','Light Armor','gloves','true','none',NULL,580,'b',0,-1,0,44,0,0,618800,83,'true','armor_t72_g_i00',1,1,1,'0','0',0,0),
	(5724,'Doom Gloves','Robe','gloves','true','none',NULL,580,'b',0,-1,0,44,0,0,618800,83,'true','armor_t73_g_i00',1,1,1,'0','0',0,0),
	(5725,'Sealed Zubei\'s Boots','','feet','true','none',NULL,1180,'b',0,-1,0,41,0,0,399100,69,'true','armor_t64_b_i00',1,1,1,'0','0',0,0),
	(5726,'Zubei\'s Boots','Heavy Armor','feet','true','none',NULL,1180,'b',0,-1,0,41,0,0,399100,53,'true','armor_t64_b_i00',1,1,1,'0','0',0,0),
	(5727,'Zubei\'s Boots','Light Armor','feet','true','none',NULL,1180,'b',0,-1,0,41,0,0,399100,53,'true','armor_t65_b_i00',1,1,1,'0','0',0,0),
	(5728,'Zubei\'s Boots','Robe','feet','true','none',NULL,1180,'b',0,-1,0,41,0,0,399100,53,'true','armor_t56_b_i00',1,1,1,'0','0',0,0),
	(5729,'Sealed Avadon Boots','','feet','true','none',NULL,1180,'b',0,-1,0,41,0,0,399100,69,'true','armor_t66_b_i00',1,1,1,'0','0',0,0),
	(5730,'Avadon Boots','Heavy Armor','feet','true','none',NULL,1180,'b',0,-1,0,41,0,0,399100,53,'true','armor_t66_b_i00',1,1,1,'0','0',0,0),
	(5731,'Avadon Boots','Light Armor','feet','true','none',NULL,1180,'b',0,-1,0,41,0,0,399100,53,'true','armor_t67_b_i00',1,1,1,'0','0',0,0),
	(5732,'Avadon Boots','Robe','feet','true','none',NULL,1180,'b',0,-1,0,41,0,0,399100,53,'true','armor_t59_b_i00',1,1,1,'0','0',0,0),
	(5733,'Sealed Blue Wolf Boots','','feet','true','none',NULL,1130,'b',0,-1,0,44,0,0,618800,107,'true','armor_t68_b_i00',1,1,1,'0','0',0,0),
	(5734,'Blue Wolf Boots','Heavy Armor','feet','true','none',NULL,1130,'b',0,-1,0,44,0,0,618800,83,'true','armor_t68_b_i00',1,1,1,'0','0',0,0),
	(5735,'Blue Wolf Boots','Light Armor','feet','true','none',NULL,1130,'b',0,-1,0,44,0,0,618800,83,'true','armor_t69_b_i00',1,1,1,'0','0',0,0),
	(5736,'Blue Wolf Boots','Robe','feet','true','none',NULL,1130,'b',0,-1,0,44,0,0,618800,83,'true','armor_t70_b_i00',1,1,1,'0','0',0,0),
	(5737,'Sealed Boots of Doom','','feet','true','none',NULL,1130,'b',0,-1,0,44,0,0,618800,107,'true','armor_t71_b_i00',1,1,1,'0','0',0,0),
	(5738,'Doom Boots','Heavy Armor','feet','true','none',NULL,1130,'b',0,-1,0,44,0,0,618800,83,'true','armor_t71_b_i00',1,1,1,'0','0',0,0),
	(5739,'Doom Boots','Light Armor','feet','true','none',NULL,1130,'b',0,-1,0,44,0,0,618800,83,'true','armor_t72_b_i00',1,1,1,'0','0',0,0),
	(5740,'Doom Boots','Robe','feet','true','none',NULL,1130,'b',0,-1,0,44,0,0,618800,83,'true','armor_t73_b_i00',1,1,1,'0','0',0,0),
	(5765,'Dark Crystal Gloves','Heavy Armor','gloves','true','none',NULL,580,'a',0,-1,0,46,0,0,890000,71,'true','armor_t74_g_i00',1,1,1,'0','0',0,0),
	(5766,'Dark Crystal Gloves','Light Armor','gloves','true','none',NULL,580,'a',0,-1,0,46,0,0,890000,71,'true','armor_t75_g_i00',1,1,1,'0','0',0,0),
	(5767,'Dark Crystal Gloves','Robe','gloves','true','none',NULL,580,'a',0,-1,0,46,0,0,890000,71,'true','armor_t76_g_i00',1,1,1,'0','0',0,0),
	(5768,'Tallum Gloves','Heavy Armor','gloves','true','none',NULL,580,'a',0,-1,0,46,0,0,890000,71,'true','armor_t77_g_i00',1,1,1,'0','0',0,0),
	(5769,'Tallum Gloves','Light Armor','gloves','true','none',NULL,580,'a',0,-1,0,46,0,0,890000,71,'true','armor_t78_g_i00',1,1,1,'0','0',0,0),
	(5770,'Tallum Gloves','Robe','gloves','true','none',NULL,580,'a',0,-1,0,46,0,0,890000,71,'true','armor_t79_g_i00',1,1,1,'0','0',0,0),
	(5771,'Gauntlets of Nightmare','Heavy Armor','gloves','true','none',NULL,550,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t80_g_i00',1,1,1,'0','0',0,0),
	(5772,'Gauntlets of Nightmare','Light Armor','gloves','true','none',NULL,550,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t81_g_i00',1,1,1,'0','0',0,0),
	(5773,'Gauntlets of Nightmare','Robe','gloves','true','none',NULL,550,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t82_g_i00',1,1,1,'0','0',0,0),
	(5774,'Majestic Gauntlets','Heavy Armor','gloves','true','none',NULL,540,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t83_g_i00',1,1,1,'0','0',0,0),
	(5775,'Majestic Gauntlets','Light Armor','gloves','true','none',NULL,540,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t84_g_i00',1,1,1,'0','0',0,0),
	(5776,'Majestic Gauntlets','Robe','gloves','true','none',NULL,540,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t85_g_i00',1,1,1,'0','0',0,0),
	(5777,'Dark Crystal Boots','Heavy Armor','feet','true','none',NULL,1110,'a',0,-1,0,46,0,0,890000,71,'true','armor_t74_b_i00',1,1,1,'0','0',0,0),
	(5778,'Dark Crystal Boots','Light Armor','feet','true','none',NULL,1110,'a',0,-1,0,46,0,0,890000,71,'true','armor_t75_b_i00',1,1,1,'0','0',0,0),
	(5779,'Dark Crystal Boots','Robe','feet','true','none',NULL,1110,'a',0,-1,0,46,0,0,890000,71,'true','armor_t76_b_i00',1,1,1,'0','0',0,0),
	(5780,'Tallum Boots','Heavy Armor','feet','true','none',NULL,1130,'a',0,-1,0,46,0,0,890000,71,'true','armor_t77_b_i00',1,1,1,'0','0',0,0),
	(5781,'Tallum Boots','Light Armor','feet','true','none',NULL,1130,'a',0,-1,0,46,0,0,890000,71,'true','armor_t78_b_i00',1,1,1,'0','0',0,0),
	(5782,'Tallum Boots','Robe','feet','true','none',NULL,1130,'a',0,-1,0,46,0,0,890000,71,'true','armor_t79_b_i00',1,1,1,'0','0',0,0),
	(5783,'Boots of Nightmare','Heavy Armor','feet','true','none',NULL,1110,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t80_b_i00',1,1,1,'0','0',0,0),
	(5784,'Boots of Nightmare','Light Armor','feet','true','none',NULL,1110,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t81_b_i00',1,1,1,'0','0',0,0),
	(5785,'Boots of Nightmare','Robe','feet','true','none',NULL,1110,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t82_b_i00',1,1,1,'0','0',0,0),
	(5786,'Majestic Boots','Heavy Armor','feet','true','none',NULL,1110,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t83_b_i00',1,1,1,'0','0',0,0),
	(5787,'Majestic Boots','Light Armor','feet','true','none',NULL,1110,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t84_b_i00',1,1,1,'0','0',0,0),
	(5788,'Majestic Boots','Robe','feet','true','none',NULL,1110,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t85_b_i00',1,1,1,'0','0',0,0),
	(5808,'Party Mask','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'true','etc_party_mask_i00',1,1,1,'0','0',0,0),
	(6323,'Sealed Phoenix Necklace','','neck','true','none',NULL,150,'a',0,-1,0,0,76,0,1340000,107,'true','accessary_phoenixs_necklace_i02',1,1,1,'0','0',0,0),
	(6324,'Sealed Phoenix Earring','','rear,lear','true','none',NULL,150,'a',0,-1,0,0,57,0,1005000,80,'true','accessary_phoenixs_earing_i02',1,1,1,'0','0',0,0),
	(6325,'Sealed Phoenix Ring','','rfinger,lfinger','true','none',NULL,150,'a',0,-1,0,0,38,0,670000,54,'true','accessary_phoenixs_ring_i02',1,1,1,'0','0',0,0),
	(6326,'Sealed Majestic Necklace','','neck','true','none',NULL,150,'a',0,-1,0,0,80,0,1998000,160,'true','accessary_inferno_necklace_i02',1,1,1,'0','0',0,0),
	(6327,'Sealed Majestic Earring','','rear,lear','true','none',NULL,150,'a',0,-1,0,0,60,0,1498000,120,'true','accessary_inferno_earing_i02',1,1,1,'0','0',0,0),
	(6328,'Sealed Majestic Ring','','rfinger,lfinger','true','none',NULL,150,'a',0,-1,0,0,40,0,999000,80,'true','accessary_inferno_ring_i02',1,1,1,'0','0',0,0),
	(6373,'Imperial Crusader Breastplate','','chest','true','heavy',NULL,7620,'s',0,-1,0,205,0,0,12781000,613,'true','armor_t88_u_i00',1,1,1,'0','0',0,0),
	(6374,'Imperial Crusader Gaiters','','legs','true','heavy',NULL,3260,'s',0,-1,0,128,0,0,7988000,383,'true','armor_t88_l_i00',1,1,1,'0','0',0,0),
	(6375,'Imperial Crusader Gauntlets','','gloves','true','none',NULL,540,'s',0,-1,0,55,0,0,3195000,153,'true','armor_t88_g_i00',1,1,1,'0','0',0,0),
	(6376,'Imperial Crusader Boots','','feet','true','none',NULL,1110,'s',0,-1,0,55,0,0,3195000,153,'true','armor_t88_b_i00',1,1,1,'0','0',0,0),
	(6378,'Imperial Crusader Helmet','','head','true','none',NULL,550,'s',0,-1,0,83,0,0,4793000,230,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(6379,'Draconic Leather Armor','','fullarmor','true','light',NULL,4950,'s',0,-1,0,249,0,0,15577000,748,'true','armor_t89_ul_i00',1,1,1,'0','0',0,0),
	(6380,'Draconic Leather Gloves','','gloves','true','none',NULL,540,'s',0,-1,0,55,0,0,3195000,153,'true','armor_t89_g_i00',1,1,1,'0','0',0,0),
	(6381,'Draconic Leather Boots','','feet','true','none',NULL,1110,'s',0,-1,0,55,0,0,3195000,153,'true','armor_t89_b_i00',1,1,1,'0','0',0,0),
	(6382,'Draconic Leather Helmet','','head','true','none',NULL,550,'s',0,-1,0,83,0,0,4793000,230,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(6383,'Major Arcana Robe','','fullarmor','true','magic',NULL,2300,'s',0,-1,0,166,0,866,15577000,748,'true','armor_t90_ul_i00',1,1,1,'0','0',0,0),
	(6384,'Major Arcana Gloves','','gloves','true','none',NULL,540,'s',0,-1,0,55,0,0,3195000,153,'true','armor_t90_g_i00',1,1,1,'0','0',0,0),
	(6385,'Major Arcana Boots','','feet','true','none',NULL,1110,'s',0,-1,0,55,0,0,3195000,153,'true','armor_t90_b_i00',1,1,1,'0','0',0,0),
	(6386,'Major Arcana Circlet','','head','true','none',NULL,550,'s',0,-1,0,83,0,0,4793000,230,'true','armor_circlet_i00',1,1,1,'0','0',0,0),
	(6394,'Red Party Mask','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'true','etc_party_mask_i01',1,1,1,'0','0',0,0),
	(6408,'Formal Wear','','formalwear','false','none',NULL,1000,'none',0,-1,0,0,0,0,5000000,0,'false','armor_t2000_ul_i00',1,1,1,'0','0',0,0),
	(6656,'Earring of Antharas','','rear,lear','true','none',NULL,150,'s',0,-1,0,0,71,31,3700000,178,'false','accessory_earring_of_antaras_i00',1,1,1,'3558','1',0,0),
	(6657,'Necklace of Valakas','','neck','true','none',NULL,150,'s',0,-1,0,0,95,42,4940000,237,'false','accessory_necklace_of_valakas_i00',1,1,1,'3557','1',0,0),
	(6658,'Ring of Baium','','rfinger,lfinger','true','none',NULL,150,'s',0,-1,0,0,48,21,1730000,83,'false','accessory_ring_of_baium_i00',1,1,1,'3561','1',0,0),
	(6659,'Zaken\'s Earring','','rear,lear','true','none',NULL,150,'s',0,-1,0,0,71,31,2590000,124,'false','accessory_earring_of_zaken_i00',1,1,1,'3559','1',0,0),
	(6660,'Ring of Queen Ant','','rfinger,lfinger','true','none',NULL,150,'b',0,-1,0,0,48,21,616000,82,'false','accessory_ring_of_queen_ant_i00',1,1,1,'3562','1',0,0),
	(6661,'Earring of Orfen','','rear,lear','true','none',NULL,150,'a',0,-1,0,0,71,31,1300000,104,'false','accessory_earring_of_orfen_i00',1,1,1,'3560','1',0,0),
	(6662,'Ring of Core','','rfinger,lfinger','true','none',NULL,150,'a',0,-1,0,0,48,21,870000,69,'false','accessory_ring_of_core_i00',1,1,1,'3563','1',0,0),
	(6674,'Sealed Imperial Crusader Breastplate','','chest','true','heavy',NULL,7620,'s',0,-1,0,193,0,0,12781000,613,'true','armor_t88_u_i02',1,1,1,'0','0',0,0),
	(6675,'Sealed Imperial Crusader Gaiters','','legs','true','heavy',NULL,3260,'s',0,-1,0,121,0,0,7988000,383,'true','armor_t88_l_i02',1,1,1,'0','0',0,0),
	(6676,'Sealed Imperial Crusader Gauntlet','','gloves','true','none',NULL,540,'s',0,-1,0,55,0,0,3195000,153,'true','armor_t88_g_i02',1,1,1,'0','0',0,0),
	(6677,'Sealed Imperial Crusader Boots','','feet','true','none',NULL,1110,'s',0,-1,0,55,0,0,3195000,153,'true','armor_t88_b_i02',1,1,1,'0','0',0,0),
	(6679,'Sealed Imperial Crusader Helmet','','head','true','none',NULL,550,'s',0,-1,0,83,0,0,4793000,230,'true','armor_helmet_i02',1,1,1,'0','0',0,0),
	(6680,'Sealed Draconic Leather Armor','','fullarmor','true','light',NULL,4950,'s',0,-1,0,236,0,0,15577000,748,'true','armor_t89_ul_i02',1,1,1,'0','0',0,0),
	(6681,'Sealed Draconic Leather Glove','','gloves','true','none',NULL,540,'s',0,-1,0,55,0,0,3195000,153,'true','armor_t89_g_i02',1,1,1,'0','0',0,0),
	(6682,'Sealed Draconic Leather Boots','','feet','true','none',NULL,1110,'s',0,-1,0,55,0,0,3195000,153,'true','armor_t89_b_i02',1,1,1,'0','0',0,0),
	(6683,'Sealed Draconic Leather Helmet','','head','true','none',NULL,550,'s',0,-1,0,83,0,0,4793000,230,'true','armor_leather_helmet_i02',1,1,1,'0','0',0,0),
	(6684,'Sealed Major Arcana Robe','','fullarmor','true','magic',NULL,2300,'s',0,-1,0,157,0,866,15577000,748,'true','armor_t90_ul_i02',1,1,1,'0','0',0,0),
	(6685,'Sealed Major Arcana Glove','','gloves','true','none',NULL,540,'s',0,-1,0,55,0,0,3195000,153,'true','armor_t90_g_i02',1,1,1,'0','0',0,0),
	(6686,'Sealed Major Arcana Boots','','feet','true','none',NULL,1110,'s',0,-1,0,55,0,0,3195000,153,'true','armor_t90_b_i02',1,1,1,'0','0',0,0),
	(6687,'Sealed Major Arcana Circlet','','head','true','none',NULL,550,'s',0,-1,0,83,0,0,4793000,230,'true','armor_circlet_i02',1,1,1,'0','0',0,0),
	(6724,'Sealed Tateossian Earring','','rear,lear','true','none',NULL,150,'s',0,-1,0,0,68,0,3270000,157,'true','accessory_tateossian_earring_i02',1,1,1,'0','0',0,0),
	(6725,'Sealed Tateossian Ring','','rfinger,lfinger','true','none',NULL,150,'s',0,-1,0,0,46,0,2180000,105,'true','accessory_tateossian_ring_i02',1,1,1,'0','0',0,0),
	(6726,'Sealed Tateossian Necklace','','neck','true','none',NULL,150,'s',0,-1,0,0,91,0,4361000,209,'true','accessory_tateossian_necklace_i02',1,1,1,'0','0',0,0),
	(6834,'Circlet of Innadril','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'false','accessory_pledge_cap1_i00',0,1,0,'3633','1',0,0),
	(6835,'Circlet of Dion','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'false','accessory_pledge_cap1_i02',0,1,0,'3633','1',0,0),
	(6836,'Circlet of Goddard','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'false','accessory_pledge_cap1_i03',0,1,0,'3633','2',0,0),
	(6837,'Circlet of Oren','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'false','accessory_pledge_cap1_i04',0,1,0,'3633','1',0,0),
	(6838,'Circlet of Gludio','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'false','accessory_pledge_cap1_i05',0,1,0,'3633','1',0,0),
	(6839,'Circlet of Giran','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'false','accessory_pledge_cap1_i06',0,1,0,'3633','1',0,0),
	(6840,'Circlet of Aden','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'false','accessory_pledge_cap2_i07',0,1,0,'3633','2',0,0),
	(6841,'The Lord\'s Crown','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessory_crown_i00',0,1,0,'0','0',0,0),
	(6842,'Wings of Destiny Circlet','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessory_hero_cap_i00',0,1,0,'0','0',0,0),
	(6843,'Cat Ear','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'false','accessory_cat_ear_i00',1,1,1,'0','0',0,0),
	(6844,'Lady\'s Hair Pin','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'false','accessory_hairpin_i00',1,1,1,'0','0',0,0),
	(6845,'Pirate\'s Eye Patch','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'false','accessory_eye_bandage_i00',1,1,1,'0','0',0,0),
	(6846,'Monocle','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'false','accessory_glasses_i00',1,1,1,'0','0',0,0),
	(7059,'Golden Festival Mask','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessory_taiwan_i00',1,1,1,'0','0',0,0),
	(7060,'Tateossian Hairband','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessory_tateossian_i00',1,1,1,'0','0',0,0),
	(7680,'Raccoon Ears','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'false','accessory_racoon_ear_i00',1,1,1,'0','0',0,0),
	(7681,'Outlaw\'s Eyepatch','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'false','accessory_outlaw_eyepatch_i00',1,1,1,'0','0',0,0),
	(7682,'Maiden\'s Hairpin','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'false','accessory_maidens_hairpin_i00',1,1,1,'0','0',0,0),
	(7683,'Rabbit Ears','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'false','accessory_rabbit_ear_i00',1,1,1,'0','0',0,0),
	(7694,'Noblesse Tiara','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessory_noblesse_tiara_i00',0,1,0,'0','0',0,0),
	(7695,'Forget-me-not Hairpin','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'false','accessory_forget_me_not_hairpin_i00',1,1,1,'0','0',0,0),
	(7696,'Daisy Hairpin','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'false','accessory_daisy_hairpin_i00',1,1,1,'0','0',0,0),
	(7836,'Santa\'s Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessory_santas_cap_i00',1,1,1,'0','0',0,0),
	(7837,'Sayha\'s White Mask','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessory_full_mask_i00',1,1,1,'0','0',0,0),
	(7838,'Santa\'s Hat','','hair','false','none',NULL,10,'none',0,90,0,0,0,0,0,0,'false','accessory_santas_cap_i00',0,1,0,'0','0',0,0),
	(7839,'Gran Kain\'s Black Mask','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_full_mask_i01',1,1,1,'0','0',0,0),
	(7840,'Rabbit Ears (Event)','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_rabbit_ear_i00',1,1,1,'0','0',0,0),
	(7841,'Racoon Ears (Event)','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_racoon_ear_i00',1,1,1,'0','0',0,0),
	(7842,'Cat Ears (Event)','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_cat_ear_i00',1,1,1,'0','0',0,0),
	(7843,'Pirate\'s Eyepatch (Event)','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_eye_bandage_i00',1,1,1,'0','0',0,0),
	(7844,'Monocle (Event)','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_glasses_i00',1,1,1,'0','0',0,0),
	(7845,'Outlaw\'s Eyepatch (Event)','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_outlaw_eyepatch_i00',0,1,0,'0','0',0,0),
	(7846,'Lady\'s Hairpin (Event)','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_maidens_hairpin_i00',1,1,1,'0','0',0,0),
	(7847,'Noblewoman\'s Hairpin (Event)','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_hairpin_i00',1,1,1,'0','0',0,0),
	(7848,'Forget-me-not Hairpin (Event)','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_forget_me_not_hairpin_i00',1,1,1,'0','0',0,0),
	(7849,'Daisy Hairpin (Event)','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_daisy_hairpin_i00',1,1,1,'0','0',0,0),
	(7850,'Clan Oath Helm','','head','true','none',NULL,640,'d',0,-1,0,37,0,0,58600,108,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(7851,'Clan Oath Armor','','fullarmor','true','heavy',NULL,9870,'d',0,-1,0,158,0,0,253900,469,'true','armor_t1001_ul_i00',1,1,1,'0','0',0,0),
	(7852,'Clan Oath Gauntlets','Heavy Armor','gloves','true','none',NULL,640,'d',0,-1,0,24,0,0,39100,72,'true','armor_t1001_g_i00',1,1,1,'0','0',0,0),
	(7853,'Clan Oath Sabaton','Heavy Armor','feet','true','none',NULL,1280,'d',0,-1,0,24,0,0,39100,72,'true','armor_t1001_b_i00',1,1,1,'0','0',0,0),
	(7854,'Clan Oath Brigandine','','fullarmor','true','light',NULL,5400,'d',0,-1,0,119,0,0,190400,352,'true','armor_t1002_ul_i00',1,1,1,'0','0',0,0),
	(7855,'Clan Oath Leather Gloves','Light Armor','gloves','true','none',NULL,640,'d',0,-1,0,24,0,0,39100,72,'true','armor_t1002_g_i00',1,1,1,'0','0',0,0),
	(7856,'Clan Oath Boots','Light Armor','feet','true','none',NULL,1280,'d',0,-1,0,24,0,0,39100,72,'true','armor_t1002_b_i00',1,1,1,'0','0',0,0),
	(7857,'Clan Oath Aketon','','fullarmor','true','magic',NULL,2450,'d',0,-1,0,79,0,239,190400,352,'true','armor_t1003_ul_i00',1,1,1,'0','0',0,0),
	(7858,'Clan Oath Padded Gloves','Robe','gloves','true','none',NULL,640,'d',0,-1,0,24,0,0,39100,72,'true','armor_t1003_g_i00',1,1,1,'0','0',0,0),
	(7859,'Clan Oath Sandals','Robe','feet','true','none',NULL,1280,'d',0,-1,0,24,0,0,39100,72,'true','armor_t1003_b_i00',1,1,1,'0','0',0,0),
	(7860,'Apella Helm','','head','true','none',NULL,570,'a',0,-1,0,69,0,0,1336000,107,'false','armor_helmet_i00',1,1,1,'0','0',0,0),
	(7861,'Apella Plate Armor','','fullarmor','true','heavy',NULL,9780,'a',0,-1,0,278,0,0,5788000,463,'false','armor_t1004_ul_i00',1,1,1,'0','0',0,0),
	(7862,'Apella Gauntlet','Heavy Armor','gloves','true','heavy',NULL,580,'a',0,-1,0,46,0,0,890000,71,'false','armor_t1004_g_i00',1,1,1,'0','0',0,0),
	(7863,'Apella Solleret','Heavy Armor','feet','true','heavy',NULL,1130,'a',0,-1,0,46,0,0,890000,71,'false','armor_t1004_b_i00',1,1,1,'0','0',0,0),
	(7864,'Apella Brigandine','','fullarmor','true','light',NULL,5400,'a',0,-1,0,209,0,0,4341000,347,'false','armor_t1005_ul_i00',1,1,1,'0','0',0,0),
	(7865,'Apella Leather Gloves','Light Armor','gloves','true','light',NULL,580,'a',0,-1,0,46,0,0,890000,71,'false','armor_t1005_g_i00',1,1,1,'0','0',0,0),
	(7866,'Apella Boots','Light Armor','feet','true','light',NULL,1130,'a',0,-1,0,46,0,0,890000,71,'false','armor_t1005_b_i00',1,1,1,'0','0',0,0),
	(7867,'Apella Doublet','','fullarmor','true','magic',NULL,2450,'a',0,-1,0,139,0,665,4341000,347,'false','armor_t1006_ul_i00',1,1,1,'0','0',0,0),
	(7868,'Apella Silk Gloves','Robe','gloves','true','magic',NULL,580,'a',0,-1,0,46,0,0,890000,71,'false','armor_t1006_g_i00',1,1,1,'0','0',0,0),
	(7869,'Apella Sandals','Robe','feet','true','magic',NULL,1130,'a',0,-1,0,46,0,0,890000,71,'false','armor_t1006_b_i00',1,1,1,'0','0',0,0),
	(7870,'Sealed Apella Helm','','head','true','none',NULL,570,'a',0,-1,0,69,0,0,1336000,107,'false','armor_helmet_i02',1,1,1,'0','0',0,0),
	(7871,'Sealed Apella Plate Armor','','fullarmor','true','heavy',NULL,9780,'a',0,-1,0,278,0,0,5788000,463,'false','armor_t1004_ul_i02',1,1,1,'0','0',0,0),
	(7872,'Sealed Apella Gauntlet','','gloves','true','heavy',NULL,580,'a',0,-1,0,46,0,0,890000,71,'false','armor_t1004_g_i02',1,1,1,'0','0',0,0),
	(7873,'Sealed Apella Solleret','','feet','true','heavy',NULL,1130,'a',0,-1,0,46,0,0,890000,71,'false','armor_t1004_b_i02',1,1,1,'0','0',0,0),
	(7874,'Sealed Apella Brigandine','','fullarmor','true','light',NULL,5400,'a',0,-1,0,209,0,0,4341000,347,'false','armor_t1005_ul_i02',1,1,1,'0','0',0,0),
	(7875,'Sealed Apella Leather Gloves','','gloves','true','light',NULL,580,'a',0,-1,0,46,0,0,890000,71,'false','armor_t1005_g_i02',1,1,1,'0','0',0,0),
	(7876,'Sealed Apella Boots','','feet','true','light',NULL,1130,'a',0,-1,0,46,0,0,890000,71,'false','armor_t1005_b_i02',1,1,1,'0','0',0,0),
	(7877,'Sealed Apella Doublet','','fullarmor','true','magic',NULL,2450,'a',0,-1,0,139,0,665,4341000,347,'false','armor_t1006_ul_i02',1,1,1,'0','0',0,0),
	(7878,'Sealed Apella Silk Gloves','','gloves','true','magic',NULL,580,'a',0,-1,0,46,0,0,890000,71,'false','armor_t1006_g_i02',1,1,1,'0','0',0,0),
	(7879,'Sealed Apella Sandals','','feet','true','magic',NULL,1130,'a',0,-1,0,46,0,0,890000,71,'false','armor_t1006_b_i02',1,1,1,'0','0',0,0),
	(8177,'Raid Challenger\'s Circlet','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'true','accessory_raid_challenger_i00',1,1,1,'0','0',0,0),
	(8178,'Raid Adventurer\'s Circlet','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'true','accessory_raid_explorer_i00',1,1,1,'0','0',0,0),
	(8179,'Raid Master\'s Circlet','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'true','accessory_raid_master_i00',1,1,1,'0','0',0,0),
	(8180,'Circlet of Ice Fairy Sirra','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'true','accessory_ice_queen_i00',1,1,1,'0','0',0,0),
	(8181,'Academy Circlet','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'true','accessory_academy_i00',0,1,0,'0','0',0,0),
	(8182,'Circlet of Rune','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'true','accessory_pledge_cap1_i01',0,1,0,'3633','2',0,0),
	(8183,'Circlet of Schuttgart','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'true','accessory_pledge_cap1_i07',0,1,0,'3633','2',0,0),
	(8184,'Party Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_party_hat_i00',1,1,1,'0','0',0,0),
	(8185,'Feathered Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_archer_hat_i00',1,1,1,'0','0',0,0),
	(8186,'Artisan\'s Goggles','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_dwarf_goggle_i00',1,1,1,'0','0',0,0),
	(8187,'Demon Horns','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_hair_cornu_i00',1,1,1,'0','0',0,0),
	(8188,'Little Angel Wings','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'true','accessory_hair_ring_i00',1,1,1,'0','0',0,0),
	(8189,'Fairy Antennae','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'true','accessory_hair_feeler_i00',1,1,1,'0','0',0,0),
	(8191,'Frintezza\'s Necklace','','neck','true','none',NULL,150,'a',0,-1,0,0,95,42,3450000,230,'false','accessory_necklace_of_frintessa_i00',1,1,1,'3604','1',0,0),
	(8541,'Little Harness','','baby','false','pet',NULL,160,'none',0,-1,0,10,25,0,200000,0,'true','etc_pet_armor_little_harness_i00',1,1,1,'0','0',0,0),
	(8552,'Mask of Spirits','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_worldcup_mask_i00',1,1,1,'0','0',0,0),
	(8557,'Blue Party Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessory_party_hat_blue_i00',1,1,1,'0','0',0,0),
	(8558,'Eva\'s Mark (Event)','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessory_soaring_bird_i00',0,1,0,'0','0',0,0),
	(8559,'Diadem','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessory_flower_cap_i00',1,1,1,'0','0',0,0),
	(8560,'Teddy Bear Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'false','accessory_bear_cap_i00',1,1,1,'0','0',0,0),
	(8561,'Piggy Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'false','accessory_pig_cap_i00',1,1,1,'0','0',0,0),
	(8562,'Jester Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'false','accessory_jester_cap_i00',1,1,1,'0','0',0,0),
	(8563,'Wizard Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'false','accessory_magic_cap_i00',1,1,1,'0','0',0,0),
	(8564,'Dapper Cap','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'false','accessory_dandy_cap_i00',1,1,1,'0','0',0,0),
	(8565,'Romantic Chapeau','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'false','accessory_romantic_chaperon_i00',1,1,1,'0','0',0,0),
	(8566,'Iron Circlet','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessory_iron_circlet_i00',0,1,0,'0','0',0,0),
	(8567,'Valakas Slayer Circlet','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'false','accessory_valakas_circlet_i00',1,1,1,'0','0',0,0),
	(8568,'Antharas Slayer Circlet','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'false','accessory_antaras_circlet_i00',1,1,1,'0','0',0,0),
	(8569,'Half Face Mask','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'false','accessory_half_face_i00',1,1,1,'0','0',0,0),
	(8660,'Demon Horns','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_hair_cornu_i00',1,1,1,'0','0',0,0),
	(8661,'Mask of Spirits','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_worldcup_mask_i00',1,1,1,'0','0',0,0),
	(8662,'Fairy Antennae (Event)','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessory_hair_feeler_i00',0,1,0,'0','0',0,0),
	(8910,'Black Feather Mask (Event)','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessary_black_feather_mask_i00',0,1,0,'0','0',0,0),
	(8911,'Black Half-Mask (Event)','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','Accessary_black_half_mask_i00',1,1,1,'0','0',0,0),
	(8912,'Single Stem Flower','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'true','accessory_hairpin_i00',1,1,1,'0','0',0,0),
	(8913,'Butterfly Hairpin','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'true','Accessary_butterfly_hearpin_i00',1,1,1,'0','0',0,0),
	(8914,'Luxurious Gold Circlet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'true','Accessary_gold_circlet_i00',1,1,1,'0','0',0,0),
	(8915,'Luxurious Silver Circlet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'true','Accessary_gold_circlet_i01',1,1,1,'0','0',0,0),
	(8916,'Eye Patch','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'true','Accessary_one_eye_i00',1,1,1,'0','0',0,0),
	(8917,'Goddess Circlet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'true','Accessary_goddess_circlet_i00',1,1,1,'0','0',0,0),
	(8918,'Leather Cap','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','Accessary_middle_ages_i00',1,1,1,'0','0',0,0),
	(8919,'First Mate\'s Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','Accessary_middle_ages_i01',0,1,0,'0','0',0,0),
	(8920,'Angel Halo','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'true','Accessary_angel_circlet_i00',1,1,1,'0','0',0,0),
	(8921,'Demon Circlet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'true','Accessary_demon_circlet_i00',1,1,1,'0','0',0,0),
	(8922,'Pirate Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','Accessary_sea_robber_i00',1,1,1,'0','0',0,0),
	(8923,'Scar','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'true','Accessary_scar_i00',1,1,1,'0','0',0,0),
	(8936,'Santa\'s Antlers','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_santas_antler_i00',1,1,1,'0','0',0,0),
	(8947,'L2 Day: Rabbit Ears','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_rabbit_ear_i00',1,1,1,'0','0',0,0),
	(8948,'L2 Day: Little Angel Wings','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_hair_ring_i00',1,1,1,'0','0',0,0),
	(8949,'L2 Day: Fairy Antennae','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_hair_feeler_i00',1,1,1,'0','0',0,0),
	(8950,'L2 Day: Feathered Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_archer_hat_i00',1,1,1,'0','0',0,0),
	(8951,'L2 Day: Artisan\'s Goggles','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_dwarf_goggle_i00',1,1,1,'0','0',0,0),
	(9030,'Shadow Item: Bronze Breastplate','','chest','false','heavy',NULL,2973,'none',0,600,0,68,0,0,0,0,'false','armor_t34_u_i00',0,1,0,'0','0',0,0),
	(9031,'Shadow Item: Bronze Gaiters','','legs','false','heavy',NULL,1320,'none',0,600,0,43,0,0,0,0,'false','armor_t34_l_i00',0,1,0,'0','0',0,0),
	(9032,'Shadow Item: Hard Leather Shirt','','chest','false','light',NULL,1573,'none',0,600,0,53,0,0,0,0,'false','armor_t30_u_i00',0,1,0,'0','0',0,0),
	(9033,'Shadow Item: Hard Leather Gaiters','','legs','false','light',NULL,537,'none',0,600,0,33,0,0,0,0,'false','armor_t30_l_i00',0,1,0,'0','0',0,0),
	(9034,'Shadow Item: Tunic of Magic','','chest','false','magic',NULL,693,'none',0,600,0,34,0,86,0,0,'false','armor_t58_u_i00',0,1,0,'0','0',0,0),
	(9035,'Shadow Item: Stockings of Magic','','legs','false','magic',NULL,343,'none',0,600,0,21,0,54,0,0,'false','armor_t58_l_i00',0,1,0,'0','0',0,0),
	(9037,'Shadow Item: Hard Leather Helmet','','head','false','none',NULL,213,'none',0,600,0,26,0,0,0,0,'false','armor_leather_helmet_i00',0,1,0,'0','0',0,0),
	(9038,'Shadow Item: Boots','','feet','false','none',NULL,437,'none',0,600,0,17,0,0,0,0,'false','armor_t30_b_i00',0,1,0,'0','0',0,0),
	(9039,'Shadow Item: Bracer','','gloves','false','none',NULL,217,'none',0,600,0,17,0,0,0,0,'false','armor_t30_g_i00',0,1,0,'0','0',0,0),
	(9040,'Shadow Item: Mithril Breastplate','','chest','false','heavy',NULL,2890,'d',0,600,0,95,0,0,0,0,'false','armor_t19_u_i00',0,1,0,'0','0',0,0),
	(9041,'Shadow Item: Mithril Gaiters','','legs','false','heavy',NULL,1277,'d',0,600,0,61,0,0,0,0,'false','armor_t19_l_i00',0,1,0,'0','0',0,0),
	(9042,'Shadow Item: Gauntlet','','gloves','false','none',NULL,213,'d',0,600,0,24,0,0,0,0,'false','armor_t10_g_i00',0,1,0,'0','0',0,0),
	(9043,'Shadow Item: Iron Boots','','feet','false','none',NULL,427,'d',0,600,0,24,0,0,0,0,'false','armor_t10_b_i00',0,1,0,'0','0',0,0),
	(9045,'Shadow Item: Reinforced Leather Shirt','','chest','false','light',NULL,1523,'d',0,600,0,73,0,0,0,0,'false','armor_t13_u_i00',0,1,0,'0','0',0,0),
	(9046,'Shadow Item: Reinforced Leather Gaiters','','legs','false','light',NULL,523,'d',0,600,0,46,0,0,0,0,'false','armor_t13_l_i00',0,1,0,'0','0',0,0),
	(9047,'Shadow Item: Reinforced Leather Gloves','','gloves','false','none',NULL,213,'d',0,600,0,24,0,0,0,0,'false','armor_t13_g_i00',0,1,0,'0','0',0,0),
	(9048,'Shadow Item: Reinforced Leather Boots','','feet','false','none',NULL,427,'d',0,600,0,24,0,0,0,0,'false','armor_t13_b_i00',0,1,0,'0','0',0,0),
	(9049,'Shadow Item: Tunic of Knowledge','','chest','false','magic',NULL,673,'d',0,600,0,49,0,147,0,0,'false','armor_t41_u_i00',0,1,0,'0','0',0,0),
	(9050,'Shadow Item: Stockings of Knowledge','','legs','false','magic',NULL,333,'d',0,600,0,30,0,92,0,0,'false','armor_t41_l_i00',0,1,0,'0','0',0,0),
	(9051,'Shadow Item: Gloves of Knowledge','','gloves','false','none',NULL,213,'d',0,600,0,24,0,0,0,0,'false','armor_t41_g_i00',0,1,0,'0','0',0,0),
	(9052,'Shadow Item: Boots of Knowledge','','feet','false','none',NULL,423,'d',0,600,0,24,0,0,0,0,'false','armor_t41_b_i00',0,1,0,'0','0',0,0),
	(9053,'Shadow Item: Helmet','','head','false','none',NULL,213,'d',0,600,0,37,0,0,0,0,'false','armor_helmet_i00',0,1,0,'0','0',0,0),
	(9054,'Shadow Item: Composite Armor','','fullarmor','false','heavy',NULL,3660,'c',0,600,0,224,0,0,0,0,'false','armor_t61_ul_i00',0,1,0,'0','0',0,0),
	(9055,'Shadow Item: Composite Boots','','feet','false','none',NULL,407,'c',0,600,0,36,0,0,0,0,'false','armor_t61_b_i00',0,1,0,'0','0',0,0),
	(9057,'Shadow Item: Composite Helmet','','head','false','none',NULL,203,'c',0,600,0,54,0,0,0,0,'false','armor_leather_helmet_i00',0,1,0,'0','0',0,0),
	(9058,'Shadow Item: Theca Leather Armor','','chest','false','light',NULL,1457,'c',0,600,0,106,0,0,0,0,'false','armor_t63_u_i00',0,1,0,'0','0',0,0),
	(9059,'Shadow Item: Theca Leather Gaiters','','legs','false','light',NULL,510,'c',0,600,0,66,0,0,0,0,'false','armor_t63_l_i00',0,1,0,'0','0',0,0),
	(9060,'Shadow Item: Theca Leather Boots','','feet','false','none',NULL,403,'c',0,600,0,37,0,0,0,0,'false','armor_t63_b_i00',0,1,0,'0','0',0,0),
	(9061,'Shadow Item: Theca Leather Gloves','','gloves','false','none',NULL,200,'c',0,600,0,37,0,0,0,0,'false','armor_t63_g_i00',0,1,0,'0','0',0,0),
	(9062,'Shadow Item: Demon\'s Tunic','','chest','false','magic',NULL,663,'c',0,600,0,69,0,284,0,0,'false','armor_t54_u_i00',0,1,0,'0','0',0,0),
	(9063,'Shadow Item: Demon\'s Stockings','','legs','false','magic',NULL,327,'c',0,600,0,43,0,177,0,0,'false','armor_t54_l_i00',0,1,0,'0','0',0,0),
	(9064,'Shadow Item: Demon\'s Boots','','feet','false','none',NULL,407,'c',0,600,0,36,0,0,0,0,'false','armor_t54_b_i00',0,1,0,'0','0',0,0),
	(9065,'Shadow Item: Demon\'s Gloves','','gloves','false','none',NULL,203,'c',0,600,0,36,0,0,0,0,'false','armor_t54_g_i00',0,1,0,'0','0',0,0),
	(9066,'Shadow Item: Shining Circlet','','head','false','none',NULL,200,'c',0,600,0,54,0,0,0,0,'false','armor_circlet_i00',0,1,0,'0','0',0,0),
	(9067,'Shadow Item: Zubei\'s Breastplate','','chest','false','heavy',NULL,2657,'b',0,600,0,157,0,0,0,0,'false','armor_t64_u_i00',0,1,0,'0','0',0,0),
	(9068,'Shadow Item: Zubei\'s Gaiters','','legs','false','heavy',NULL,1190,'b',0,600,0,98,0,0,0,0,'false','armor_t64_l_i00',0,1,0,'0','0',0,0),
	(9069,'Shadow Item: Zubei\'s Helmet','','head','false','none',NULL,197,'b',0,600,0,62,0,0,0,0,'false','armor_helmet_i00',0,1,0,'0','0',0,0),
	(9071,'Shadow Item: Zubei\'s Gauntlet','','gloves','false','none',NULL,197,'b',0,600,0,41,0,0,0,0,'false','armor_t64_g_i00',0,1,0,'0','0',0,0),
	(9072,'Shadow Item: Zubei\'s Boots','','feet','false','none',NULL,393,'b',0,600,0,41,0,0,0,0,'false','armor_t64_b_i00',0,1,0,'0','0',0,0),
	(9073,'Shadow Item: Zubei\'s Leather Shirt','','chest','false','light',NULL,1443,'b',0,600,0,117,0,0,0,0,'false','armor_t65_u_i00',0,1,0,'0','0',0,0),
	(9074,'Shadow Item: Zubei\'s Leather Gaiters','','legs','false','light',NULL,493,'b',0,600,0,73,0,0,0,0,'false','armor_t65_l_i00',0,1,0,'0','0',0,0),
	(9075,'Shadow Item: Zubei\'s Gauntlet','','gloves','false','none',NULL,197,'b',0,600,0,41,0,0,0,0,'false','armor_t65_g_i00',0,1,0,'0','0',0,0),
	(9076,'Shadow Item: Zubei\'s Boots','','feet','false','none',NULL,393,'b',0,600,0,41,0,0,0,0,'false','armor_t65_b_i00',0,1,0,'0','0',0,0),
	(9077,'Shadow Item: Tunic of Zubei','','chest','false','magic',NULL,653,'b',0,600,0,78,0,345,0,0,'false','armor_t56_u_i00',0,1,0,'0','0',0,0),
	(9078,'Shadow Item: Stockings of Zubei','','legs','false','magic',NULL,313,'b',0,600,0,49,0,216,0,0,'false','armor_t56_l_i00',0,1,0,'0','0',0,0),
	(9079,'Shadow Item: Zubei\'s Gauntlet','','gloves','false','none',NULL,197,'b',0,600,0,41,0,0,0,0,'false','armor_t56_g_i00',0,1,0,'0','0',0,0),
	(9080,'Shadow Item: Zubei\'s Boots','','feet','false','none',NULL,393,'b',0,600,0,41,0,0,0,0,'false','armor_t56_b_i00',0,1,0,'0','0',0,0),
	(9081,'Shadow Item: Dark Crystal Breastplate','','chest','false','heavy',NULL,2567,'a',0,600,0,171,0,0,0,0,'false','armor_t74_u_i00',0,1,0,'0','0',0,0),
	(9082,'Shadow Item: Dark Crystal Gaiters','','legs','false','heavy',NULL,1107,'a',0,600,0,107,0,0,0,0,'false','armor_t74_l_i00',0,1,0,'0','0',0,0),
	(9083,'Shadow Item: Dark Crystal Helmet','','head','false','none',NULL,190,'a',0,600,0,69,0,0,0,0,'false','armor_helmet_i00',0,1,0,'0','0',0,0),
	(9085,'Shadow Item: Dark Crystal Gloves','','gloves','false','none',NULL,193,'a',0,600,0,46,0,0,0,0,'false','armor_t74_g_i00',0,1,0,'0','0',0,0),
	(9086,'Shadow Item: Dark Crystal Boots','','feet','false','none',NULL,370,'a',0,600,0,46,0,0,0,0,'false','armor_t74_b_i00',0,1,0,'0','0',0,0),
	(9087,'Shadow Item: Dark Crystal Leather Armor','','chest','false','light',NULL,1433,'a',0,600,0,128,0,0,0,0,'false','armor_t75_u_i00',0,1,0,'0','0',0,0),
	(9088,'Shadow Item: Dark Crystal Leggings','','legs','false','light',NULL,493,'a',0,600,0,80,0,0,0,0,'false','armor_t75_l_i00',0,1,0,'0','0',0,0),
	(9089,'Shadow Item: Dark Crystal Gloves','','gloves','false','none',NULL,193,'a',0,600,0,46,0,0,0,0,'false','armor_t75_g_i00',0,1,0,'0','0',0,0),
	(9090,'Shadow Item: Dark Crystal Boots','','feet','false','none',NULL,370,'a',0,600,0,46,0,0,0,0,'false','armor_t75_b_i00',0,1,0,'0','0',0,0),
	(9091,'Shadow Item: Dark Crystal Robe','','fullarmor','false','magic',NULL,817,'a',0,600,0,139,0,665,0,0,'false','armor_t76_ul_i00',0,1,0,'0','0',0,0),
	(9092,'Shadow Item: Dark Crystal Gloves','','gloves','false','none',NULL,193,'a',0,600,0,46,0,0,0,0,'false','armor_t76_g_i00',0,1,0,'0','0',0,0),
	(9093,'Shadow Item: Dark Crystal Boots','','feet','false','none',NULL,370,'a',0,600,0,46,0,0,0,0,'false','armor_t76_b_i00',0,1,0,'0','0',0,0),
	(9094,'Shadow Item: Majestic Plate Armor','','fullarmor','false','heavy',NULL,3067,'a',0,600,0,293,0,0,0,0,'false','armor_t83_ul_i00',0,1,0,'0','0',0,0),
	(9095,'Shadow Item: Magestic Circlet','','head','false','none',NULL,183,'a',0,600,0,73,0,0,0,0,'false','armor_leather_helmet_i00',0,1,0,'0','0',0,0),
	(9096,'Shadow Item: Magestic Gauntlet','','gloves','false','none',NULL,180,'a',0,600,0,49,0,0,0,0,'false','armor_t83_g_i00',0,1,0,'0','0',0,0),
	(9097,'Shadow Item: Magestic Boots','','feet','false','none',NULL,370,'a',0,600,0,49,0,0,0,0,'false','armor_t83_b_i00',0,1,0,'0','0',0,0),
	(9098,'Shadow Item: Majestic Leather Armor','','fullarmor','false','light',NULL,1783,'a',0,600,0,220,0,0,0,0,'false','armor_t84_ul_i00',0,1,0,'0','0',0,0),
	(9099,'Shadow Item: Magestic Gauntlet','','gloves','false','none',NULL,180,'a',0,600,0,49,0,0,0,0,'false','armor_t84_g_i00',0,1,0,'0','0',0,0),
	(9100,'Shadow Item: Magestic Boots','','feet','false','none',NULL,370,'a',0,600,0,49,0,0,0,0,'false','armor_t84_b_i00',0,1,0,'0','0',0,0),
	(9101,'Shadow Item: Magestic Robe','','fullarmor','false','magic',NULL,777,'a',0,600,0,147,0,718,0,0,'false','armor_t85_ul_i00',0,1,0,'0','0',0,0),
	(9102,'Shadow Item: Magestic Gauntlet','','gloves','false','none',NULL,180,'a',0,600,0,49,0,0,0,0,'false','armor_t85_g_i00',0,1,0,'0','0',0,0),
	(9103,'Shadow Item: Magestic Boots','','feet','false','none',NULL,370,'a',0,600,0,49,0,0,0,0,'false','armor_t85_b_i00',0,1,0,'0','0',0,0),
	(9128,'Shadow Item: Mithril Gauntlet','','gloves','false','none',NULL,200,'c',0,600,0,36,0,0,0,0,'false','armor_t61_g_i00',0,1,0,'0','0',0,0),
	(9138,'Santa\'s Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_santas_cap_i00',1,1,1,'0','0',0,0),
	(9145,'Little Angel Wings (Event)','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessory_hair_ring_i00',0,1,0,'0','0',0,0),
	(9158,'Golden Circlet of Redemption','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','Accessary_gold_circlet_i00',1,1,1,'0','0',0,0),
	(9159,'Silver Circlet of Salvation','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','Accessary_gold_circlet_i01',1,1,1,'0','0',0,0),
	(9160,'Pig Wrangler\'s Cap','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','Accessary_middle_ages_i00',1,1,1,'0','0',0,0),
	(9161,'Santa\'s Antlers','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_santas_antler_i00',1,1,1,'0','0',0,0),
	(9177,'Shadow Item - Teddy Bear Hat','Resurrection','dhair','false','none',NULL,10,'none',0,360,0,0,0,0,0,0,'false','accessory_bear_cap_i00',0,1,0,'3263','1',0,0),
	(9178,'Shadow Item - Piggy Hat','Resurrection','dhair','false','none',NULL,10,'none',0,360,0,0,0,0,0,0,'false','accessory_pig_cap_i00',0,1,0,'3263','1',0,0),
	(9179,'Shadow Item - Jester Hat','Resurrection','dhair','false','none',NULL,10,'none',0,360,0,0,0,0,0,0,'false','accessory_jester_cap_i00',0,1,0,'3263','1',0,0),
	(9180,'Shadow Item - Wizard Hat','Resurrection','dhair','false','none',NULL,10,'none',0,360,0,0,0,0,0,0,'false','accessory_magic_cap_i00',0,1,0,'3263','1',0,0),
	(9181,'Shadow Item - Dapper Cap','Resurrection','dhair','false','none',NULL,10,'none',0,360,0,0,0,0,0,0,'false','accessory_dandy_cap_i00',0,1,0,'3263','1',0,0),
	(9182,'Shadow Item - Romantic Chapeau','Resurrection','dhair','false','none',NULL,10,'none',0,360,0,0,0,0,0,0,'false','accessory_romantic_chaperon_i00',0,1,0,'3263','1',0,0),
	(9183,'Shadow Item - Iron Circlet','Resurrection','face','false','none',NULL,10,'none',0,360,0,0,0,0,0,0,'false','accessory_iron_circlet_i00',0,1,0,'3263','1',0,0),
	(9184,'Shadow Item - Teddy Bear Hat','Escape','dhair','false','none',NULL,10,'none',0,360,0,0,0,0,0,0,'false','accessory_bear_cap_i00',0,1,0,'3264','1',0,0),
	(9185,'Shadow Item - Piggy Hat','Escape','dhair','false','none',NULL,10,'none',0,360,0,0,0,0,0,0,'false','accessory_pig_cap_i00',0,1,0,'3264','1',0,0),
	(9186,'Shadow Item - Jester Hat','Escape','dhair','false','none',NULL,10,'none',0,360,0,0,0,0,0,0,'false','accessory_jester_cap_i00',0,1,0,'3264','1',0,0),
	(9187,'Shadow Item - Wizard Hat','Escape','dhair','false','none',NULL,10,'none',0,360,0,0,0,0,0,0,'false','accessory_magic_cap_i00',0,1,0,'3264','1',0,0),
	(9188,'Shadow Item - Dapper Cap','Escape','dhair','false','none',NULL,10,'none',0,360,0,0,0,0,0,0,'false','accessory_dandy_cap_i00',0,1,0,'3264','1',0,0),
	(9189,'Shadow Item - Romantic Chapeau','Escape','dhair','false','none',NULL,10,'none',0,360,0,0,0,0,0,0,'false','accessory_romantic_chaperon_i00',0,1,0,'3264','1',0,0),
	(9190,'Shadow Item - Iron Circlet','Escape','face','false','none',NULL,10,'none',0,360,0,0,0,0,0,0,'false','accessory_iron_circlet_i00',0,1,0,'3264','1',0,0),
	(9191,'Shadow Item - Teddy Bear Hat','Big Head','dhair','false','none',NULL,10,'none',0,360,0,0,0,0,0,0,'false','accessory_bear_cap_i00',0,1,0,'3265','1',0,0),
	(9192,'Shadow Item - Piggy Hat','Big Head','dhair','false','none',NULL,10,'none',0,360,0,0,0,0,0,0,'false','accessory_pig_cap_i00',0,1,0,'3265','1',0,0),
	(9193,'Shadow Item - Jester Hat','Big Head','dhair','false','none',NULL,10,'none',0,360,0,0,0,0,0,0,'false','accessory_jester_cap_i00',0,1,0,'3265','1',0,0),
	(9194,'Shadow Item - Wizard Hat','Big Head','dhair','false','none',NULL,10,'none',0,360,0,0,0,0,0,0,'false','accessory_magic_cap_i00',0,1,0,'3265','1',0,0),
	(9195,'Shadow Item - Dapper Cap','Big Head','dhair','false','none',NULL,10,'none',0,360,0,0,0,0,0,0,'false','accessory_dandy_cap_i00',0,1,0,'3265','1',0,0),
	(9196,'Shadow Item - Romantic Chapeau','Big Head','dhair','false','none',NULL,10,'none',0,360,0,0,0,0,0,0,'false','accessory_romantic_chaperon_i00',0,1,0,'3265','1',0,0),
	(9197,'Shadow Item - Iron Circlet','Big Head','face','false','none',NULL,10,'none',0,360,0,0,0,0,0,0,'false','accessory_iron_circlet_i00',0,1,0,'3265','1',0,0),
	(9198,'Shadow Item - Teddy Bear Hat','Firework','dhair','false','none',NULL,10,'none',0,360,0,0,0,0,0,0,'false','accessory_bear_cap_i00',0,1,0,'3266','1',0,0),
	(9199,'Shadow Item - Piggy Hat','Firework','dhair','false','none',NULL,10,'none',0,360,0,0,0,0,0,0,'false','accessory_pig_cap_i00',0,1,0,'3266','1',0,0),
	(9200,'Shadow Item - Jester Hat','Firework','dhair','false','none',NULL,10,'none',0,360,0,0,0,0,0,0,'false','accessory_jester_cap_i00',0,1,0,'3266','1',0,0),
	(9201,'Shadow Item - Wizard Hat','Firework','dhair','false','none',NULL,10,'none',0,360,0,0,0,0,0,0,'false','accessory_magic_cap_i00',0,1,0,'3266','1',0,0),
	(9202,'Shadow Item - Dapper Cap','Firework','dhair','false','none',NULL,10,'none',0,360,0,0,0,0,0,0,'false','accessory_dandy_cap_i00',0,1,0,'3266','1',0,0),
	(9203,'Shadow Item - Romantic Chapeau','Firework','dhair','false','none',NULL,10,'none',0,360,0,0,0,0,0,0,'false','accessory_romantic_chaperon_i00',0,1,0,'3266','1',0,0),
	(9204,'Shadow Item - Iron Circlet','Firework','face','false','none',NULL,10,'none',0,360,0,0,0,0,0,0,'false','accessory_iron_circlet_i00',0,1,0,'3266','1',0,0),
	(9208,'Phantom Mask (Event)','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessary_mask_of_chaotic_i00',0,1,0,'0','0',0,0),
	(9391,'Human Circlet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessary_human_circlet_i00',0,1,0,'0','0',0,0),
	(9392,'Elven Circlet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessary_elf_circlet_i00',0,1,0,'0','0',0,0),
	(9393,'Dark Elven Circlet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessary_darkelf_circlet_i00',0,1,0,'0','0',0,0),
	(9394,'Orcish Circlet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessary_orc_circlet_i00',0,1,0,'0','0',0,0),
	(9395,'Dwarven Circlet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessary_dwarf_circlet_i00',0,1,0,'0','0',0,0),
	(9396,'Kamaelic Circlet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessary_kamael_circlet_i00',0,1,0,'0','0',0,0),
	(9397,'Shield Master Circlet','','dhair','false','none','ShieldMaster',10,'none',0,-1,0,0,0,0,0,0,'false','accessary_knight_circlet_i00',0,1,0,'0','0',0,0),
	(9398,'Bard Circlet','','dhair','false','none','Bard',10,'none',0,-1,0,0,0,0,0,0,'false','accessary_enchant_knight_circlet_i00',0,1,0,'0','0',0,0),
	(9399,'Force Master Circlet','','dhair','false','none','ForceMaster',10,'none',0,-1,0,0,0,0,0,0,'false','accessary_force_master_circlet_i00',0,1,0,'0','0',0,0),
	(9400,'Weapon Master Circlet','','dhair','false','none','WeaponMaster',10,'none',0,-1,0,0,0,0,0,0,'false','accessary_weapon_master_circlet_i00',0,1,0,'0','0',0,0),
	(9401,'Dagger Master Circlet','','dhair','false','none','DaggerMaster',10,'none',0,-1,0,0,0,0,0,0,'false','accessary_dagger_master_circlet_i00',0,1,0,'0','0',0,0),
	(9402,'Bow Master Circlet','','dhair','false','none','BowMaster',10,'none',0,-1,0,0,0,0,0,0,'false','accessary_bow_master_circlet_i00',0,1,0,'0','0',0,0),
	(9403,'Wizard Circlet','','dhair','false','none','Wizard',10,'none',0,-1,0,0,0,0,0,0,'false','accessary_wizard_circlet_i00',0,1,0,'0','0',0,0),
	(9404,'Summoner Circlet','','dhair','false','none','Summoner',10,'none',0,-1,0,0,0,0,0,0,'false','accessary_summoner_circlet_i00',0,1,0,'0','0',0,0),
	(9405,'Healer Circlet','','dhair','false','none','Healer',10,'none',0,-1,0,0,0,0,0,0,'false','accessary_healer_circlet_i00',0,1,0,'0','0',0,0),
	(9406,'Enchanter Circlet','','dhair','false','none','Enchanter',10,'none',0,-1,0,0,0,0,0,0,'false','accessary_enchanter_circlet_i00',0,1,0,'0','0',0,0),
	(9407,'Weapon Master Circlet (Kamael only)','','dhair','false','none','WeaponMaster',10,'none',0,-1,0,0,0,0,0,0,'false','accessary_weapon_master_circlet_i00',0,1,0,'0','0',0,0),
	(9408,'Bow Master Circlet (Kamael only)','','dhair','false','none','BowMaster',10,'none',0,-1,0,0,0,0,0,0,'false','accessary_bow_master_circlet_i00',0,1,0,'0','0',0,0),
	(9409,'Black Phantom Mask (Event)','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessory_high_phantom_mask_i00',0,1,0,'0','0',0,0),
	(9410,'Human Veteran\'s Circlet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessary_human_high_circlet_i00',0,1,0,'0','0',0,0),
	(9411,'Elven Veteran\'s Circlet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessary_elf_high_circlet_i00',0,1,0,'0','0',0,0),
	(9412,'Dark Elven Veteran\'s Circlet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessary_darkelf_high_circlet_i00',0,1,0,'0','0',0,0),
	(9413,'Orcish Veteran\'s Circlet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessary_orc_high_circlet_i00',0,1,0,'0','0',0,0),
	(9414,'Dwarf Veteran\'s Circlet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessary_dwarf_high_circlet_i00',0,1,0,'0','0',0,0),
	(9415,'Kamaelic Veteran\'s Circlet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessary_kamael_high_circlet_i00',0,1,0,'0','0',0,0),
	(9416,'Dynasty Breast Plate','','chest','true','heavy',NULL,7570,'s80',0,-1,0,226,0,0,24398000,1171,'false','armor_t91_u_i00',1,1,1,'0','0',0,0),
	(9417,'Dynasty Breast Plate','Shield Master','chest','true','heavy','ShieldMaster',7570,'s80',0,-1,0,226,0,0,24398000,1171,'false','armor_t91_uk_i00',1,1,1,'0','0',0,0),
	(9418,'Dynasty Breast Plate','Weapon Master','chest','true','heavy','WeaponMaster',7570,'s80',0,-1,0,226,0,0,24398000,1171,'false','armor_t91_uw_i00',1,1,1,'0','0',0,0),
	(9419,'Dynasty Breast Plate','Force Master','chest','true','heavy','ForceMaster',7570,'s80',0,-1,0,226,0,0,24398000,1171,'false','armor_t91_uf_i00',1,1,1,'0','0',0,0),
	(9420,'Dynasty Breast Plate','Bard','chest','true','heavy','Bard',7570,'s80',0,-1,0,226,0,0,24398000,1171,'false','armor_t91_uke_i00',1,1,1,'0','0',0,0),
	(9421,'Dynasty Gaiter','','legs','true','heavy',NULL,3210,'s80',0,-1,0,141,0,0,15248000,731,'false','armor_t91_l_i00',1,1,1,'0','0',0,0),
	(9422,'Dynasty Helmet','','head','true','none',NULL,530,'s80',0,-1,0,92,0,0,9149000,439,'false','armor_helmet_i00',1,1,1,'0','0',0,0),
	(9423,'Dynasty Gauntlet','Heavy Armor','gloves','true','none',NULL,520,'s80',0,-1,0,61,0,0,6099000,293,'false','armor_t91_g_i00',1,1,1,'0','0',0,0),
	(9424,'Dynasty Boots','Heavy Armor','feet','true','none',NULL,1090,'s80',0,-1,0,61,0,0,6099000,293,'false','armor_t91_b_i00',1,1,1,'0','0',0,0),
	(9425,'Dynasty Leather Armor','','chest','true','light',NULL,4180,'s80',0,-1,0,170,0,0,18298000,878,'false','armor_t92_u_i00',1,1,1,'0','0',0,0),
	(9426,'Dynasty Leather Armor','Dagger Master','chest','true','light','DaggerMaster',4180,'s80',0,-1,0,170,0,0,18298000,878,'false','armor_t92_ud_i00',1,1,1,'0','0',0,0),
	(9427,'Dynasty Leather Armor','Bow Master','chest','true','light','BowMaster',4180,'s80',0,-1,0,170,0,0,18298000,878,'false','armor_t92_ub_i00',1,1,1,'0','0',0,0),
	(9428,'Dynasty Leather Leggings','','legs','true','light',NULL,1370,'s80',0,-1,0,106,0,0,11436000,549,'false','armor_t92_l_i00',1,1,1,'0','0',0,0),
	(9429,'Dynasty Leather Helmet','','head','true','none',NULL,530,'s80',0,-1,0,92,0,0,9149000,439,'false','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(9430,'Dynasty Leather Gloves','Light Armor','gloves','true','none',NULL,520,'s80',0,-1,0,61,0,0,6099000,293,'false','armor_t92_g_i00',1,1,1,'0','0',0,0),
	(9431,'Dynasty Leather Boots','Light Armor','feet','true','none',NULL,1090,'s80',0,-1,0,61,0,0,6099000,293,'false','armor_t92_b_i00',1,1,1,'0','0',0,0),
	(9432,'Dynasty Tunic','','chest','true','magic',NULL,1780,'s80',0,-1,0,113,0,592,18298000,878,'false','armor_t93_u_i00',1,1,1,'0','0',0,0),
	(9433,'Dynasty Tunic','Healer','chest','true','magic','Healer',1780,'s80',0,-1,0,113,0,592,18298000,878,'false','armor_t93_uh_i00',1,1,1,'0','0',0,0),
	(9434,'Dynasty Tunic','Enchanter','chest','true','magic','Enchanter',1780,'s80',0,-1,0,113,0,592,18298000,878,'false','armor_t93_ue_i00',1,1,1,'0','0',0,0),
	(9435,'Dynasty Tunic','Summoner','chest','true','magic','Summoner',1780,'s80',0,-1,0,113,0,592,18298000,878,'false','armor_t93_us_i00',1,1,1,'0','0',0,0),
	(9436,'Dynasty Tunic','Wizard','chest','true','magic','Wizard',1780,'s80',0,-1,0,113,0,592,18298000,878,'false','armor_t93_uw_i00',1,1,1,'0','0',0,0),
	(9437,'Dynasty Stockings','','legs','true','magic',NULL,860,'s80',0,-1,0,71,0,370,11436000,549,'false','armor_t93_l_i00',1,1,1,'0','0',0,0),
	(9438,'Dynasty Circlet','','head','true','none',NULL,530,'s80',0,-1,0,92,0,0,9149000,439,'false','armor_circlet_i00',1,1,1,'0','0',0,0),
	(9439,'Dynasty Gloves','Robe','gloves','true','none',NULL,520,'s80',0,-1,0,61,0,0,6099000,293,'false','armor_t93_g_i00',1,1,1,'0','0',0,0),
	(9440,'Dynasty Shoes','Robe','feet','true','none',NULL,1090,'s80',0,-1,0,61,0,0,6099000,293,'false','armor_t93_b_i00',1,1,1,'0','0',0,0),
	(9452,'Sealed Dynasty Earring','','rear,lear','true','none',NULL,150,'s80',0,-1,0,0,71,0,4032000,194,'false','accessary_dynasty_earing_i01',1,1,1,'0','0',0,0),
	(9453,'Sealed Dynasty Necklace','','neck','true','none',NULL,150,'s80',0,-1,0,0,95,0,5376000,258,'false','accessary_dynasty_necklace_i01',1,1,1,'0','0',0,0),
	(9454,'Sealed Dynasty Ring','','rfinger,lfinger','true','none',NULL,150,'s80',0,-1,0,0,53,0,2688000,129,'false','accessary_dynasty_ring_i01',1,1,1,'0','0',0,0),
	(9455,'Dynasty Earrings','','rear,lear','true','none',NULL,150,'s80',0,-1,0,0,79,35,5956000,285,'false','accessary_dynasty_earing_i00',1,1,1,'0','0',0,0),
	(9456,'Dynasty Necklace','','neck','true','none',NULL,150,'s80',0,-1,0,0,106,46,7942000,381,'false','accessary_dynasty_necklace_i00',1,1,1,'0','0',0,0),
	(9457,'Dynasty Ring','','rfinger,lfinger','true','none',NULL,150,'s80',0,-1,0,0,60,23,3971000,190,'false','accessary_dynasty_ring_i00',1,1,1,'0','0',0,0),
	(9458,'Dynasty Earrings','Stun Resistance','rear,lear','true','none',NULL,150,'s80',0,-1,0,0,27,35,5956000,285,'false','accessary_dynasty_earing_i00',1,1,1,'3367','1',0,0),
	(9459,'Dynasty Necklace','Stun Resistance','neck','true','none',NULL,150,'s80',0,-1,0,0,36,46,7942000,381,'false','accessary_dynasty_necklace_i00',1,1,1,'3365','1',0,0),
	(9460,'Dynasty Ring','Stun Resistance','rfinger,lfinger','true','none',NULL,150,'s80',0,-1,0,0,18,23,3971000,190,'false','accessary_dynasty_ring_i00',1,1,1,'3366','1',0,0),
	(9461,'Dynasty Earrings','Poison Resistance','rear,lear','true','none',NULL,150,'s80',0,-1,0,0,27,35,5956000,285,'false','accessary_dynasty_earing_i00',1,1,1,'3379','1',0,0),
	(9462,'Dynasty Necklace','Poison Resistance','neck','true','none',NULL,150,'s80',0,-1,0,0,36,46,7942000,381,'false','accessary_dynasty_necklace_i00',1,1,1,'3377','1',0,0),
	(9463,'Dynasty Ring','Poison Resistance','rfinger,lfinger','true','none',NULL,150,'s80',0,-1,0,0,18,23,3971000,190,'false','accessary_dynasty_ring_i00',1,1,1,'3378','1',0,0),
	(9464,'Dynasty Earrings','Bleeding Resistance','rear,lear','true','none',NULL,150,'s80',0,-1,0,0,27,35,5956000,285,'false','accessary_dynasty_earing_i00',1,1,1,'3373','1',0,0),
	(9465,'Dynasty Necklace','Bleeding Resistance','neck','true','none',NULL,150,'s80',0,-1,0,0,36,46,7942000,381,'false','accessary_dynasty_necklace_i00',1,1,1,'3371','1',0,0),
	(9466,'Dynasty Ring','Bleeding Resistance','rfinger,lfinger','true','none',NULL,150,'s80',0,-1,0,0,18,23,3971000,190,'false','accessary_dynasty_ring_i00',1,1,1,'3372','1',0,0),
	(9467,'Dynasty Earrings','Sleep Resistance','rear,lear','true','none',NULL,150,'s80',0,-1,0,0,27,35,5956000,285,'false','accessary_dynasty_earing_i00',1,1,1,'3397','1',0,0),
	(9468,'Dynasty Necklace','Sleep Resistance','neck','true','none',NULL,150,'s80',0,-1,0,0,36,46,7942000,381,'false','accessary_dynasty_necklace_i00',1,1,1,'3395','1',0,0),
	(9469,'Dynasty Ring','Sleep Resistance','rfinger,lfinger','true','none',NULL,150,'s80',0,-1,0,0,18,23,3971000,190,'false','accessary_dynasty_ring_i00',1,1,1,'3396','1',0,0),
	(9470,'Dynasty Earrings','Paralysis Resistance','rear,lear','true','none',NULL,150,'s80',0,-1,0,0,27,35,5956000,285,'false','accessary_dynasty_earing_i00',1,1,1,'3385','1',0,0),
	(9471,'Dynasty Necklace','Paralysis Resistance','neck','true','none',NULL,150,'s80',0,-1,0,0,36,46,7942000,381,'false','accessary_dynasty_necklace_i00',1,1,1,'3383','1',0,0),
	(9472,'Dynasty Ring','Paralysis Resistance','rfinger,lfinger','true','none',NULL,150,'s80',0,-1,0,0,18,23,3971000,190,'false','accessary_dynasty_ring_i00',1,1,1,'3384','1',0,0),
	(9473,'Dynasty Earrings','Hold Resistance','rear,lear','true','none',NULL,150,'s80',0,-1,0,0,27,35,5956000,285,'false','accessary_dynasty_earing_i00',1,1,1,'3391','1',0,0),
	(9474,'Dynasty Necklace','Hold Resistance','neck','true','none',NULL,150,'s80',0,-1,0,0,36,46,7942000,381,'false','accessary_dynasty_necklace_i00',1,1,1,'3389','1',0,0),
	(9475,'Dynasty Ring','Hold Resistance','rfinger,lfinger','true','none',NULL,150,'s80',0,-1,0,0,18,23,3971000,190,'false','accessary_dynasty_ring_i00',1,1,1,'3390','1',0,0),
	(9476,'Dynasty Earrings','Fear Resistance','rear,lear','true','none',NULL,150,'s80',0,-1,0,0,27,35,5956000,285,'false','accessary_dynasty_earing_i00',1,1,1,'3403','1',0,0),
	(9477,'Dynasty Necklace','Fear Resistance','neck','true','none',NULL,150,'s80',0,-1,0,0,36,46,7942000,381,'false','accessary_dynasty_necklace_i00',1,1,1,'3401','1',0,0),
	(9478,'Dynasty Ring','Fear Resistance','rfinger,lfinger','true','none',NULL,150,'s80',0,-1,0,0,18,23,3971000,190,'false','accessary_dynasty_ring_i00',1,1,1,'3402','1',0,0),
	(9479,'Dynasty Earrings (not used)','Darkness Resistance','rear,lear','true','none',NULL,150,'s80',0,-1,0,0,27,35,5956000,285,'false','accessary_dynasty_earing_i00',1,1,1,'0','0',0,0),
	(9480,'Dynasty Necklace (not used)','Darkness Resistance','neck','true','none',NULL,150,'s80',0,-1,0,0,36,46,7942000,381,'false','accessary_dynasty_necklace_i00',1,1,1,'0','0',0,0),
	(9481,'Dynasty Ring (not used)','Darkness Resistance','rfinger,lfinger','true','none',NULL,150,'s80',0,-1,0,0,18,23,3971000,190,'false','accessary_dynasty_ring_i00',1,1,1,'0','0',0,0),
	(9514,'Sealed Dynasty Breast Plate','','chest','true','heavy',NULL,7570,'s80',0,-1,0,214,0,0,24398000,1171,'false','armor_t91_u_i02',1,1,1,'0','0',0,0),
	(9515,'Sealed Dynasty Gaiter','','legs','true','heavy',NULL,3210,'s80',0,-1,0,134,0,0,15248000,731,'false','armor_t91_l_i02',1,1,1,'0','0',0,0),
	(9516,'Sealed Dynasty Helmet','','head','true','none',NULL,530,'s80',0,-1,0,92,0,0,9149000,439,'false','armor_helmet_i02',1,1,1,'0','0',0,0),
	(9517,'Sealed Dynasty Gauntlets','','gloves','true','none',NULL,520,'s80',0,-1,0,61,0,0,6099000,293,'false','armor_t91_g_i02',1,1,1,'0','0',0,0),
	(9518,'Sealed Dynasty Boots','','feet','true','none',NULL,1090,'s80',0,-1,0,61,0,0,6099000,293,'false','armor_t91_b_i02',1,1,1,'0','0',0,0),
	(9519,'Sealed Dynasty Leather Armor','','chest','true','light',NULL,4180,'s80',0,-1,0,161,0,0,18298000,878,'false','armor_t92_u_i02',1,1,1,'0','0',0,0),
	(9520,'Sealed Dynasty Leather Leggings','','legs','true','light',NULL,1370,'s80',0,-1,0,100,0,0,11436000,549,'false','armor_t92_l_i02',1,1,1,'0','0',0,0),
	(9521,'Sealed Dynasty Leather Helmet','','head','true','none',NULL,530,'s80',0,-1,0,92,0,0,9149000,439,'false','armor_leather_helmet_i02',1,1,1,'0','0',0,0),
	(9522,'Sealed Dynasty Leather Gloves','','gloves','true','none',NULL,520,'s80',0,-1,0,61,0,0,6099000,293,'false','armor_t92_g_i02',1,1,1,'0','0',0,0),
	(9523,'Sealed Dynasty Leather Boots','','feet','true','none',NULL,1090,'s80',0,-1,0,61,0,0,6099000,293,'false','armor_t92_b_i02',1,1,1,'0','0',0,0),
	(9524,'Sealed Dynasty Tunic','','chest','true','magic',NULL,1780,'s80',0,-1,0,107,0,592,18298000,878,'false','armor_t93_u_i02',1,1,1,'0','0',0,0),
	(9525,'Sealed Dynasty Stockings','','legs','true','magic',NULL,860,'s80',0,-1,0,67,0,370,11436000,549,'false','armor_t93_l_i02',1,1,1,'0','0',0,0),
	(9526,'Sealed Dynasty Circlet','','head','true','none',NULL,530,'s80',0,-1,0,92,0,0,9149000,439,'false','armor_circlet_i02',1,1,1,'0','0',0,0),
	(9527,'Sealed Dynasty Gloves','','gloves','true','none',NULL,520,'s80',0,-1,0,61,0,0,6099000,293,'false','armor_t93_g_i02',1,1,1,'0','0',0,0),
	(9528,'Sealed Dynasty Shoes','','feet','true','none',NULL,1090,'s80',0,-1,0,61,0,0,6099000,293,'false','armor_t93_b_i02',1,1,1,'0','0',0,0),
	(9577,'Cotton Shirt','','underwear','false','none',NULL,130,'none',0,-1,0,6,0,0,1300,0,'true','etc_shirts_none_i00',1,1,1,'0','0',0,0),
	(9578,'Linen Shirt','','underwear','true','none',NULL,130,'d',0,-1,0,12,0,0,25000,39,'true','etc_shirts_d_i01',1,1,1,'0','0',0,0),
	(9579,'Silk Shirt','','underwear','true','none',NULL,130,'c',0,-1,0,17,0,0,80000,27,'true','etc_shirts_c_i02',1,1,1,'0','0',0,0),
	(9580,'Thin Leather Shirt','','underwear','true','none',NULL,130,'b',0,-1,0,21,0,0,260000,29,'true','etc_shirts_b_i03',1,1,1,'0','0',0,0),
	(9581,'Scale Shirt','','underwear','true','none',NULL,130,'a',0,-1,0,23,0,0,588000,39,'true','etc_shirts_a_i04',1,1,1,'0','0',0,0),
	(9582,'Mithril Shirt','','underwear','true','none',NULL,130,'s',0,-1,0,28,0,0,1800000,86,'true','etc_shirts_s_i05',1,1,1,'0','0',0,0),
	(9583,'Striped Cotton Shirt','','underwear','false','none',NULL,130,'none',0,-1,0,8,0,0,6100,0,'true','etc_stripe_shirts_none_i00',1,1,1,'0','0',0,0),
	(9584,'Striped Linen Shirt','','underwear','true','none',NULL,130,'d',0,-1,0,14,0,0,49000,75,'true','etc_stripe_shirts_d_i01',1,1,1,'0','0',0,0),
	(9585,'Striped Silk Shirt','','underwear','true','none',NULL,130,'c',0,-1,0,19,0,0,180000,60,'true','etc_stripe_shirts_c_i02',1,1,1,'0','0',0,0),
	(9586,'Thin Striped Leather Shirt','','underwear','true','none',NULL,130,'b',0,-1,0,22,0,0,400000,44,'true','etc_stripe_shirts_b_i03',1,1,1,'0','0',0,0),
	(9587,'Striped Scale Shirt','','underwear','true','none',NULL,130,'a',0,-1,0,26,0,0,880000,59,'true','etc_stripe_shirts_a_i04',1,1,1,'0','0',0,0),
	(9588,'Striped Mithril Shirt','','underwear','true','none',NULL,130,'s',0,-1,0,30,0,0,2540000,122,'true','etc_stripe_shirts_s_i05',1,1,1,'0','0',0,0),
	(9589,'Iron Bracelet','','rbracelet','true','none',NULL,150,'c',0,-1,0,0,0,0,216000,72,'true','etc_rbracelet_c_i00',1,1,1,'3322','1',0,0),
	(9590,'Bronze Bracelet','','rbracelet','true','none',NULL,150,'b',0,-1,0,0,0,0,480000,53,'false','etc_rbracelet_b_i01',1,1,1,'3323','1',0,0),
	(9591,'Steel Bracelet','','rbracelet','true','none',NULL,150,'a',0,-1,0,0,0,0,1144000,76,'false','etc_rbracelet_a_i02',1,1,1,'3324','1',0,0),
	(9592,'Mithril Bracelet','','rbracelet','true','none',NULL,150,'s',0,-1,0,0,0,0,3556000,171,'false','etc_rbracelet_s_i03',1,1,1,'3325','1',0,0),
	(9605,'Agathion Seal Bracelet - Rainbow Clan Hall','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,7000000,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'3269;5414','1;1',0,0),
	(9606,'Agathion Seal Bracelet - Wild Beast Reserve','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,7000000,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'3270;5413','1;1',0,0),
	(9607,'Agathion Seal Bracelet - Gludio','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,30000000,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'3268;5415','1;1',0,0),
	(9608,'Agathion Seal Bracelet - Dion','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,30000000,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'3268;5415','1;1',0,0),
	(9609,'Agathion Seal Bracelet - Giran','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,30000000,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'3268;5415','1;1',0,0),
	(9610,'Agathion Seal Bracelet - Oren','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,30000000,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'3268;5415','1;1',0,0),
	(9611,'Agathion Seal Bracelet - Aden','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,30000000,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'3268;5415','1;1',0,0),
	(9612,'Agathion Seal Bracelet - Innadril','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,30000000,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'3268;5415','1;1',0,0),
	(9613,'Agathion Seal Bracelet - Goddard','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,30000000,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'3268;5415','1;1',0,0),
	(9614,'Agathion Seal Bracelet - Rune','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,30000000,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'3268;5415','1;1',0,0),
	(9615,'Agathion Seal Bracelet - Schuttgart','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,30000000,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'3268;5415','1;1',0,0),
	(9662,'Great Wolf Scale Armor','','gwolf','false','pet',NULL,160,'none',0,-1,0,112,14,0,1877000,0,'true','etc_wolf_r_a_01',1,1,1,'0','0',0,0),
	(9663,'Great Wolf Bronze Armor','','gwolf','false','pet',NULL,160,'none',0,-1,0,124,14,0,3620000,0,'true','etc_wolf_r_a_01',1,1,1,'0','0',0,0),
	(9664,'Great Wolf Plate Armor','','gwolf','false','pet',NULL,160,'none',0,-1,0,136,14,0,7126000,0,'true','etc_wolf_r_a_01',1,1,1,'0','0',0,0),
	(9665,'Great Wolf Mithril Armor','','gwolf','false','pet',NULL,160,'none',0,-1,0,148,14,0,12563000,0,'true','etc_wolf_r_a_01',1,1,1,'0','0',0,0),
	(9666,'Great Wolf Oriharukon Armor','','gwolf','false','pet',NULL,160,'none',0,-1,0,160,14,0,24236000,0,'true','etc_wolf_r_a_01',1,1,1,'0','0',0,0),
	(9667,'Great Wolf Orichalcum Armor','','gwolf','false','pet',NULL,160,'none',0,-1,0,171,14,0,48879000,0,'true','etc_wolf_r_a_01',1,1,1,'0','0',0,0),
	(9669,'Native Helmet','','head','false','none',NULL,70,'none',0,-1,0,33,0,0,0,0,'true','armor_leather_helmet_i00',0,1,0,'0','0',0,0),
	(9670,'Native Tunic','','chest','false','light',NULL,4720,'none',0,-1,0,53,0,0,0,0,'true','armor_t34_u_i00',0,1,0,'0','0',0,0),
	(9671,'Native Pants','','legs','false','light',NULL,1700,'none',0,-1,0,29,0,0,0,0,'true','armor_t34_l_i00',0,1,0,'0','0',0,0),
	(9677,'Ring of Wind Mastery','','rfinger,lfinger','false','none',NULL,150,'b',0,-1,0,0,36,0,616000,0,'true','accessary_ring_of_mana_i00',1,1,1,'0','0',0,0),
	(9820,'Shadow Item: Clan Oath Helm','','head','false','none',NULL,210,'d',0,300,0,37,0,0,0,0,'true','armor_helmet_i00',0,1,0,'0','0',0,0),
	(9821,'Shadow Item: Clan Oath Armor','','fullarmor','false','heavy',NULL,3290,'d',0,300,0,158,0,0,0,0,'true','armor_t1001_ul_i00',0,1,0,'0','0',0,0),
	(9822,'Shadow Item: Clan Oath Gauntlets','Heavy Armor','gloves','false','none',NULL,210,'d',0,300,0,24,0,0,0,0,'true','armor_t1001_g_i00',0,1,0,'0','0',0,0),
	(9823,'Shadow Item: Clan Oath Sabaton','Heavy Armor','feet','false','none',NULL,430,'d',0,300,0,24,0,0,0,0,'true','armor_t1001_b_i00',0,1,0,'0','0',0,0),
	(9824,'Shadow Item: Clan Oath Brigandine','','fullarmor','false','light',NULL,1800,'d',0,300,0,119,0,0,0,0,'true','armor_t1002_ul_i00',0,1,0,'0','0',0,0),
	(9825,'Shadow Item: Clan Oath Leather Gloves','Light Armor','gloves','false','none',NULL,210,'d',0,300,0,24,0,0,0,0,'true','armor_t1002_g_i00',0,1,0,'0','0',0,0),
	(9826,'Shadow Item: Clan Oath Boots','Light Armor','feet','false','none',NULL,430,'d',0,300,0,24,0,0,0,0,'false','armor_t1002_b_i00',0,1,0,'0','0',0,0),
	(9827,'Shadow Item: Clan Oath Aketon','','fullarmor','false','magic',NULL,820,'d',0,300,0,79,0,239,0,0,'true','armor_t1003_ul_i00',0,1,0,'0','0',0,0),
	(9828,'Shadow Item: Clan Oath Padded Gloves','Robe','gloves','false','none',NULL,210,'d',0,300,0,24,0,0,0,0,'true','armor_t1003_g_i00',0,1,0,'0','0',0,0),
	(9829,'Shadow Item: Clan Oath Sandals','Robe','feet','false','none',NULL,430,'d',0,300,0,24,0,0,0,0,'true','armor_t1003_b_i00',0,1,0,'0','0',0,0),
	(9830,'Improved Apella Helm','','head','true','none',NULL,570,'a',0,-1,0,73,0,0,2032000,163,'false','armor_helmet_i00',1,1,1,'0','0',0,0),
	(9831,'Improved Apella Plate Armor','','fullarmor','true','heavy',NULL,9780,'a',0,-1,0,293,0,0,8804000,704,'false','armor_t1004_ul_i00',1,1,1,'0','0',0,0),
	(9832,'Improved Apella Gauntlet','Heavy Armor','gloves','true','none',NULL,580,'a',0,-1,0,49,0,0,1355000,108,'false','armor_t1004_g_i00',1,1,1,'0','0',0,0),
	(9833,'Improved Apella Solleret','Heavy Armor','feet','true','none',NULL,1130,'a',0,-1,0,49,0,0,1355000,108,'false','armor_t1004_b_i00',1,1,1,'0','0',0,0),
	(9834,'Improved Apella Brigandine','','fullarmor','true','light',NULL,5400,'a',0,-1,0,220,0,0,6603000,528,'false','armor_t1005_ul_i00',1,1,1,'0','0',0,0),
	(9835,'Improved Apella Leather Gloves','Light Armor','gloves','true','none',NULL,580,'a',0,-1,0,49,0,0,1355000,108,'false','armor_t1005_g_i00',1,1,1,'0','0',0,0),
	(9836,'Improved Apella Boots','Light Armor','feet','true','none',NULL,1130,'a',0,-1,0,49,0,0,1355000,108,'false','armor_t1005_b_i00',1,1,1,'0','0',0,0),
	(9837,'Improved Apella Doublet','','fullarmor','true','magic',NULL,2450,'a',0,-1,0,147,0,718,6603000,528,'false','armor_t1006_ul_i00',1,1,1,'0','0',0,0),
	(9838,'Improved Apella Silk Gloves','Robe','gloves','true','none',NULL,580,'a',0,-1,0,49,0,0,1355000,108,'false','armor_t1006_g_i00',1,1,1,'0','0',0,0),
	(9839,'Improved Apella Sandals','Robe','feet','true','none',NULL,1130,'a',0,-1,0,49,0,0,1355000,108,'false','armor_t1006_b_i00',1,1,1,'0','0',0,0),
	(9883,'Teddy Bear Hat','Big Head','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_bear_cap_i00',1,1,1,'3265','1',0,0),
	(9884,'Piggy Hat','Big Head','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_pig_cap_i00',1,1,1,'3265','1',0,0),
	(9885,'Jester Hat','Big Head','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_jester_cap_i00',1,1,1,'3265','1',0,0),
	(9886,'Wizard Hat','Big Head','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_magic_cap_i00',1,1,1,'3265','1',0,0),
	(9887,'Dapper Cap','Big Head','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_dandy_cap_i00',1,1,1,'3265','1',0,0),
	(9888,'Romantic Chapeau','Big Head','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_romantic_chaperon_i00',1,1,1,'3265','1',0,0),
	(9889,'Iron Circlet','Big Head','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_iron_circlet_i00',1,1,1,'3265','1',0,0),
	(9890,'Teddy Bear Hat','Firework','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_bear_cap_i00',1,1,1,'3266','1',0,0),
	(9891,'Piggy Hat','Firework','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_pig_cap_i00',1,1,1,'3266','1',0,0),
	(9892,'Jester Hat','Firework','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_jester_cap_i00',1,1,1,'3266','1',0,0),
	(9893,'Wizard Hat','Firework','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_magic_cap_i00',1,1,1,'3266','1',0,0),
	(9894,'Dapper Cap','Firework','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_dandy_cap_i00',1,1,1,'3266','1',0,0),
	(9895,'Romantic Chapeau','Firework','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_romantic_chaperon_i00',1,1,1,'3266','1',0,0),
	(9896,'Iron Circlet','Firework','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_iron_circlet_i00',1,1,1,'3266','1',0,0),
	(9899,'Weight Loss Ring','','rfinger,lfinger','false','none',NULL,150,'none',0,-1,0,0,24,0,25,0,'true','accessary_ring_of_mana_i00',1,1,1,'0','0',0,0),
	(9900,'Quiet Footsteps Ring','','rfinger,lfinger','false','none',NULL,150,'none',0,400,0,0,0,0,25,0,'true','accessary_ring_of_mana_i00',0,1,0,'0','0',0,0),
	(9909,'Agathion Seal Bracelet','','lbracelet','false','none',NULL,150,'none',0,700,0,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'3361','1',0,0),
	(9913,'Talisman_Test','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_crystal_ball_silver_i00',0,1,0,'0','0',0,0),
	(9914,'Blue Talisman of Power','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i01',0,1,0,'3271','1',0,0),
	(9915,'Blue Talisman of Wild Magic','','talisman','false','none',NULL,150,'none',0,75,0,0,0,0,0,0,'true','etc_talisman_i01',0,1,0,'3277','1',0,0),
	(9916,'Blue Talisman of Defense','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i01',0,1,0,'3285','1',0,0),
	(9917,'Red Talisman of Minimum Clarity','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i00',0,1,0,'3281','1',0,0),
	(9918,'Red Talisman of Maximum Clarity','','talisman','false','none',NULL,150,'none',0,74,0,0,0,0,0,0,'true','etc_talisman_i00',0,1,0,'3282','1',0,0),
	(9919,'Blue Talisman of Reflection','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i01',0,1,0,'3410','1',0,0),
	(9920,'Blue Talisman of Invisibility','','talisman','false','none',NULL,150,'none',0,64,0,0,0,0,0,0,'true','etc_talisman_i01',0,1,0,'3280','1',0,0),
	(9921,'Blue Talisman - Shield Protection','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i01',0,1,0,'3274','1',0,0),
	(9922,'Black Talisman - Mending','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i05',0,1,0,'3286','1',0,0),
	(9923,'Black Talisman - Escape','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i05',0,1,0,'3289','1',0,0),
	(9924,'Blue Talisman of Healing','','talisman','false','none',NULL,150,'none',0,64,0,0,0,0,0,0,'true','etc_talisman_i01',0,1,0,'3283','1',0,0),
	(9925,'Red Talisman of Recovery','','talisman','false','none',NULL,150,'none',0,64,0,0,0,0,0,0,'true','etc_talisman_i00',0,1,0,'3273','1',0,0),
	(9926,'Blue Talisman of Defense','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i01',0,1,0,'3272','1',0,0),
	(9927,'Blue Talisman of Magic Defense','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i01',0,1,0,'3276','1',0,0),
	(9928,'Red Talisman of Mental Regeneration','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i00',0,1,0,'3278','1',0,0),
	(9929,'Blue Talisman of Protection','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i01',0,1,0,'3275','1',0,0),
	(9930,'Blue Talisman of Evasion','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i01',0,1,0,'3321','1',0,0),
	(9931,'Red Talisman of Meditation','','talisman','false','none',NULL,150,'none',0,74,0,0,0,0,0,0,'true','etc_talisman_i00',0,1,0,'3279','1',0,0),
	(9932,'Blue Talisman - Divine Protection','','talisman','false','none',NULL,150,'none',0,74,0,0,0,0,0,0,'true','etc_talisman_i01',0,1,0,'3284','1',0,0),
	(9933,'Yellow Talisman of Power','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i02',0,1,0,'3293','1',0,0),
	(9934,'Yellow Talisman of Violent Haste','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i02',0,1,0,'3301','1',0,0),
	(9935,'Yellow Talisman of Arcane Defense','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i02',0,1,0,'3296','1',0,0),
	(9936,'Yellow Talisman of Arcane Power','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i02',0,1,0,'3294','1',0,0),
	(9937,'Yellow Talisman of Arcane Haste','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i02',0,1,0,'3302','1',0,0),
	(9938,'Yellow Talisman of Accuracy','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i02',0,1,0,'3297','1',0,0),
	(9939,'Yellow Talisman of Defense','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i02',0,1,0,'3295','1',0,0),
	(9940,'Yellow Talisman of Alacrity','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i02',0,1,0,'3313','1',0,0),
	(9941,'Yellow Talisman of Speed','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i02',0,1,0,'3300','1',0,0),
	(9942,'Yellow Talisman of Critical Reduction','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i02',0,1,0,'3317','1',0,0),
	(9943,'Yellow Talisman of Critical Power','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i02',0,1,0,'3299','1',0,0),
	(9944,'Yellow Talisman of Critical Dodging','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i02',0,1,0,'3316','1',0,0),
	(9945,'Yellow Talisman of Evasion','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i02',0,1,0,'3298','1',0,0),
	(9946,'Yellow Talisman of Healing','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i02',0,1,0,'3312','1',0,0),
	(9947,'Yellow Talisman of CP Regeneration','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i02',0,1,0,'3311','1',0,0),
	(9948,'Yellow Talisman of Physical Regeneration','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i02',0,1,0,'3310','1',0,0),
	(9949,'Yellow Talisman of Mental Regeneration','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i02',0,1,0,'3320','1',0,0),
	(9950,'Grey Talisman of Weight Training','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i07',0,1,0,'3314','1',0,0),
	(9951,'Grey Talisman of Mid-Grade Fishing','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i07',0,1,0,'3315','1',0,0),
	(9952,'Orange Talisman - Hot Springs Recovery','','talisman','false','none',NULL,150,'none',0,64,0,0,0,0,0,0,'true','etc_talisman_i04',0,1,0,'3332','1',0,0),
	(9953,'Orange Talisman - Elixir of Life','','talisman','false','none',NULL,150,'none',0,64,0,0,0,0,0,0,'true','etc_talisman_i04',0,1,0,'3333','1',0,0),
	(9954,'Orange Talisman - Elixir of Mental Strength','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i04',0,1,0,'3334','1',0,0),
	(9955,'Black Talisman of Vocalization','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i05',0,1,0,'3291','1',0,0),
	(9956,'Black Talisman of Arcane Freedom','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i05',0,1,0,'3288','1',0,0),
	(9957,'Black Talisman of Physical Freedom','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i05',0,1,0,'3287','1',0,0),
	(9958,'Black Talisman of Rescue','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i05',0,1,0,'3290','1',0,0),
	(9959,'Black Talisman of Free Speech','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i05',0,1,0,'3292','1',0,0),
	(9960,'White Talisman of Bravery','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i06',0,1,0,'3306','1',0,0),
	(9961,'White Talisman of Motion','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i06',0,1,0,'3307','1',0,0),
	(9962,'White Talisman of Grounding','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i06',0,1,0,'3305','1',0,0),
	(9963,'White Talisman of Attention','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i06',0,1,0,'3304','1',0,0),
	(9964,'White Talisman of Bandages','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i06',0,1,0,'3303','1',0,0),
	(9965,'White Talisman of Protection','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i06',0,1,0,'3309','1',0,0),
	(9966,'White Talisman of Freedom','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i06',0,1,0,'3308','1',0,0),
	(10018,'Agathion Seal Bracelet - Fortress','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,5000000,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'3361;5458','1;1',0,0),
	(10019,'Ring Mail Breastplate','','chest','false','heavy',NULL,8820,'d',0,-1,0,77,0,0,64210,151,'true','armor_t12_u_i00',0,1,0,'0','0',0,0),
	(10020,'Iron Plate Gaiters','','legs','false','heavy',NULL,3820,'d',0,-1,0,48,0,0,40100,94,'true','armor_t12_l_i00',0,1,0,'0','0',0,0),
	(10021,'Puma Skin Shirt','','chest','false','light',NULL,4700,'d',0,-1,0,58,0,0,48200,113,'true','armor_t09_u_i00',0,1,0,'0','0',0,0),
	(10022,'Puma Skin Gaiters','','legs','false','light',NULL,1600,'d',0,-1,0,36,0,0,30100,71,'true','armor_t09_l_i00',0,1,0,'0','0',0,0),
	(10023,'Cursed Tunic','','chest','false','magic',NULL,2090,'d',0,-1,0,39,0,106,48200,113,'true','armor_t14_u_i00',0,1,0,'0','0',0,0),
	(10024,'Cursed Stockings','','legs','false','magic',NULL,1020,'d',0,-1,0,24,0,66,30100,71,'true','armor_t14_l_i00',0,1,0,'0','0',0,0),
	(10119,'Dynasty Sigil','','lhand','true','sigil',NULL,930,'s80',-8,-1,0,15,0,0,6404000,307,'true','dynasty_sigil_i00',1,1,1,'8311','1',0,0),
	(10120,'Sealed Dynasty Sigil','','lhand','true','sigil',NULL,930,'s80',-8,-1,0,15,0,0,6404000,307,'true','armor_dynasty_sigil_i01',1,1,1,'0','0',0,0),
	(10121,'Sealed Arcana Sigil','','lhand','true','sigil',NULL,940,'s',-8,-1,0,13,0,0,3355000,161,'true','arcana_sigil_i01',1,1,1,'0','0',0,0),
	(10122,'Red Crescent Earring','','rear,lear','false','none',NULL,150,'d',0,-1,0,0,24,0,20700,48,'true','accessary_red_cresent_earing_i00',0,1,0,'0','0',0,0),
	(10123,'Necklace of Devotion','','neck','false','none',NULL,150,'d',0,-1,0,0,32,0,27600,65,'true','accessary_necklace_of_devotion_i00',0,1,0,'0','0',0,0),
	(10124,'Ring of Devotion','','rfinger,lfinger','false','none',NULL,150,'d',0,-1,0,0,16,0,13800,32,'true','accessary_ring_of_devotion_i00',0,1,0,'0','0',0,0),
	(10126,'Dynasty Leather Armor','Force Master','chest','true','light','ForceMaster',4180,'s80',0,-1,0,170,0,0,18298000,878,'false','armor_t92_ud_i00',1,1,1,'0','0',0,0),
	(10127,'Dynasty Leather Armor','Weapon Master','chest','true','light','WeaponMaster',4180,'s80',0,-1,0,170,0,0,18298000,878,'false','armor_t92_ub_i00',1,1,1,'0','0',0,0),
	(10139,'Agathion Bracelet','','lbracelet','false','none',NULL,150,'none',0,700,0,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'3361','1',0,0),
	(10140,'Blessed Ring of Escape','','rfinger,lfinger','false','none',NULL,150,'none',0,250,0,0,24,0,0,0,'true','accessary_ring_of_mana_i00',0,1,0,'0','0',0,0),
	(10141,'Grey Talisman - Yeti Transform','','talisman','false','none',NULL,150,'none',0,70,0,0,0,0,50000,0,'true','etc_talisman_i07',0,1,0,'3335','1',0,0),
	(10142,'Grey Talisman - Buffalo Transform','','talisman','false','none',NULL,150,'none',0,70,0,0,0,0,50000,0,'true','etc_talisman_i07',0,1,0,'3336','1',0,0),
	(10158,'Grey Talisman of Upper Grade Fishing','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i07',0,1,0,'3315','1',0,0),
	(10168,'Dynasty Leather Armor','Enchanter','chest','true','light','Enchanter',4180,'s80',0,-1,0,170,0,0,18298000,878,'false','armor_t92_ud_i00',1,1,1,'0','0',0,0),
	(10169,'Enchanter Circlet (Kamael only)','','dhair','false','none','Enchanter',10,'none',0,-1,0,0,0,0,0,0,'true','accessary_weapon_master_circlet_i00',1,1,1,'0','0',0,0),
	(10170,'Baylor\'s Earring','','rear,lear','true','none',NULL,150,'s80',0,-1,0,0,71,31,12185000,487,'false','accessary_dynasty_earing_i00',1,1,1,'0','0',0,0),
	(10175,'Gobblin Circlet (Event)','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_taiwan_i00',0,1,0,'0','0',0,0),
	(10176,'White Half Mask','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_half_face_i00',1,1,1,'0','0',0,0),
	(10177,'Black Half Mask','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','Accessary_black_half_mask_i00',1,1,1,'0','0',0,0),
	(10207,'Enhanced Striped Scale Shirt','','underwear','true','none',NULL,130,'a',0,-1,0,26,0,0,880000,59,'true','etc_stripe_shirts_a_i04',1,1,1,'0','0',0,0),
	(10208,'Enhanced Striped Mithril Shirt','','underwear','true','none',NULL,130,'s',0,-1,0,30,0,70,2540000,122,'true','etc_stripe_shirts_s_i05',1,1,1,'0','0',0,0),
	(10209,'Enhanced Steel Bracelet','','rbracelet','true','none',NULL,150,'a',0,-1,0,0,0,60,1144000,76,'false','etc_rbracelet_a_i02',1,1,1,'0','0',0,0),
	(10210,'Enhanced Mithril Bracelet','','rbracelet','true','none',NULL,150,'s',0,-1,0,0,0,120,3556000,170,'false','etc_rbracelet_s_i03',1,1,1,'0','0',0,0),
	(10211,'Blessed Ring of Resurrection','','rfinger,lfinger','false','none',NULL,150,'none',0,180,0,0,24,0,0,0,'true','accessary_ring_of_mana_i00',0,1,0,'0','0',0,0),
	(10214,'Dynasty Leather Armor','Summoner','chest','true','light','Summoner',4180,'s80',0,-1,0,170,0,0,18298000,878,'false','armor_t92_u_i00',1,1,1,'0','0',0,0),
	(10227,'Dynasty Platinum Plate','','chest','true','heavy',NULL,7570,'s80',0,-1,0,226,0,0,33673000,1616,'false','armor_t91_u_i00',1,1,1,'0','0',0,0),
	(10228,'Dynasty Platinum Plate','Shield Master','chest','true','heavy','ShieldMaster',7570,'s80',0,-1,0,226,0,0,33673000,1616,'false','armor_t91_uk_i00',1,1,1,'0','0',0,0),
	(10229,'Dynasty Platinum Plate','Weapon Master','chest','true','heavy','WeaponMaster',7570,'s80',0,-1,0,226,0,0,33673000,1616,'false','armor_t91_uw_i00',1,1,1,'0','0',0,0),
	(10230,'Dynasty Platinum Plate','Force Master','chest','true','heavy','ForceMaster',7570,'s80',0,-1,0,226,0,0,33673000,1616,'false','armor_t91_uf_i00',1,1,1,'0','0',0,0),
	(10231,'Dynasty Platinum Plate','Bard','chest','true','heavy','Bard',7570,'s80',0,-1,0,226,0,0,33673000,1616,'false','armor_t91_uke_i00',1,1,1,'0','0',0,0),
	(10232,'Dynasty Jewel Leather Mail','','chest','true','light',NULL,4180,'s80',0,-1,0,170,0,0,25255000,1212,'false','armor_t92_u_i00',1,1,1,'0','0',0,0),
	(10233,'Dynasty Jewel Leather Mail','Dagger Master','chest','true','light','DaggerMaster',4180,'s80',0,-1,0,170,0,0,25255000,1212,'false','armor_t92_ud_i00',1,1,1,'0','0',0,0),
	(10234,'Dynasty Jewel Leather Mail','Bow Master','chest','true','light','BowMaster',4180,'s80',0,-1,0,170,0,0,25255000,1212,'false','armor_t92_ub_i00',1,1,1,'0','0',0,0),
	(10235,'Dynasty Silver Satin Tunic','','chest','true','magic',NULL,1780,'s80',0,-1,0,113,0,592,25255000,1212,'false','armor_t93_u_i00',1,1,1,'0','0',0,0),
	(10236,'Dynasty Silver Satin Tunic','Healer','chest','true','magic','Healer',1780,'s80',0,-1,0,113,0,592,25255000,1212,'false','armor_t93_uh_i00',1,1,1,'0','0',0,0),
	(10237,'Dynasty Silver Satin Tunic','Enchanter','chest','true','magic','Enchanter',1780,'s80',0,-1,0,113,0,592,25255000,1212,'false','armor_t93_ue_i00',1,1,1,'0','0',0,0),
	(10238,'Dynasty Silver Satin Tunic','Summoner','chest','true','magic','Summoner',1780,'s80',0,-1,0,113,0,592,25255000,1212,'false','armor_t93_us_i00',1,1,1,'0','0',0,0),
	(10239,'Dynasty Silver Satin Tunic','Wizard','chest','true','magic','Wizard',1780,'s80',0,-1,0,113,0,592,25255000,1212,'false','armor_t93_uw_i00',1,1,1,'0','0',0,0),
	(10240,'Bird Nest','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_nest_hat_i00',1,1,1,'0','0',0,0),
	(10241,'Purple Viking Circlet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_viking_circlet_violet_i00',1,1,1,'0','0',0,0),
	(10242,'Golden Viking Circlet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_viking_circlet_gold_i00',1,1,1,'0','0',0,0),
	(10243,'Panda Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_panda_cap_i00',1,1,1,'0','0',0,0),
	(10244,'White Sheep Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_sheep_cap_white_i00',1,1,1,'0','0',0,0),
	(10245,'Black Sheep Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_sheep_cap_black_i00',1,1,1,'0','0',0,0),
	(10246,'Frog Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_frog_cap_i00',1,1,1,'0','0',0,0),
	(10247,'Fish Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_fish_cap_i00',1,1,1,'0','0',0,0),
	(10248,'Straw Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_straw_hat_i00',1,1,1,'0','0',0,0),
	(10249,'Chicken Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_chicken_cap_i00',1,1,1,'0','0',0,0),
	(10250,'Adventurer Hat (Event)','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessory_explorer_hat_i00',0,1,0,'0','0',0,0),
	(10251,'Medieval Party Mask','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_middle_age_party_mask_i00',1,1,1,'0','0',0,0),
	(10273,'Wolf Summoning Bracelet','','lbracelet','false','none',NULL,150,'none',0,200,0,0,0,0,0,0,'true','etc_rbracelet_aga_agit_i00',0,1,0,'3421;3422','1;1',0,0),
	(10314,'Beleth\'s Ring','','rfinger,lfinger','true','none',NULL,150,'s',0,-1,0,0,48,21,2400000,152,'false','accessary_dynasty_ring_i00',1,1,1,'0','0',0,0),
	(10315,'Shadow Item - Purple Viking Circlet','','dhair','false','none',NULL,10,'none',0,500,0,0,0,0,0,0,'true','accessory_viking_circlet_violet_i00',0,1,0,'0','0',0,0),
	(10316,'Agathion Seal Bracelet - Little Angel','Firecracker','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'3423;5535;5538','1;1;1',0,0),
	(10317,'Agathion Seal Bracelet - Little Angel','Big Head','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'3423;5535;5539','1;1;1',0,0),
	(10318,'Agathion Seal Bracelet - Little Angel','Escape','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'3423;5535;5540','1;1;1',0,0),
	(10319,'Agathion Seal Bracelet - Little Angel','Resurrection','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'3423;5535;5541','1;1;1',0,0),
	(10320,'Agathion Seal Bracelet - Little Angel','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'3423;5535','1;1',0,0),
	(10321,'Shadow Item - Golden Viking Circlet','','dhair','false','none',NULL,10,'none',0,500,0,0,0,0,0,0,'true','accessory_viking_circlet_gold_i00',0,1,0,'0','0',0,0),
	(10322,'Agathion Seal Bracelet - Little Devil','Firecracker','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'3424;5536;5542','1;1;1',0,0),
	(10323,'Agathion Seal Bracelet - Little Devil','Big Head','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'3424;5536;5543','1;1;1',0,0),
	(10324,'Agathion Seal Bracelet - Little Devil','Escape','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'3424;5536;5544','1;1;1',0,0),
	(10325,'Agathion Seal Bracelet - Little Devil','Resurrection','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'3424;5536;5545','1;1;1',0,0),
	(10326,'Agathion Seal Bracelet - Little Devil','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'3424;5536','1;1',0,0),
	(10416,'Blue Talisman - Explosion','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i01',0,1,0,'3428','1',0,0),
	(10417,'Blue Talisman - Magic Explosion','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i01',0,1,0,'3437','1',0,0),
	(10418,'White Talisman - Storm','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i06',0,1,0,'3431','1',0,0),
	(10419,'White Talisman - Darkness','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i06',0,1,0,'3430','1',0,0),
	(10420,'White Talisman - Water','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i06',0,1,0,'3432','1',0,0),
	(10421,'White Talisman - Fire','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i06',0,1,0,'3433','1',0,0),
	(10422,'White Talisman - Light','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i06',0,1,0,'3435','1',0,0),
	(10423,'Blue Talisman - Self-Destruction','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i01',0,1,0,'3436','1',0,0),
	(10424,'Blue Talisman - Greater Healing','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i01',0,1,0,'3438','1',0,0),
	(10470,'Shadow Item - Red Crescent','','rear,lear','false','none',NULL,150,'d',0,180,0,0,24,0,0,0,'true','accessary_red_cresent_earing_i00',0,1,0,'0','0',0,0),
	(10471,'Shadow Item - Ring of Devotion','','rfinger,lfinger','false','none',NULL,150,'d',0,180,0,0,16,0,0,0,'true','accessary_ring_of_devotion_i00',0,1,0,'0','0',0,0),
	(10472,'Shadow Item - Necklace of Devotion','','neck','false','none',NULL,150,'d',0,180,0,0,32,0,0,0,'true','accessary_necklace_of_devotion_i00',0,1,0,'0','0',0,0),
	(10487,'Dynasty Jeweled Leather Armor','Force Master','chest','true','light','ForceMaster',4180,'s80',0,-1,0,170,0,0,25255000,1212,'false','armor_t92_u_i00',1,1,1,'0','0',0,0),
	(10488,'Dynasty Jeweled Leather Armor','Weapon Master','chest','true','light','WeaponMaster',4180,'s80',0,-1,0,170,0,0,25255000,1212,'false','armor_t92_u_i00',1,1,1,'0','0',0,0),
	(10489,'Dynasty Jeweled Leather Armor','Enchanter','chest','true','light','Enchanter',4180,'s80',0,-1,0,170,0,0,25255000,1212,'false','armor_t92_u_i00',1,1,1,'0','0',0,0),
	(10490,'Dynasty Jeweled Leather Armor','Summoner','chest','true','light','Summoner',4180,'s80',0,-1,0,170,0,0,25255000,1212,'false','armor_t92_u_i00',1,1,1,'0','0',0,0),
	(10491,'Silk Shirt','HP','underwear','true','none',NULL,130,'c',0,-1,0,17,0,0,80000,27,'false','etc_shirts_c_i02',1,1,1,'0','0',3439,1),
	(10492,'Silk Shirt','MP','underwear','true','none',NULL,130,'c',0,-1,0,17,0,0,80000,27,'false','etc_shirts_c_i02',1,1,1,'0','0',3440,1),
	(10493,'Silk Shirt','CP','underwear','true','none',NULL,130,'c',0,-1,0,17,0,0,80000,27,'false','etc_shirts_c_i02',1,1,1,'0','0',3441,1),
	(10494,'Thin Leather Shirt','HP','underwear','true','none',NULL,130,'b',0,-1,0,21,0,0,260000,29,'false','etc_shirts_b_i03',1,1,1,'0','0',3445,1),
	(10495,'Thin Leather Shirt','MP','underwear','true','none',NULL,130,'b',0,-1,0,21,0,0,260000,29,'false','etc_shirts_b_i03',1,1,1,'0','0',3446,1),
	(10496,'Thin Leather Shirt','CP','underwear','true','none',NULL,130,'b',0,-1,0,21,0,0,260000,29,'false','etc_shirts_b_i03',1,1,1,'0','0',3447,1),
	(10497,'Scale Shirt','HP','underwear','true','none',NULL,130,'a',0,-1,0,23,0,0,588000,39,'false','etc_shirts_a_i04',1,1,1,'0','0',3451,1),
	(10498,'Scale Shirt','MP','underwear','true','none',NULL,130,'a',0,-1,0,23,0,0,588000,39,'false','etc_shirts_a_i04',1,1,1,'0','0',3452,1),
	(10499,'Scale Shirt','CP','underwear','true','none',NULL,130,'a',0,-1,0,23,0,0,588000,39,'false','etc_shirts_a_i04',1,1,1,'0','0',3453,1),
	(10500,'Mithril Shirt','HP','underwear','true','none',NULL,130,'s',0,-1,0,28,0,0,1800000,86,'false','etc_shirts_s_i05',1,1,1,'0','0',3457,1),
	(10501,'Mithril Shirt','MP','underwear','true','none',NULL,130,'s',0,-1,0,28,0,0,1800000,86,'false','etc_shirts_s_i05',1,1,1,'0','0',3458,1),
	(10502,'Mithril Shirt','CP','underwear','true','none',NULL,130,'s',0,-1,0,28,0,0,1800000,86,'false','etc_shirts_s_i05',1,1,1,'0','0',3459,1),
	(10503,'Striped Silk Shirt','HP','underwear','true','none',NULL,130,'c',0,-1,0,19,0,0,180000,60,'false','etc_stripe_shirts_c_i02',1,1,1,'0','0',3463,1),
	(10504,'Striped Silk Shirt','MP','underwear','true','none',NULL,130,'c',0,-1,0,19,0,0,180000,60,'false','etc_stripe_shirts_c_i02',1,1,1,'0','0',3464,1),
	(10505,'Striped Silk Shirt','CP','underwear','true','none',NULL,130,'c',0,-1,0,19,0,0,180000,60,'false','etc_stripe_shirts_c_i02',1,1,1,'0','0',3465,1),
	(10506,'Thin Striped Leather Shirt','HP','underwear','true','none',NULL,130,'b',0,-1,0,22,0,0,400000,44,'false','etc_stripe_shirts_b_i03',1,1,1,'0','0',3469,1),
	(10507,'Thin Striped Leather Shirt','MP','underwear','true','none',NULL,130,'b',0,-1,0,22,0,0,400000,44,'false','etc_stripe_shirts_b_i03',1,1,1,'0','0',3470,1),
	(10508,'Thin Striped Leather Shirt','CP','underwear','true','none',NULL,130,'b',0,-1,0,22,0,0,400000,44,'false','etc_stripe_shirts_b_i03',1,1,1,'0','0',3471,1),
	(10509,'Striped Scale Shirt','HP','underwear','true','none',NULL,130,'a',0,-1,0,26,0,0,880000,59,'true','etc_stripe_shirts_a_i04',1,1,1,'0','0',3475,1),
	(10510,'Striped Scale Shirt','MP','underwear','true','none',NULL,130,'a',0,-1,0,26,0,0,880000,59,'true','etc_stripe_shirts_a_i04',1,1,1,'0','0',3476,1),
	(10511,'Striped Scale Shirt','CP','underwear','true','none',NULL,130,'a',0,-1,0,26,0,0,880000,59,'true','etc_stripe_shirts_a_i04',1,1,1,'0','0',3477,1),
	(10512,'Striped Mithril Shirt','HP','underwear','true','none',NULL,130,'s',0,-1,0,30,0,0,2540000,122,'true','etc_stripe_shirts_s_i05',1,1,1,'0','0',3481,1),
	(10513,'Striped Mithril Shirt','MP','underwear','true','none',NULL,130,'s',0,-1,0,30,0,0,2540000,122,'true','etc_stripe_shirts_s_i05',1,1,1,'0','0',3482,1),
	(10514,'Striped Mithril Shirt','CP','underwear','true','none',NULL,130,'s',0,-1,0,30,0,0,2540000,122,'true','etc_stripe_shirts_s_i05',1,1,1,'0','0',3483,1),
	(10518,'Red Talisman - Life Force','','talisman','false','none',NULL,150,'none',0,70,0,0,0,0,0,0,'true','etc_talisman_i00',0,1,0,'3429','1',0,0),
	(10519,'White Talisman -  Earth','','talisman','false','none',NULL,150,'none',0,80,0,0,0,0,0,0,'true','etc_talisman_i06',0,1,0,'3434','1',0,0),
	(10533,'Blue Talisman - Attack Power','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i01',0,1,0,'3487','1',0,0),
	(10534,'Blue Talisman - Shield Defense','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i01',0,1,0,'3488','1',0,0),
	(10535,'Yellow Talisman - Defense Power','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i02',0,1,0,'3490','1',0,0),
	(10536,'Yellow Talisman - Magic Power','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i02',0,1,0,'3489','1',0,0),
	(10537,'Yellow Talisman - Evasion','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i02',0,1,0,'3491','1',0,0),
	(10538,'Yellow Talisman - Healing Power','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i02',0,1,0,'3495','1',0,0),
	(10539,'Yellow Talisman - CP Recovery Rate','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i02',0,1,0,'3494','1',0,0),
	(10540,'Yellow Talisman - HP Recovery Rate','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i02',0,1,0,'3493','1',0,0),
	(10541,'Yellow Talisman - Low Grade MP regeneration rate','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i02',0,1,0,'3497','1',0,0),
	(10542,'Red Talisman - HP/CP Recovery','','talisman','false','none',NULL,150,'none',0,64,0,0,0,0,0,0,'true','etc_talisman_i00',0,1,0,'3496','1',0,0),
	(10543,'Yellow Talisman - Speed','','talisman','false','none',NULL,150,'none',0,60,0,0,0,0,0,0,'true','etc_talisman_i02',0,1,0,'3492','1',0,0),
	(10606,'Agathion Seal Bracelet - Rudolph','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'3425;5537','1;1',0,0),
	(10607,'Agathion Seal Bracelet - Rudolph','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'3425;5537','1;1',0,0),
	(10613,'Bird Nest (Event)','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_nest_hat_i00',0,1,0,'0','0',0,0),
	(10614,'White Wool Hat (Event)','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_sheep_cap_white_i00',0,1,0,'0','0',0,0),
	(10615,'Black Wool Hat (Event)','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_sheep_cap_black_i00',0,1,0,'0','0',0,0),
	(10616,'Straw Hat (Event)','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_straw_hat_i00',0,1,0,'0','0',0,0),
	(10617,'Ant Hat','Year 2008','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_ant_cap_i00',0,1,0,'0','0',0,0),
	(10618,'Ol Mahum Hat','Year 2008','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_ol_mahum_cap_i00',0,1,0,'0','0',0,0),
	(10619,'Wolf Hat','Year 2008','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_wolf_cap_i00',0,1,0,'0','0',0,0),
	(10620,'Shadow Item - Ant Hat','Blessed Scroll of Escape','dhair','false','none',NULL,10,'none',0,1440,0,0,0,0,0,0,'true','accessory_ant_cap_i00',0,1,0,'0','0',0,0),
	(10621,'Shadow Item - Ant Hat','Blessed Scroll of Resurrection','dhair','false','none',NULL,10,'none',0,1440,0,0,0,0,0,0,'true','accessory_ant_cap_i00',0,1,0,'0','0',0,0),
	(10622,'Shadow Item - Ant Hat','Firecracker','dhair','false','none',NULL,10,'none',0,1440,0,0,0,0,0,0,'true','accessory_ant_cap_i00',0,1,0,'0','0',0,0),
	(10623,'Shadow Item - Ant Hat','Big Head','dhair','false','none',NULL,10,'none',0,1440,0,0,0,0,0,0,'true','accessory_ant_cap_i00',0,1,0,'0','0',0,0),
	(10624,'Shadow Item - Ol Mahum Hat','Blessed Scroll of Escape','dhair','false','none',NULL,10,'none',0,1440,0,0,0,0,0,0,'true','accessory_ol_mahum_cap_i00',0,1,0,'0','0',0,0),
	(10625,'Shadow Item - Ol Mahum Hat','Blessed Scroll of Resurrection','dhair','false','none',NULL,10,'none',0,1440,0,0,0,0,0,0,'true','accessory_ol_mahum_cap_i00',0,1,0,'0','0',0,0),
	(10626,'Shadow Item - Ol Mahum Hat','Firecracker','dhair','false','none',NULL,10,'none',0,1440,0,0,0,0,0,0,'true','accessory_ol_mahum_cap_i00',0,1,0,'0','0',0,0),
	(10627,'Shadow Item - Ol Mahum Hat','Big Head','dhair','false','none',NULL,10,'none',0,1440,0,0,0,0,0,0,'true','accessory_ol_mahum_cap_i00',0,1,0,'0','0',0,0),
	(10628,'Shadow Item - Wolf Hat','Blessed Scroll of Escape','dhair','false','none',NULL,10,'none',0,1440,0,0,0,0,0,0,'true','accessory_wolf_cap_i00',0,1,0,'0','0',0,0),
	(10629,'Shadow Item - Wolf Hat','Blessed Scroll of Resurrection','dhair','false','none',NULL,10,'none',0,1440,0,0,0,0,0,0,'true','accessory_wolf_cap_i00',0,1,0,'0','0',0,0),
	(10630,'Shadow Item - Wolf Hat','Firecracker','dhair','false','none',NULL,10,'none',0,1440,0,0,0,0,0,0,'true','accessory_wolf_cap_i00',0,1,0,'0','0',0,0),
	(10631,'Shadow Item - Wolf Hat','Big Head','dhair','false','none',NULL,10,'none',0,1440,0,0,0,0,0,0,'true','accessory_wolf_cap_i00',0,1,0,'0','0',0,0),
	(10658,'Pet Accessory (not used)','','none','false','pet',NULL,150,'none',0,-1,0,0,7,0,33,0,'true','etc_prefect_belt_i00',1,1,1,'0','0',0,0),
	(10659,'Agathion Summon Bracelet - Monkey','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,7000000,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8254','1',0,0),
	(10660,'Agathion Summon Bracelet - Griffin','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,7000000,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8255','1',0,0),
	(10793,'Armor of Nightmare {PvP}','','fullarmor','true','heavy',NULL,9580,'a',0,-1,0,293,0,0,8804000,704,'true','armor_t80_ul_i00',0,1,0,'3662;3659','1;1',0,0),
	(10794,'Majestic Plate Armor {PvP}','','fullarmor','true','heavy',NULL,9200,'a',0,-1,0,293,0,0,8804000,704,'true','armor_t83_ul_i00',0,1,0,'3662;3659','1;1',0,0),
	(10795,'Nightmarish Leather Armor {PvP}','','fullarmor','true','light',NULL,5300,'a',0,-1,0,220,0,0,6603000,528,'true','armor_t81_ul_i00',0,1,0,'3663;3659','1;1',0,0),
	(10796,'Majestic Leather Armor {PvP}','','fullarmor','true','light',NULL,5350,'a',0,-1,0,220,0,0,6603000,528,'true','armor_t84_ul_i00',0,1,0,'3663;3659','1;1',0,0),
	(10797,'Robe of Nightmare {PvP}','','fullarmor','true','light',NULL,2300,'a',0,-1,0,147,0,718,6603000,528,'true','armor_t82_ul_i00',0,1,0,'3660;3659','1;1',0,0),
	(10798,'Majestic Robe {PvP}','','fullarmor','true','magic',NULL,2330,'a',0,-1,0,147,0,718,6603000,528,'true','armor_t85_ul_i00',0,1,0,'3660;3659','1;1',0,0),
	(10799,'Imperial Crusader Breastplate {PvP}','','chest','true','heavy',NULL,7620,'s',0,-1,0,205,0,0,12781000,613,'true','armor_t88_u_i00',0,1,0,'3662;3659','1;1',0,0),
	(10800,'Draconic Leather Armor {PvP}','','fullarmor','true','light',NULL,4950,'s',0,-1,0,249,0,0,15577000,748,'true','armor_t89_ul_i00',0,1,0,'3663;3659','1;1',0,0),
	(10801,'Major Arcana Robe {PvP}','','fullarmor','true','magic',NULL,2300,'s',0,-1,0,166,0,866,15577000,748,'true','armor_t90_ul_i00',0,1,0,'3660;3659','1;1',0,0),
	(10802,'Dynasty Breastplate {PvP}','','chest','true','heavy',NULL,7570,'s80',0,-1,0,226,0,0,24398000,1171,'true','armor_t91_u_i00',0,1,0,'3662;3659','1;1',0,0),
	(10803,'Dynasty Breastplate {PvP}','Shield Master','chest','true','heavy','ShieldMaster',7570,'s80',0,-1,0,226,0,0,24398000,1171,'true','armor_t91_uk_i00',0,1,0,'3662;3659','1;1',0,0),
	(10804,'Dynasty Breastplate {PvP}','Weapon Master','chest','true','heavy','WeaponMaster',7570,'s80',0,-1,0,226,0,0,24398000,1171,'true','armor_t91_uw_i00',0,1,0,'3662;3659','1;1',0,0),
	(10805,'Dynasty Breastplate {PvP}','Force Master','chest','true','heavy','ForceMaster',7570,'s80',0,-1,0,226,0,0,24398000,1171,'true','armor_t91_uf_i00',0,1,0,'3662;3659','1;1',0,0),
	(10806,'Dynasty Breastplate {PvP}','Bard','chest','true','heavy','Bard',7570,'s80',0,-1,0,226,0,0,24398000,1171,'true','armor_t91_uke_i00',0,1,0,'3662;3659','1;1',0,0),
	(10807,'Dynasty Leather Armor {PvP}','','chest','true','light',NULL,4180,'s80',0,-1,0,170,0,0,18298000,878,'false','armor_t92_u_i00',0,1,0,'3663;3659','1;1',0,0),
	(10808,'Dynasty Leather Armor {PvP}','Dagger Master','chest','true','light','DaggerMaster',4180,'s80',0,-1,0,170,0,0,18298000,878,'false','armor_t92_ud_i00',0,1,0,'3663;3659','1;1',0,0),
	(10809,'Dynasty Leather Armor {PvP}','Bow Master','chest','true','light','BowMaster',4180,'s80',0,-1,0,170,0,0,18298000,878,'false','armor_t92_ub_i00',0,1,0,'3663;3659','1;1',0,0),
	(10810,'Dynasty Tunic {PvP}','','chest','true','magic',NULL,1780,'s80',0,-1,0,113,0,592,18298000,878,'false','armor_t93_u_i00',0,1,0,'3660;3659','1;1',0,0),
	(10811,'Dynasty Tunic {PvP}','Healer','chest','true','magic','Healer',1780,'s80',0,-1,0,113,0,592,18298000,878,'false','armor_t93_uh_i00',0,1,0,'3660;3659','1;1',0,0),
	(10812,'Dynasty Tunic {PvP}','Enchanter','chest','true','magic','Enchanter',1780,'s80',0,-1,0,113,0,592,18298000,878,'false','armor_t93_ue_i00',0,1,0,'3660;3659','1;1',0,0),
	(10813,'Dynasty Tunic {PvP}','Summoner','chest','true','magic','Summoner',1780,'s80',0,-1,0,113,0,592,18298000,878,'false','armor_t93_us_i00',0,1,0,'3660;3659','1;1',0,0),
	(10814,'Dynasty Tunic {PvP}','Wizard','chest','true','magic','Wizard',1780,'s80',0,-1,0,113,0,592,18298000,878,'false','armor_t93_uw_i00',0,1,0,'3660;3659','1;1',0,0),
	(10815,'Dynasty Leather Armor {PvP}','Force Master','chest','true','light','ForceMaster',4180,'s80',0,-1,0,170,0,0,18298000,878,'false','armor_t92_ud_i00',0,1,0,'3663;3659','1;1',0,0),
	(10816,'Dynasty Leather Armor {PvP}','Weapon Master','chest','true','light','WeaponMaster',4180,'s80',0,-1,0,170,0,0,18298000,878,'false','armor_t92_ub_i00',0,1,0,'3663;3659','1;1',0,0),
	(10817,'Dynasty Leather Armor {PvP}','Enchanter','chest','true','light','Enchanter',4180,'s80',0,-1,0,170,0,0,18298000,878,'false','armor_t92_ud_i00',0,1,0,'3663;3659','1;1',0,0),
	(10818,'Dynasty Leather Armor {PvP}','Summoner','chest','true','light','Summoner',4180,'s80',0,-1,0,170,0,0,18298000,878,'false','armor_t92_u_i00',0,1,0,'3663;3659','1;1',0,0),
	(10819,'Dynasty Platinum Breastplate {PvP}','','chest','true','heavy',NULL,7570,'s80',0,-1,0,226,0,0,33673000,1616,'true','armor_t91_u_i00',0,1,0,'0','0',0,0),
	(10820,'Dynasty Platinum Breastplate {PvP}','Shield Master','chest','true','heavy','ShieldMaster',7570,'s80',0,-1,0,226,0,0,33673000,1616,'true','armor_t91_uk_i00',0,1,0,'3662;3659','1;1',0,0),
	(10821,'Dynasty Platinum Breastplate {PvP}','Weapon Master','chest','true','heavy','WeaponMaster',7570,'s80',0,-1,0,226,0,0,33673000,1616,'true','armor_t91_uw_i00',0,1,0,'3662;3659','1;1',0,0),
	(10822,'Dynasty Platinum Breastplate {PvP}','Force Master','chest','true','heavy','ForceMaster',7570,'s80',0,-1,0,226,0,0,33673000,1616,'true','armor_t91_uf_i00',0,1,0,'3662;3659','1;1',0,0),
	(10823,'Dynasty Platinum Breastplate {PvP}','Bard','chest','true','heavy','Bard',7570,'s80',0,-1,0,226,0,0,33673000,1616,'true','armor_t91_uke_i00',0,1,0,'3662;3659','1;1',0,0),
	(10824,'Dynasty Jewel Leather Armor {PvP}','','chest','true','light',NULL,4180,'s80',0,-1,0,170,0,0,25255000,1212,'true','armor_t92_u_i00',0,1,0,'0','0',0,0),
	(10825,'Dynasty Jewel Leather Armor {PvP}','Dagger Master','chest','true','light','DaggerMaster',4180,'s80',0,-1,0,170,0,0,25255000,1212,'true','armor_t92_ud_i00',0,1,0,'3663;3659','1;1',0,0),
	(10826,'Dynasty Jewel Leather Armor {PvP}','Bow Master','chest','true','light','BowMaster',4180,'s80',0,-1,0,170,0,0,25255000,1212,'true','armor_t92_ub_i00',0,1,0,'3663;3659','1;1',0,0),
	(10827,'Dynasty Silver Satin Tunic {PvP}','','chest','true','magic',NULL,1780,'s80',0,-1,0,113,0,592,25255000,1212,'false','armor_t93_u_i00',0,1,0,'0','0',0,0),
	(10828,'Dynasty Silver Satin Tunic {PvP}','Healer','chest','true','magic','Healer',1780,'s80',0,-1,0,113,0,592,25255000,1212,'false','armor_t93_uh_i00',0,1,0,'3660;3659','1;1',0,0),
	(10829,'Dynasty Silver Satin Tunic {PvP}','Enchanter','chest','true','magic','Enchanter',1780,'s80',0,-1,0,113,0,592,25255000,1212,'false','armor_t93_ue_i00',0,1,0,'3660;3659','1;1',0,0),
	(10830,'Dynasty Silver Satin Tunic {PvP}','Summoner','chest','true','magic','Summoner',1780,'s80',0,-1,0,113,0,592,25255000,1212,'false','armor_t93_us_i00',0,1,0,'3660;3659','1;1',0,0),
	(10831,'Dynasty Silver Satin Tunic {PvP}','Wizard','chest','true','magic','Wizard',1780,'s80',0,-1,0,113,0,592,25255000,1212,'false','armor_t93_uw_i00',0,1,0,'3660;3659','1;1',0,0),
	(10832,'Dynasty Jewel Leather Armor {PvP}','Force Master','chest','true','light','ForceMaster',4180,'s80',0,-1,0,170,0,0,25255000,1212,'true','armor_t92_u_i00',0,1,0,'3663;3659','1;1',0,0),
	(10833,'Dynasty Jewel Leather Armor {PvP}','Weapon Master','chest','true','light','WeaponMaster',4180,'s80',0,-1,0,170,0,0,25255000,1212,'true','armor_t92_u_i00',0,1,0,'3663;3659','1;1',0,0),
	(10834,'Dynasty Jewel Leather Armor {PvP}','Enchanter','chest','true','light','Enchanter',4180,'s80',0,-1,0,170,0,0,25255000,1212,'true','armor_t92_u_i00',0,1,0,'3663;3659','1;1',0,0),
	(10835,'Dynasty Jewel Leather Armor {PvP}','Summoner','chest','true','light','Summoner',4180,'s80',0,-1,0,170,0,0,25255000,1212,'true','armor_t92_u_i00',0,1,0,'3663;3659','1;1',0,0),
	(11349,'Sealed Zubei\'s Gauntlet','','none','true','none',NULL,590,'b',0,-1,0,41,0,0,399100,53,'true','armor_t64_g_i02',1,1,1,'0','0',0,0),
	(11350,'Sealed Zubei\'s Boots','','feet','true','none',NULL,1180,'b',0,-1,0,41,0,0,399100,53,'true','armor_t64_b_i02',1,1,1,'0','0',0,0),
	(11351,'Sealed Avadon Gloves','','gloves','true','none',NULL,590,'b',0,-1,0,41,0,0,399100,53,'true','armor_t66_g_i02',1,1,1,'0','0',0,0),
	(11352,'Sealed Avadon Boots','','feet','true','none',NULL,1170,'b',0,-1,0,41,0,0,399100,53,'true','armor_t66_b_i02',1,1,1,'0','0',0,0),
	(11353,'Zubei\'s Leather Gaiters','','legs','true','light',NULL,1480,'b',0,-1,0,73,0,0,748300,100,'true','armor_t65_l_i00',1,1,1,'3668','1',0,0),
	(11354,'Zubei\'s Leather Shirt','','chest','true','light',NULL,4330,'b',0,-1,0,117,0,0,1197000,160,'true','armor_t65_u_i00',1,1,1,'3669','1',0,0),
	(11355,'Zubei\'s Gaiters','','legs','true','heavy',NULL,3570,'b',0,-1,0,98,0,0,997700,133,'true','armor_t64_l_i00',1,1,1,'3672','1',0,0),
	(11356,'Zubei\'s Gauntlet','Heavy Armor Use','gloves','true','none',NULL,590,'b',0,-1,0,41,0,0,399100,53,'true','armor_t64_g_i00',1,1,1,'3673','1',0,0),
	(11357,'Zubei\'s Gauntlet','Light Armor Use','gloves','true','none',NULL,590,'b',0,-1,0,41,0,0,399100,53,'true','armor_t65_g_i00',1,1,1,'3670','1',0,0),
	(11358,'Zubei\'s Gauntlet','Robe Use','gloves','true','none',NULL,590,'b',0,-1,0,41,0,0,399100,53,'true','armor_t56_g_i00',1,1,1,'3679','1',0,0),
	(11359,'Zubei\'s Boots','Heavy Armor Use','feet','true','none',NULL,1180,'b',0,-1,0,41,0,0,399100,53,'true','armor_t64_b_i00',1,1,1,'3674','1',0,0),
	(11360,'Zubei\'s Boots','Light Armor Use','feet','true','none',NULL,1180,'b',0,-1,0,41,0,0,399100,53,'true','armor_t65_b_i00',1,1,1,'3671','1',0,0),
	(11361,'Zubei\'s Boots','Robe Use','feet','true','none',NULL,1180,'b',0,-1,0,41,0,0,399100,53,'true','armor_t56_b_i00',1,1,1,'3680','1',0,0),
	(11363,'Zubei\'s Helmet','Heavy Armor Use','head','true','none',NULL,590,'b',0,-1,0,62,0,0,598600,80,'true','armor_helmet_i00',1,1,1,'3675','1',0,0),
	(11364,'Zubei\'s Breastplate','','chest','true','heavy',NULL,7970,'b',0,-1,0,157,0,0,1596000,213,'true','armor_t64_u_i00',1,1,1,'3676','1',0,0),
	(11365,'Avadon Gloves','Heavy Armor Use','gloves','true','none',NULL,590,'b',0,-1,0,41,0,0,399100,53,'true','armor_t66_g_i00',1,1,1,'3682','1',0,0),
	(11366,'Avadon Gloves','Light Armor Use','gloves','true','none',NULL,590,'b',0,-1,0,41,0,0,399100,53,'true','armor_t67_g_i00',1,1,1,'3689','1',0,0),
	(11367,'Avadon Gloves','Robe Use','gloves','true','none',NULL,590,'b',0,-1,0,41,0,0,399100,53,'true','armor_t59_g_i00',1,1,1,'3693','1',0,0),
	(11368,'Avadon Leather Armor','','fullarmor','true','light',NULL,5600,'b',0,-1,0,191,0,0,1946000,259,'true','armor_t67_ul_i00',1,1,1,'3690','1',0,0),
	(11369,'Avadon Robe','','fullarmor','true','magic',NULL,2540,'b',0,-1,0,127,0,561,1946000,259,'true','armor_t59_ul_i00',1,1,1,'3694','1',0,0),
	(11370,'Avadon Boots','Heavy Armor Use','feet','true','none',NULL,1180,'b',0,-1,0,41,0,0,399100,53,'true','armor_t66_b_i00',1,1,1,'3683','1',0,0),
	(11371,'Avadon Boots','Light Armor Use','feet','true','none',NULL,1180,'b',0,-1,0,41,0,0,399100,53,'true','armor_t67_b_i00',1,1,1,'3691','1',0,0),
	(11372,'Avadon Boots','Robe Use','feet','true','none',NULL,1180,'b',0,-1,0,41,0,0,399100,53,'true','armor_t59_b_i00',1,1,1,'3695','1',0,0),
	(11373,'Avadon Circlet','Heavy Armor Use','head','true','none',NULL,590,'b',0,-1,0,62,0,0,598600,80,'true','armor_leather_helmet_i00',1,1,1,'3684','1',0,0),
	(11375,'Avadon Gaiters','','legs','true','heavy',NULL,3520,'b',0,-1,0,98,0,0,997700,133,'true','armor_t66_l_i00',1,1,1,'3685','1',0,0),
	(11376,'Avadon Breastplate','','chest','true','heavy',NULL,7920,'b',0,-1,0,157,0,0,1596000,213,'true','armor_t66_u_i00',1,1,1,'3686','1',0,0),
	(11377,'Tunic of Zubei','','chest','true','magic',NULL,1960,'b',0,-1,0,78,0,345,1197000,160,'true','armor_t56_u_i00',1,1,1,'3677','1',0,0),
	(11378,'Stockings of Zubei','','legs','true','magic',NULL,940,'b',0,-1,0,49,0,216,748300,100,'true','armor_t56_l_i00',1,1,1,'3678','1',0,0),
	(11379,'Doom Gloves','Heavy Armor Use','gloves','true','none',NULL,580,'b',0,-1,0,44,0,0,618800,83,'true','armor_t71_g_i00',1,1,1,'3696','1',0,0),
	(11380,'Doom Gloves','Light Armor Use','gloves','true','none',NULL,580,'b',0,-1,0,44,0,0,618800,83,'true','armor_t72_g_i00',1,1,1,'3702','1',0,0),
	(11381,'Doom Gloves','Robe Use','gloves','true','none',NULL,580,'b',0,-1,0,44,0,0,618800,83,'true','armor_t73_g_i00',1,1,1,'3705','1',0,0),
	(11382,'Doom Boots','Heavy Armor Use','feet','true','none',NULL,1130,'b',0,-1,0,44,0,0,618800,83,'true','armor_t71_b_i00',1,1,1,'3697','1',0,0),
	(11383,'Doom Boots','Light Armor Use','feet','true','none',NULL,1130,'b',0,-1,0,44,0,0,618800,83,'true','armor_t72_b_i00',1,1,1,'3703','1',0,0),
	(11384,'Doom Boots','Robe Use','feet','true','none',NULL,1130,'b',0,-1,0,44,0,0,618800,83,'true','armor_t73_b_i00',1,1,1,'3706','1',0,0),
	(11386,'Doom Plate Armor','','fullarmor','true','heavy',NULL,9980,'b',0,-1,0,270,0,0,4022000,536,'true','armor_t71_ul_i00',1,1,1,'3698','1',0,0),
	(11387,'Doom Helmet','Heavy Armor Use','head','true','none',NULL,580,'b',0,-1,0,66,0,0,928300,124,'true','armor_leather_helmet_i00',1,1,1,'3704','1',0,0),
	(11388,'Leather Armor of Doom','','fullarmor','true','light',NULL,5500,'b',0,-1,0,202,0,0,3017000,402,'true','armor_t72_ul_i00',1,1,1,'3701','1',0,0),
	(11389,'Sealed Doom Gloves','','gloves','true','none',NULL,580,'b',0,-1,0,44,0,0,618800,83,'true','armor_t71_g_i02',1,1,1,'0','0',0,0),
	(11390,'Sealed Boots of Doom','','feet','true','none',NULL,1130,'b',0,-1,0,44,0,0,618800,83,'true','armor_t71_b_i02',1,1,1,'0','0',0,0),
	(11391,'Sealed Blue Wolf Boots','','feet','true','none',NULL,1130,'b',0,-1,0,44,0,0,618800,83,'true','armor_t68_b_i02',1,1,1,'0','0',0,0),
	(11392,'Sealed Blue Wolf Gloves','','gloves','true','none',NULL,590,'b',0,-1,0,44,0,0,618800,83,'true','armor_t68_g_i02',1,1,1,'0','0',0,0),
	(11393,'Tunic of Doom','','chest','true','magic',NULL,1900,'b',0,-1,0,83,0,377,1857000,248,'true','armor_t73_u_i00',1,1,1,'3707','1',0,0),
	(11394,'Blue Wolf Gaiters','','legs','true','heavy',NULL,3370,'b',0,-1,0,104,0,0,1547100,206,'true','armor_t68_l_i00',1,1,1,'3711','1',0,0),
	(11395,'Blue Wolf Leather Armor','','fullarmor','true','light',NULL,5500,'b',0,-1,0,202,0,0,3017000,402,'true','armor_t69_ul_i00',1,1,1,'3715','1',0,0),
	(11396,'Blue Wolf Boots','Heavy Armor Use','feet','true','none',NULL,1130,'b',0,-1,0,44,0,0,618800,83,'true','armor_t68_b_i00',1,1,1,'3712','1',0,0),
	(11397,'Blue Wolf Boots','Light Armor Use','feet','true','none',NULL,1130,'b',0,-1,0,44,0,0,618800,83,'true','armor_t69_b_i00',1,1,1,'3716','1',0,0),
	(11398,'Blue Wolf Boots','Robe Use','feet','true','none',NULL,1130,'b',0,-1,0,44,0,0,618800,83,'true','armor_t70_b_i00',1,1,1,'3719','1',0,0),
	(11399,'Blue Wolf Gloves','Heavy Armor Use','gloves','true','none',NULL,590,'b',0,-1,0,44,0,0,618800,83,'true','armor_t68_g_i00',1,1,1,'3713','1',0,0),
	(11400,'Blue Wolf Gloves','Light Armor Use','gloves','true','none',NULL,590,'b',0,-1,0,44,0,0,618800,83,'true','armor_t69_g_i00',1,1,1,'3717','1',0,0),
	(11401,'Blue Wolf Gloves','Robe Use','gloves','true','none',NULL,590,'b',0,-1,0,44,0,0,618800,83,'true','armor_t70_g_i00',1,1,1,'3720','1',0,0),
	(11402,'Blue Wolf Tunic','','chest','true','magic',NULL,1920,'b',0,-1,0,83,0,377,1857000,248,'true','armor_t70_u_i00',1,1,1,'3721','1',0,0),
	(11403,'Blue Wolf Helmet','Heavy Armor Use','head','true','none',NULL,580,'b',0,-1,0,66,0,0,928300,124,'true','armor_leather_helmet_i00',1,1,1,'3714','1',0,0),
	(11404,'Blue Wolf Stockings','','legs','true','magic',NULL,920,'b',0,-1,0,52,0,236,1160300,155,'true','armor_t70_l_i00',1,1,1,'3722','1',0,0),
	(11405,'Blue Wolf Breastplate','','chest','true','heavy',NULL,7820,'b',0,-1,0,166,0,0,2475000,330,'true','armor_t68_u_i00',1,1,1,'3710','1',0,0),
	(11406,'Stockings of Doom','','legs','true','magic',NULL,910,'b',0,-1,0,52,0,236,1160300,155,'true','armor_t73_l_i00',1,1,1,'3708','1',0,0),
	(11407,'Dark Crystal Gaiters','','legs','true','heavy',NULL,3320,'a',0,-1,0,107,0,0,2226000,178,'true','armor_t74_l_i00',1,1,1,'3726','1',0,0),
	(11408,'Dark Crystal Gloves','Heavy Armor Use','gloves','true','none',NULL,580,'a',0,-1,0,46,0,0,890000,71,'true','armor_t74_g_i00',1,1,1,'3727','1',0,0),
	(11409,'Dark Crystal Gloves','Light Armor Use','gloves','true','none',NULL,580,'a',0,-1,0,46,0,0,890000,71,'true','armor_t75_g_i00',1,1,1,'3731','1',0,0),
	(11410,'Dark Crystal Gloves','Robe Use','gloves','true','none',NULL,580,'a',0,-1,0,46,0,0,890000,71,'true','armor_t76_g_i00',1,1,1,'3735','1',0,0),
	(11411,'Dark Crystal Leather Armor','','chest','true','light',NULL,4300,'a',0,-1,0,128,0,0,2671000,214,'true','armor_t75_u_i00',1,1,1,'3730','1',0,0),
	(11412,'Dark Crystal Robe','','fullarmor','true','magic',NULL,2450,'a',0,-1,0,139,0,665,4341000,347,'true','armor_t76_ul_i00',1,1,1,'3736','1',0,0),
	(11413,'Dark Crystal Boots','Heavy Armor Use','feet','true','none',NULL,1110,'a',0,-1,0,46,0,0,890000,71,'true','armor_t74_b_i00',1,1,1,'3728','1',0,0),
	(11414,'Dark Crystal Boots','Light Armor Use','feet','true','none',NULL,1110,'a',0,-1,0,46,0,0,890000,71,'true','armor_t75_b_i00',1,1,1,'3732','1',0,0),
	(11415,'Dark Crystal Boots','Robe Use','feet','true','none',NULL,1110,'a',0,-1,0,46,0,0,890000,71,'true','armor_t76_b_i00',1,1,1,'3737','1',0,0),
	(11417,'Dark Crystal Helmet','Heavy Armor Use','head','true','none',NULL,570,'a',0,-1,0,69,0,0,1336000,107,'true','armor_helmet_i00',1,1,1,'3724','1',0,0),
	(11418,'Dark Crystal Breastplate','','chest','true','heavy',NULL,7700,'a',0,-1,0,171,0,0,3562000,285,'true','armor_t74_u_i00',1,1,1,'3725','1',0,0),
	(11419,'Dark Crystal Leggings','','legs','true','light',NULL,1480,'a',0,-1,0,80,0,0,1670000,134,'true','armor_t75_l_i00',1,1,1,'3734','1',0,0),
	(11420,'Sealed Dark Crystal Gaiters','','legs','true','heavy',NULL,3320,'a',0,-1,0,107,0,0,2226000,178,'true','armor_t74_l_i02',1,1,1,'0','0',0,0),
	(11421,'Sealed Dark Crystal Gloves','','gloves','true','none',NULL,580,'a',0,-1,0,46,0,0,890000,71,'true','armor_t74_g_i02',1,1,1,'0','0',0,0),
	(11422,'Sealed Dark Crystal Leather Armor','','chest','true','light',NULL,4300,'a',0,-1,0,128,0,0,2671000,214,'true','armor_t75_u_i02',1,1,1,'0','0',0,0),
	(11423,'Sealed Dark Crystal Robe','','fullarmor','true','magic',NULL,2450,'a',0,-1,0,139,0,665,4341000,347,'true','armor_t76_ul_i02',1,1,1,'0','0',0,0),
	(11424,'Sealed Dark Crystal Boots','','feet','true','none',NULL,1110,'a',0,-1,0,46,0,0,890000,71,'true','armor_t74_b_i02',1,1,1,'0','0',0,0),
	(11426,'Sealed Dark Crystal Helmet','Heavy Armor Use','head','true','none',NULL,570,'a',0,-1,0,69,0,0,1336000,107,'true','armor_helmet_i02',1,1,1,'0','0',0,0),
	(11427,'Sealed Dark Crystal breastplate','','chest','true','heavy',NULL,7700,'a',0,-1,0,171,0,0,3562000,285,'true','armor_t74_u_i02',1,1,1,'0','0',0,0),
	(11428,'Sealed Dark Crystal Leggings','','legs','true','light',NULL,1480,'a',0,-1,0,80,0,0,1670000,134,'true','armor_t75_l_i02',1,1,1,'0','0',0,0),
	(11429,'Sealed Tallum Gloves','','gloves','true','none',NULL,580,'a',0,-1,0,46,0,0,890000,71,'true','armor_t77_g_i02',1,1,1,'0','0',0,0),
	(11430,'Sealed Tallum Leather Armor','','fullarmor','true','light',NULL,5400,'a',0,-1,0,209,0,0,4341000,347,'true','armor_t78_ul_i02',1,1,1,'0','0',0,0),
	(11431,'Sealed Tallum Boots','','feet','true','none',NULL,1130,'a',0,-1,0,46,0,0,890000,71,'true','armor_t77_b_i02',1,1,1,'0','0',0,0),
	(11432,'Sealed Tallum Tunic','','chest','true','magic',NULL,1860,'a',0,-1,0,86,0,409,2671000,214,'true','armor_t79_u_i02',1,1,1,'0','0',0,0),
	(11433,'Sealed Tallum Plate Armor','','fullarmor','true','heavy',NULL,9780,'a',0,-1,0,278,0,0,5788000,463,'true','armor_t77_ul_i02',1,1,1,'0','0',0,0),
	(11434,'Sealed Tallum Helmet','Heavy Armor Use','head','true','none',NULL,570,'a',0,-1,0,69,0,0,1336000,107,'true','armor_helmet_i02',1,1,1,'0','0',0,0),
	(11435,'Sealed Tallum Stockings','','legs','true','magic',NULL,920,'a',0,-1,0,53,0,256,1670000,134,'true','armor_t79_l_i02',1,1,1,'0','0',0,0),
	(11436,'(Not In Use) Holy Spirit\'s Cloak','','back','true','none',NULL,220,'a',0,-1,0,18,0,0,1160000,92,'true','armor_back09',1,1,1,'0','0',0,0),
	(11437,'Tallum Gloves','Heavy Armor Use','gloves','true','none',NULL,580,'a',0,-1,0,46,0,0,890000,71,'true','armor_t77_g_i00',1,1,1,'3739','1',0,0),
	(11438,'Tallum Gloves','Light Armor Use','gloves','true','none',NULL,580,'a',0,-1,0,46,0,0,890000,71,'true','armor_t78_g_i00',1,1,1,'3744','1',0,0),
	(11439,'Tallum Gloves','Robe Use','gloves','true','none',NULL,580,'a',0,-1,0,46,0,0,890000,71,'true','armor_t79_g_i00',1,1,1,'3747','1',0,0),
	(11440,'Tallum Leather Armor','','fullarmor','true','light',NULL,5400,'a',0,-1,0,209,0,0,4341000,347,'true','armor_t78_ul_i00',1,1,1,'3743','1',0,0),
	(11441,'Tallum Boots','Heavy Armor Use','feet','true','none',NULL,1130,'a',0,-1,0,46,0,0,890000,71,'true','armor_t77_b_i00',1,1,1,'3740','1',0,0),
	(11442,'Tallum Boots','Light Armor Use','feet','true','none',NULL,1130,'a',0,-1,0,46,0,0,890000,71,'true','armor_t78_b_i00',1,1,1,'3745','1',0,0),
	(11443,'Tallum Boots','Robe Use','feet','true','none',NULL,1130,'a',0,-1,0,46,0,0,890000,71,'true','armor_t79_b_i00',1,1,1,'3748','1',0,0),
	(11444,'Tallum Tunic','','chest','true','magic',NULL,1860,'a',0,-1,0,86,0,409,2671000,214,'true','armor_t79_u_i00',1,1,1,'3749','1',0,0),
	(11445,'Tallum Plate Armor','','fullarmor','true','heavy',NULL,9780,'a',0,-1,0,278,0,0,5788000,463,'true','armor_t77_ul_i00',1,1,1,'3741','1',0,0),
	(11446,'Tallum Helmet','Heavy Armor Use','head','true','none',NULL,570,'a',0,-1,0,69,0,0,1336000,107,'true','armor_helmet_i00',1,1,1,'3742','1',0,0),
	(11447,'Tallum Stockings','','legs','true','magic',NULL,920,'a',0,-1,0,53,0,256,1670000,134,'true','armor_t79_l_i00',1,1,1,'3750','1',0,0),
	(11448,'Majestic Gauntlet','Heavy Armor Use','gloves','true','none',NULL,540,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t83_g_i00',1,1,1,'3752','1',0,0),
	(11449,'Majestic Gauntlet','Light Armor Use','gloves','true','none',NULL,540,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t84_g_i00',1,1,1,'3756','1',0,0),
	(11450,'Majestic Gauntlet','Robe Use','gloves','true','none',NULL,540,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t85_g_i00',1,1,1,'3760','1',0,0),
	(11451,'Majestic Leather Armor','','fullarmor','true','light',NULL,5350,'a',0,-1,0,220,0,0,6603000,528,'true','armor_t84_ul_i00',1,1,1,'3757','1',0,0),
	(11452,'Majestic Robe','','fullarmor','true','magic',NULL,2330,'a',0,-1,0,147,0,718,6603000,528,'true','armor_t85_ul_i00',1,1,1,'3761','1',0,0),
	(11453,'Majestic Boots','Heavy Armor Use','feet','true','none',NULL,1110,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t83_b_i00',1,1,1,'3755','1',0,0),
	(11454,'Majestic Boots','Light Armor Use','feet','true','none',NULL,1110,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t84_b_i00',1,1,1,'3758','1',0,0),
	(11455,'Majestic Boots','Robe Use','feet','true','none',NULL,1110,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t85_b_i00',1,1,1,'3762','1',0,0),
	(11456,'Majestic Circlet','Heavy Armor Use','head','true','none',NULL,550,'a',0,-1,0,73,0,0,2032000,163,'true','armor_leather_helmet_i00',1,1,1,'3753','1',0,0),
	(11457,'Majestic Plate Armor','','fullarmor','true','heavy',NULL,9200,'a',0,-1,0,293,0,0,8804000,704,'true','armor_t83_ul_i00',1,1,1,'3754','1',0,0),
	(11458,'Sealed Majestic Gauntlet','','none','true','none',NULL,540,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t83_g_i02',1,1,1,'0','0',0,0),
	(11459,'Sealed Majestic Leather Armor','','fullarmor','true','light',NULL,5350,'a',0,-1,0,220,0,0,6603000,528,'true','armor_t84_ul_i02',1,1,1,'0','0',0,0),
	(11460,'Sealed Majestic Robe','','fullarmor','true','magic',NULL,2330,'a',0,-1,0,147,0,718,6603000,528,'true','armor_t85_ul_i02',1,1,1,'0','0',0,0),
	(11461,'Sealed Majestic Boots','','feet','true','none',NULL,1110,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t83_b_i02',1,1,1,'0','0',0,0),
	(11462,'Sealed Majestic Circlet','Heavy Armor Use','head','true','none',NULL,550,'a',0,-1,0,73,0,0,2032000,163,'true','armor_leather_helmet_i02',1,1,1,'0','0',0,0),
	(11463,'Sealed Majestic Plate Armor','','fullarmor','true','heavy',NULL,9200,'a',0,-1,0,293,0,0,8804000,704,'true','armor_t83_ul_i02',1,1,1,'0','0',0,0),
	(11464,'Sealed Armor of Nightmare','','fullarmor','true','heavy',NULL,9580,'a',0,-1,0,293,0,0,8804000,704,'true','armor_t80_ul_i02',1,1,1,'0','0',0,0),
	(11465,'Sealed Gauntlet of Nightmare','','none','true','none',NULL,550,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t80_g_i02',1,1,1,'0','0',0,0),
	(11466,'Sealed Leather Armor of Nightmare','','fullarmor','true','light',NULL,5300,'a',0,-1,0,220,0,0,6603000,528,'true','armor_t81_ul_i02',1,1,1,'0','0',0,0),
	(11467,'Sealed Nightmare Robe','','fullarmor','true','magic',NULL,2300,'a',0,-1,0,147,0,718,6603000,528,'true','armor_t82_ul_i02',1,1,1,'0','0',0,0),
	(11468,'Sealed Boots of Nightmare','','feet','true','none',NULL,1110,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t80_b_i02',1,1,1,'0','0',0,0),
	(11470,'Sealed Helm of Nightmare','Heavy Armor Use','head','true','none',NULL,560,'a',0,-1,0,73,0,0,2032000,163,'true','armor_leather_helmet_i02',1,1,1,'0','0',0,0),
	(11471,'Armor of Nightmare','','fullarmor','true','heavy',NULL,9580,'a',0,-1,0,293,0,0,8804000,704,'true','armor_t80_ul_i00',1,1,1,'3764','1',0,0),
	(11472,'Gauntlet of Nightmare','Heavy Armor Use','gloves','true','none',NULL,550,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t80_g_i00',1,1,1,'3769','1',0,0),
	(11473,'Gauntlet of Nightmare','Light Armor Use','gloves','true','none',NULL,550,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t81_g_i00',1,1,1,'3765','1',0,0),
	(11474,'Gauntlet of Nightmare','Robe Use','gloves','true','none',NULL,550,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t82_g_i00',1,1,1,'3771','1',0,0),
	(11475,'Nightmarish Leather Armor','','fullarmor','true','light',NULL,5300,'a',0,-1,0,220,0,0,6603000,528,'true','armor_t81_ul_i00',1,1,1,'3768','1',0,0),
	(11476,'Nightmare Robe','','fullarmor','true','magic',NULL,2300,'a',0,-1,0,147,0,718,6603000,528,'true','armor_t82_ul_i00',1,1,1,'3772','1',0,0),
	(11477,'Boots of Nightmare','Heavy Armor Use','feet','true','none',NULL,1110,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t80_b_i00',1,1,1,'3766','1',0,0),
	(11478,'Boots of Nightmare','Light Armor Use','feet','true','none',NULL,1110,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t81_b_i00',1,1,1,'3770','1',0,0),
	(11479,'Boots of Nightmare','Robe Use','feet','true','none',NULL,1110,'a',0,-1,0,49,0,0,1355000,108,'true','armor_t82_b_i00',1,1,1,'3773','1',0,0),
	(11481,'Helm of Nightmare','Heavy Armor Use','head','true','none',NULL,560,'a',0,-1,0,73,0,0,2032000,163,'true','armor_leather_helmet_i00',1,1,1,'3767','1',0,0),
	(11482,'Great Wolf Oriharukon Armor','','gwolf','false','pet',NULL,160,'none',0,-1,0,160,14,0,24236000,0,'true','etc_wolf_r_a_01',1,1,1,'0','0',0,0),
	(11483,'Draconic Leather Gloves','','gloves','true','none',NULL,540,'s',0,-1,0,55,0,0,3195000,153,'true','armor_t89_g_i00',1,1,1,'3775','1',0,0),
	(11484,'Draconic Leather Boots','','feet','true','none',NULL,1110,'s',0,-1,0,55,0,0,3195000,153,'true','armor_t89_b_i00',1,1,1,'3776','1',0,0),
	(11485,'Draconic Leather Armor','','fullarmor','true','light',NULL,4950,'s',0,-1,0,249,0,0,15577000,748,'true','armor_t89_ul_i00',1,1,1,'3777','1',0,0),
	(11486,'Draconic Leather Helmet','','head','true','none',NULL,550,'s',0,-1,0,83,0,0,4793000,230,'true','armor_leather_helmet_i00',1,1,1,'3778','1',0,0),
	(11487,'Major Arcana Gloves','','gloves','true','none',NULL,540,'s',0,-1,0,55,0,0,3195000,153,'true','armor_t90_g_i00',1,1,1,'3779','1',0,0),
	(11488,'Major Arcana Robe','','fullarmor','true','magic',NULL,2300,'s',0,-1,0,166,0,866,15577000,748,'true','armor_t90_ul_i00',1,1,1,'3780','1',0,0),
	(11489,'Major Arcana Boots','','feet','true','none',NULL,1110,'s',0,-1,0,55,0,0,3195000,153,'true','armor_t90_b_i00',1,1,1,'3781','1',0,0),
	(11490,'Major Arcana Circlet','','head','true','none',NULL,550,'s',0,-1,0,83,0,0,4793000,230,'true','armor_circlet_i00',1,1,1,'3782','1',0,0),
	(11491,'Sealed Draconic Leather Gloves','','none','true','none',NULL,540,'s',0,-1,0,55,0,0,3195000,153,'true','armor_t89_g_i02',1,1,1,'0','0',0,0),
	(11492,'Sealed Draconic Leather Boots','','feet','true','none',NULL,1110,'s',0,-1,0,55,0,0,3195000,153,'true','armor_t89_b_i02',1,1,1,'0','0',0,0),
	(11493,'Sealed Draconic Leather Armor','','fullarmor','true','light',NULL,4950,'s',0,-1,0,236,0,0,15577000,748,'true','armor_t89_ul_i02',1,1,1,'0','0',0,0),
	(11494,'Sealed Draconic Leather Helmet','','head','true','none',NULL,550,'s',0,-1,0,83,0,0,4793000,230,'true','armor_leather_helmet_i02',1,1,1,'0','0',0,0),
	(11495,'Sealed Major Arcana Gloves','','none','true','none',NULL,540,'s',0,-1,0,55,0,0,3195000,153,'true','armor_t90_g_i02',1,1,1,'0','0',0,0),
	(11496,'Sealed Major Arcana Robe','','fullarmor','true','magic',NULL,2300,'s',0,-1,0,157,0,866,15577000,748,'true','armor_t90_ul_i02',1,1,1,'0','0',0,0),
	(11497,'Sealed Major Arcana Boots','','feet','true','none',NULL,1110,'s',0,-1,0,55,0,0,3195000,153,'true','armor_t90_b_i02',1,1,1,'0','0',0,0),
	(11498,'Sealed Major Arcana Circlet','','head','true','none',NULL,550,'s',0,-1,0,83,0,0,4793000,230,'true','armor_circlet_i02',1,1,1,'0','0',0,0),
	(11499,'Sealed Imperial Crusader Gaiters','','legs','true','heavy',NULL,3260,'s',0,-1,0,121,0,0,7988000,383,'true','armor_t88_l_i02',1,1,1,'0','0',0,0),
	(11500,'Sealed Imperial Crusader Gauntlet','','gloves','true','none',NULL,540,'s',0,-1,0,55,0,0,3195000,153,'true','armor_t88_g_i02',1,1,1,'0','0',0,0),
	(11501,'Sealed Imperial Crusader Boots','','feet','true','none',NULL,1110,'s',0,-1,0,55,0,0,3195000,153,'true','armor_t88_b_i02',1,1,1,'0','0',0,0),
	(11503,'Sealed Imperial Crusader Helmet','','head','true','none',NULL,550,'s',0,-1,0,83,0,0,4793000,230,'true','armor_helmet_i02',1,1,1,'0','0',0,0),
	(11504,'Sealed Imperial Crusader Breastplate','','chest','true','heavy',NULL,7620,'s',0,-1,0,193,0,0,12781000,613,'true','armor_t88_u_i02',1,1,1,'0','0',0,0),
	(11505,'Imperial Crusader Gaiters','','legs','true','heavy',NULL,3260,'s',0,-1,0,128,0,0,7988000,383,'true','armor_t88_l_i00',1,1,1,'3783','1',0,0),
	(11506,'Imperial Crusader Gauntlet','','gloves','true','none',NULL,540,'s',0,-1,0,55,0,0,3195000,153,'true','armor_t88_g_i00',1,1,1,'3784','1',0,0),
	(11507,'Imperial Crusader Boots','','feet','true','none',NULL,1110,'s',0,-1,0,55,0,0,3195000,153,'true','armor_t88_b_i00',1,1,1,'3785','1',0,0),
	(11509,'Imperial Crusader Helmet','','head','true','none',NULL,550,'s',0,-1,0,83,0,0,4793000,230,'true','armor_helmet_i00',1,1,1,'3787','1',0,0),
	(11510,'Imperial Crusader Breastplate','','chest','true','heavy',NULL,7620,'s',0,-1,0,205,0,0,12781000,613,'true','armor_t88_u_i00',1,1,1,'3788','1',0,0),
	(11511,'Great Wolf Orichalcum Armor','','gwolf','false','pet',NULL,160,'none',0,-1,0,171,14,0,0,0,'true','etc_wolf_r_a_01',1,1,1,'0','0',0,0),
	(11512,'Dynasty Gaiters','','legs','true','heavy',NULL,3210,'s80',0,-1,0,141,0,0,15248000,732,'true','armor_t91_l_i00',1,1,1,'3790','1',0,0),
	(11513,'Dynasty Gauntlet','','gloves','true','none',NULL,520,'s80',0,-1,0,61,0,0,6099000,293,'false','armor_t91_g_i00',1,1,1,'3791','1',0,0),
	(11514,'Dynasty Gloves','','gloves','true','none',NULL,520,'s80',0,-1,0,61,0,0,6099000,293,'false','armor_t93_g_i00',1,1,1,'3801','1',0,0),
	(11515,'Dynasty Leather Gloves','','gloves','true','none',NULL,520,'s80',0,-1,0,61,0,0,6099000,293,'false','armor_t92_g_i00',1,1,1,'3866','1',0,0),
	(11516,'Dynasty Leather Leggings','','legs','true','light',NULL,1370,'s80',0,-1,0,106,0,0,11436000,549,'false','armor_t92_l_i00',1,1,1,'3796','1',0,0),
	(11517,'Dynasty Leather Armor','','chest','true','light',NULL,4180,'s80',0,-1,0,170,0,0,18298000,878,'false','armor_t92_u_i00',1,1,1,'3795','1',0,0),
	(11518,'Dynasty Leather Armor','','chest','true','light',NULL,4180,'s80',0,-1,0,170,0,0,18298000,878,'false','armor_t92_ud_i00',1,1,1,'3795','1',0,0),
	(11519,'Dynasty Leather Armor','','chest','true','light',NULL,4180,'s80',0,-1,0,170,0,0,18298000,878,'false','armor_t92_ub_i00',1,1,1,'3795','1',0,0),
	(11520,'Dynasty Leather Armor','','chest','true','light',NULL,4180,'s80',0,-1,0,170,0,0,18298000,878,'false','armor_t92_ud_i00',1,1,1,'3795','1',0,0),
	(11521,'Dynasty Leather Armor','','chest','true','light',NULL,4180,'s80',0,-1,0,170,0,0,18298000,878,'false','armor_t92_ub_i00',1,1,1,'3795','1',0,0),
	(11522,'Dynasty Leather Armor','','chest','true','light',NULL,4180,'s80',0,-1,0,170,0,0,18298000,878,'false','armor_t92_ud_i00',1,1,1,'3795','1',0,0),
	(11523,'Dynasty Leather Armor','','chest','true','light',NULL,4180,'s80',0,-1,0,170,0,0,18298000,878,'false','armor_t92_u_i00',1,1,1,'3795','1',0,0),
	(11524,'Dynasty Leather Boots','','feet','true','none',NULL,1090,'s80',0,-1,0,61,0,0,6099000,293,'false','armor_t92_b_i00',1,1,1,'3797','1',0,0),
	(11525,'Dynasty Leather Helmet','','head','true','none',NULL,530,'s80',0,-1,0,92,0,0,9149000,439,'false','armor_leather_helmet_i00',1,1,1,'3798','1',0,0),
	(11526,'Dynasty Boots','','feet','true','none',NULL,1090,'s80',0,-1,0,61,0,0,6099000,293,'false','armor_t91_b_i00',1,1,1,'3792','1',0,0),
	(11527,'Dynasty Breastplate','','chest','true','heavy',NULL,7570,'s80',0,-1,0,226,0,0,24398000,1171,'true','armor_t91_u_i00',1,1,1,'3789','1',0,0),
	(11528,'Dynasty Breastplate','','chest','true','heavy',NULL,7570,'s80',0,-1,0,226,0,0,24398000,1171,'true','armor_t91_uk_i00',1,1,1,'3789','1',0,0),
	(11529,'Dynasty Breastplate','','chest','true','heavy',NULL,7570,'s80',0,-1,0,226,0,0,24398000,1171,'true','armor_t91_uw_i00',1,1,1,'3789','1',0,0),
	(11530,'Dynasty Breastplate','','chest','true','heavy',NULL,7570,'s80',0,-1,0,226,0,0,24398000,1171,'true','armor_t91_uf_i00',1,1,1,'3789','1',0,0),
	(11531,'Dynasty Breastplate','','chest','true','heavy',NULL,7570,'s80',0,-1,0,226,0,0,24398000,1171,'true','armor_t91_uke_i00',1,1,1,'3789','1',0,0),
	(11533,'Dynasty Shoes','','feet','true','none',NULL,1090,'s80',0,-1,0,61,0,0,6099000,293,'false','armor_t93_b_i00',1,1,1,'3802','1',0,0),
	(11534,'Dynasty Silver Satin Tunic','','chest','true','magic',NULL,1780,'s80',0,-1,0,113,0,592,25255000,1212,'false','armor_t93_u_i00',1,1,1,'0','0',0,0),
	(11535,'Dynasty Silver Satin Tunic','','chest','true','magic',NULL,1780,'s80',0,-1,0,113,0,592,25255000,1212,'false','armor_t93_uh_i00',1,1,1,'3804','1',0,0),
	(11536,'Dynasty Silver Satin Tunic','','chest','true','magic',NULL,1780,'s80',0,-1,0,113,0,592,25255000,1212,'false','armor_t93_ue_i00',1,1,1,'3804','1',0,0),
	(11537,'Dynasty Silver Satin Tunic','','chest','true','magic',NULL,1780,'s80',0,-1,0,113,0,592,25255000,1212,'false','armor_t93_us_i00',1,1,1,'3804','1',0,0),
	(11538,'Dynasty Silver Satin Tunic','','chest','true','magic',NULL,1780,'s80',0,-1,0,113,0,592,25255000,1212,'false','armor_t93_uw_i00',1,1,1,'3804','1',0,0),
	(11539,'Dynasty Circlet','','head','true','none',NULL,530,'s80',0,-1,0,92,0,0,9149000,439,'false','armor_circlet_i00',1,1,1,'3803','1',0,0),
	(11540,'Dynasty Jewel Leather Mail','','chest','true','light',NULL,4180,'s80',0,-1,0,170,0,0,25255000,1212,'false','armor_t92_u_i00',1,1,1,'3805','1',0,0),
	(11541,'Dynasty Jewel Leather Mail','','chest','true','light',NULL,4180,'s80',0,-1,0,170,0,0,25255000,1212,'false','armor_t92_ud_i00',1,1,1,'3805','1',0,0),
	(11542,'Dynasty Jewel Leather Mail','','chest','true','light',NULL,4180,'s80',0,-1,0,170,0,0,25255000,1212,'false','armor_t92_ub_i00',1,1,1,'3805','1',0,0),
	(11543,'Dynasty Jewel Leather Mail','','chest','true','light',NULL,4180,'s80',0,-1,0,170,0,0,25255000,1212,'false','armor_t92_u_i00',1,1,1,'3805','1',0,0),
	(11544,'Dynasty Jewel Leather Mail','','chest','true','light',NULL,4180,'s80',0,-1,0,170,0,0,25255000,1212,'false','armor_t92_u_i00',1,1,1,'3805','1',0,0),
	(11545,'Dynasty Jewel Leather Mail','','chest','true','light',NULL,4180,'s80',0,-1,0,170,0,0,25255000,1212,'false','armor_t92_u_i00',1,1,1,'3805','1',0,0),
	(11546,'Dynasty Jewel Leather Mail','','chest','true','light',NULL,4180,'s80',0,-1,0,170,0,0,25255000,1212,'false','armor_t92_u_i00',1,1,1,'3805','1',0,0),
	(11547,'Dynasty Tunic','','chest','true','magic',NULL,1780,'s80',0,-1,0,113,0,592,18298000,878,'false','armor_t93_u_i00',1,1,1,'3799','1',0,0),
	(11548,'Dynasty Tunic','','chest','true','magic',NULL,1780,'s80',0,-1,0,113,0,592,18298000,878,'false','armor_t93_uh_i00',1,1,1,'0','0',0,0),
	(11549,'Dynasty Tunic','','chest','true','magic',NULL,1780,'s80',0,-1,0,113,0,592,18298000,878,'false','armor_t93_ue_i00',1,1,1,'0','0',0,0),
	(11550,'Dynasty Tunic','','chest','true','magic',NULL,1780,'s80',0,-1,0,113,0,592,18298000,878,'false','armor_t93_us_i00',1,1,1,'0','0',0,0),
	(11551,'Dynasty Tunic','','chest','true','magic',NULL,1780,'s80',0,-1,0,113,0,592,18298000,878,'false','armor_t93_uw_i00',1,1,1,'0','0',0,0),
	(11552,'Dynasty Platinum Plate','','chest','true','heavy',NULL,7570,'s80',0,-1,0,226,0,0,33673000,1616,'false','armor_t91_u_i00',1,1,1,'3806','1',0,0),
	(11553,'Dynasty Platinum Plate','','chest','true','heavy',NULL,7570,'s80',0,-1,0,226,0,0,33673000,1616,'false','armor_t91_uk_i00',1,1,1,'3806','1',0,0),
	(11554,'Dynasty Platinum Plate','','chest','true','heavy',NULL,7570,'s80',0,-1,0,226,0,0,33673000,1616,'false','armor_t91_uw_i00',1,1,1,'3806','1',0,0),
	(11555,'Dynasty Platinum Plate','','chest','true','heavy',NULL,7570,'s80',0,-1,0,226,0,0,33673000,1616,'false','armor_t91_uf_i00',1,1,1,'3806','1',0,0),
	(11556,'Dynasty Platinum Plate','','chest','true','heavy',NULL,7570,'s80',0,-1,0,226,0,0,33673000,1616,'false','armor_t91_uke_i00',1,1,1,'3806','1',0,0),
	(11557,'Dynasty Helmet','Heavy Armor Use','head','true','none',NULL,530,'s80',0,-1,0,92,0,0,9149000,439,'false','armor_helmet_i00',1,1,1,'3794','1',0,0),
	(11558,'Dynasty Stockings','','legs','true','magic',NULL,860,'s80',0,-1,0,71,0,370,11436000,549,'false','armor_t93_l_i00',1,1,1,'3800','1',0,0),
	(11559,'Sealed Dynasty Gaiters','','none','true','heavy',NULL,3210,'s80',0,-1,0,134,0,0,15248000,732,'true','armor_t91_l_i02',1,1,1,'0','0',0,0),
	(11560,'Sealed Dynasty Gauntlet','','none','true','heavy',NULL,520,'s80',0,-1,0,61,0,0,6099000,293,'true','armor_t91_g_i02',1,1,1,'0','0',0,0),
	(11561,'Sealed Dynasty Gloves','','gloves','true','none',NULL,520,'s80',0,-1,0,61,0,0,6099000,293,'true','armor_t93_g_i02',1,1,1,'0','0',0,0),
	(11562,'Sealed Dynasty Leather Gloves','','gloves','true','none',NULL,520,'s80',0,-1,0,61,0,0,6099000,293,'true','armor_t92_g_i02',1,1,1,'0','0',0,0),
	(11563,'Sealed Dynasty Leather Leggings','','legs','true','light',NULL,1370,'s80',0,-1,0,100,0,0,11436000,549,'true','armor_t92_l_i02',1,1,1,'0','0',0,0),
	(11564,'Sealed Dynasty Leather Armor','','chest','true','light',NULL,4180,'s80',0,-1,0,161,0,0,18298000,878,'true','armor_t92_u_i02',1,1,1,'0','0',0,0),
	(11565,'Sealed Dynasty Leather Boots','','feet','true','none',NULL,1090,'s80',0,-1,0,61,0,0,6099000,293,'true','armor_t92_b_i02',1,1,1,'0','0',0,0),
	(11566,'Sealed Dynasty Leather Helmet','','head','true','none',NULL,530,'s80',0,-1,0,92,0,0,9149000,439,'true','armor_leather_helmet_i02',1,1,1,'0','0',0,0),
	(11567,'Sealed Dynasty Boots','','feet','true','none',NULL,1090,'s80',0,-1,0,61,0,0,6099000,293,'true','armor_t91_b_i02',1,1,1,'0','0',0,0),
	(11568,'Sealed Dynasty Breastplate','','none','true','heavy',NULL,7570,'s80',0,-1,0,214,0,0,24398000,1171,'true','armor_t91_u_i02',1,1,1,'0','0',0,0),
	(11570,'Sealed Dynasty Shoes','','feet','true','none',NULL,1090,'s80',0,-1,0,61,0,0,6099000,293,'true','armor_t93_b_i02',1,1,1,'0','0',0,0),
	(11571,'Sealed Dynasty Circlet','','head','true','none',NULL,530,'s80',0,-1,0,92,0,0,9149000,439,'true','armor_circlet_i02',1,1,1,'0','0',0,0),
	(11572,'Sealed Dynasty Tunic','','chest','true','magic',NULL,1780,'s80',0,-1,0,107,0,592,18298000,878,'true','armor_t93_u_i02',1,1,1,'0','0',0,0),
	(11573,'Sealed Dynasty Helmet','','head','true','none',NULL,530,'s80',0,-1,0,92,0,0,9149000,439,'true','armor_helmet_i02',1,1,1,'0','0',0,0),
	(11574,'Sealed Dynasty Stockings','','legs','true','magic',NULL,860,'s80',0,-1,0,67,0,370,11436000,549,'true','armor_t93_l_i02',1,1,1,'0','0',0,0),
	(11575,'Adamantite Earring','','rear,lear','true','none',NULL,150,'b',0,-1,0,0,51,0,465900,62,'true','accessary_adamantite_earing_i00',1,1,1,'3807','1',0,0),
	(11576,'Adamantite Necklace','','neck','true','none',NULL,150,'b',0,-1,0,0,68,0,621200,83,'true','accessary_adamantite_necklace_i00',1,1,1,'3808','1',0,0),
	(11577,'Adamantite Ring','','rfinger,lfinger','true','none',NULL,150,'b',0,-1,0,0,34,0,310600,41,'true','accessary_adamantite_ring_i00',1,1,1,'3809','1',0,0),
	(11578,'Earring of Black Ore','','rear,lear','true','none',NULL,150,'b',0,-1,0,0,54,0,711000,95,'true','accessary_earing_of_black_ore_i00',1,1,1,'3810','1',0,0),
	(11579,'Necklace of Black Ore','','neck','true','none',NULL,150,'b',0,-1,0,0,72,0,948000,126,'true','accessary_necklace_of_black_ore_i00',1,1,1,'3811','1',0,0),
	(11580,'Ring of Black Ore','','rfinger,lfinger','true','none',NULL,150,'b',0,-1,0,0,36,0,474000,63,'true','accessary_ring_of_black_ore_i00',1,1,1,'3812','1',0,0),
	(11581,'Sealed Phoenix Necklace','','neck','true','none',NULL,150,'a',0,-1,0,0,76,0,1340000,107,'true','accessary_phoenixs_necklace_i02',1,1,1,'0','0',0,0),
	(11582,'Sealed Phoenix Ring','','rfinger,lfinger','true','none',NULL,150,'a',0,-1,0,0,38,0,670000,54,'true','accessary_phoenixs_ring_i02',1,1,1,'0','0',0,0),
	(11583,'Sealed Phoenix Earring','','rear,lear','true','none',NULL,150,'a',0,-1,0,0,57,0,1005000,80,'true','accessary_phoenixs_earing_i02',1,1,1,'0','0',0,0),
	(11584,'Phoenix Necklace','','neck','true','none',NULL,150,'a',0,-1,0,0,80,26,1340000,107,'true','accessary_phoenixs_necklace_i00',1,1,1,'3813','1',0,0),
	(11585,'Phoenix Ring','','rfinger,lfinger','true','none',NULL,150,'a',0,-1,0,0,40,13,670000,54,'true','accessary_phoenixs_ring_i00',1,1,1,'3814','1',0,0),
	(11586,'Phoenix Earring','','rear,lear','true','none',NULL,150,'a',0,-1,0,0,60,20,1005000,80,'true','accessary_phoenixs_earing_i00',1,1,1,'3815','1',0,0),
	(11587,'Majestic Necklace','','neck','true','none',NULL,150,'a',0,-1,0,0,85,33,1998000,160,'true','accessary_inferno_necklace_i00',1,1,1,'3816','1',0,0),
	(11588,'Majestic Ring','','rfinger,lfinger','true','none',NULL,150,'a',0,-1,0,0,42,17,999000,80,'true','accessary_inferno_ring_i00',1,1,1,'3817','1',0,0),
	(11589,'Majestic Earring','','rear,lear','true','none',NULL,150,'a',0,-1,0,0,63,25,1498000,120,'true','accessary_inferno_earing_i00',1,1,1,'3818','1',0,0),
	(11590,'Sealed Majestic Necklace','','neck','true','none',NULL,150,'a',0,-1,0,0,80,0,1998000,160,'true','accessary_inferno_necklace_i02',1,1,1,'0','0',0,0),
	(11591,'Sealed Majestic Ring','','rfinger,lfinger','true','none',NULL,150,'a',0,-1,0,0,40,0,999000,80,'true','accessary_inferno_ring_i02',1,1,1,'0','0',0,0),
	(11592,'Sealed Majestic Earring','','rear,lear','true','none',NULL,150,'a',0,-1,0,0,60,0,1498000,120,'true','accessary_inferno_earing_i02',1,1,1,'0','0',0,0),
	(11593,'Sealed Tateossian Necklace','','neck','true','none',NULL,150,'s',0,-1,0,0,91,0,4361000,209,'true','accessory_tateossian_necklace_i02',1,1,1,'0','0',0,0),
	(11594,'Sealed Tateossian Ring','','rfinger,lfinger','true','none',NULL,150,'s',0,-1,0,0,46,0,2180000,105,'true','accessory_tateossian_ring_i02',1,1,1,'0','0',0,0),
	(11595,'Sealed Tateossian Earring','','rear,lear','true','none',NULL,150,'s',0,-1,0,0,68,0,3270000,157,'true','accessory_tateossian_earring_i02',1,1,1,'0','0',0,0),
	(11596,'Tateossian Necklace','','neck','true','none',NULL,150,'s',0,-1,0,0,95,42,4361000,209,'true','accessory_tateossian_necklace_i00',1,1,1,'3819','1',0,0),
	(11597,'Tateossian Ring','','rfinger,lfinger','true','none',NULL,150,'s',0,-1,0,0,48,21,2180000,105,'true','accessory_tateossian_ring_i00',1,1,1,'3820','1',0,0),
	(11598,'Tateossian Earring','','rear,lear','true','none',NULL,150,'s',0,-1,0,0,71,31,3270000,157,'true','accessory_tateossian_earring_i00',1,1,1,'3821','1',0,0),
	(11599,'Dynasty Necklace','','neck','true','none',NULL,150,'s80',0,-1,0,0,106,46,7942000,381,'false','accessary_dynasty_necklace_i00',1,1,1,'3822','1',0,0),
	(11600,'Dynasty Ring','','rfinger,lfinger','true','none',NULL,150,'s80',0,-1,0,0,60,23,3971000,190,'false','accessary_dynasty_ring_i00',1,1,1,'3823','1',0,0),
	(11601,'Dynasty Earring','','rear,lear','true','none',NULL,150,'s80',0,-1,0,0,79,35,5956000,285,'true','accessary_dynasty_earing_i00',1,1,1,'3824','1',0,0),
	(11602,'Sealed Dynasty Necklace','','neck','true','none',NULL,150,'s80',0,-1,0,0,95,0,5376000,258,'true','accessary_dynasty_necklace_i01',1,1,1,'0','0',0,0),
	(11603,'Sealed Dynasty Ring','','rfinger,lfinger','true','none',NULL,150,'s80',0,-1,0,0,53,0,2688000,129,'true','accessary_dynasty_ring_i01',1,1,1,'0','0',0,0),
	(11604,'Sealed Dynasty Earring','','rear,lear','true','none',NULL,150,'s80',0,-1,0,0,71,0,4032000,194,'true','accessary_dynasty_earing_i01',1,1,1,'0','0',0,0),
	(12006,'Common Item - Leather Boots','','feet','true','none',NULL,433,'d',0,-1,0,19,0,0,890,2,'true','armor_t09_b_i00',1,1,1,'0','0',0,0),
	(12007,'Common Item - Crafted Leather Gloves','','gloves','true','none',NULL,217,'d',0,-1,0,19,0,0,890,2,'true','armor_t09_g_i00',1,1,1,'0','0',0,0),
	(12008,'Common Item - Ring Mail Breastplate','','chest','true','heavy',NULL,2940,'d',0,-1,0,77,0,0,3560,7,'true','armor_t12_u_i00',1,1,1,'0','0',0,0),
	(12009,'Common Item - Bone Helmet','','head','true','none',NULL,213,'d',0,-1,0,29,0,0,1340,2,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(12010,'Common Item - Cursed Tunic','','chest','true','magic',NULL,697,'d',0,-1,0,39,0,106,2670,5,'true','armor_t14_u_i00',1,1,1,'0','0',0,0),
	(12011,'Common Item - Cursed Stockings','','legs','true','magic',NULL,340,'d',0,-1,0,24,0,66,1670,3,'true','armor_t14_l_i00',1,1,1,'0','0',0,0),
	(12012,'Common Item - Iron Plate Gaiters','','legs','true','heavy',NULL,1273,'d',0,-1,0,48,0,0,2230,4,'true','armor_t12_l_i00',1,1,1,'0','0',0,0),
	(12014,'Common Item - Puma Skin Gaiters','','legs','true','light',NULL,533,'d',0,-1,0,36,0,0,1670,3,'true','armor_t09_l_i00',1,1,1,'0','0',0,0),
	(12015,'Common Item - Puma Skin Shirt','','chest','true','light',NULL,1567,'d',0,-1,0,58,0,0,2670,5,'true','armor_t09_u_i00',1,1,1,'0','0',0,0),
	(12016,'Common Item - Leather Gauntlet','','gloves','true','none',NULL,213,'d',0,-1,0,22,0,0,1350,2,'true','armor_t18_g_i00',1,1,1,'0','0',0,0),
	(12017,'Common Item - Dark Stockings','','legs','true','magic',NULL,333,'d',0,-1,0,27,0,79,2520,5,'true','armor_t16_l_i00',1,1,1,'0','0',0,0),
	(12018,'Common Item - Mystic\'s Tunic','','chest','true','magic',NULL,677,'d',0,-1,0,43,0,126,4040,7,'true','armor_t17_u_i00',1,1,1,'0','0',0,0),
	(12019,'Common Item - Mystic\'s Stockings','','legs','true','magic',NULL,330,'d',0,-1,0,27,0,79,2520,5,'true','armor_t17_l_i00',1,1,1,'0','0',0,0),
	(12020,'Common Item - Lion Skin Gaiters','','legs','true','light',NULL,523,'d',0,-1,0,41,0,0,2520,5,'true','armor_t18_l_i00',1,1,1,'0','0',0,0),
	(12021,'Common Item - Lion Skin Shirt','','chest','true','light',NULL,1527,'d',0,-1,0,65,0,0,4040,7,'true','armor_t18_u_i00',1,1,1,'0','0',0,0),
	(12022,'Common Item - White Tunic','','chest','true','magic',NULL,680,'d',0,-1,0,43,0,126,4040,7,'true','armor_t16_u_i00',1,1,1,'0','0',0,0),
	(12023,'Common Item - Scale Gaiters','','legs','true','heavy',NULL,1287,'d',0,-1,0,54,0,0,3360,6,'true','armor_t08_l_i00',1,1,1,'0','0',0,0),
	(12024,'Common Item - Scale Mail','','chest','true','heavy',NULL,2907,'d',0,-1,0,87,0,0,5380,10,'true','armor_t08_u_i00',1,1,1,'0','0',0,0),
	(12026,'Common Item - Elven Tunic','','chest','true','magic',NULL,693,'d',0,-1,0,43,0,126,4040,7,'true','armor_t11_u_i00',1,1,1,'0','0',0,0),
	(12027,'Common Item - Elven Stockings','','legs','true','magic',NULL,337,'d',0,-1,0,27,0,79,2520,5,'true','armor_t11_l_i00',1,1,1,'0','0',0,0),
	(12028,'Common Item - Bronze Helmet','','head','true','none',NULL,210,'d',0,-1,0,33,0,0,2020,4,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(12029,'Common Item - Blue Buckskin Boots','','feet','true','none',NULL,433,'d',0,-1,0,22,0,0,1350,2,'true','armor_t18_b_i00',1,1,1,'0','0',0,0),
	(12030,'Common Item - Dwarven Scale Mail','','chest','true','heavy',NULL,2847,'d',0,-1,0,95,0,0,7160,13,'true','armor_t15_u_i00',1,1,1,'0','0',0,0),
	(12031,'Common Item - Mithril Breastplate','','chest','true','heavy',NULL,2890,'d',0,-1,0,95,0,0,7160,13,'true','armor_t19_u_i00',1,1,1,'0','0',0,0),
	(12032,'Common Item - Compound Scale Mail','','chest','true','heavy',NULL,2873,'d',0,-1,0,95,0,0,7160,13,'true','armor_t20_u_i00',1,1,1,'0','0',0,0),
	(12033,'Common Item - Iron Boots','','feet','true','none',NULL,427,'d',0,-1,0,24,0,0,1960,4,'true','armor_t10_b_i00',1,1,1,'0','0',0,0),
	(12034,'Common Item - Reinforced Leather Gaiters','','legs','true','light',NULL,523,'d',0,-1,0,46,0,0,3680,7,'true','armor_t13_l_i00',1,1,1,'0','0',0,0),
	(12035,'Common Item - Reinforced Leather Boots','','feet','true','none',NULL,427,'d',0,-1,0,24,0,0,1960,4,'true','armor_t13_b_i00',1,1,1,'0','0',0,0),
	(12036,'Common Item - Reinforced Leather Shirt','','chest','true','light',NULL,1523,'d',0,-1,0,73,0,0,5890,11,'true','armor_t13_u_i00',1,1,1,'0','0',0,0),
	(12037,'Common Item - Reinforced Leather Gloves','','gloves','true','none',NULL,213,'d',0,-1,0,24,0,0,1960,4,'true','armor_t13_g_i00',1,1,1,'0','0',0,0),
	(12038,'Common Item - Gauntlet','','gloves','true','none',NULL,213,'d',0,-1,0,24,0,0,1960,4,'true','armor_t10_g_i00',1,1,1,'0','0',0,0),
	(12039,'Common Item - Dwarven Scale Gaiters','','legs','true','heavy',NULL,1280,'d',0,-1,0,61,0,0,4910,9,'true','armor_t15_l_i00',1,1,1,'0','0',0,0),
	(12040,'Common Item - Linen Shirt','','underwear','true','none',NULL,43,'d',0,-1,0,12,0,0,4910,39,'true','etc_shirts_d_i01',1,1,1,'0','0',0,0),
	(12041,'Common Item - Mithril Gaiters','','legs','true','heavy',NULL,1277,'d',0,-1,0,61,0,0,4910,9,'true','armor_t19_l_i00',1,1,1,'0','0',0,0),
	(12042,'Common Item - Mithril Banded Gaiters','','legs','true','light',NULL,527,'d',0,-1,0,46,0,0,3680,7,'true','armor_t10_l_i00',1,1,1,'0','0',0,0),
	(12043,'Common Item - Mithril Banded Mail','','chest','true','light',NULL,1523,'d',0,-1,0,73,0,0,5890,11,'true','armor_t10_u_i00',1,1,1,'0','0',0,0),
	(12044,'Common Item - Blast Plate','','chest','true','heavy',NULL,2807,'d',0,-1,0,97,0,0,7860,15,'true','armor_t40_u_i00',1,1,1,'0','0',0,0),
	(12045,'Common Item - Boots of Knowledge','','feet','true','none',NULL,423,'d',0,-1,0,24,0,0,1960,4,'true','armor_t41_b_i00',1,1,1,'0','0',0,0),
	(12046,'Common Item - Gloves of Knowledge','','gloves','true','none',NULL,213,'d',0,-1,0,24,0,0,1960,4,'true','armor_t41_g_i00',1,1,1,'0','0',0,0),
	(12047,'Common Item - Tunic of Knowledge','','chest','true','magic',NULL,673,'d',0,-1,0,49,0,147,5890,11,'true','armor_t41_u_i00',1,1,1,'0','0',0,0),
	(12048,'Common Item - Stockings of Knowledge','','legs','true','magic',NULL,333,'d',0,-1,0,30,0,92,3680,7,'true','armor_t41_l_i00',1,1,1,'0','0',0,0),
	(12049,'Common Item - Compound Scale Gaiters','','legs','true','heavy',NULL,1257,'d',0,-1,0,61,0,0,4910,9,'true','armor_t20_l_i00',1,1,1,'0','0',0,0),
	(12050,'Common Item - Helmet','','head','true','none',NULL,213,'d',0,-1,0,37,0,0,2950,5,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(12052,'Common Item - Manticore Skin Gaiters','','legs','true','light',NULL,517,'d',0,-1,0,48,0,0,5220,10,'true','armor_t42_l_i00',1,1,1,'0','0',0,0),
	(12053,'Common Item - Manticore Skin Boots','','feet','true','none',NULL,420,'d',0,-1,0,27,0,0,2780,5,'true','armor_t42_b_i00',1,1,1,'0','0',0,0),
	(12054,'Common Item - Manticore Skin Shirt','','chest','true','light',NULL,1507,'d',0,-1,0,77,0,0,8350,15,'true','armor_t42_u_i00',1,1,1,'0','0',0,0),
	(12055,'Common Item - Manticore Skin Gloves','','gloves','true','none',NULL,210,'d',0,-1,0,27,0,0,2780,5,'true','armor_t42_g_i00',1,1,1,'0','0',0,0),
	(12056,'Common Item - Mithril Scale Gaiters','','legs','true','heavy',NULL,1290,'d',0,-1,0,64,0,0,6960,13,'true','armor_t40_l_i00',1,1,1,'0','0',0,0),
	(12057,'Common Item - Mithril Tunic','','chest','true','magic',NULL,670,'d',0,-1,0,52,0,169,8350,15,'true','armor_t51_u_i00',1,1,1,'0','0',0,0),
	(12058,'Common Item - Mithril Stockings','','legs','true','magic',NULL,327,'d',0,-1,0,32,0,105,5220,10,'true','armor_t51_l_i00',1,1,1,'0','0',0,0),
	(12059,'Common Item - Brigandine','','chest','true','heavy',NULL,2773,'d',0,-1,0,103,0,0,11100,20,'true','armor_t43_u_i00',1,1,1,'0','0',0,0),
	(12060,'Common Item - Brigandine Gaiters','','legs','true','heavy',NULL,1273,'d',0,-1,0,64,0,0,6960,13,'true','armor_t43_l_i00',1,1,1,'0','0',0,0),
	(12061,'Common Item - Brigandine Gauntlet','','gloves','true','none',NULL,210,'d',0,-1,0,27,0,0,2780,5,'true','armor_t43_g_i00',1,1,1,'0','0',0,0),
	(12062,'Common Item - Brigandine Boots','','feet','true','none',NULL,417,'d',0,-1,0,27,0,0,2780,5,'true','armor_t43_b_i00',1,1,1,'0','0',0,0),
	(12064,'Common Item - Brigandine Helmet','','head','true','none',NULL,210,'d',0,-1,0,41,0,0,4170,8,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(12065,'Common Item - Elven Mithril Gloves','','gloves','true','none',NULL,213,'d',0,-1,0,27,0,0,2780,5,'true','armor_t51_g_i00',1,1,1,'0','0',0,0),
	(12066,'Common Item - Elven Mithril Boots','','feet','true','none',NULL,417,'d',0,-1,0,27,0,0,2780,5,'true','armor_t51_b_i00',1,1,1,'0','0',0,0),
	(12067,'Common Item - Striped Linen Shirt','','underwear','true','none',NULL,43,'d',0,-1,0,14,0,0,6960,75,'true','etc_stripe_shirts_d_i01',1,1,1,'0','0',0,0),
	(12068,'Common Item - Rip Gauntlet','','gloves','true','none',NULL,210,'d',0,-1,0,27,0,0,2780,5,'true','armor_t40_g_i00',1,1,1,'0','0',0,0),
	(12070,'Common Item - Boots of Power','','feet','true','none',NULL,417,'d',0,-1,0,27,0,0,2780,5,'true','armor_t40_b_i00',1,1,1,'0','0',0,0),
	(12071,'Common Item - Assault Boots','','feet','true','none',NULL,413,'d',0,-1,0,29,0,0,3560,7,'true','armor_t44_b_i00',1,1,1,'0','0',0,0),
	(12072,'Common Item - Mithril Gloves','','gloves','true','none',NULL,210,'d',0,-1,0,29,0,0,3560,7,'true','armor_t46_g_i00',1,1,1,'0','0',0,0),
	(12074,'Common Item - Salamander Skin Mail','','fullarmor','true','light',NULL,2033,'d',0,-1,0,136,0,0,17300,32,'true','armor_t45_ul_i00',1,1,1,'0','0',0,0),
	(12075,'Common Item - Salamander Skin Boots','','feet','true','none',NULL,410,'d',0,-1,0,29,0,0,3560,7,'true','armor_t45_b_i00',1,1,1,'0','0',0,0),
	(12076,'Common Item - Ogre Power Gauntlet','','gloves','true','none',NULL,207,'d',0,-1,0,29,0,0,3560,7,'true','armor_t45_g_i00',1,1,1,'0','0',0,0),
	(12077,'Common Item - Plate Boots','','feet','true','none',NULL,413,'d',0,-1,0,29,0,0,3560,7,'true','armor_t46_b_i00',1,1,1,'0','0',0,0),
	(12079,'Common Item - Plate Helmet','','head','true','none',NULL,210,'d',0,-1,0,44,0,0,5340,10,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(12080,'Common Item - Plate Gaiters','','legs','true','heavy',NULL,1257,'d',0,-1,0,70,0,0,8890,16,'true','armor_t46_l_i00',1,1,1,'0','0',0,0),
	(12081,'Common Item - Half Plate Armor','','chest','true','heavy',NULL,2740,'d',0,-1,0,111,0,0,14200,26,'true','armor_t46_u_i00',1,1,1,'0','0',0,0),
	(12082,'Common Item - Sage\'s Worn Gloves','','gloves','true','none',NULL,210,'d',0,-1,0,29,0,0,3560,7,'true','armor_t44_g_i00',1,1,1,'0','0',0,0),
	(12083,'Common Item - Sage\'s Rag','','fullarmor','true','magic',NULL,860,'d',0,-1,0,90,0,320,17300,32,'true','armor_t44_ul_i00',1,1,1,'0','0',0,0),
	(12084,'Common Item - Tempered Mithril Gaiters','','legs','true','light',NULL,510,'c',0,-1,0,56,0,0,8430,3,'true','armor_t47_l_i00',1,1,1,'0','0',0,0),
	(12085,'Common Item - Tempered Mithril Boots','','feet','true','none',NULL,410,'c',0,-1,0,32,0,0,4500,2,'true','armor_t47_b_i00',1,1,1,'0','0',0,0),
	(12086,'Common Item - Tempered Mithril Shirt','','chest','true','light',NULL,1490,'c',0,-1,0,90,0,0,13500,5,'true','armor_t47_u_i00',1,1,1,'0','0',0,0),
	(12087,'Common Item - Reinforced Mithril Gloves','','gloves','true','none',NULL,207,'c',0,-1,0,32,0,0,4500,2,'true','armor_t47_g_i00',1,1,1,'0','0',0,0),
	(12088,'Common Item - Dwarven Chain Boots','','feet','true','none',NULL,403,'c',0,-1,0,32,0,0,4500,2,'true','armor_t60_b_i00',1,1,1,'0','0',0,0),
	(12089,'Common Item - Boots of Seal','','feet','true','none',NULL,407,'c',0,-1,0,32,0,0,4500,2,'true','armor_t44_b_i00',1,1,1,'0','0',0,0),
	(12090,'Common Item - Chain Hood','','head','true','none',NULL,207,'c',0,-1,0,47,0,0,6740,3,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(12092,'Common Item - Chain Gloves','','gloves','true','none',NULL,207,'c',0,-1,0,32,0,0,4500,2,'true','armor_t48_g_i00',1,1,1,'0','0',0,0),
	(12093,'Common Item - Chain Boots','','feet','true','none',NULL,407,'c',0,-1,0,32,0,0,4500,2,'true','armor_t48_b_i00',1,1,1,'0','0',0,0),
	(12094,'Common Item - Chain Gaiters','','legs','true','heavy',NULL,1227,'c',0,-1,0,75,0,0,11200,4,'true','armor_t48_l_i00',1,1,1,'0','0',0,0),
	(12095,'Common Item - Chain Mail Shirt','','chest','true','heavy',NULL,2707,'c',0,-1,0,120,0,0,18000,7,'true','armor_t48_u_i00',1,1,1,'0','0',0,0),
	(12097,'Common Item - Karmian Gloves','','gloves','true','none',NULL,207,'c',0,-1,0,32,0,0,4500,2,'true','armor_t53_g_i00',1,1,1,'0','0',0,0),
	(12098,'Common Item - Karmian Boots','','feet','true','none',NULL,410,'c',0,-1,0,32,0,0,4500,2,'true','armor_t53_b_i00',1,1,1,'0','0',0,0),
	(12099,'Common Item - Karmian Tunic','','chest','true','magic',NULL,660,'c',0,-1,0,60,0,225,13500,5,'true','armor_t53_u_i00',1,1,1,'0','0',0,0),
	(12100,'Common Item - Karmian Stockings','','legs','true','magic',NULL,323,'c',0,-1,0,37,0,141,8430,3,'true','armor_t53_l_i00',1,1,1,'0','0',0,0),
	(12101,'Common Item - Plate Leather Boots','','feet','true','none',NULL,407,'c',0,-1,0,32,0,0,4500,2,'true','armor_t47_b_i00',1,1,1,'0','0',0,0),
	(12103,'Common Item - Plate Leather Gaiters','','legs','true','light',NULL,520,'c',0,-1,0,59,0,0,9780,4,'true','armor_t47_l_i00',1,1,1,'0','0',0,0),
	(12104,'Common Item - Plate Leather Gloves','','gloves','true','none',NULL,203,'c',0,-1,0,33,0,0,5220,2,'true','armor_t47_g_i00',1,1,1,'0','0',0,0),
	(12105,'Common Item - Plate Leather Armor','','chest','true','light',NULL,1483,'c',0,-1,0,94,0,0,15700,6,'true','armor_t47_u_i00',1,1,1,'0','0',0,0),
	(12106,'Common Item - Great Helmet','','head','true','none',NULL,203,'c',0,-1,0,51,0,0,8420,3,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(12108,'Common Item - Dwarven Chain Gloves','','gloves','true','none',NULL,200,'c',0,-1,0,34,0,0,5620,2,'true','armor_t60_g_i00',1,1,1,'0','0',0,0),
	(12109,'Common Item - Dwarven Chain Gaiters','','legs','true','heavy',NULL,1207,'c',0,-1,0,80,0,0,14000,6,'true','armor_t60_l_i00',1,1,1,'0','0',0,0),
	(12110,'Common Item - Dwarven Chain Mail Shirt','','chest','true','heavy',NULL,2690,'c',0,-1,0,129,0,0,22500,9,'true','armor_t60_u_i00',1,1,1,'0','0',0,0),
	(12111,'Common Item - Rind Leather Gaiters','','legs','true','light',NULL,517,'c',0,-1,0,60,0,0,10500,4,'true','armor_t49_l_i00',1,1,1,'0','0',0,0),
	(12112,'Common Item - Rind Leather Gloves','','gloves','true','none',NULL,200,'c',0,-1,0,34,0,0,5620,2,'true','armor_t49_g_i00',1,1,1,'0','0',0,0),
	(12113,'Common Item - Rind Leather Armor','','chest','true','light',NULL,1473,'c',0,-1,0,97,0,0,16800,7,'true','armor_t49_u_i00',1,1,1,'0','0',0,0),
	(12114,'Common Item - Rind Leather Boots','','feet','true','none',NULL,407,'c',0,-1,0,34,0,0,5620,2,'true','armor_t49_b_i00',1,1,1,'0','0',0,0),
	(12115,'Common Item - Robe of Seal','','fullarmor','true','magic',NULL,833,'c',0,-1,0,105,0,413,27400,11,'true','armor_t44_ul_i00',1,1,1,'0','0',0,0),
	(12116,'Common Item - Gloves of Seal','','gloves','true','none',NULL,207,'c',0,-1,0,34,0,0,5620,2,'true','armor_t44_g_i00',1,1,1,'0','0',0,0),
	(12117,'Common Item - Silk Shirt','','underwear','true','none',NULL,43,'c',0,-1,0,17,0,0,14000,27,'true','etc_shirts_c_i02',1,1,1,'0','0',0,0),
	(12118,'Common Item - Crimson Boots','','feet','true','none',NULL,403,'c',0,-1,0,34,0,0,5620,2,'true','armor_t57_b_i00',1,1,1,'0','0',0,0),
	(12119,'Common Item - Mithril Gauntlet','','gloves','true','none',NULL,200,'c',0,-1,0,36,0,0,10400,4,'true','armor_t61_g_i00',1,1,1,'0','0',0,0),
	(12120,'Common Item - Shining Circlet','','head','true','none',NULL,200,'c',0,-1,0,54,0,0,15600,6,'true','armor_circlet_i00',1,1,1,'0','0',0,0),
	(12121,'Common Item - Demon\'s Boots','','feet','true','none',NULL,407,'c',0,-1,0,36,0,0,10400,4,'true','armor_t54_b_i00',1,1,1,'0','0',0,0),
	(12122,'Common Item - Demon\'s Gloves','','gloves','true','none',NULL,203,'c',0,-1,0,36,0,0,10400,4,'true','armor_t54_g_i00',1,1,1,'0','0',0,0),
	(12123,'Common Item - Demon\'s Tunic','','chest','true','magic',NULL,663,'c',0,-1,0,69,0,284,31200,12,'true','armor_t54_u_i00',1,1,1,'0','0',0,0),
	(12124,'Common Item - Demon\'s Stockings','','legs','true','magic',NULL,327,'c',0,-1,0,43,0,177,19500,8,'true','armor_t54_l_i00',1,1,1,'0','0',0,0),
	(12125,'Common Item - Composite Boots','','feet','true','none',NULL,407,'c',0,-1,0,36,0,0,10400,4,'true','armor_t61_b_i00',1,1,1,'0','0',0,0),
	(12127,'Common Item - Composite Helmet','','head','true','none',NULL,203,'c',0,-1,0,54,0,0,15600,6,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(12128,'Common Item - Composite Armor','','fullarmor','true','heavy',NULL,3660,'c',0,-1,0,224,0,0,67700,27,'true','armor_t61_ul_i00',1,1,1,'0','0',0,0),
	(12130,'Common Item - Theca Leather Gaiters','','legs','true','light',NULL,510,'c',0,-1,0,66,0,0,21000,8,'true','armor_t63_l_i00',1,1,1,'0','0',0,0),
	(12131,'Common Item - Theca Leather Gloves','','gloves','true','none',NULL,200,'c',0,-1,0,37,0,0,11200,4,'true','armor_t63_g_i00',1,1,1,'0','0',0,0),
	(12132,'Common Item - Theca Leather Boots','','feet','true','none',NULL,403,'c',0,-1,0,37,0,0,11200,4,'true','armor_t63_b_i00',1,1,1,'0','0',0,0),
	(12133,'Common Item - Theca Leather Armor','','chest','true','light',NULL,1457,'c',0,-1,0,106,0,0,33600,13,'true','armor_t63_u_i00',1,1,1,'0','0',0,0),
	(12134,'Common Item - Drake Leather Gloves','','gloves','true','none',NULL,200,'c',0,-1,0,39,0,0,16300,7,'true','armor_t21_g_i00',1,1,1,'0','0',0,0),
	(12135,'Common Item - Drake Leather Armor','','fullarmor','true','light',NULL,1933,'c',0,-1,0,179,0,0,79500,32,'true','armor_t21_ul_i00',1,1,1,'0','0',0,0),
	(12136,'Common Item - Drake Leather Boots','','feet','true','none',NULL,403,'c',0,-1,0,39,0,0,16300,7,'true','armor_t21_b_i00',1,1,1,'0','0',0,0),
	(12137,'Common Item - Divine Gloves','','gloves','true','none',NULL,203,'c',0,-1,0,39,0,0,16300,7,'true','armor_t57_g_i00',1,1,1,'0','0',0,0),
	(12138,'Common Item - Divine Tunic','','chest','true','magic',NULL,660,'c',0,-1,0,74,0,314,48900,20,'true','armor_t57_u_i00',1,1,1,'0','0',0,0),
	(12139,'Common Item - Divine Stockings','','legs','true','magic',NULL,320,'c',0,-1,0,46,0,196,30600,12,'true','armor_t57_l_i00',1,1,1,'0','0',0,0),
	(12140,'Common Item - Stripe Silk Shirt','','underwear','true','none',NULL,43,'c',0,-1,0,19,0,0,40800,60,'true','etc_stripe_shirts_c_i02',1,1,1,'0','0',0,0),
	(12141,'Common Item - Full Plate Gauntlet','','gloves','true','none',NULL,200,'c',0,-1,0,39,0,0,16300,7,'true','armor_t62_g_i00',1,1,1,'0','0',0,0),
	(12142,'Common Item - Full Plate Boots','','feet','true','none',NULL,400,'c',0,-1,0,39,0,0,16300,7,'true','armor_t62_b_i00',1,1,1,'0','0',0,0),
	(12144,'Common Item - Full Plate Armor','','fullarmor','true','heavy',NULL,3493,'c',0,-1,0,239,0,0,106000,42,'true','armor_t62_ul_i00',1,1,1,'0','0',0,0),
	(12145,'Common Item - Full Plate Helmet','','head','true','none',NULL,200,'c',0,-1,0,58,0,0,24500,10,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(12146,'Common Item - Sealed Zubei\'s Gauntlet','','gloves','true','none',NULL,197,'b',0,-1,0,41,0,0,20900,3,'true','armor_t64_g_i02',1,1,1,'0','0',0,0),
	(12147,'Common Item - Sealed Zubei\'s Boots','','feet','true','none',NULL,393,'b',0,-1,0,41,0,0,20900,3,'true','armor_t64_b_i02',1,1,1,'0','0',0,0),
	(12148,'Common Item - Sealed Avadon Gloves','','gloves','true','none',NULL,197,'b',0,-1,0,41,0,0,20900,3,'true','armor_t66_g_i02',1,1,1,'0','0',0,0),
	(12149,'Common Item - Sealed Avadon Boots','','feet','true','none',NULL,390,'b',0,-1,0,41,0,0,20900,3,'true','armor_t66_b_i02',1,1,1,'0','0',0,0),
	(12150,'Common Item - Zubei\'s Leather Gaiters','','legs','true','light',NULL,493,'b',0,-1,0,73,0,0,39100,5,'true','armor_t65_l_i00',1,1,1,'0','0',0,0),
	(12151,'Common Item - Zubei\'s Leather Shirt','','chest','true','light',NULL,1443,'b',0,-1,0,117,0,0,62600,8,'true','armor_t65_u_i00',1,1,1,'0','0',0,0),
	(12152,'Common Item - Zubei\'s Gaiters','','legs','true','heavy',NULL,1190,'b',0,-1,0,98,0,0,52200,7,'true','armor_t64_l_i00',1,1,1,'0','0',0,0),
	(12153,'Common Item - Zubei\'s Gauntlet','Heavy Armor Use','gloves','true','none',NULL,197,'b',0,-1,0,41,0,0,20900,3,'true','armor_t64_g_i00',1,1,1,'0','0',0,0),
	(12154,'Common Item - Zubei\'s Gauntlet','Tans Armor Use','gloves','true','none',NULL,197,'b',0,-1,0,41,0,0,20900,3,'true','armor_t65_g_i00',1,1,1,'0','0',0,0),
	(12155,'Common Item - Zubei\'s Gauntlet','Robe Use','gloves','true','none',NULL,197,'b',0,-1,0,41,0,0,20900,3,'true','armor_t56_g_i00',1,1,1,'0','0',0,0),
	(12156,'Common Item - Zubei\'s Boots','Heavy Armor Use','feet','true','none',NULL,393,'b',0,-1,0,41,0,0,20900,3,'true','armor_t64_b_i00',1,1,1,'0','0',0,0),
	(12157,'Common Item - Zubei\'s Boots','Tans Armor Use','feet','true','none',NULL,393,'b',0,-1,0,41,0,0,20900,3,'true','armor_t65_b_i00',1,1,1,'0','0',0,0),
	(12158,'Common Item - Zubei\'s Boots','Robe Use','feet','true','none',NULL,393,'b',0,-1,0,41,0,0,20900,3,'true','armor_t56_b_i00',1,1,1,'0','0',0,0),
	(12160,'Common Item - Zubei\'s Helmet','','head','true','none',NULL,197,'b',0,-1,0,62,0,0,31300,4,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(12161,'Common Item - Zubei\'s Breastplate','','chest','true','heavy',NULL,2657,'b',0,-1,0,157,0,0,83500,11,'true','armor_t64_u_i00',1,1,1,'0','0',0,0),
	(12162,'Common Item - Avadon Gloves','Heavy Armor Use','gloves','true','none',NULL,197,'b',0,-1,0,41,0,0,20900,3,'true','armor_t66_g_i00',1,1,1,'0','0',0,0),
	(12163,'Common Item - Avadon Gloves','Tans Armor Use','gloves','true','none',NULL,197,'b',0,-1,0,41,0,0,20900,3,'true','armor_t67_g_i00',1,1,1,'0','0',0,0),
	(12164,'Common Item - Avadon Gloves','Robe Use','gloves','true','none',NULL,197,'b',0,-1,0,41,0,0,20900,3,'true','armor_t59_g_i00',1,1,1,'0','0',0,0),
	(12165,'Common Item - Avadon Leather Armor','','fullarmor','true','light',NULL,1867,'b',0,-1,0,191,0,0,102000,14,'true','armor_t67_ul_i00',1,1,1,'0','0',0,0),
	(12166,'Common Item - Avadon Robe','','fullarmor','true','magic',NULL,847,'b',0,-1,0,127,0,561,102000,14,'true','armor_t59_ul_i00',1,1,1,'0','0',0,0),
	(12167,'Common Item - Avadon Boots','Heavy Armor Use','feet','true','none',NULL,393,'b',0,-1,0,41,0,0,20900,3,'true','armor_t66_b_i00',1,1,1,'0','0',0,0),
	(12168,'Common Item - Avadon Boots','Tans Armor Use','feet','true','none',NULL,393,'b',0,-1,0,41,0,0,20900,3,'true','armor_t67_b_i00',1,1,1,'0','0',0,0),
	(12169,'Common Item - Avadon Boots','Robe Use','feet','true','none',NULL,393,'b',0,-1,0,41,0,0,20900,3,'true','armor_t59_b_i00',1,1,1,'0','0',0,0),
	(12170,'Common Item - Avadon Circlet','','head','true','none',NULL,197,'b',0,-1,0,62,0,0,31300,4,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(12172,'Common Item - Avadon Plate Gaiters','','legs','true','heavy',NULL,1173,'b',0,-1,0,98,0,0,52200,7,'true','armor_t66_l_i00',1,1,1,'0','0',0,0),
	(12173,'Common Item - Avadon Breastplate','','chest','true','heavy',NULL,2640,'b',0,-1,0,157,0,0,83500,11,'true','armor_t66_u_i00',1,1,1,'0','0',0,0),
	(12174,'Common Item - Thin Leather Shirt','','underwear','true','none',NULL,43,'b',0,-1,0,21,0,0,52200,29,'false','etc_shirts_b_i03',1,1,1,'0','0',0,0),
	(12175,'Common Item - Tunic of Zubei','','chest','true','magic',NULL,653,'b',0,-1,0,78,0,345,62600,8,'true','armor_t56_u_i00',1,1,1,'0','0',0,0),
	(12176,'Common Item - Stockings of Zubei','','legs','true','magic',NULL,313,'b',0,-1,0,49,0,216,39100,5,'true','armor_t56_l_i00',1,1,1,'0','0',0,0),
	(12177,'Common Item - Doom Gloves','Heavy Armor Use','gloves','true','none',NULL,193,'b',0,-1,0,44,0,0,37600,5,'true','armor_t71_g_i00',1,1,1,'0','0',0,0),
	(12178,'Common Item - Doom Gloves','Tans Armor Use','gloves','true','none',NULL,193,'b',0,-1,0,44,0,0,37600,5,'true','armor_t72_g_i00',1,1,1,'0','0',0,0),
	(12179,'Common Item - Doom Gloves','Robe Use','gloves','true','none',NULL,193,'b',0,-1,0,44,0,0,37600,5,'true','armor_t73_g_i00',1,1,1,'0','0',0,0),
	(12180,'Common Item - Doom Boots','Heavy Armor Use','feet','true','none',NULL,377,'b',0,-1,0,44,0,0,37600,5,'true','armor_t71_b_i00',1,1,1,'0','0',0,0),
	(12181,'Common Item - Doom Boots','Tans Armor Use','feet','true','none',NULL,377,'b',0,-1,0,44,0,0,37600,5,'true','armor_t72_b_i00',1,1,1,'0','0',0,0),
	(12182,'Common Item - Doom Boots','Robe Use','feet','true','none',NULL,377,'b',0,-1,0,44,0,0,37600,5,'true','armor_t73_b_i00',1,1,1,'0','0',0,0),
	(12184,'Common Item - Doom Plate Armor','','fullarmor','true','heavy',NULL,3327,'b',0,-1,0,270,0,0,244000,33,'true','armor_t71_ul_i00',1,1,1,'0','0',0,0),
	(12185,'Common Item - Doom Helmet','','head','true','none',NULL,193,'b',0,-1,0,66,0,0,56300,8,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(12186,'Common Item - Leather Armor of Doom','','fullarmor','true','light',NULL,1833,'b',0,-1,0,202,0,0,183000,24,'true','armor_t72_ul_i00',1,1,1,'0','0',0,0),
	(12187,'Common Item - Sealed Doom Gloves','','gloves','true','none',NULL,193,'b',0,-1,0,44,0,0,37600,5,'true','armor_t71_g_i02',1,1,1,'0','0',0,0),
	(12188,'Common Item - Sealed Doom Boots','','feet','true','none',NULL,377,'b',0,-1,0,44,0,0,37600,5,'true','armor_t71_b_i02',1,1,1,'0','0',0,0),
	(12189,'Common Item - Sealed Blue Wolf Boots','','feet','true','none',NULL,377,'b',0,-1,0,44,0,0,37600,5,'true','armor_t68_b_i02',1,1,1,'0','0',0,0),
	(12190,'Common Item - Sealed Blue Wolf Gloves','','gloves','true','none',NULL,197,'b',0,-1,0,44,0,0,37600,5,'true','armor_t68_g_i02',1,1,1,'0','0',0,0),
	(12191,'Common Item - Thin Stripe Leather Shirt','','underwear','true','none',NULL,43,'b',0,-1,0,22,0,0,93900,44,'true','etc_stripe_shirts_b_i03',1,1,1,'0','0',0,0),
	(12192,'Common Item - Tunic of Doom','','chest','true','magic',NULL,633,'b',0,-1,0,83,0,377,112700,15,'true','armor_t73_u_i00',1,1,1,'0','0',0,0),
	(12193,'Common Item - Blue Wolf Gaiters','','legs','true','heavy',NULL,1123,'b',0,-1,0,104,0,0,93900,13,'true','armor_t68_l_i00',1,1,1,'0','0',0,0),
	(12194,'Common Item - Blue Wolf Leather Armor','','fullarmor','true','light',NULL,1833,'b',0,-1,0,202,0,0,183000,24,'true','armor_t69_ul_i00',1,1,1,'0','0',0,0),
	(12195,'Common Item - Blue Wolf Boots','Heavy Armor Use','feet','true','none',NULL,377,'b',0,-1,0,44,0,0,37600,5,'true','armor_t68_b_i00',1,1,1,'0','0',0,0),
	(12196,'Common Item - Blue Wolf Boots','Tans Armor Use','feet','true','none',NULL,377,'b',0,-1,0,44,0,0,37600,5,'true','armor_t69_b_i00',1,1,1,'0','0',0,0),
	(12197,'Common Item - Blue Wolf Boots','Robe Use','feet','true','none',NULL,377,'b',0,-1,0,44,0,0,37600,5,'true','armor_t70_b_i00',1,1,1,'0','0',0,0),
	(12198,'Common Item - Blue Wolf Gloves','Heavy Armor Use','gloves','true','none',NULL,197,'b',0,-1,0,44,0,0,37600,5,'true','armor_t68_g_i00',1,1,1,'0','0',0,0),
	(12199,'Common Item - Blue Wolf Gloves','Tans Armor Use','gloves','true','none',NULL,197,'b',0,-1,0,44,0,0,37600,5,'true','armor_t69_g_i00',1,1,1,'0','0',0,0),
	(12200,'Common Item - Blue Wolf Gloves','Robe Use','gloves','true','none',NULL,197,'b',0,-1,0,44,0,0,37600,5,'true','armor_t70_g_i00',1,1,1,'0','0',0,0),
	(12201,'Common Item - Blue Wolf Tunic','','chest','true','magic',NULL,640,'b',0,-1,0,83,0,377,112700,15,'true','armor_t70_u_i00',1,1,1,'0','0',0,0),
	(12202,'Common Item - Blue Wolf Helmet','','head','true','none',NULL,193,'b',0,-1,0,66,0,0,56300,8,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(12203,'Common Item - Blue Wolf Stockings','','legs','true','magic',NULL,307,'b',0,-1,0,52,0,236,70400,9,'true','armor_t70_l_i00',1,1,1,'0','0',0,0),
	(12204,'Common Item - Blue Wolf Breastplate','','chest','true','heavy',NULL,2607,'b',0,-1,0,166,0,0,150200,20,'true','armor_t68_u_i00',1,1,1,'0','0',0,0),
	(12205,'Common Item - Stockings of Doom','','legs','true','magic',NULL,303,'b',0,-1,0,52,0,236,70400,9,'true','armor_t73_l_i00',1,1,1,'0','0',0,0),
	(12206,'Common Item - Dark Crystal Gaiters','','legs','true','heavy',NULL,1107,'a',0,-1,0,107,0,0,115000,9,'true','armor_t74_l_i00',1,1,1,'0','0',0,0),
	(12207,'Common Item - Dark Crystal Gloves','Heavy Armor Use','gloves','true','none',NULL,193,'a',0,-1,0,46,0,0,45900,4,'true','armor_t74_g_i00',1,1,1,'0','0',0,0),
	(12208,'Common Item - Dark Crystal Gloves','Tans Armor Use','gloves','true','none',NULL,193,'a',0,-1,0,46,0,0,45900,4,'true','armor_t75_g_i00',1,1,1,'0','0',0,0),
	(12209,'Common Item - Dark Crystal Gloves','Robe Use','gloves','true','none',NULL,193,'a',0,-1,0,46,0,0,45900,4,'true','armor_t76_g_i00',1,1,1,'0','0',0,0),
	(12210,'Common Item - Dark Crystal Leather Armor','','chest','true','light',NULL,1433,'a',0,-1,0,128,0,0,137700,11,'true','armor_t75_u_i00',1,1,1,'0','0',0,0),
	(12211,'Common Item - Dark Crystal Robe','','fullarmor','true','magic',NULL,817,'a',0,-1,0,139,0,665,224000,18,'true','armor_t76_ul_i00',1,1,1,'0','0',0,0),
	(12212,'Common Item - Dark Crystal Boots','Heavy Armor Use','feet','true','none',NULL,370,'a',0,-1,0,46,0,0,45900,4,'true','armor_t74_b_i00',1,1,1,'0','0',0,0),
	(12213,'Common Item - Dark Crystal Boots','Tans Armor Use','feet','true','none',NULL,370,'a',0,-1,0,46,0,0,45900,4,'true','armor_t75_b_i00',1,1,1,'0','0',0,0),
	(12214,'Common Item - Dark Crystal Boots','Robe Use','feet','true','none',NULL,370,'a',0,-1,0,46,0,0,45900,4,'true','armor_t76_b_i00',1,1,1,'0','0',0,0),
	(12216,'Common Item - Dark Crystal Helmet','','head','true','none',NULL,190,'a',0,-1,0,69,0,0,68800,6,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(12217,'Common Item - Dark Crystal Breastplate','','chest','true','heavy',NULL,2567,'a',0,-1,0,171,0,0,183500,15,'true','armor_t74_u_i00',1,1,1,'0','0',0,0),
	(12218,'Common Item - Dark Crystal Leggings','','legs','true','light',NULL,493,'a',0,-1,0,80,0,0,86000,7,'true','armor_t75_l_i00',1,1,1,'0','0',0,0),
	(12219,'Common Item - Barbed Shirt','','underwear','true','none',NULL,43,'a',0,-1,0,23,0,0,115000,39,'true','etc_shirts_a_i04',1,1,1,'0','0',0,0),
	(12220,'Common Item - Sealed Dark Crystal Gaiters','','legs','true','heavy',NULL,1107,'a',0,-1,0,107,0,0,115000,9,'true','armor_t74_l_i02',1,1,1,'0','0',0,0),
	(12221,'Common Item - Sealed Dark Crystal Gloves','','gloves','true','none',NULL,193,'a',0,-1,0,46,0,0,45900,4,'true','armor_t74_g_i02',1,1,1,'0','0',0,0),
	(12222,'Common Item - Sealed Dark Crystal Leather Armor','','chest','true','light',NULL,1433,'a',0,-1,0,128,0,0,137700,11,'true','armor_t75_u_i02',1,1,1,'0','0',0,0),
	(12223,'Common Item - Sealed Dark Crystal Robe','','fullarmor','true','magic',NULL,817,'a',0,-1,0,139,0,665,224000,18,'true','armor_t76_ul_i02',1,1,1,'0','0',0,0),
	(12224,'Common Item - Sealed Dark Crystal Boots','','feet','true','none',NULL,370,'a',0,-1,0,46,0,0,45900,4,'true','armor_t74_b_i02',1,1,1,'0','0',0,0),
	(12226,'Common Item - Sealed Dark Crystal Helmet','','head','true','none',NULL,190,'a',0,-1,0,69,0,0,68800,6,'true','armor_helmet_i02',1,1,1,'0','0',0,0),
	(12227,'Common Item - Sealed Dark Crystal Breastplate','','chest','true','heavy',NULL,2567,'a',0,-1,0,171,0,0,183500,15,'true','armor_t74_u_i02',1,1,1,'0','0',0,0),
	(12228,'Common Item - Sealed Dark Crystal Leggings','','legs','true','light',NULL,493,'a',0,-1,0,80,0,0,86000,7,'true','armor_t75_l_i02',1,1,1,'0','0',0,0),
	(12229,'Common Item - Sealed Tallum Gloves','','gloves','true','none',NULL,193,'a',0,-1,0,46,0,0,45900,4,'true','armor_t77_g_i02',1,1,1,'0','0',0,0),
	(12230,'Common Item - Sealed Tallum Leather Armor','','fullarmor','true','light',NULL,1800,'a',0,-1,0,209,0,0,224000,18,'true','armor_t78_ul_i02',1,1,1,'0','0',0,0),
	(12231,'Common Item - Sealed Tallum Boots','','feet','true','none',NULL,377,'a',0,-1,0,46,0,0,45900,4,'true','armor_t77_b_i02',1,1,1,'0','0',0,0),
	(12232,'Common Item - Sealed Tallum Tunic','','chest','true','magic',NULL,620,'a',0,-1,0,86,0,409,137700,11,'true','armor_t79_u_i02',1,1,1,'0','0',0,0),
	(12233,'Common Item - Sealed Tallum Plate Armor','','fullarmor','true','heavy',NULL,3260,'a',0,-1,0,278,0,0,298000,24,'true','armor_t77_ul_i02',1,1,1,'0','0',0,0),
	(12234,'Common Item - Sealed Tallum Helmet','','head','true','none',NULL,190,'a',0,-1,0,69,0,0,68800,6,'true','armor_helmet_i02',1,1,1,'0','0',0,0),
	(12235,'Common Item - Sealed Tallum Stockings','','legs','true','magic',NULL,307,'a',0,-1,0,53,0,256,86000,7,'true','armor_t79_l_i02',1,1,1,'0','0',0,0),
	(12236,'Common Item - Tallum Gloves','Heavy Armor Use','gloves','true','none',NULL,193,'a',0,-1,0,46,0,0,45900,4,'true','armor_t77_g_i00',1,1,1,'0','0',0,0),
	(12237,'Common Item - Tallum Gloves','Tans Armor Use','gloves','true','none',NULL,193,'a',0,-1,0,46,0,0,45900,4,'true','armor_t78_g_i00',1,1,1,'0','0',0,0),
	(12238,'Common Item - Tallum Gloves','Robe Use','gloves','true','none',NULL,193,'a',0,-1,0,46,0,0,45900,4,'true','armor_t79_g_i00',1,1,1,'0','0',0,0),
	(12239,'Common Item - Tallum Leather Armor','','fullarmor','true','light',NULL,1800,'a',0,-1,0,209,0,0,224000,18,'true','armor_t78_ul_i00',1,1,1,'0','0',0,0),
	(12240,'Common Item - Tallum Boots','Heavy Armor Use','feet','true','none',NULL,377,'a',0,-1,0,46,0,0,45900,4,'true','armor_t77_b_i00',1,1,1,'0','0',0,0),
	(12241,'Common Item - Tallum Boots','Tans Armor Use','feet','true','none',NULL,377,'a',0,-1,0,46,0,0,45900,4,'true','armor_t78_b_i00',1,1,1,'0','0',0,0),
	(12242,'Common Item - Tallum Boots','Robe Use','feet','true','none',NULL,377,'a',0,-1,0,46,0,0,45900,4,'true','armor_t79_b_i00',1,1,1,'0','0',0,0),
	(12243,'Common Item - Tallum Tunic','','chest','true','magic',NULL,620,'a',0,-1,0,86,0,409,137700,11,'true','armor_t79_u_i00',1,1,1,'0','0',0,0),
	(12244,'Common Item - Tallum Plate Armor','','fullarmor','true','heavy',NULL,3260,'a',0,-1,0,278,0,0,298000,24,'true','armor_t77_ul_i00',1,1,1,'0','0',0,0),
	(12245,'Common Item - Tallum Helmet','','head','true','none',NULL,190,'a',0,-1,0,69,0,0,68800,6,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(12246,'Common Item - Tallum Stockings','','legs','true','magic',NULL,307,'a',0,-1,0,53,0,256,86000,7,'true','armor_t79_l_i00',1,1,1,'0','0',0,0),
	(12247,'Common Item - Majestic Gauntlet','Heavy Armor Use','gloves','true','none',NULL,180,'a',0,-1,0,49,0,0,73500,6,'true','armor_t83_g_i00',1,1,1,'0','0',0,0),
	(12248,'Common Item - Majestic Gauntlet','Tans Armor Use','gloves','true','none',NULL,180,'a',0,-1,0,49,0,0,73500,6,'true','armor_t84_g_i00',1,1,1,'0','0',0,0),
	(12249,'Common Item - Majestic Gauntlet','Robe Use','gloves','true','none',NULL,180,'a',0,-1,0,49,0,0,73500,6,'true','armor_t85_g_i00',1,1,1,'0','0',0,0),
	(12250,'Common Item - Majestic Leather Armor','','fullarmor','true','light',NULL,1783,'a',0,-1,0,220,0,0,358000,29,'true','armor_t84_ul_i00',1,1,1,'0','0',0,0),
	(12251,'Common Item - Majestic Robe','','fullarmor','true','magic',NULL,777,'a',0,-1,0,147,0,718,358000,29,'true','armor_t85_ul_i00',1,1,1,'0','0',0,0),
	(12252,'Common Item - Majestic Boots','Heavy Armor Use','feet','true','none',NULL,370,'a',0,-1,0,49,0,0,73500,6,'true','armor_t83_b_i00',1,1,1,'0','0',0,0),
	(12253,'Common Item - Majestic Boots','Tans Armor Use','feet','true','none',NULL,370,'a',0,-1,0,49,0,0,73500,6,'true','armor_t84_b_i00',1,1,1,'0','0',0,0),
	(12254,'Common Item - Majestic Boots','Robe Use','feet','true','none',NULL,370,'a',0,-1,0,49,0,0,73500,6,'true','armor_t85_b_i00',1,1,1,'0','0',0,0),
	(12255,'Common Item - Majestic Circlet','','head','true','none',NULL,183,'a',0,-1,0,73,0,0,110200,9,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(12256,'Common Item - Majestic Plate Armor','','fullarmor','true','heavy',NULL,3067,'a',0,-1,0,293,0,0,477000,38,'true','armor_t83_ul_i00',1,1,1,'0','0',0,0),
	(12257,'Common Item - Sealed Majestic Gauntlet','','gloves','true','none',NULL,180,'a',0,-1,0,49,0,0,73500,6,'true','armor_t83_g_i02',1,1,1,'0','0',0,0),
	(12258,'Common Item - Sealed Majestic Leather Armor','','fullarmor','true','light',NULL,1783,'a',0,-1,0,220,0,0,358000,29,'true','armor_t84_ul_i02',1,1,1,'0','0',0,0),
	(12259,'Common Item - Sealed Majestic Robe','','fullarmor','true','magic',NULL,777,'a',0,-1,0,147,0,718,358000,29,'true','armor_t85_ul_i02',1,1,1,'0','0',0,0),
	(12260,'Common Item - Sealed Majestic Boots','','feet','true','none',NULL,370,'a',0,-1,0,49,0,0,73500,6,'true','armor_t83_b_i02',1,1,1,'0','0',0,0),
	(12261,'Common Item - Sealed Majestic Circlet','','head','true','none',NULL,183,'a',0,-1,0,73,0,0,110200,9,'true','armor_leather_helmet_i02',1,1,1,'0','0',0,0),
	(12262,'Common Item - Sealed Majestic Plate Armor','','fullarmor','true','heavy',NULL,3067,'a',0,-1,0,293,0,0,477000,38,'true','armor_t83_ul_i02',1,1,1,'0','0',0,0),
	(12263,'Common Item - Sealed Armor of Nightmare','','fullarmor','true','heavy',NULL,3193,'a',0,-1,0,293,0,0,477000,38,'true','armor_t80_ul_i02',1,1,1,'0','0',0,0),
	(12264,'Common Item - Sealed Gauntlet of Nightmare','','gloves','true','none',NULL,183,'a',0,-1,0,49,0,0,73500,6,'true','armor_t80_g_i02',1,1,1,'0','0',0,0),
	(12265,'Common Item - Sealed Leather Armor of Nightmare','','fullarmor','true','light',NULL,1767,'a',0,-1,0,220,0,0,358000,29,'true','armor_t81_ul_i02',1,1,1,'0','0',0,0),
	(12266,'Common Item - Sealed Nightmare Robe','','fullarmor','true','magic',NULL,767,'a',0,-1,0,147,0,718,358000,29,'true','armor_t82_ul_i02',1,1,1,'0','0',0,0),
	(12267,'Common Item - Sealed Boots of Nightmare','','feet','true','none',NULL,370,'a',0,-1,0,49,0,0,73500,6,'true','armor_t80_b_i02',1,1,1,'0','0',0,0),
	(12269,'Common Item - Sealed Helm of Nightmare','','head','true','none',NULL,187,'a',0,-1,0,73,0,0,110200,9,'true','armor_leather_helmet_i02',1,1,1,'0','0',0,0),
	(12270,'Common Item - Armor of Nightmare','','fullarmor','true','heavy',NULL,3193,'a',0,-1,0,293,0,0,477000,38,'true','armor_t80_ul_i00',1,1,1,'0','0',0,0),
	(12271,'Common Item - Gauntlet of Nightmare','Heavy Armor Use','gloves','true','none',NULL,183,'a',0,-1,0,49,0,0,73500,6,'true','armor_t80_g_i00',1,1,1,'0','0',0,0),
	(12272,'Common Item - Gauntlet of Nightmare','Tans Armor Use','gloves','true','none',NULL,183,'a',0,-1,0,49,0,0,73500,6,'true','armor_t81_g_i00',1,1,1,'0','0',0,0),
	(12273,'Common Item - Gauntlet of Nightmare','Robe Use','gloves','true','none',NULL,183,'a',0,-1,0,49,0,0,73500,6,'true','armor_t82_g_i00',1,1,1,'0','0',0,0),
	(12274,'Common Item - Nightmarish Leather Armor','','fullarmor','true','light',NULL,1767,'a',0,-1,0,220,0,0,358000,29,'true','armor_t81_ul_i00',1,1,1,'0','0',0,0),
	(12275,'Common Item - Nightmare Robe','','fullarmor','true','magic',NULL,767,'a',0,-1,0,147,0,718,358000,29,'true','armor_t82_ul_i00',1,1,1,'0','0',0,0),
	(12276,'Common Item - Boots of Nightmare','Heavy Armor Use','feet','true','none',NULL,370,'a',0,-1,0,49,0,0,73500,6,'true','armor_t80_b_i00',1,1,1,'0','0',0,0),
	(12277,'Common Item - Boots of Nightmare','Tans Armor Use','feet','true','none',NULL,370,'a',0,-1,0,49,0,0,73500,6,'true','armor_t81_b_i00',1,1,1,'0','0',0,0),
	(12278,'Common Item - Boots of Nightmare','Robe Use','feet','true','none',NULL,370,'a',0,-1,0,49,0,0,73500,6,'true','armor_t82_b_i00',1,1,1,'0','0',0,0),
	(12280,'Common Item - Helm of Nightmare','','head','true','none',NULL,187,'a',0,-1,0,73,0,0,110200,9,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(12281,'Common Item - Stripe Barbed Shirt','','underwear','true','none',NULL,43,'a',0,-1,0,26,0,0,184000,59,'true','etc_stripe_shirts_a_i04',1,1,1,'0','0',0,0),
	(12282,'Common Item - Draconic Leather Gloves','','gloves','true','none',NULL,180,'s',0,-1,0,55,0,0,259800,12,'true','armor_t89_g_i00',1,1,1,'0','0',0,0),
	(12283,'Common Item - Draconic Leather Boots','','feet','true','none',NULL,370,'s',0,-1,0,55,0,0,259800,12,'true','armor_t89_b_i00',1,1,1,'0','0',0,0),
	(12284,'Common Item - Draconic Leather Armor','','fullarmor','true','light',NULL,1650,'s',0,-1,0,249,0,0,1267000,61,'true','armor_t89_ul_i00',1,1,1,'0','0',0,0),
	(12285,'Common Item - Draconic Leather Helmet','','head','true','none',NULL,183,'s',0,-1,0,83,0,0,389700,19,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(12286,'Common Item - Major Arcana Gloves','','gloves','true','none',NULL,180,'s',0,-1,0,55,0,0,259800,12,'true','armor_t90_g_i00',1,1,1,'0','0',0,0),
	(12287,'Common Item - Major Arcana Robe','','fullarmor','true','magic',NULL,767,'s',0,-1,0,166,0,866,1267000,61,'true','armor_t90_ul_i00',1,1,1,'0','0',0,0),
	(12288,'Common Item - Major Arcana Boots','','feet','true','none',NULL,370,'s',0,-1,0,55,0,0,259800,12,'true','armor_t90_b_i00',1,1,1,'0','0',0,0),
	(12289,'Common Item - Major Arcana Circlet','','head','true','none',NULL,183,'s',0,-1,0,83,0,0,389700,19,'true','armor_circlet_i00',1,1,1,'0','0',0,0),
	(12290,'Common Item - Mithril Shirt','','underwear','true','none',NULL,43,'s',0,-1,0,28,0,0,650000,72,'true','etc_shirts_s_i05',1,1,1,'0','0',0,0),
	(12291,'Common Item - Sealed Draconic Leather Gloves','','gloves','true','none',NULL,180,'s',0,-1,0,55,0,0,259800,12,'true','armor_t89_g_i02',1,1,1,'0','0',0,0),
	(12292,'Common Item - Sealed Draconic Leather Boots','','feet','true','none',NULL,370,'s',0,-1,0,55,0,0,259800,12,'true','armor_t89_b_i02',1,1,1,'0','0',0,0),
	(12293,'Common Item - Sealed Draconic Leather Armor','','fullarmor','true','light',NULL,1650,'s',0,-1,0,236,0,0,1267000,61,'true','armor_t89_ul_i02',1,1,1,'0','0',0,0),
	(12294,'Common Item - Sealed Draconic Leather Helmet','','head','true','none',NULL,183,'s',0,-1,0,83,0,0,389700,19,'true','armor_leather_helmet_i02',1,1,1,'0','0',0,0),
	(12295,'Common Item - Sealed Major Arcana Gloves','','gloves','true','none',NULL,180,'s',0,-1,0,55,0,0,259800,12,'true','armor_t90_g_i02',1,1,1,'0','0',0,0),
	(12296,'Common Item - Sealed Major Arcana Robe','','fullarmor','true','magic',NULL,767,'s',0,-1,0,157,0,866,1267000,61,'true','armor_t90_ul_i02',1,1,1,'0','0',0,0),
	(12297,'Common Item - Sealed Major Arcana Boots','','feet','true','none',NULL,370,'s',0,-1,0,55,0,0,259800,12,'true','armor_t90_b_i02',1,1,1,'0','0',0,0),
	(12298,'Common Item - Sealed Major Arcana Circlet','','head','true','none',NULL,183,'s',0,-1,0,83,0,0,389700,19,'true','armor_circlet_i02',1,1,1,'0','0',0,0),
	(12299,'Common Item - Sealed Imperial Crusader Gaiters','','legs','true','heavy',NULL,1087,'s',0,-1,0,121,0,0,650000,31,'true','armor_t88_l_i02',1,1,1,'0','0',0,0),
	(12300,'Common Item - Sealed Imperial Crusader Gauntlet','','gloves','true','none',NULL,180,'s',0,-1,0,55,0,0,259800,12,'true','armor_t88_g_i02',1,1,1,'0','0',0,0),
	(12301,'Common Item - Sealed Imperial Crusader Boots','','feet','true','none',NULL,370,'s',0,-1,0,55,0,0,259800,12,'true','armor_t88_b_i02',1,1,1,'0','0',0,0),
	(12303,'Common Item - Sealed Imperial Crusader Helmet','','head','true','none',NULL,183,'s',0,-1,0,83,0,0,389700,19,'true','armor_helmet_i02',1,1,1,'0','0',0,0),
	(12304,'Common Item - Sealed Imperial Crusader Breastplate','','chest','true','heavy',NULL,2540,'s',0,-1,0,193,0,0,1039000,50,'true','armor_t88_u_i02',1,1,1,'0','0',0,0),
	(12305,'Common Item - Imperial Crusader Gaiters','','legs','true','heavy',NULL,1087,'s',0,-1,0,128,0,0,650000,31,'true','armor_t88_l_i00',1,1,1,'0','0',0,0),
	(12306,'Common Item - Imperial Crusader Gauntlet','','gloves','true','none',NULL,180,'s',0,-1,0,55,0,0,259800,12,'true','armor_t88_g_i00',1,1,1,'0','0',0,0),
	(12307,'Common Item - Imperial Crusader Boots','','feet','true','none',NULL,370,'s',0,-1,0,55,0,0,259800,12,'true','armor_t88_b_i00',1,1,1,'0','0',0,0),
	(12309,'Common Item - Imperial Crusader Helmet','','head','true','none',NULL,183,'s',0,-1,0,83,0,0,389700,19,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(12310,'Common Item - Imperial Crusader Breastplate','','chest','true','heavy',NULL,2540,'s',0,-1,0,205,0,0,1039000,50,'true','armor_t88_u_i00',1,1,1,'0','0',0,0),
	(12311,'Common Item - Red Crescent','','rear,lear','true','none',NULL,50,'d',0,-1,0,0,24,0,1150,2,'true','accessary_red_cresent_earing_i00',1,1,1,'0','0',0,0),
	(12312,'Common Item - Necklace of Devotion','','neck','true','none',NULL,50,'d',0,-1,0,0,32,0,1530,3,'true','accessary_necklace_of_devotion_i00',1,1,1,'0','0',0,0),
	(12313,'Common Item - Ring of Devotion','','rfinger,lfinger','true','none',NULL,50,'d',0,-1,0,0,16,0,766,1,'true','accessary_ring_of_devotion_i00',1,1,1,'0','0',0,0),
	(12314,'Common Item - Enchanted Earring','','rear,lear','true','none',NULL,50,'d',0,-1,0,0,27,0,1720,3,'true','accessary_enchanted_earing_i00',1,1,1,'0','0',0,0),
	(12315,'Common Item - Enchanted Necklace','','neck','true','none',NULL,50,'d',0,-1,0,0,36,0,2290,4,'true','accessary_enchanted_necklace_i00',1,1,1,'0','0',0,0),
	(12316,'Common Item - Enchanted Ring','','rfinger,lfinger','true','none',NULL,50,'d',0,-1,0,0,18,0,1150,2,'true','accessary_enchanted_ring_i00',1,1,1,'0','0',0,0),
	(12317,'Common Item - Near Forest Necklace','','neck','true','none',NULL,50,'d',0,-1,0,0,40,0,3320,6,'true','accessary_near_forest_necklace_i00',1,1,1,'0','0',0,0),
	(12318,'Common Item - Tiger\'s Eye','','rear,lear','true','none',NULL,50,'d',0,-1,0,0,30,0,2490,5,'true','accessary_tigerseye_earing_i00',1,1,1,'0','0',0,0),
	(12319,'Common Item - Black Pearl Ring','','rfinger,lfinger','true','none',NULL,50,'d',0,-1,0,0,20,0,1660,3,'true','accessary_black_pearl_ring_i00',1,1,1,'0','0',0,0),
	(12320,'Common Item - Elven Necklace','','neck','true','none',NULL,50,'d',0,-1,0,0,45,0,4640,9,'true','accessary_elven_necklace_i00',1,1,1,'0','0',0,0),
	(12321,'Common Item - Elven Ring','','rfinger,lfinger','true','none',NULL,50,'d',0,-1,0,0,22,0,2320,4,'true','accessary_elven_ring_i00',1,1,1,'0','0',0,0),
	(12322,'Common Item - Elven Earring','','rear,lear','true','none',NULL,50,'d',0,-1,0,0,34,0,3480,6,'true','accessary_elven_earing_i00',1,1,1,'0','0',0,0),
	(12323,'Common Item - Mithril Ring','','rfinger,lfinger','true','none',NULL,50,'d',0,-1,0,0,24,0,2940,5,'true','accessary_mithril_ring_i00',1,1,1,'0','0',0,0),
	(12324,'Common Item - Necklace of Darkness','','neck','true','none',NULL,50,'d',0,-1,0,0,48,0,5880,11,'true','accessary_necklace_of_darkness_i00',1,1,1,'0','0',0,0),
	(12325,'Common Item - Omen Beast\'s Eye','','rear,lear','true','none',NULL,50,'d',0,-1,0,0,36,0,4410,8,'true','accessary_onyxbeastseye_earing_i00',1,1,1,'0','0',0,0),
	(12326,'Common Item - Moonstone Earring','','rear,lear','true','none',NULL,50,'c',0,-1,0,0,39,0,5520,2,'true','accessary_moonstone_earing_i00',1,1,1,'0','0',0,0),
	(12327,'Common Item - Aquastone Necklace','','neck','true','none',NULL,50,'c',0,-1,0,0,52,0,7360,3,'true','accessary_aquastone_necklace_i00',1,1,1,'0','0',0,0),
	(12328,'Common Item - Aquastone Ring','','rfinger,lfinger','true','none',NULL,50,'c',0,-1,0,0,26,0,3680,1,'true','accessary_aquastone_ring_i00',1,1,1,'0','0',0,0),
	(12329,'Common Item - Earring of Protection','','rear,lear','true','none',NULL,50,'c',0,-1,0,0,42,0,6820,3,'true','accessary_earing_of_protection_i00',1,1,1,'0','0',0,0),
	(12330,'Common Item - Necklace of Protection','','neck','true','none',NULL,50,'c',0,-1,0,0,56,0,9090,4,'true','accessary_necklace_of_protection_i00',1,1,1,'0','0',0,0),
	(12331,'Common Item - Ring of Protection','','rfinger,lfinger','true','none',NULL,50,'c',0,-1,0,0,28,0,4550,2,'true','accessary_ring_of_protection_i00',1,1,1,'0','0',0,0),
	(12332,'Common Item - Earring of Binding','','rear,lear','true','none',NULL,50,'c',0,-1,0,0,45,0,12500,5,'true','accessary_earing_of_binding_i00',1,1,1,'0','0',0,0),
	(12333,'Common Item - Ring of Ages','','rfinger,lfinger','true','none',NULL,50,'c',0,-1,0,0,30,0,8330,3,'true','accessary_ring_of_ages_i00',1,1,1,'0','0',0,0),
	(12334,'Common Item - Necklace of Mermaid','','neck','true','none',NULL,50,'c',0,-1,0,0,60,0,16700,7,'true','accessary_necklace_of_mermaid_i00',1,1,1,'0','0',0,0),
	(12335,'Common Item - Nassen\'s Earring','','rear,lear','true','none',NULL,50,'c',0,-1,0,0,48,0,19300,8,'true','accessary_nassens_earing_i00',1,1,1,'0','0',0,0),
	(12336,'Common Item - Necklace of Binding','','neck','true','none',NULL,50,'c',0,-1,0,0,64,0,25700,10,'true','accessary_necklace_of_binding_i00',1,1,1,'0','0',0,0),
	(12337,'Common Item - Ring of Binding','','rfinger,lfinger','true','none',NULL,50,'c',0,-1,0,0,32,0,12900,5,'true','accessary_ring_of_binding_i00',1,1,1,'0','0',0,0),
	(12338,'Common Item - Adamantite Earring','','rear,lear','true','none',NULL,50,'b',0,-1,0,0,51,0,24400,3,'true','accessary_adamantite_earing_i00',1,1,1,'0','0',0,0),
	(12339,'Common Item - Adamantite Necklace','','neck','true','none',NULL,50,'b',0,-1,0,0,68,0,32500,4,'true','accessary_adamantite_necklace_i00',1,1,1,'0','0',0,0),
	(12340,'Common Item - Adamantite Ring','','rfinger,lfinger','true','none',NULL,50,'b',0,-1,0,0,34,0,16200,2,'true','accessary_adamantite_ring_i00',1,1,1,'0','0',0,0),
	(12341,'Common Item - Earring of Black Ore','','rear,lear','true','none',NULL,50,'b',0,-1,0,0,54,0,43100,6,'true','accessary_earing_of_black_ore_i00',1,1,1,'0','0',0,0),
	(12342,'Common Item - Necklace of Black Ore','','neck','true','none',NULL,50,'b',0,-1,0,0,72,0,57500,8,'true','accessary_necklace_of_black_ore_i00',1,1,1,'0','0',0,0),
	(12343,'Common Item - Ring of Black Ore','','rfinger,lfinger','true','none',NULL,50,'b',0,-1,0,0,36,0,28800,4,'true','accessary_ring_of_black_ore_i00',1,1,1,'0','0',0,0),
	(12344,'Common Item - Sealed Phoenix Necklace','','neck','true','none',NULL,50,'a',0,-1,0,0,76,0,69000,6,'true','accessary_phoenixs_necklace_i02',1,1,1,'0','0',0,0),
	(12345,'Common Item - Sealed Phoenix Earring','','rear,lear','true','none',NULL,50,'a',0,-1,0,0,57,0,51800,4,'true','accessary_phoenixs_earing_i02',1,1,1,'0','0',0,0),
	(12346,'Common Item - Sealed Phoenix Ring','','rfinger,lfinger','true','none',NULL,50,'a',0,-1,0,0,38,0,34500,3,'true','accessary_phoenixs_ring_i02',1,1,1,'0','0',0,0),
	(12347,'Common Item - Phoenix Necklace','','neck','true','none',NULL,50,'a',0,-1,0,0,80,26,69000,6,'true','accessary_phoenixs_necklace_i00',1,1,1,'0','0',0,0),
	(12348,'Common Item - Phoenix Ring','','rfinger,lfinger','true','none',NULL,50,'a',0,-1,0,0,40,13,34500,3,'true','accessary_phoenixs_ring_i00',1,1,1,'0','0',0,0),
	(12349,'Common Item - Phoenix Earring','','rear,lear','true','none',NULL,50,'a',0,-1,0,0,60,20,51800,4,'true','accessary_phoenixs_earing_i00',1,1,1,'0','0',0,0),
	(12350,'Common Item - Sealed Majestic Necklace','','neck','true','none',NULL,50,'a',0,-1,0,0,80,0,108300,9,'true','accessary_inferno_necklace_i02',1,1,1,'0','0',0,0),
	(12351,'Common Item - Sealed Majestic Ring','','rfinger,lfinger','true','none',NULL,50,'a',0,-1,0,0,40,0,54200,4,'true','accessary_inferno_ring_i02',1,1,1,'0','0',0,0),
	(12352,'Common Item - Sealed Majestic Earring','','rear,lear','true','none',NULL,50,'a',0,-1,0,0,60,0,81300,7,'true','accessary_inferno_earing_i02',1,1,1,'0','0',0,0),
	(12353,'Common Item - Majestic Necklace','','neck','true','none',NULL,50,'a',0,-1,0,0,85,33,108300,9,'true','accessary_inferno_necklace_i00',1,1,1,'0','0',0,0),
	(12354,'Common Item - Majestic Ring','','rfinger,lfinger','true','none',NULL,50,'a',0,-1,0,0,42,17,54200,4,'true','accessary_inferno_ring_i00',1,1,1,'0','0',0,0),
	(12355,'Common Item - Majestic Earring','','rear,lear','true','none',NULL,50,'a',0,-1,0,0,63,25,81300,7,'true','accessary_inferno_earing_i00',1,1,1,'0','0',0,0),
	(12356,'Common Item - Sealed Tateossian Necklace','','neck','true','none',NULL,50,'s',0,-1,0,0,91,0,354600,17,'true','accessory_tateossian_necklace_i02',1,1,1,'0','0',0,0),
	(12357,'Common Item - Sealed Tateossian Ring','','rfinger,lfinger','true','none',NULL,50,'s',0,-1,0,0,46,0,177300,9,'true','accessory_tateossian_ring_i02',1,1,1,'0','0',0,0),
	(12358,'Common Item - Sealed Tateossian Earring','','rear,lear','true','none',NULL,50,'s',0,-1,0,0,68,0,265900,13,'true','accessory_tateossian_earring_i02',1,1,1,'0','0',0,0),
	(12359,'Common Item - Tateossian Necklace','','neck','true','none',NULL,50,'s',0,-1,0,0,95,42,354600,17,'true','accessory_tateossian_necklace_i00',1,1,1,'0','0',0,0),
	(12360,'Common Item - Tateossian Ring','','rfinger,lfinger','true','none',NULL,50,'s',0,-1,0,0,48,21,177300,9,'true','accessory_tateossian_ring_i00',1,1,1,'0','0',0,0),
	(12361,'Common Item - Tateossian Earring','','rear,lear','true','none',NULL,50,'s',0,-1,0,0,71,31,265900,13,'true','accessory_tateossian_earring_i00',1,1,1,'0','0',0,0),
	(12372,'Monkey Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','monkey_cap_i00',1,1,1,'0','0',0,0),
	(12373,'Pig Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','event_pig_cap_i00',1,1,1,'0','0',0,0),
	(12740,'Baby Pet Scale Armor','','baby','false','pet',NULL,160,'none',0,-1,0,112,0,0,1877000,0,'true','etc_pet_armor_i03',1,1,1,'0','0',0,0),
	(12741,'Baby Pet Bronze Armor','','baby','false','pet',NULL,160,'none',0,-1,0,124,0,0,3620000,0,'true','etc_pet_armor_i03',1,1,1,'0','0',0,0),
	(12742,'Baby Pet Plate Armor','','baby','false','pet',NULL,160,'none',0,-1,0,136,0,0,7126000,0,'true','etc_pet_armor_i03',1,1,1,'0','0',0,0),
	(12743,'Baby Pet Mithril Armor','','baby','false','pet',NULL,160,'none',0,-1,0,148,0,0,12563000,0,'true','etc_pet_armor_i03',1,1,1,'0','0',0,0),
	(12744,'Baby Pet Oriharukon Armor','','baby','false','pet',NULL,160,'none',0,-1,0,160,0,0,24236000,0,'true','etc_pet_armor_i03',1,1,1,'0','0',0,0),
	(12745,'Baby Pet Orichalcum Armor','','baby','false','pet',NULL,160,'none',0,-1,0,171,0,0,48879000,0,'true','etc_pet_armor_i03',1,1,1,'0','0',0,0),
	(12746,'Crystal Pendant','','pendant','false','pet',NULL,150,'none',0,-1,0,0,22,0,3864,0,'true','accessory_necklace_of_funtion_pet_i00',1,1,1,'0','0',0,0),
	(12747,'Ruby Pendant','','pendant','false','pet',NULL,150,'none',0,-1,0,0,30,0,20181,0,'true','accessory_necklace_of_funtion_pet_i00',1,1,1,'0','0',0,0),
	(12748,'Sapphire Pendant','','pendant','false','pet',NULL,150,'none',0,-1,0,0,40,0,63897,0,'true','accessory_necklace_of_funtion_pet_i01',1,1,1,'0','0',0,0),
	(12749,'Diamond Pendant','','pendant','false','pet',NULL,150,'none',0,-1,0,0,52,0,156747,0,'true','accessory_necklace_of_funtion_pet_i01',1,1,1,'0','0',0,0),
	(12750,'Enria Pendant','','pendant','false','pet',NULL,150,'none',0,-1,0,0,66,0,462834,0,'true','accessory_necklace_of_funtion_pet_i02',1,1,1,'0','0',0,0),
	(12751,'Thons Pendant','','pendant','false','pet',NULL,150,'none',0,-1,0,0,80,0,1656980,0,'true','accessory_necklace_of_funtion_pet_i03',1,1,1,'0','0',0,0),
	(12752,'Asofe Pendant','','pendant','false','pet',NULL,150,'none',0,-1,0,0,94,0,5165599,0,'true','accessory_necklace_of_funtion_pet_i04',1,1,1,'0','0',0,0),
	(12766,'Gold Circlet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'true','Accessary_gold_circlet_i00',1,1,1,'0','0',0,0),
	(12767,'Silver Circlet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,500000,0,'true','Accessary_gold_circlet_i01',1,1,1,'0','0',0,0),
	(12779,'Agathion Seal Bracelet - Little Angel','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'3423;5535','1;1',0,0),
	(12780,'Agathion Seal Bracelet - Little Devil','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'3424;5536','1;1',0,0),
	(12781,'Ol Mahum Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_ol_mahum_cap_i00',1,1,1,'0','0',0,0),
	(12782,'Kat the Cat Hat','30 day limited period','dhair','false','none',NULL,10,'none',0,43200,1,0,0,0,0,0,'false','accessory_cat_the_cat_cap_i00',0,1,0,'0','0',0,0),
	(12783,'Feline Queen Hat','30 day limited period','dhair','false','none',NULL,10,'none',0,43200,1,0,0,0,0,0,'false','accessory_queen_of_cat_cap_i00',0,1,0,'0','0',0,0),
	(12784,'Ant Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_ant_cap_i00',1,1,1,'0','0',0,0),
	(12785,'Wolf Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_wolf_cap_i00',1,1,1,'0','0',0,0),
	(12786,'Monster Eye Hat','30 day limited period','dhair','false','none',NULL,10,'none',0,43200,1,0,0,0,0,0,'false','accessory_monstereye_cap_i00',0,1,0,'0','0',0,0),
	(12787,'Brown Bear Hat','30 day limited period','dhair','false','none',NULL,10,'none',0,43200,1,0,0,0,0,0,'false','accessory_brown_bear_cap_i00',0,1,0,'0','0',0,0),
	(12788,'Fungus Hat','30 day limited period','dhair','false','none',NULL,10,'none',0,43200,1,0,0,0,0,0,'false','accessory_fungus_cap_i00',0,1,0,'0','0',0,0),
	(12789,'Skull Hat','30 day limited period','dhair','false','none',NULL,10,'none',0,43200,1,0,0,0,0,0,'false','accessory_skeleton_cap_i00',0,1,0,'0','0',0,0),
	(12790,'Ornithomimus Hat','30 day limited period','dhair','false','none',NULL,10,'none',0,43200,1,0,0,0,0,0,'false','accessory_ornithomimus_cap_i00',0,1,0,'0','0',0,0),
	(12791,'Feline King Hat','30 day limited period','dhair','false','none',NULL,10,'none',0,43200,1,0,0,0,0,0,'false','accessory_king_of_cat_cap_i00',0,1,0,'0','0',0,0),
	(12792,'Kai the Cat Hat','30 day limited period','dhair','false','none',NULL,10,'none',0,43200,1,0,0,0,0,0,'false','accessory_chi_the_cat_cap_i00',0,1,0,'0','0',0,0),
	(12811,'Arcana Sigil','','lhand','true','sigil',NULL,940,'s',-8,-1,0,13,0,0,3355000,161,'true','arcana_sigil_i00',1,1,1,'0','0',0,0),
	(12812,'Dynasty Sigil','','lhand','true','sigil',NULL,930,'s80',-8,-1,0,15,0,0,6404000,307,'true','dynasty_sigil_i00',1,1,1,'0','0',0,0),
	(12813,'Vesper Sigil','','lhand','true','sigil',NULL,920,'s84',-8,-1,0,17,0,0,12250000,588,'true','verper_sigil_i00',1,1,1,'0','0',0,0),
	(12815,'Red Talisman - Max CP','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i00',0,1,0,'3664','1',0,0),
	(12816,'Red Talisman - CP Regeneration','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i00',0,1,0,'3665','1',0,0),
	(12817,'Yellow Talisman - Increase Force','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i02',0,1,0,'3666','1',0,0),
	(12818,'Yellow Talisman - Damage Transition','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i02',0,1,0,'3667','1',0,0),
	(12835,'Shadow Item - Teddy Bear Hat','','dhair','false','none',NULL,10,'none',0,300,0,0,0,0,0,0,'true','accessory_bear_cap_i00',0,1,0,'0','0',0,0),
	(12836,'Shadow Item - Piggy Hat','','dhair','false','none',NULL,10,'none',0,300,0,0,0,0,0,0,'true','accessory_pig_cap_i00',0,1,0,'0','0',0,0),
	(12837,'Shadow Item - Jester Hat','','dhair','false','none',NULL,10,'none',0,300,0,0,0,0,0,0,'true','accessory_jester_cap_i00',0,1,0,'0','0',0,0),
	(12838,'Fish Hat (Event)','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_fish_cap_i00',0,1,0,'0','0',0,0),
	(12839,'Medieval Style Party Mask (Event)','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_middle_age_party_mask_i00',0,1,0,'0','0',0,0),
	(12978,'Zubei\'s Helmet','Light Armor Use','head','true','none',NULL,590,'b',0,-1,0,62,0,0,598600,80,'true','armor_helmet_i00',1,1,1,'8233','1',0,0),
	(12979,'Zubei\'s Helmet','Robe Use','head','true','none',NULL,590,'b',0,-1,0,62,0,0,598600,80,'true','armor_helmet_i00',1,1,1,'8234','1',0,0),
	(12980,'Avadon Circlet','Light Armor Use','head','true','none',NULL,590,'b',0,-1,0,62,0,0,598600,80,'true','armor_leather_helmet_i00',1,1,1,'3688','1',0,0),
	(12981,'Avadon Circlet','Robe Use','head','true','none',NULL,590,'b',0,-1,0,62,0,0,598600,80,'true','armor_leather_helmet_i00',1,1,1,'3692','1',0,0),
	(12982,'Doom Helmet','Light Armor Use','head','true','none',NULL,580,'b',0,-1,0,66,0,0,928300,124,'true','armor_leather_helmet_i00',1,1,1,'3704','1',0,0),
	(12983,'Doom Helmet','Robe Use','head','true','none',NULL,580,'b',0,-1,0,66,0,0,928300,124,'true','armor_leather_helmet_i00',1,1,1,'3709','1',0,0),
	(12984,'Blue Wolf Helmet','Light Armor Use','head','true','none',NULL,580,'b',0,-1,0,66,0,0,928300,124,'true','armor_leather_helmet_i00',1,1,1,'3718','1',0,0),
	(12985,'Blue Wolf Helmet','Robe Use','head','true','none',NULL,580,'b',0,-1,0,66,0,0,928300,124,'true','armor_leather_helmet_i00',1,1,1,'3723','1',0,0),
	(12986,'Dark Crystal Helmet','Light Armor Use','head','true','none',NULL,570,'a',0,-1,0,69,0,0,1336000,107,'true','armor_helmet_i00',1,1,1,'3733','1',0,0),
	(12987,'Dark Crystal Helmet','Robe Use','head','true','none',NULL,570,'a',0,-1,0,69,0,0,1336000,107,'true','armor_helmet_i00',1,1,1,'3738','1',0,0),
	(12988,'Tallum Helmet','Light Armor Use','head','true','none',NULL,570,'a',0,-1,0,69,0,0,1336000,107,'true','armor_helmet_i00',1,1,1,'3746','1',0,0),
	(12989,'Tallum Helmet','Robe Use','head','true','none',NULL,570,'a',0,-1,0,69,0,0,1336000,107,'true','armor_helmet_i00',1,1,1,'3751','1',0,0),
	(12990,'Majestic Circlet','Light Armor Use','head','true','none',NULL,550,'a',0,-1,0,73,0,0,2032000,163,'true','armor_leather_helmet_i00',1,1,1,'3759','1',0,0),
	(12991,'Majestic Circlet','Robe Use','head','true','none',NULL,550,'a',0,-1,0,73,0,0,2032000,163,'true','armor_leather_helmet_i00',1,1,1,'3763','1',0,0),
	(12992,'Helm of Nightmare','Light Armor Use','head','true','none',NULL,560,'a',0,-1,0,73,0,0,2032000,163,'true','armor_leather_helmet_i00',1,1,1,'8235','1',0,0),
	(12993,'Helm of Nightmare','Robe Use','head','true','none',NULL,560,'a',0,-1,0,73,0,0,2032000,163,'true','armor_leather_helmet_i00',1,1,1,'8236','1',0,0),
	(12994,'Sealed Dark Crystal Helmet','Light Armor Use','head','true','none',NULL,570,'a',0,-1,0,69,0,0,1336000,107,'true','armor_helmet_i02',1,1,1,'0','0',0,0),
	(12995,'Sealed Dark Crystal Helmet','Robe Use','head','true','none',NULL,570,'a',0,-1,0,69,0,0,1336000,107,'true','armor_helmet_i02',1,1,1,'0','0',0,0),
	(12996,'Sealed Tallum Helmet','Light Armor Use','head','true','none',NULL,570,'a',0,-1,0,69,0,0,1336000,107,'true','armor_helmet_i02',1,1,1,'0','0',0,0),
	(12997,'Sealed Tallum Helmet','Robe Use','head','true','none',NULL,570,'a',0,-1,0,69,0,0,1336000,107,'true','armor_helmet_i02',1,1,1,'0','0',0,0),
	(12998,'Sealed Majestic Circlet','Light Armor Use','head','true','none',NULL,550,'a',0,-1,0,73,0,0,2032000,163,'true','armor_leather_helmet_i02',1,1,1,'0','0',0,0),
	(12999,'Sealed Majestic Circlet','Robe Use','head','true','none',NULL,550,'a',0,-1,0,73,0,0,2032000,163,'true','armor_leather_helmet_i02',1,1,1,'0','0',0,0),
	(13000,'Sealed Helm of Nightmare','Light Armor Use','head','true','none',NULL,560,'a',0,-1,0,73,0,0,2032000,163,'true','armor_leather_helmet_i02',1,1,1,'0','0',0,0),
	(13001,'Sealed Helm of Nightmare','Robe Use','head','true','none',NULL,560,'a',0,-1,0,73,0,0,2032000,163,'true','armor_leather_helmet_i02',1,1,1,'0','0',0,0),
	(13022,'Light Purple-Maned Horse Mounting Bracelet','7 day limited period','lbracelet','false','none',NULL,30,'none',0,10080,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8247','1',0,0),
	(13023,'Agathion of Love','30-day limited period','lbracelet','false','none',NULL,30,'none',0,43200,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8245','1',0,0),
	(13024,'Sudden Agathion','30-day limited period','lbracelet','false','none',NULL,30,'none',0,43200,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8256;5955','1;1',0,0),
	(13025,'Shiny Agathion','30-day limited period','lbracelet','false','none',NULL,30,'none',0,43200,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8257;5956','1;1',0,0),
	(13026,'Sobbing Agathion','30-day limited period','lbracelet','false','none',NULL,30,'none',0,43200,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8258;5957','1;1',0,0),
	(13050,'Tigress exclusive armor','','baby','false','pet',NULL,160,'none',0,-1,0,49,49,0,0,0,'true','etc_wolf_r_a_01',1,1,1,'0','0',0,0),
	(13058,'Silenos Hair Accessory','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_barka_karm_i00',1,1,1,'0','0',0,0),
	(13074,'Shadow Item - Top Hat','','dhair','false','none',NULL,10,'none',0,10080,0,0,0,0,0,0,'true','accessory_magicial_cap_i00',0,1,0,'0','0',0,0),
	(13075,'Shadow Item - Black Mask','','dhair','false','none',NULL,10,'none',0,10080,0,0,0,0,0,0,'true','accessory_jjoro_masj_i00',0,1,0,'0','0',0,0),
	(13076,'Shadow Item - Rider Goggles','','dhair','false','none',NULL,10,'none',0,10080,0,0,0,0,0,0,'true','accessory_dragonfly_goggle_i00',0,1,0,'0','0',0,0),
	(13078,'Arcana Sigil','','lhand','true','sigil',NULL,940,'s',-8,-1,0,13,0,0,3355000,161,'true','arcana_sigil_i00',1,1,1,'8310','1',0,0),
	(13137,'Vesper Helmet','','head','true','none',NULL,530,'s84',0,-1,0,101,0,0,17500000,840,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(13138,'Vesper Leather Helmet','','head','true','none',NULL,530,'s84',0,-1,0,101,0,0,17500000,840,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(13139,'Vesper Circlet','','head','true','none',NULL,530,'s84',0,-1,0,101,0,0,17500000,840,'true','armor_circlet_i00',1,1,1,'0','0',0,0),
	(13140,'Vesper Noble Helmet','','head','true','none',NULL,530,'s84',0,-1,0,101,0,0,17500000,840,'true','armor_helmet_i00',1,1,1,'0','0',0,0),
	(13141,'Vesper Noble Leather Helmet','','head','true','none',NULL,530,'s84',0,-1,0,101,0,0,17500000,840,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(13142,'Vesper Noble Circlet','','head','true','none',NULL,530,'s84',0,-1,0,101,0,0,17500000,840,'true','armor_circlet_i00',1,1,1,'0','0',0,0),
	(13143,'Sealed Vesper Helmet','','head','true','none',NULL,530,'s84',0,-1,0,101,0,0,17500000,840,'true','armor_helmet_i02',1,1,1,'0','0',0,0),
	(13144,'Sealed Vesper Leather Helmet','','head','true','none',NULL,530,'s84',0,-1,0,101,0,0,17500000,840,'true','armor_leather_helmet_i02',1,1,1,'0','0',0,0),
	(13145,'Sealed Vesper Circlet','','head','true','none',NULL,530,'s84',0,-1,0,101,0,0,17500000,840,'true','armor_circlet_i02',1,1,1,'0','0',0,0),
	(13146,'Sealed Vesper Noble Helmet','','head','true','none',NULL,530,'s84',0,-1,0,101,0,0,17500000,840,'true','armor_helmet_i02',1,1,1,'0','0',0,0),
	(13147,'Sealed Vesper Noble Leather Helmet','','head','true','none',NULL,530,'s84',0,-1,0,101,0,0,17500000,840,'true','armor_leather_helmet_i02',1,1,1,'0','0',0,0),
	(13148,'Sealed Vesper Noble Circlet','','head','true','none',NULL,530,'s84',0,-1,0,101,0,0,17500000,840,'true','armor_circlet_i02',1,1,1,'0','0',0,0),
	(13234,'Varka Karm (used by Varka Silenos)','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_barka_karm_i00',1,1,1,'0','0',0,0),
	(13235,'Ketra Karm (used by Ketra Orcs)','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_ketra_karm_i00',1,1,1,'0','0',0,0),
	(13236,'AU Karm','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_au_karm_i00',0,1,0,'0','0',0,0),
	(13237,'AR Karm','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_ar_karm_i00',0,1,0,'0','0',0,0),
	(13238,'AE Karm','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_ae_karm_i00',0,1,0,'0','0',0,0),
	(13239,'Kat the Cat Hat','7-day Limited Period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_cat_the_cat_cap_i00',0,1,0,'0','0',0,0),
	(13240,'Feline Queen Hat','7-day Limited Period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_queen_of_cat_cap_i00',0,1,0,'0','0',0,0),
	(13241,'Monster Eye Hat','7-day Limited Period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_monstereye_cap_i00',0,1,0,'0','0',0,0),
	(13242,'Brown Bear Hat','7-day Limited Period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_brown_bear_cap_i00',0,1,0,'0','0',0,0),
	(13243,'Fungus Hat','7-day Limited Period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_fungus_cap_i00',0,1,0,'0','0',0,0),
	(13244,'Skull Hat','7-day Limited Period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_skeleton_cap_i00',0,1,0,'0','0',0,0),
	(13245,'Ornithomimus Hat','7-day Limited Period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_ornithomimus_cap_i00',0,1,0,'0','0',0,0),
	(13246,'Feline King Hat','7-day Limited Period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_king_of_cat_cap_i00',0,1,0,'0','0',0,0),
	(13247,'Kai the Cat Hat','7-day Limited Period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_chi_the_cat_cap_i00',0,1,0,'0','0',0,0),
	(13254,'Agathion of Love','7-day Limited Period','lbracelet','false','none',NULL,30,'none',0,10080,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8245','1',0,0),
	(13260,'Gran Kain\'s Squeaking Shoes','10 hours limited period','feet','false','none',NULL,50,'none',0,600,1,0,0,0,0,0,'false','armor_t02_b_i00',0,1,0,'0','0',0,0),
	(13293,'Pailaka Earring','','rear,lear','false','none',NULL,150,'d',0,-1,0,0,43,20,0,0,'true','accessary_onyxbeastseye_earing_i00',0,1,0,'0','0',0,0),
	(13294,'Pailaka Ring','','rfinger,lfinger','false','none',NULL,150,'d',0,-1,0,0,29,15,0,0,'true','accessary_mithril_ring_i00',0,1,0,'0','0',0,0),
	(13295,'Pailaka Bracelet','','rbracelet','false','none',NULL,150,'b',0,-1,0,0,0,20,0,0,'true','etc_rbracelet_c_i00',0,1,0,'3323','1',0,0),
	(13296,'Pailaka Shirt','','underwear','false','none',NULL,130,'a',0,-1,0,28,0,40,0,0,'false','etc_shirts_a_i04',0,1,0,'0','0',0,0),
	(13308,'Light Purple-Maned Horse Mounting Bracelet (Event)','7-day Limited Period','lbracelet','false','none',NULL,30,'none',0,10080,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8247','1',0,0),
	(13309,'Agathion of Love (Event)','30-day limited period','lbracelet','false','none',NULL,30,'none',0,43200,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8245','1',0,0),
	(13310,'Kat the Cat Hat (Event)','30-day limited period','dhair','false','none',NULL,10,'none',0,43200,1,0,0,0,0,0,'false','accessory_cat_the_cat_cap_i00',0,1,0,'0','0',0,0),
	(13311,'Feline Queen Hat (Event)','30-day limited period','dhair','false','none',NULL,10,'none',0,43200,1,0,0,0,0,0,'false','accessory_queen_of_cat_cap_i00',0,1,0,'0','0',0,0),
	(13312,'Monster Eye Hat (Event)','30-day limited period','dhair','false','none',NULL,10,'none',0,43200,1,0,0,0,0,0,'false','accessory_monstereye_cap_i00',0,1,0,'0','0',0,0),
	(13313,'Brown Bear Hat (Event)','30-day limited period','dhair','false','none',NULL,10,'none',0,43200,1,0,0,0,0,0,'false','accessory_brown_bear_cap_i00',0,1,0,'0','0',0,0),
	(13314,'Fungus Hat (Event)','30-day limited period','dhair','false','none',NULL,10,'none',0,43200,1,0,0,0,0,0,'false','accessory_fungus_cap_i00',0,1,0,'0','0',0,0),
	(13315,'Skull Hat (Event)','30-day limited period','dhair','false','none',NULL,10,'none',0,43200,1,0,0,0,0,0,'false','accessory_skeleton_cap_i00',0,1,0,'0','0',0,0),
	(13316,'Ornithomimus Hat (Event)','30-day limited period','dhair','false','none',NULL,10,'none',0,43200,1,0,0,0,0,0,'false','accessory_ornithomimus_cap_i00',0,1,0,'0','0',0,0),
	(13317,'Feline King Hat (Event)','30-day limited period','dhair','false','none',NULL,10,'none',0,43200,1,0,0,0,0,0,'false','accessory_king_of_cat_cap_i00',0,1,0,'0','0',0,0),
	(13318,'Kai the Cat Hat (Event)','30-day limited period','dhair','false','none',NULL,10,'none',0,43200,1,0,0,0,0,0,'false','accessory_chi_the_cat_cap_i00',0,1,0,'0','0',0,0),
	(13325,'Kat the Cat Hat (Event)','7-day Limited Period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_cat_the_cat_cap_i00',0,1,0,'0','0',0,0),
	(13326,'Feline Queen Hat (Event)','7-day Limited Period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_queen_of_cat_cap_i00',0,1,0,'0','0',0,0),
	(13327,'Monster Eye Hat (Event)','7-day Limited Period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_monstereye_cap_i00',0,1,0,'0','0',0,0),
	(13328,'Brown Bear Hat (Event)','7-day Limited Period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_brown_bear_cap_i00',0,1,0,'0','0',0,0),
	(13329,'Fungus Hat (Event)','7-day Limited Period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_fungus_cap_i00',0,1,0,'0','0',0,0),
	(13330,'Skull Hat (Event)','7-day Limited Period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_skeleton_cap_i00',0,1,0,'0','0',0,0),
	(13331,'Ornithomimus Hat (Event)','7-day Limited Period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_ornithomimus_cap_i00',0,1,0,'0','0',0,0),
	(13332,'Feline King Hat (Event)','7-day Limited Period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_king_of_cat_cap_i00',0,1,0,'0','0',0,0),
	(13333,'Kai the Cat Hat (Event)','7-day Limited Period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_chi_the_cat_cap_i00',0,1,0,'0','0',0,0),
	(13340,'Agathion of Love (Event)','7-day Limited Period','lbracelet','false','none',NULL,30,'none',0,10080,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8245','1',0,0),
	(13389,'Kratei Barbed Shirt','CP','underwear','true','none',NULL,130,'a',0,-1,0,23,0,0,0,0,'false','etc_shirts_a_i04',0,1,0,'0','0',0,0),
	(13390,'Kratei Mithril Shirt','CP','underwear','true','none',NULL,130,'s',0,-1,0,28,0,0,0,0,'false','etc_shirts_s_i05',0,1,0,'0','0',0,0),
	(13391,'Kratei Striped Barbed Shirt','CP','underwear','true','none',NULL,130,'a',0,-1,0,26,0,0,0,0,'false','etc_stripe_shirts_a_i04',0,1,0,'0','0',0,0),
	(13392,'Kratei Striped Mithril Shirt','CP','underwear','true','none',NULL,130,'s',0,-1,0,30,0,0,0,0,'false','etc_stripe_shirts_s_i05',0,1,0,'0','0',0,0),
	(13393,'Shadow Item - Monkey Hat','','dhair','false','none',NULL,10,'none',0,100,0,0,0,0,0,0,'true','monkey_cap_i00',0,1,0,'0','0',0,0),
	(13394,'Shadow Item - Pig Hat','','dhair','false','none',NULL,10,'none',0,100,0,0,0,0,0,0,'true','event_pig_cap_i00',0,1,0,'0','0',0,0),
	(13415,'Frog Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_frog_cap_i00',0,1,0,'0','0',0,0),
	(13416,'Chicken Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_chicken_cap_i00',0,1,0,'0','0',0,0),
	(13429,'Teddy Bear Hat (Event)','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_bear_cap_i00',0,1,0,'0','0',0,0),
	(13430,'Piggy Hat (Event)','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_pig_cap_i00',0,1,0,'0','0',0,0),
	(13431,'Jester Hat (Event)','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_jester_cap_i00',0,1,0,'0','0',0,0),
	(13432,'Vesper Breastplate','','chest','true','heavy',NULL,7520,'s84',0,-1,0,250,0,0,46668000,2240,'true','armor_t94_u_i00',1,1,1,'0','0',0,0),
	(13433,'Vesper Leather Breastplate','','chest','true','light',NULL,4140,'s84',0,-1,0,187,0,0,35000000,1680,'true','armor_t95_u_i00',1,1,1,'0','0',0,0),
	(13434,'Vesper Tunic','','chest','true','magic',NULL,1750,'s84',0,-1,0,125,0,637,35000000,1680,'true','armor_t96_u_i00',1,1,1,'0','0',0,0),
	(13435,'Vesper Noble Breastplate','','chest','true','heavy',NULL,7520,'s84',0,-1,0,250,0,0,55840000,2680,'true','armor_t94_u_i01',1,1,1,'0','0',0,0),
	(13436,'Vesper Noble Leather Breastplate','','chest','true','light',NULL,4140,'s84',0,-1,0,187,0,0,41880000,2010,'true','armor_t95_u_i01',1,1,1,'0','0',0,0),
	(13437,'Vesper Noble Tunic','','chest','true','magic',NULL,1750,'s84',0,-1,0,125,0,637,41880000,2010,'true','armor_t96_u_i01',1,1,1,'0','0',0,0),
	(13438,'Vesper Gaiters','','legs','true','heavy',NULL,3170,'s84',0,-1,0,156,0,0,29168000,1400,'true','armor_t94_l_i00',1,1,1,'0','0',0,0),
	(13439,'Vesper Gauntlet','','gloves','true','none',NULL,510,'s84',0,-1,0,68,0,0,11667000,560,'true','armor_t94_g_i00',1,1,1,'0','0',0,0),
	(13440,'Vesper Boots','','feet','true','none',NULL,1070,'s84',0,-1,0,68,0,0,11667000,560,'true','armor_t94_b_i00',1,1,1,'0','0',0,0),
	(13441,'Vesper Leather Leggings','','legs','true','light',NULL,1320,'s84',0,-1,0,117,0,0,21876000,1050,'true','armor_t95_l_i00',1,1,1,'0','0',0,0),
	(13442,'Vesper Leather Gloves','','gloves','true','none',NULL,510,'s84',0,-1,0,68,0,0,11667000,560,'true','armor_t95_g_i00',1,1,1,'0','0',0,0),
	(13443,'Vesper Leather Boots','','feet','true','none',NULL,1070,'s84',0,-1,0,68,0,0,11667000,560,'true','armor_t95_b_i00',1,1,1,'0','0',0,0),
	(13444,'Vesper Stockings','','legs','true','magic',NULL,850,'s84',0,-1,0,78,0,415,21876000,1050,'true','armor_t96_l_i00',1,1,1,'0','0',0,0),
	(13445,'Vesper Gloves','','gloves','true','none',NULL,510,'s84',0,-1,0,68,0,0,11667000,560,'true','armor_t96_g_i00',1,1,1,'0','0',0,0),
	(13446,'Vesper Shoes','','feet','true','none',NULL,1070,'s84',0,-1,0,68,0,0,11667000,560,'true','armor_t96_b_i00',1,1,1,'0','0',0,0),
	(13448,'Vesper Noble Gaiters','','legs','true','heavy',NULL,3170,'s84',0,-1,0,156,0,0,34900000,1675,'true','armor_t94_l_i01',1,1,1,'0','0',0,0),
	(13449,'Vesper Noble Gauntlet','','gloves','true','none',NULL,510,'s84',0,-1,0,68,0,0,13960000,670,'true','armor_t94_g_i01',1,1,1,'0','0',0,0),
	(13450,'Vesper Noble Boots','','feet','true','none',NULL,1070,'s84',0,-1,0,68,0,0,13960000,670,'true','armor_t94_b_i01',1,1,1,'0','0',0,0),
	(13451,'Vesper Noble Leather Leggings','','legs','true','light',NULL,1320,'s84',0,-1,0,117,0,0,26175000,1256,'true','armor_t95_l_i01',1,1,1,'0','0',0,0),
	(13452,'Vesper Noble Leather Gloves','','gloves','true','none',NULL,510,'s84',0,-1,0,68,0,0,13960000,670,'true','armor_t95_g_i01',1,1,1,'0','0',0,0),
	(13453,'Vesper Noble Leather Boots','','feet','true','none',NULL,1070,'s84',0,-1,0,68,0,0,13960000,670,'true','armor_t95_b_i01',1,1,1,'0','0',0,0),
	(13454,'Vesper Noble Stockings','','legs','true','magic',NULL,850,'s84',0,-1,0,78,0,415,26175000,1256,'true','armor_t96_l_i01',1,1,1,'0','0',0,0),
	(13455,'Vesper Noble Gloves','','gloves','true','none',NULL,510,'s84',0,-1,0,68,0,0,13960000,670,'true','armor_t96_g_i01',1,1,1,'0','0',0,0),
	(13456,'Vesper Noble Shoes','','feet','true','none',NULL,1070,'s84',0,-1,0,68,0,0,13960000,670,'true','armor_t96_b_i01',1,1,1,'0','0',0,0),
	(13472,'Circlet of Innadril Valor','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_pledge_hair1_i00',0,1,0,'0','0',0,0),
	(13473,'Circlet of Aden Valor','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_pledge_hair2_i00',0,1,0,'0','0',0,0),
	(13474,'Circlet of Dion Valor','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_pledge_hair3_i00',0,1,0,'0','0',0,0),
	(13475,'Circlet of Dion Sniper','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_pledge_hair4_i00',0,1,0,'0','0',0,0),
	(13476,'Circlet of Innadril Sniper','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_pledge_hair5_i00',0,1,0,'0','0',0,0),
	(13477,'Circlet of Oren Sniper','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_pledge_hair6_i00',0,1,0,'0','0',0,0),
	(13478,'Circlet of Gludio Sage','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_pledge_hair7_i00',0,1,0,'0','0',0,0),
	(13479,'Circlet of Rune Sage','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_pledge_hair8_i00',0,1,0,'0','0',0,0),
	(13480,'Circlet of Giran Sage','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_pledge_hair9_i00',0,1,0,'0','0',0,0),
	(13481,'Circlet of Goddard Combat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_pledge_hair10_i00',0,1,0,'0','0',0,0),
	(13482,'Circlet of Schuttgart Combat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_pledge_hair11_i00',0,1,0,'0','0',0,0),
	(13483,'Circlet of Oren Combat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_pledge_hair12_i00',0,1,0,'0','0',0,0),
	(13484,'Circlet of Gludio Silence','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_pledge_hair13_i00',0,1,0,'0','0',0,0),
	(13485,'Circlet of Schuttgart Silence','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_pledge_hair14_i00',0,1,0,'0','0',0,0),
	(13486,'Circlet of Aden Unity','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_pledge_hair15_i00',0,1,0,'0','0',0,0),
	(13487,'Circlet of Rune Silence','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_pledge_hair16_i00',0,1,0,'0','0',0,0),
	(13488,'Birthday Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_birthday_cap_i00',1,1,1,'0','0',0,0),
	(13489,'Halloween Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_halloween_cap_i00',1,1,1,'0','0',0,0),
	(13490,'Arrow-Pierced Apple','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_arrow_apple_i00',1,1,1,'0','0',0,0),
	(13491,'Popped-Out Eye','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_beetle_eye_i00',1,1,1,'0','0',0,0),
	(13492,'Graduation Cap','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_graduation_cap_i00',1,1,1,'0','0',0,0),
	(13493,'Refined Carnival Circlet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_carnival_circlet_i00',1,1,1,'0','0',0,0),
	(13494,'Refined Angel Ring','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_angel_ring_i00',1,1,1,'0','0',0,0),
	(13495,'Refined Devil Horn','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_devil_horn_i00',1,1,1,'0','0',0,0),
	(13496,'Refined Pirate Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_captain_cap_i00',1,1,1,'0','0',0,0),
	(13497,'Refined Chick Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_chicken_cap2_i00',1,1,1,'0','0',0,0),
	(13498,'Refined Wizard Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_magician_cap2_i00',1,1,1,'0','0',0,0),
	(13499,'Refined Jester Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_jester_cap_2_i00',1,1,1,'0','0',0,0),
	(13500,'Refined Black Feather Mask','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_black_feather_mask2_i00',1,1,1,'0','0',0,0),
	(13501,'Refined Romantic Chapeau','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_archer_hat2_i00',1,1,1,'0','0',0,0),
	(13502,'Refined Carnival Circlet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_carnival_circlet2_i00',1,1,1,'0','0',0,0),
	(13503,'Refined Medieval Style Party Mask','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_middle_age_party_mask2_i00',1,1,1,'0','0',0,0),
	(13504,'Refined Dapper Cap','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_dandy_cap2_i00',1,1,1,'0','0',0,0),
	(13505,'Clownfish Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_fish_cap2_i00',1,1,1,'0','0',0,0),
	(13506,'Improved Lord\'s Crown','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_pig_cap_i00',1,1,1,'0','0',0,0),
	(13507,'Circlet of Flames','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_flame_circlet_i00',1,1,1,'0','0',0,0),
	(13508,'Circlet of Freeze','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_ice_circlet_i00',1,1,1,'0','0',0,0),
	(13509,'Circlet of Storm','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_storm_circlet_i00',1,1,1,'0','0',0,0),
	(13510,'Circlet of Earthquake','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_earthquake_circlet_i00',1,1,1,'0','0',0,0),
	(13511,'Circlet of Darkness','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_darkness_circlet_i00',1,1,1,'0','0',0,0),
	(13512,'Circlet of Splendor','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_shining_circlet_i00',1,1,1,'0','0',0,0),
	(13513,'Mining Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_mining_cap_i00',1,1,1,'0','0',0,0),
	(13514,'Improved Mining Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_advence_mining_cap_i00',1,1,1,'0','0',0,0),
	(13515,'Search Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_mine_search_cap_i00',1,1,1,'0','0',0,0),
	(13516,'Improved Search Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_advence_mine_search_cap_i00',1,1,1,'0','0',0,0),
	(13517,'Event - Raccoon Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_raccoon_cap_i00',0,1,0,'0','0',0,0),
	(13518,'Event - Top Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_magicial_cap_i00',0,1,0,'0','0',0,0),
	(13519,'Event - Black Mask','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_jjoro_masj_i00',0,1,0,'0','0',0,0),
	(13520,'Event - Jindo Dog Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_jindo_cap_i00',0,1,0,'0','0',0,0),
	(13521,'Event - Shaggy Dog Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_sapsal_cap_i00',0,1,0,'0','0',0,0),
	(13522,'Event - Rider Goggles','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_dragonfly_goggle_i00',0,1,0,'0','0',0,0),
	(13523,'Event - Lineage Souvenir Circlet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_event_5th_circlet_i00',0,1,0,'0','0',0,0),
	(13526,'Test Belt','','belt','true','light',NULL,4830,'none',0,-1,0,36,0,0,113,0,'true','etc_shirts_a_i04',1,1,1,'0','0',0,0),
	(13527,'Test Cloak','','back','false','none',NULL,260,'none',0,-1,0,2,0,0,37,0,'true','armor_back01',1,1,1,'0','0',0,0),
	(13529,'Test Sigil','','lhand','false','sigil',NULL,1430,'none',-8,-1,0,0,0,0,0,0,'true','shield_arcana_sigil_i00',1,1,1,'0','0',0,0),
	(13543,'Agathion Summon Bracelet - Collection','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,7000000,0,'false','pi_high_agathion_bracelet_i00',0,1,0,'8251;5780','1;1',0,0),
	(13544,'Agathion Summon Bracelet - Boy Teddy Bear','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,7000000,0,'true','pi_high_agathion_bracelet_i00',0,0,0,'8259;5958','1;1',0,0),
	(13545,'Agathion Summon Bracelet - Girl Teddy Bear','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,7000000,0,'true','pi_high_agathion_bracelet_i00',0,0,0,'8260;5959','1;1',0,0),
	(13546,'Steam Sledge Mounting Bracelet','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,1144000,76,'true','pi_high_agathion_bracelet_i00',0,0,0,'8261','1',0,0),
	(13547,'Tawny-Maned Lion Mounting Bracelet','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,1144000,76,'true','pi_high_agathion_bracelet_i00',0,0,0,'8262','1',0,0),
	(13687,'Knight\'s Cloak','','back','false','none',NULL,220,'s84',0,-1,0,20,0,0,28671000,0,'true','vesper_cloack_i00',0,1,0,'0','0',0,0),
	(13688,'Knight\'s Cloak - Light Armor exclusive','','back','false','none',NULL,220,'s84',0,-1,0,20,0,0,28671000,0,'true','vesper_cloack_i00',0,1,0,'0','0',0,0),
	(13689,'Knight\'s Cloak - Robe exclusive','','back','false','none',NULL,220,'s84',0,-1,0,20,0,0,28671000,0,'true','vesper_cloack_i00',0,1,0,'0','0',0,0),
	(13690,'Knight\'s Cloak - Kamael exclusive','','back','false','none',NULL,220,'s84',0,-1,0,20,0,0,28671000,0,'true','vesper_cloack_i00',0,1,0,'0','0',0,0),
	(13740,'Gludio Water Protection Necklace','','neck','true','none',NULL,150,'a',0,-1,0,0,85,33,0,160,'true','accessary_inferno_necklace_i00',0,1,0,'8388','1',0,0),
	(13741,'Dion Divinity Protection Necklace','','neck','true','none',NULL,150,'a',0,-1,0,0,85,33,0,160,'true','accessary_inferno_necklace_i00',0,1,0,'8389','1',0,0),
	(13742,'Giran Wind Protection Necklace','','neck','true','none',NULL,150,'a',0,-1,0,0,85,33,0,160,'true','accessary_inferno_necklace_i00',0,1,0,'8390','1',0,0),
	(13743,'Oren Protection Necklace of Darkness','','neck','true','none',NULL,150,'a',0,-1,0,0,85,33,0,160,'true','accessary_inferno_necklace_i00',0,1,0,'8391','1',0,0),
	(13744,'Aden Earth Protection Necklace','','neck','true','none',NULL,150,'a',0,-1,0,0,85,33,0,160,'true','accessary_inferno_necklace_i00',0,1,0,'8392','1',0,0),
	(13745,'Innadril Water Protection Necklace','','neck','true','none',NULL,150,'a',0,-1,0,0,85,33,0,160,'true','accessary_inferno_necklace_i00',0,1,0,'8393','1',0,0),
	(13746,'Goddard Fire Protection Necklace','','neck','true','none',NULL,150,'a',0,-1,0,0,85,33,0,160,'true','accessary_inferno_necklace_i00',0,1,0,'8394','1',0,0),
	(13747,'Rune Fire Protection Necklace','','neck','true','none',NULL,150,'a',0,-1,0,0,85,33,0,160,'true','accessary_inferno_necklace_i00',0,1,0,'8395','1',0,0),
	(13748,'Schuttgart Wind Protection Necklace','','neck','true','none',NULL,150,'a',0,-1,0,0,85,33,0,160,'true','accessary_inferno_necklace_i00',0,1,0,'8396','1',0,0),
	(13751,'Warrior\'s T-shirt','','underwear','false','none',NULL,130,'a',0,-1,0,28,0,0,0,0,'true','etc_shirts_a_i04',0,1,0,'0','0',8324,1),
	(13752,'Olympiad Warrior\'s Ring','','rfinger,lfinger','true','none',NULL,150,'a',0,43200,1,0,42,21,0,0,'true','accessory_ring_of_hero_i00',0,1,0,'8292','1',0,0),
	(13753,'Olympiad Warrior\'s Necklace','','neck','false','none',NULL,150,'a',0,43200,1,0,85,26,0,0,'true','accessory_necklace_of_hero_i00',0,1,0,'8294','1',0,0),
	(13754,'Olympiad Warrior\'s Earring','','rear,lear','false','none',NULL,150,'a',0,43200,1,0,63,31,0,0,'true','accessory_earring_of_hero_i00',0,1,0,'8293','1',0,0),
	(13756,'Agathion Summon Bracelet - Knight','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8275;5954','1;1',0,0),
	(13802,'Native\'s Hood','','head','false','none',NULL,70,'none',0,-1,0,33,0,0,0,0,'true','armor_leather_helmet_i00',1,1,1,'0','0',0,0),
	(13803,'Native\'s Tunic','','chest','false','light',NULL,4720,'none',0,-1,0,53,0,0,0,0,'true','armor_t34_u_i00',1,1,1,'0','0',0,0),
	(13804,'Native\'s Trousers','','legs','false','light',NULL,1700,'none',0,-1,0,29,0,0,0,0,'true','armor_t34_l_i00',1,1,1,'0','0',0,0),
	(13805,'Guards of the Dawn Helmet','','head','true','none',NULL,70,'none',0,-1,0,33,0,0,0,0,'true','armor_leather_helmet_i02',1,1,1,'0','0',0,0),
	(13806,'Guards of the Dawn Tunic','','chest','false','light',NULL,4720,'none',0,-1,0,53,0,0,0,0,'true','armor_t08_u_i00',1,1,1,'0','0',0,0),
	(13807,'Guards of the Dawn Trousers','','legs','false','light',NULL,1700,'none',0,-1,0,29,0,0,0,0,'true','armor_t08_l_i00',1,1,1,'0','0',0,0),
	(13885,'Sealed Arcana Sigil','','lhand','true','sigil',NULL,940,'s',-8,-1,0,13,0,0,3355000,161,'true','arcana_sigil_i01',1,1,1,'0','0',0,0),
	(13886,'Sealed Dynasty Sigil','','lhand','true','sigil',NULL,930,'s80',-8,-1,0,15,0,0,6404000,307,'true','armor_dynasty_sigil_i01',1,1,1,'0','0',0,0),
	(13887,'Sealed Vesper Sigil','','lhand','true','sigil',NULL,920,'s84',-8,-1,0,17,0,0,12250000,588,'true','armor_verper_sigil_i01',1,1,1,'0','0',0,0),
	(13888,'Sealed Lord\'s Cloak','','back','false','none',NULL,220,'s84',0,-1,0,2,0,0,28671000,0,'true','feud_load_cloak_i01',0,1,0,'0','0',0,0),
	(13889,'Holy Spirit\'s Cloak - Kamael exclusive','','back','false','none',NULL,220,'s84',0,-1,0,20,0,0,28671000,0,'true','vesper_cloack_i00',0,1,0,'0','0',0,0),
	(13890,'Holy Spirit\'s Cloak','','back','false','none',NULL,220,'s84',0,-1,0,20,0,0,28671000,0,'true','vesper_cloack_i00',0,1,0,'0','0',0,0),
	(13891,'Holy Spirit\'s Cloak - Light Armor exclusive','','back','false','none',NULL,220,'s84',0,-1,0,20,0,0,28671000,0,'true','vesper_cloack_i00',0,1,0,'0','0',0,0),
	(13892,'Holy Spirit\'s Cloak - Robe exclusive','','back','false','none',NULL,220,'s84',0,-1,0,20,0,0,28671000,0,'true','vesper_cloack_i00',0,1,0,'0','0',0,0),
	(13894,'Cloth Belt','','belt','true','light',NULL,500,'c',0,-1,0,10,0,0,45100,18,'true','armor_belt_i00',1,1,1,'0','0',0,0),
	(13895,'Leather Belt','','belt','true','light',NULL,480,'b',0,-1,0,11,0,0,165000,22,'true','armor_belt_i01',1,1,1,'0','0',0,0),
	(13896,'Iron Belt','','belt','true','light',NULL,460,'a',0,-1,0,12,0,0,371300,30,'true','armor_belt_i02',1,1,1,'0','0',0,0),
	(13897,'Mithril Belt','','belt','true','light',NULL,440,'s',0,-1,0,14,0,0,1917000,92,'true','armor_belt_i03',1,1,1,'0','0',0,0),
	(13938,'Low-Grade Magic Pouch Cloth Belt','','belt','true','light',NULL,500,'c',0,-1,0,10,0,0,45100,18,'true','armor_magic_pouch_belt_i00',1,1,1,'8290','1',0,0),
	(13939,'Regular Magic Pouch Cloth Belt','','belt','true','light',NULL,500,'c',0,-1,0,10,0,0,45100,18,'true','armor_magic_pouch_belt_i00',1,1,1,'8290','2',0,0),
	(13940,'High-Grade Magic Pouch Cloth Belt','','belt','true','light',NULL,500,'c',0,-1,0,10,0,0,45100,18,'true','armor_magic_pouch_belt_i00',1,1,1,'8290','3',0,0),
	(13941,'Top-Grade Magic Pouch Cloth Belt','','belt','true','light',NULL,500,'c',0,-1,0,10,0,0,45100,18,'true','armor_magic_pouch_belt_i00',1,1,1,'8290','4',0,0),
	(13942,'Low-Grade Magic Pouch Leather Belt','','belt','true','light',NULL,480,'b',0,-1,0,11,0,0,165000,22,'true','armor_magic_pouch_belt_i01',1,1,1,'8290','3',0,0),
	(13943,'Regular Magic Pouch Leather Belt','','belt','true','light',NULL,480,'b',0,-1,0,11,0,0,165000,22,'true','armor_magic_pouch_belt_i01',1,1,1,'8290','4',0,0),
	(13944,'High-Grade Magic Pouch Leather Belt','','belt','true','light',NULL,480,'b',0,-1,0,11,0,0,165000,22,'true','armor_magic_pouch_belt_i01',1,1,1,'8290','5',0,0),
	(13945,'Top-Grade Magic Pouch Leather Belt','','belt','true','light',NULL,480,'b',0,-1,0,11,0,0,165000,22,'true','armor_magic_pouch_belt_i01',1,1,1,'8290','6',0,0),
	(13946,'Low-Grade Magic Pouch Iron Belt','','belt','true','light',NULL,460,'a',0,-1,0,12,0,0,371300,30,'true','armor_magic_pouch_belt_i02',1,1,1,'8290','5',0,0),
	(13947,'Regular Magic Pouch Iron Belt','','belt','true','light',NULL,460,'a',0,-1,0,12,0,0,371300,30,'true','armor_magic_pouch_belt_i02',1,1,1,'8290','6',0,0),
	(13948,'High-Grade Magic Pouch Iron Belt','','belt','true','light',NULL,460,'a',0,-1,0,12,0,0,371300,30,'true','armor_magic_pouch_belt_i02',1,1,1,'8290','7',0,0),
	(13949,'Top-Grade Magic Pouch Iron Belt','','belt','true','light',NULL,460,'a',0,-1,0,12,0,0,371300,30,'true','armor_magic_pouch_belt_i02',1,1,1,'8290','8',0,0),
	(13950,'Low-Grade Magic Pouch Mithril Belt','','belt','true','light',NULL,440,'s',0,-1,0,14,0,0,1917000,92,'true','armor_magic_pouch_belt_i03',1,1,1,'8290','7',0,0),
	(13951,'Regular Magic Pouch Mithril Belt','','belt','true','light',NULL,440,'s',0,-1,0,14,0,0,1917000,92,'true','armor_magic_pouch_belt_i03',1,1,1,'8290','8',0,0),
	(13952,'High-Grade Magic Pouch Mithril Belt','','belt','true','light',NULL,440,'s',0,-1,0,14,0,0,1917000,92,'true','armor_magic_pouch_belt_i03',1,1,1,'8290','9',0,0),
	(13953,'Top-Grade Magic Pouch Mithril Belt','','belt','true','light',NULL,440,'s',0,-1,0,14,0,0,1917000,92,'true','armor_magic_pouch_belt_i03',1,1,1,'8290','10',0,0),
	(13954,'Low-Grade Magic Pin Cloth Belt','','belt','true','light',NULL,500,'c',0,-1,0,10,0,0,45100,18,'true','armor_magic_pin_belt_i00',1,1,1,'8291','1',0,0),
	(13955,'Regular Magic Pin Cloth Belt','','belt','true','light',NULL,500,'c',0,-1,0,10,0,0,45100,18,'true','armor_magic_pin_belt_i00',1,1,1,'8291','2',0,0),
	(13956,'High-Grade Magic Pin Cloth Belt','','belt','true','light',NULL,500,'c',0,-1,0,10,0,0,45100,18,'true','armor_magic_pin_belt_i00',1,1,1,'8291','3',0,0),
	(13957,'Top-Grade Magic Pin Cloth Belt','','belt','true','light',NULL,500,'c',0,-1,0,10,0,0,45100,18,'true','armor_magic_pin_belt_i00',1,1,1,'8291','4',0,0),
	(13958,'Low-Grade Magic Pin Leather Belt','','belt','true','light',NULL,480,'b',0,-1,0,11,0,0,165000,22,'true','armor_magic_pin_belt_i01',1,1,1,'8291','3',0,0),
	(13959,'Regular Magic Pin Leather Belt','','belt','true','light',NULL,480,'b',0,-1,0,11,0,0,165000,22,'true','armor_magic_pin_belt_i01',1,1,1,'8291','4',0,0),
	(13960,'High-Grade Magic Pin Leather Belt','','belt','true','light',NULL,480,'b',0,-1,0,11,0,0,165000,22,'true','armor_magic_pin_belt_i01',1,1,1,'8291','5',0,0),
	(13961,'Top-Grade Magic Pin Leather Belt','','belt','true','light',NULL,480,'b',0,-1,0,11,0,0,165000,22,'true','armor_magic_pin_belt_i01',1,1,1,'8291','6',0,0),
	(13962,'Low-Grade Magic Pin Iron Belt','','belt','true','light',NULL,460,'a',0,-1,0,12,0,0,371300,30,'true','armor_magic_pin_belt_i02',1,1,1,'8291','5',0,0),
	(13963,'Regular Magic Pin Iron Belt','','belt','true','light',NULL,460,'a',0,-1,0,12,0,0,371300,30,'true','armor_magic_pin_belt_i02',1,1,1,'8291','6',0,0),
	(13964,'High-Grade Magic Pin Iron Belt','','belt','true','light',NULL,460,'a',0,-1,0,12,0,0,371300,30,'true','armor_magic_pin_belt_i02',1,1,1,'8291','7',0,0),
	(13965,'Top-Grade Magic Pin Iron Belt','','belt','true','light',NULL,460,'a',0,-1,0,12,0,0,371300,30,'true','armor_magic_pin_belt_i02',1,1,1,'8291','8',0,0),
	(13966,'Low-Grade Magic Pin Mithril Belt','','belt','true','light',NULL,440,'s',0,-1,0,14,0,0,1917000,92,'true','armor_magic_pin_belt_i03',1,1,1,'8291','7',0,0),
	(13967,'Regular Magic Pin Mithril Belt','','belt','true','light',NULL,440,'s',0,-1,0,14,0,0,1917000,92,'true','armor_magic_pin_belt_i03',1,1,1,'8291','8',0,0),
	(13968,'High-Grade Magic Pin Mithril Belt','','belt','true','light',NULL,440,'s',0,-1,0,14,0,0,1917000,92,'true','armor_magic_pin_belt_i03',1,1,1,'8291','9',0,0),
	(13969,'Top-Grade Magic Pin Mithril Belt','','belt','true','light',NULL,440,'s',0,-1,0,14,0,0,1917000,92,'true','armor_magic_pin_belt_i03',1,1,1,'8291','10',0,0),
	(13975,'Poison Bottle 1','','rbracelet','false','light',NULL,4830,'c',0,-1,0,36,0,0,0,0,'true','etc_fruit_juice_glass_bottle_i00',1,1,1,'0','0',0,0),
	(13976,'Poison Bottle 2','','rbracelet','false','light',NULL,4830,'b',0,-1,0,36,0,0,0,0,'true','etc_fruit_juice_glass_bottle_i01',1,1,1,'0','0',0,0),
	(13977,'Poison Bottle 3','','rbracelet','false','light',NULL,4830,'a',0,-1,0,36,0,0,0,0,'true','etc_fruit_juice_glass_bottle_i02',1,1,1,'0','0',0,0),
	(14027,'Collection Agathion Summon Bracelet','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,3000000,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8251;5780','1;1',0,0),
	(14053,'Gold-Maned Lion Mounting Bracelet','7-day Limited Period','lbracelet','false','none',NULL,30,'none',0,10080,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8262','1',0,0),
	(14054,'Steam Beatle Mounting Bracelet','7-day Limited Period','lbracelet','false','none',NULL,30,'none',0,10080,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8261','1',0,0),
	(14059,'Teddy Boy Agathion Bracelet','30-day limited period','lbracelet','false','none',NULL,30,'none',0,43200,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8259;5958','1;1',0,0),
	(14060,'Teddy Girl Agathion Bracelet','30-day limited period','lbracelet','false','none',NULL,30,'none',0,43200,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8260;5959','1;1',0,0),
	(14066,'Gold Maned Lion Mounting Bracelet (event)','7-day Limited Period','lbracelet','false','none',NULL,30,'none',0,10080,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8262','1',0,0),
	(14067,'Steam Beatle Mounting Bracelet (event)','7-day Limited Period','lbracelet','false','none',NULL,30,'none',0,10080,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8261','1',0,0),
	(14072,'Teddy Boy Agathion Bracelet (event)','30-day limited period','lbracelet','false','none',NULL,30,'none',0,43200,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8259;5958','1;1',0,0),
	(14073,'Teddy Girl Agathion Bracelet (event)','30-day limited period','lbracelet','false','none',NULL,30,'none',0,43200,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8260;5959','1;1',0,0),
	(14075,'Sudden Agathion (Event)','30-day limited period','lbracelet','false','none',NULL,30,'none',0,43200,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8256;5955','1;1',0,0),
	(14076,'Shiny Agathion (Event)','30-day limited period','lbracelet','false','none',NULL,30,'none',0,43200,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8257;5956','1;1',0,0),
	(14077,'Sobbing Agathion (Event)','30-day limited period','lbracelet','false','none',NULL,30,'none',0,43200,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8258;5957','1;1',0,0),
	(14091,'Teddy Boy Agathion Bracelet','7-day Limited Period','lbracelet','false','none',NULL,30,'none',0,10080,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8259;5958','1;1',0,0),
	(14092,'Teddy Girl Agathion Bracelet','7-day Limited Period','lbracelet','false','none',NULL,30,'none',0,10080,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8260;5959','1;1',0,0),
	(14093,'Sudden Agathion','7-day Limited Period','lbracelet','false','none',NULL,30,'none',0,10080,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8256;5955','1;1',0,0),
	(14094,'Shiny Agathion','7-day Limited Period','lbracelet','false','none',NULL,30,'none',0,10080,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8257;5956','1;1',0,0),
	(14095,'Sobbing Agathion','7-day Limited Period','lbracelet','false','none',NULL,30,'none',0,10080,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8258;5957','1;1',0,0),
	(14099,'Teddy Boy Agathion Bracelet (event)','7-day Limited Period','lbracelet','false','none',NULL,30,'none',0,10080,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8259;5958','1;1',0,0),
	(14100,'Teddy Girl Agathion Bracelet (event)','7-day Limited Period','lbracelet','false','none',NULL,30,'none',0,10080,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8260;5959','1;1',0,0),
	(14101,'Sudden Agathion (Event)','7-day Limited Period','lbracelet','false','none',NULL,30,'none',0,10080,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8256;5955','1;1',0,0),
	(14102,'Shiny Agathion (Event)','7-day Limited Period','lbracelet','false','none',NULL,30,'none',0,10080,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8257;5956','1;1',0,0),
	(14103,'Sobbing Agathion (Event)','7-day Limited Period','lbracelet','false','none',NULL,30,'none',0,10080,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8258;5957','1;1',0,0),
	(14104,'Shadow Item - Collection Agathion Summon Bracelet','','lbracelet','false','none',NULL,150,'none',0,600,0,0,0,0,200000,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8251;5780','1;1',0,0),
	(14105,'Sealed Vesper Breastplate','','chest','true','heavy',NULL,7520,'s84',0,-1,0,236,0,0,46668000,2240,'true','armor_t94_u_i02',1,1,1,'0','0',0,0),
	(14106,'Sealed Vesper Leather Breastplate','','chest','true','light',NULL,4140,'s84',0,-1,0,177,0,0,35000000,1680,'true','armor_t95_u_i02',1,1,1,'0','0',0,0),
	(14107,'Sealed Vesper Tunic','','chest','true','magic',NULL,1750,'s84',0,-1,0,118,0,637,35000000,1680,'true','armor_t96_u_i02',1,1,1,'0','0',0,0),
	(14108,'Sealed Vesper Gaiters','','legs','true','heavy',NULL,3170,'s84',0,-1,0,148,0,0,29168000,1400,'true','armor_t94_l_i02',1,1,1,'0','0',0,0),
	(14109,'Sealed Vesper Gauntlet','','gloves','true','none',NULL,510,'s84',0,-1,0,68,0,0,11667000,560,'true','armor_t94_g_i02',1,1,1,'0','0',0,0),
	(14110,'Sealed Vesper Boots','','feet','true','none',NULL,1070,'s84',0,-1,0,68,0,0,11667000,560,'true','armor_t94_b_i02',1,1,1,'0','0',0,0),
	(14112,'Sealed Vesper Leather Leggings','','legs','true','light',NULL,1320,'s84',0,-1,0,111,0,0,21876000,1050,'true','armor_t95_l_i02',1,1,1,'0','0',0,0),
	(14113,'Sealed Vesper Leather Gloves','','gloves','true','none',NULL,510,'s84',0,-1,0,68,0,0,11667000,560,'true','armor_t95_g_i02',1,1,1,'0','0',0,0),
	(14114,'Sealed Vesper Leather Boots','','feet','true','none',NULL,1070,'s84',0,-1,0,68,0,0,11667000,560,'true','armor_t95_b_i02',1,1,1,'0','0',0,0),
	(14115,'Sealed Vesper Stockings','','legs','true','magic',NULL,850,'s84',0,-1,0,74,0,415,21876000,1050,'true','armor_t96_l_i02',1,1,1,'0','0',0,0),
	(14116,'Sealed Vesper Gloves','','gloves','true','none',NULL,510,'s84',0,-1,0,68,0,0,11667000,560,'true','armor_t96_g_i02',1,1,1,'0','0',0,0),
	(14117,'Sealed Vesper Shoes','','feet','true','none',NULL,1070,'s84',0,-1,0,68,0,0,11667000,560,'true','armor_t96_b_i02',1,1,1,'0','0',0,0),
	(14160,'Sealed Vesper Earring','','rear,lear','true','none',NULL,150,'s84',0,-1,0,0,83,0,6986000,335,'true','vesper_earring_i01',1,1,1,'0','0',0,0),
	(14161,'Sealed Vesper Necklace','','neck','true','none',NULL,150,'s84',0,-1,0,0,110,0,9315000,447,'true','vesper_necklace_i01',1,1,1,'0','0',0,0),
	(14162,'Sealed Vesper Ring','','rfinger,lfinger','true','none',NULL,150,'s84',0,-1,0,0,55,0,4658000,224,'true','vesper_ring_i01',1,1,1,'0','0',0,0),
	(14163,'Vesper Earring','','rear,lear','true','none',NULL,150,'s84',0,-1,0,0,94,37,11394000,547,'true','vesper_earring_i00',1,1,1,'0','0',0,0),
	(14164,'Vesper Necklace','','neck','true','none',NULL,150,'s84',0,-1,0,0,125,50,15192000,729,'true','vesper_necklace_i00',1,1,1,'0','0',0,0),
	(14165,'Vesper Ring','','rfinger,lfinger','true','none',NULL,150,'s84',0,-1,0,0,62,25,7596000,365,'true','vesper_ring_i00',1,1,1,'0','0',0,0),
	(14520,'Vesper Breastplate {PvP}','','chest','false','heavy',NULL,7520,'s84',0,-1,0,250,0,0,46668000,2240,'true','armor_t94_u_i00',0,1,0,'3659;3662','1;1',0,0),
	(14521,'Vesper Leather Breastplate {PvP}','','chest','false','light',NULL,4140,'s84',0,-1,0,187,0,0,35000000,1680,'true','armor_t95_u_i00',0,1,0,'3663;3659','1;1',0,0),
	(14522,'Vesper Tunic {PvP}','','chest','false','magic',NULL,1750,'s84',0,-1,0,125,0,637,35000000,1680,'true','armor_t96_u_i00',0,1,0,'3659;3660','1;1',0,0),
	(14523,'Vesper Noble Breastplate {PvP}','','chest','false','heavy',NULL,7520,'s84',0,-1,0,250,0,0,55840000,2680,'true','armor_t94_u_i01',0,1,0,'3659;3662','1;1',0,0),
	(14524,'Vesper Noble Leather Breastplate {PvP}','','chest','false','light',NULL,4140,'s84',0,-1,0,187,0,0,41880000,2010,'true','armor_t95_u_i01',0,1,0,'3659','1',0,0),
	(14525,'Vesper Noble Tunic {PvP}','','chest','false','magic',NULL,1750,'s84',0,-1,0,125,0,637,41880000,2010,'true','armor_t96_u_i01',0,1,0,'3659;3660','1;1',0,0),
	(14582,'Apella Combat Helmet','','head','false','none',NULL,570,'a',0,-1,0,73,0,0,0,0,'true','armor_helmet_i00',0,1,0,'0','0',0,0),
	(14583,'Apella Combat Armor','','fullarmor','false','heavy',NULL,9780,'a',0,-1,0,293,0,0,0,0,'true','armor_t1004_ul_i00',0,1,0,'0','0',0,0),
	(14584,'Apella Combat Gauntlet','Heavy Armor Use','gloves','false','none',NULL,580,'a',0,-1,0,49,0,0,0,0,'true','armor_t1004_g_i00',0,1,0,'0','0',0,0),
	(14585,'Apella Combat Boots','Heavy Armor Use','feet','false','none',NULL,1130,'a',0,-1,0,49,0,0,0,0,'true','armor_t1004_b_i00',0,1,0,'0','0',0,0),
	(14586,'Apella Combat Clothes','','fullarmor','false','light',NULL,5400,'a',0,-1,0,220,0,0,0,0,'true','armor_t1005_ul_i00',0,1,0,'0','0',0,0),
	(14587,'Apella Combat Leather Gloves','Tans Armor Use','gloves','false','none',NULL,580,'a',0,-1,0,49,0,0,0,0,'true','armor_t1005_g_i00',0,1,0,'0','0',0,0),
	(14588,'Apella Combat Shoes','Tans Armor Use','feet','false','none',NULL,1130,'a',0,-1,0,49,0,0,0,0,'true','armor_t1005_b_i00',0,1,0,'0','0',0,0),
	(14589,'Apella Combat Overcoat','','fullarmor','false','magic',NULL,2450,'a',0,-1,0,147,0,718,0,0,'true','armor_t1006_ul_i00',0,1,0,'0','0',0,0),
	(14590,'Apella Combat Silk Gloves','Robe Use','gloves','false','none',NULL,580,'a',0,-1,0,49,0,0,0,0,'true','armor_t1006_g_i00',0,1,0,'0','0',0,0),
	(14591,'Apella Combat Sandals','Robe Use','feet','false','none',NULL,1130,'a',0,-1,0,49,0,0,0,0,'true','armor_t1006_b_i00',0,1,0,'0','0',0,0),
	(14592,'Gludio Earth Protection Ring','','rfinger,lfinger','true','none',NULL,150,'a',0,-1,0,0,42,17,0,80,'true','accessary_inferno_ring_i00',0,1,0,'8379','1',0,0),
	(14593,'Dion Water Protection Ring','','rfinger,lfinger','true','none',NULL,150,'a',0,-1,0,0,42,17,0,80,'true','accessary_inferno_ring_i00',0,1,0,'8380','1',0,0),
	(14594,'Giran Fire Protection Ring','','rfinger,lfinger','true','none',NULL,150,'a',0,-1,0,0,42,17,0,80,'true','accessary_inferno_ring_i00',0,1,0,'8381','1',0,0),
	(14595,'Oren Earth Protection Ring','','rfinger,lfinger','true','none',NULL,150,'a',0,-1,0,0,42,17,0,80,'true','accessary_inferno_ring_i00',0,1,0,'8382','1',0,0),
	(14596,'Aden Divinity Protection Ring','','rfinger,lfinger','true','none',NULL,150,'a',0,-1,0,0,42,17,0,80,'true','accessary_inferno_ring_i00',0,1,0,'8383','1',0,0),
	(14597,'Innadril Divinity Protection Ring','','rfinger,lfinger','true','none',NULL,150,'a',0,-1,0,0,42,17,0,80,'true','accessary_inferno_ring_i00',0,1,0,'8384','1',0,0),
	(14598,'Goddard Dark Protection Ring','','rfinger,lfinger','true','none',NULL,150,'a',0,-1,0,0,42,17,0,80,'true','accessary_inferno_ring_i00',0,1,0,'8385','1',0,0),
	(14599,'Rune Wind Protection Ring','','rfinger,lfinger','true','none',NULL,150,'a',0,-1,0,0,42,17,0,80,'true','accessary_inferno_ring_i00',0,1,0,'8386','1',0,0),
	(14600,'Schuttgart Dark Protection Ring','','rfinger,lfinger','true','none',NULL,150,'a',0,-1,0,0,42,17,0,80,'true','accessary_inferno_ring_i00',0,1,0,'8387','1',0,0),
	(14601,'Ancient Cloak - Kamael exclusive','Kamael Use','back','false','none',NULL,220,'s80',0,-1,0,20,0,0,0,0,'true','vesper_cloack_i00',0,1,0,'0','0',0,0),
	(14602,'Ancient Cloak','','back','false','none',NULL,220,'s80',0,-1,0,20,0,0,0,0,'true','vesper_cloack_i00',0,1,0,'0','0',0,0),
	(14604,'Red Talisman - Territory Guardian','','talisman','false','none',NULL,150,'none',0,66,0,0,0,0,0,0,'true','etc_talisman_i00',0,1,0,'8308','1',0,0),
	(14605,'Red Talisman - Territory Guard','','talisman','false','none',NULL,150,'none',0,66,0,0,0,0,0,0,'true','etc_talisman_i00',0,1,0,'8309','1',0,0),
	(14608,'Ancient Cloak - Light Armor exclusive','','back','false','none',NULL,220,'s80',0,-1,0,20,0,0,0,0,'true','vesper_cloack_i00',0,1,0,'0','0',0,0),
	(14609,'Ancient Cloak','','back','false','none',NULL,220,'s80',0,-1,0,20,0,0,0,0,'true','vesper_cloack_i00',0,1,0,'0','0',0,0),
	(14610,'Ancient Cloak - Robe exclusive','','back','false','none',NULL,220,'s80',0,-1,0,20,0,0,0,0,'true','vesper_cloack_i00',0,1,0,'0','0',0,0),
	(14611,'Rudolph\'s Nose','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','Accessory_nose_of_rudolph_mask_i00',0,1,0,'0','0',0,0),
	(14613,'Rock-Paper-Scissors Santa Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_santas_cap_i00',0,1,0,'0','0',0,0),
	(14617,'Agathion Seal Bracelet - Rudolph','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','etc_rbracelet_aga_agit_i00',0,1,0,'3425;5537','1;1',0,0),
	(14664,'Gludio Protection Earring','','rear,lear','true','none',NULL,150,'a',0,-1,0,0,63,25,0,120,'true','accessary_inferno_earing_i00',0,1,0,'8313','1',0,0),
	(14665,'Dion Protection Earring','','rear,lear','true','none',NULL,150,'a',0,-1,0,0,63,25,0,120,'true','accessary_inferno_earing_i00',0,1,0,'8313','2',0,0),
	(14666,'Giran Protection Earring','','rear,lear','true','none',NULL,150,'a',0,-1,0,0,63,25,0,120,'true','accessary_inferno_earing_i00',0,1,0,'8313','3',0,0),
	(14667,'Oren Protection Earring','','rear,lear','true','none',NULL,150,'a',0,-1,0,0,63,25,0,120,'true','accessary_inferno_earing_i00',0,1,0,'8313','4',0,0),
	(14668,'Aden Protection Earring','','rear,lear','true','none',NULL,150,'a',0,-1,0,0,63,25,0,120,'true','accessary_inferno_earing_i00',0,1,0,'8313','5',0,0),
	(14669,'Innadril Protection Earring','','rear,lear','true','none',NULL,150,'a',0,-1,0,0,63,25,0,120,'true','accessary_inferno_earing_i00',0,1,0,'8313','6',0,0),
	(14670,'Goddard Protection Earring','','rear,lear','true','none',NULL,150,'a',0,-1,0,0,63,25,0,120,'true','accessary_inferno_earing_i00',0,1,0,'8313','7',0,0),
	(14671,'Rune Protection Earring','','rear,lear','true','none',NULL,150,'a',0,-1,0,0,63,25,0,120,'true','accessary_inferno_earing_i00',0,1,0,'8313','8',0,0),
	(14672,'Schuttgart Protection Earring','','rear,lear','true','none',NULL,150,'a',0,-1,0,0,63,25,0,120,'true','accessary_inferno_earing_i00',0,1,0,'8313','9',0,0),
	(14675,'Agathion Seal Bracelet - Saerom','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','pi_high_agathion_bracelet_i00',0,1,0,'8314;6124','1;1',0,0),
	(14712,'Cow Hair Accessory','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','Accessory2_cow_of_cap_i00',1,1,1,'0','0',0,0),
	(14746,'For Events - Refined Chick Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_chicken_cap2_i00',0,1,0,'0','0',0,0),
	(14747,'For Events - Refined Black Feather Mask','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_black_feather_mask2_i00',0,1,0,'0','0',0,0),
	(14748,'For Events - Refined Carnival Circlet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_carnival_circlet2_i00',0,1,0,'0','0',0,0),
	(14749,'Afro Perm Wig','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_pig_cap_i00',1,1,1,'0','0',0,0),
	(14750,'Bamboo Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_pig_cap_i00',1,1,1,'0','0',0,0),
	(14751,'Smart Glasses','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,2000000,0,'true','accessory_pig_cap_i00',1,1,1,'0','0',0,0),
	(14752,'For Events - Refined Medieval Style Party Mask','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_middle_age_party_mask2_i00',0,1,0,'0','0',0,0),
	(14753,'Shadow Item - Refined Chick Hat','Escape','dhair','false','none',NULL,10,'none',0,600,0,0,0,0,0,0,'true','accessory_chicken_cap2_i00',0,1,0,'3264','1',0,0),
	(14754,'Shadow Item - Refined Chick Hat','Big Head','dhair','false','none',NULL,10,'none',0,600,0,0,0,0,0,0,'true','accessory_chicken_cap2_i00',0,1,0,'3265','1',0,0),
	(14755,'Shadow Item - Refined Chick Hat','Firework','dhair','false','none',NULL,10,'none',0,600,0,0,0,0,0,0,'true','accessory_chicken_cap2_i00',0,1,0,'3266','1',0,0),
	(14756,'Shadow Item - Refined Black Feather Mask','Escape','dhair','false','none',NULL,10,'none',0,600,0,0,0,0,0,0,'true','accessory_black_feather_mask2_i00',0,1,0,'3264','1',0,0),
	(14757,'Shadow Item - Refined Black Feather Mask','Big Head','dhair','false','none',NULL,10,'none',0,600,0,0,0,0,0,0,'true','accessory_black_feather_mask2_i00',0,1,0,'3265','1',0,0),
	(14758,'Shadow Item - Refined Black Feather Mask','Firework','dhair','false','none',NULL,10,'none',0,600,0,0,0,0,0,0,'true','accessory_black_feather_mask2_i00',0,1,0,'3266','1',0,0),
	(14759,'Shadow Item - Refined Carnival Circlet','Escape','dhair','false','none',NULL,10,'none',0,600,0,0,0,0,0,0,'true','accessory_carnival_circlet2_i00',0,1,0,'3264','1',0,0),
	(14760,'Shadow Item - Refined Carnival Circlet','Big Head','dhair','false','none',NULL,10,'none',0,600,0,0,0,0,0,0,'true','accessory_carnival_circlet2_i00',0,1,0,'3265','1',0,0),
	(14761,'Shadow Item - Refined Carnival Circlet','Firework','dhair','false','none',NULL,10,'none',0,600,0,0,0,0,0,0,'true','accessory_carnival_circlet2_i00',0,1,0,'3266','1',0,0),
	(14762,'Shadow Item - Refined Medieval Style Party Mask','Escape','dhair','false','none',NULL,10,'none',0,600,0,0,0,0,0,0,'true','accessory_middle_age_party_mask2_i00',0,1,0,'3264','1',0,0),
	(14763,'Shadow Item - Refined Medieval Style Party Mask','Big Head','dhair','false','none',NULL,10,'none',0,600,0,0,0,0,0,0,'true','accessory_middle_age_party_mask2_i00',0,1,0,'3265','1',0,0),
	(14764,'Shadow Item - Refined Medieval Style Party Mask','Firework','dhair','false','none',NULL,10,'none',0,600,0,0,0,0,0,0,'true','accessory_middle_age_party_mask2_i00',0,1,0,'3266','1',0,0),
	(14771,'Kat the Cat Hat','14 day limited period','dhair','false','none',NULL,0,'none',0,20160,1,0,0,0,0,0,'true','accessory_cat_the_cat_cap_i00',0,1,0,'0','0',0,0),
	(14772,'Coronet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_flower_cap_i00',0,1,0,'0','0',0,0),
	(14773,'Suit','14 day limited period','formalwear','false','magic',NULL,0,'none',0,20160,1,0,0,0,0,0,'true','armor_t2000_ul_i00',0,1,0,'0','0',0,0),
	(14775,'Agathion Seal Bracelet - Love','14 day limited period','lbracelet','false','none',NULL,0,'none',0,20160,1,0,0,0,0,0,'true','etc_rbracelet_aga_agit_i00',0,1,0,'8245','1',0,0),
	(14776,'Agathion Seal Bracelet - Juju','14 day limited period','lbracelet','false','none',NULL,0,'none',0,20160,1,0,0,0,0,0,'true','high_agathion_bracelet_i01',0,1,0,'8327;6136','1;1',0,0),
	(14796,'Baguette\'s Sigil','','lhand','false','sigil',NULL,930,'none',-8,-1,0,0,0,0,0,0,'true','dynasty_sigil_i00',0,1,0,'0','0',0,0),
	(14798,'Afro Perm Wig - Black','','dhair','false','none',NULL,0,'none',0,-1,0,0,0,0,0,0,'true','accessory_captain_cap_i00',0,1,0,'0','0',0,0),
	(14799,'Afro Perm Wig - Gold','','dhair','false','none',NULL,0,'none',0,-1,0,0,0,0,0,0,'true','accessory_captain_cap_i00',0,1,0,'0','0',0,0),
	(14800,'Afro Perm Wig - Pink','','dhair','false','none',NULL,0,'none',0,-1,0,0,0,0,0,0,'true','accessory_captain_cap_i00',0,1,0,'0','0',0,0),
	(20006,'Agathion Seal Bracelet - Majo','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','BranchSys.br_bracelet_aga_mazu_i00',0,1,0,'21000;23000','1;1',0,0),
	(20007,'Agathion Seal Bracelet - Gold Majo','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','BranchSys.br_bracelet_aga_mazu_i00',0,1,0,'21001;23001','1;1',0,0),
	(20008,'Agathion Seal Bracelet - Black Majo','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','BranchSys.br_bracelet_aga_mazu_i00',0,1,0,'21002;23002','1;1',0,0),
	(20009,'Agathion Seal Bracelet - Majo','Big Head 30 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,43200,1,0,0,0,0,0,'false','BranchSys.br_bracelet_aga_mazu_i00',0,1,0,'21000;23000;23004','1;1;1',0,0),
	(20010,'Agathion Seal Bracelet - Gold Majo','Resurrection 30 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,43200,1,0,0,0,0,0,'false','BranchSys.br_bracelet_aga_mazu_i00',0,1,0,'21001;23001;23005','1;1;1',0,0),
	(20011,'Agathion Seal Bracelet - Black Majo','Escape 30 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,43200,1,0,0,0,0,0,'false','BranchSys.br_bracelet_aga_mazu_i00',0,1,0,'21002;23002;23006','1;1;1',0,0),
	(20012,'Agathion Seal Bracelet - Plaipitak','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','BranchSys.br_bracelet_aga_pitak_i00',0,1,0,'21003;23003','1;1',0,0),
	(20013,'Agathion Seal Bracelet - Plaipitak','Big Head 30 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,43200,1,0,0,0,0,0,'false','BranchSys.br_bracelet_aga_pitak_i00',0,1,0,'21003;23003;23007','1;1;1',0,0),
	(20014,'Agathion Seal Bracelet - Plaipitak','Resurrection 30 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,43200,1,0,0,0,0,0,'false','BranchSys.br_bracelet_aga_pitak_i00',0,1,0,'21003;23003;23009','1;1;1',0,0),
	(20015,'Agathion Seal Bracelet - Plaipitak','Escape 30 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,43200,1,0,0,0,0,0,'false','BranchSys.br_bracelet_aga_pitak_i00',0,1,0,'21003;23003;23008','1;1;1',0,0),
	(20016,'Horn-Rimmed Glasses','Agility','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_Eye_Glasses_i00',0,1,0,'0','0',0,0),
	(20017,'Afro Hair','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_Afro_hair_i00',1,1,1,'0','0',0,0),
	(20018,'Afro Hair','Big Head, Firework','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_Afro_hair_i00',1,1,1,'3265;3266','1;1',0,0),
	(20019,'Afro Hair','Wind Walk','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_Afro_hair_i00',1,1,1,'21063','1',0,0),
	(20020,'Uniform Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_Uniform_Hat_i00',1,1,1,'0','0',0,0),
	(20021,'Assassin\'s Bamboo Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_Bamboo_Hat_i00',1,1,1,'0','0',0,0),
	(20022,'Ruthless Tribe Mask','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_mask_i00',1,1,1,'0','0',0,0),
	(20023,'Ribbon Hairband','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_Ribbon_i00',1,1,1,'0','0',0,0),
	(20024,'Visor','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_Eye_Visor_i00',1,1,1,'0','0',0,0),
	(20029,'Light Purple-Maned Horse Mounting Bracelet','','lbracelet','false','none',NULL,30,'none',0,-1,0,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8247','1',0,0),
	(20030,'Light Purple-Maned Horse Mounting Bracelet','30 Day Expiration Period','lbracelet','false','none',NULL,30,'none',0,43200,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8247','1',0,0),
	(20031,'Kat the Cat Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_cat_the_cat_cap_i00',1,1,1,'0','0',0,0),
	(20032,'Skull Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_skeleton_cap_i00',1,1,1,'0','0',0,0),
	(20063,'Agathion Seal Bracelet - Baby Panda','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','BranchSys.br_baby_panda_i00',0,1,0,'21008;23010','1;1',0,0),
	(20064,'Agathion Seal Bracelet - Bamboo Panda','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','BranchSys.br_kunfu_panda_i00',0,1,0,'21009;23011','1;1',0,0),
	(20065,'Agathion Seal Bracelet - Sexy Panda','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','BranchSys.br_sexy_panda_i00',0,1,0,'21010;23012','1;1',0,0),
	(20066,'Agathion Seal Bracelet - Baby Panda','Big Head-15 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,21600,1,0,0,0,0,0,'false','BranchSys.br_baby_panda_i00',0,1,0,'21008;23010;23013','1;1;1',0,0),
	(20067,'Agathion Seal Bracelet - Bamboo Panda','Resurrection-15 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,21600,1,0,0,0,0,0,'false','BranchSys.br_kunfu_panda_i00',0,1,0,'21009;23011;23014','1;1;1',0,0),
	(20068,'Agathion Seal Bracelet - Sexy Panda','Escape-15 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,21600,1,0,0,0,0,0,'false','BranchSys.br_sexy_panda_i00',0,1,0,'21010;23012;23015','1;1;1',0,0),
	(20083,'Afro Hair','Energy - 3 Hour Expiration Period','dhair','false','none',NULL,10,'none',0,180,1,0,0,0,0,0,'false','BranchSys.br_Afro_hair_i00',0,1,0,'21011','1',0,0),
	(20084,'Afro Hair','Energy - 3 Day Expiration Period','dhair','false','none',NULL,10,'none',0,4320,1,0,0,0,0,0,'false','BranchSys.br_Afro_hair_i00',0,1,0,'21011','1',0,0),
	(20085,'Afro Hair','Energy - 30 Day Expiration Period','dhair','false','none',NULL,10,'none',0,43200,1,0,0,0,0,0,'false','BranchSys.br_Afro_hair_i00',0,1,0,'21011','1',0,0),
	(20086,'Horn Rimmed Glasses','Energy - 3 Hour Expiration Period','face','false','none',NULL,10,'none',0,180,1,0,0,0,0,0,'false','BranchSys.br_Eye_Glasses_i00',0,1,0,'21011','1',0,0),
	(20087,'Horn Rimmed Glasses','Energy - 3 Day Expiration Period','face','false','none',NULL,10,'none',0,4320,1,0,0,0,0,0,'false','BranchSys.br_Eye_Glasses_i00',0,1,0,'21011','1',0,0),
	(20088,'Horn Rimmed Glasses','Energy - 30 Day Expiration Period','face','false','none',NULL,10,'none',0,43200,1,0,0,0,0,0,'false','BranchSys.br_Eye_Glasses_i00',0,1,0,'21011','1',0,0),
	(20089,'Assassin\'s Bamboo Hat','Energy - 3 Hour Expiration Period','dhair','false','none',NULL,10,'none',0,180,1,0,0,0,0,0,'false','BranchSys.br_Bamboo_Hat_i00',0,1,0,'21011','1',0,0),
	(20090,'Assassin\'s Bamboo Hat','Energy - 3 Day Expiration Period','dhair','false','none',NULL,10,'none',0,4320,1,0,0,0,0,0,'false','BranchSys.br_Bamboo_Hat_i00',0,1,0,'21011','1',0,0),
	(20091,'Assassin\'s Bamboo Hat','Energy - 30 Day Expiration Period','dhair','false','none',NULL,10,'none',0,43200,1,0,0,0,0,0,'false','BranchSys.br_Bamboo_Hat_i00',0,1,0,'21011','1',0,0),
	(20094,'Agathion Seal Bracelet: Rudolph','Energy - 30 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,43200,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'3425;23016','1;1',0,0),
	(20095,'Santa Horn Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessory_santas_antler_i00',0,1,0,'0','0',0,0),
	(20098,'Formal Dress - Event','1 hour Shadow time','formalwear','false','none',NULL,1000,'none',0,60,0,0,0,0,0,0,'false','armor_t2000_ul_i00',0,1,0,'0','0',0,0),
	(20099,'Formal Dress - Event','7 Day Expiration Period','formalwear','false','none',NULL,1000,'none',0,10080,1,0,0,0,0,0,'false','armor_t2000_ul_i00',0,1,0,'0','0',0,0),
	(20100,'Saving Santa Hat','24 Hour Expiration Period','dhair','false','none',NULL,10,'none',0,1440,1,0,0,0,0,0,'false','BranchSys.br_xmas_gawibawibo_cap_i00',0,1,0,'0','0',0,0),
	(20200,'Agathion of Love','3 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,4320,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8245;23024;21086','1;1;1',0,0),
	(20201,'Agathion of Love','7 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8245;23024;21086','1;1;1',0,0),
	(20202,'Agathion of Love','15 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,21600,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8245;23024;21086','1;1;1',0,0),
	(20203,'Agathion of Love','30 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,43200,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8245;23024;21086','1;1;1',0,0),
	(20204,'Queen Ant\'s Ring (Event)','3 Day Expiration Period','rfinger,lfinger','false','none',NULL,150,'b',0,4320,1,0,48,21,0,0,'false','accessory_ring_of_queen_ant_i00',0,1,0,'3562','1',0,0),
	(20205,'Queen Ant\'s Ring (Event)','7 Day Expiration Period','rfinger,lfinger','false','none',NULL,150,'b',0,10080,1,0,48,21,0,0,'false','accessory_ring_of_queen_ant_i00',0,1,0,'3562','1',0,0),
	(20206,'Queen Ant\'s Ring (Event)','15 Day Expiration Period','rfinger,lfinger','false','none',NULL,150,'b',0,21600,1,0,48,21,0,0,'false','accessory_ring_of_queen_ant_i00',0,1,0,'3562','1',0,0),
	(20207,'Zaken\'s Earring (Event)','3 Day Expiration Period','rear,lear','false','none',NULL,150,'s',0,4320,1,0,71,31,0,0,'false','accessory_earring_of_zaken_i00',0,1,0,'3559','1',0,0),
	(20208,'Zaken\'s Earring (Event)','7 Day Expiration Period','rear,lear','false','none',NULL,150,'s',0,10080,1,0,71,31,0,0,'false','accessory_earring_of_zaken_i00',0,1,0,'3559','1',0,0),
	(20209,'Zaken\'s Earring (Event)','15 Day Expiration Period','rear,lear','false','none',NULL,150,'s',0,21600,1,0,71,31,0,0,'false','accessory_earring_of_zaken_i00',0,1,0,'3559','1',0,0),
	(20212,'Agathion Seal Bracelet - Charming Cupid','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','BranchSys.br_aga_cupid_i00',0,1,0,'21031;23025','1;1',0,0),
	(20213,'Agathion Seal Bracelet - Naughty Cupid','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','BranchSys.br_aga_cupid_i00',0,1,0,'21032;23026','1;1',0,0),
	(20221,'Agathion Seal Bracelet - White Maneki Neko','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','BranchSys.br_aga_maneki_i00',0,1,0,'21033;23027;23046','1;1;1',0,0),
	(20222,'Agathion Seal Bracelet - Black Maneki Neko','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','BranchSys.br_aga_maneki_i00',0,1,0,'21034;23028;23047','1;1;1',0,0),
	(20223,'Agathion Seal Bracelet - Brown Maneki Neko','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','BranchSys.br_aga_maneki_i00',0,1,0,'21035;23029;23048','1;1;1',0,0),
	(20224,'Agathion Seal Bracelet - White Maneki Neko','Resurrection - 7 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_aga_maneki_i00',0,1,0,'21033;23027;23046;23030','1;1;1;1',0,0),
	(20225,'Agathion Seal Bracelet - Black Maneki Neko','Escape - 7 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_aga_maneki_i00',0,1,0,'21034;23028;23047;23031','1;1;1;1',0,0),
	(20226,'Agathion Seal Bracelet - Brown Maneki Neko','Vitality - 7-day limited time','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_aga_maneki_i00',0,1,0,'21035;23029;23048;23032','1;1;1;1',0,0),
	(20230,'Agathion Seal Bracelet - One-Eyed Bat Drove','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','BranchSys.br_aga_bat_i00',0,1,0,'21036;23033','1;1',0,0),
	(20231,'Agathion Seal Bracelet - One-Eyed Bat Drove','Resist Unholy - 7 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_aga_bat_i00',0,1,0,'21036;23033;23034','1;1;1',0,0),
	(20232,'Agathion Seal Bracelet - One-Eyed Bat Drove','Vitality - 7 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_aga_bat_i00',0,1,0,'21036;23033;23035','1;1;1',0,0),
	(20236,'Agathion Seal Bracelet - Pegasus','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','BranchSys.br_aga_pegasus_i00',0,1,0,'21037;23036','1;1',0,0),
	(20237,'Agathion Seal Bracelet - Pegasus','Wind Walk - 7 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_aga_pegasus_i00',0,1,0,'21037;23036;23037','1;1;1',0,0),
	(20238,'Agathion Seal Bracelet - Pegasus','Escape - 7 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_aga_pegasus_i00',0,1,0,'21037;23036;23038','1;1;1',0,0),
	(20245,'Agathion Seal Bracelet - Yellow-Robed Tojigong','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','BranchSys.br_aga_tozi_i00',0,1,0,'21038;23039','1;1',0,0),
	(20246,'Agathion Seal Bracelet - Blue-Robed Tojigong','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','BranchSys.br_aga_tozi_i00',0,1,0,'21039;23040','1;1',0,0),
	(20247,'Agathion Seal Bracelet - Green-Robed Tojigong','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','BranchSys.br_aga_tozi_i00',0,1,0,'21040;23041','1;1',0,0),
	(20248,'Agathion Seal Bracelet - Yellow-Robed Tojigong','Greater Heal - 7 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_aga_tozi_i00',0,1,0,'21038;23039;23042','1;1;1',0,0),
	(20249,'Agathion Seal Bracelet - Blue-Robed Tojigong','Reflect Damage - 7 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_aga_tozi_i00',0,1,0,'21039;23040;23043','1;1;1',0,0),
	(20250,'Agathion Seal Bracelet - Green-Robed Tojigong','Mana Regeneration - 7 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_aga_tozi_i00',0,1,0,'21040;23041;23044','1;1;1',0,0),
	(20252,'Agathion Seal Bracelet - Bugbear','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','BranchSys.br_aga_bugbear_i00',0,1,0,'21041;23045','1;1',0,0),
	(20253,'Agathion of Love (Event)','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8245','1',0,0),
	(20275,'Gold Afro','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','BranchSys.br_Afro_hair_i00',1,1,1,'0','0',0,0),
	(20276,'Pink Afro','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','BranchSys.br_Afro_hair_i00',1,1,1,'0','0',0,0),
	(20297,'Agathion Seal Bracelet - Red Sumo Wrestler','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_sumo_i00',0,1,0,'21043;23049','1;1',0,0),
	(20298,'Agathion Seal Bracelet - Red Sumo Wrestler','Death Whisper - 7 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_aga_sumo_i00',0,1,0,'21043;23049;23057','1;1;1',0,0),
	(20299,'Agathion Seal Bracelet - Blue Sumo Wrestler','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_sumo_i00',0,1,0,'21044;23050','1;1',0,0),
	(20300,'Agathion Seal Bracelet - Blue Sumo Wrestler','Wild Magic - 7 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_aga_sumo_i00',0,1,0,'21044;23050;23058','1;1;1',0,0),
	(20301,'Agathion Seal Bracelet - Great Sumo Match','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_sumo_match_i00',0,1,0,'21045;23051','1;1',0,0),
	(20302,'Agathion Seal Bracelet - Great Sumo Match','Big Head / Firework - 7 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_aga_sumo_match_i00',0,1,0,'21045;23051;23058;23059','1;1;1;1',0,0),
	(20303,'Agathion Seal Bracelet - Button-Eyed Bear Doll','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_toybear_i00',0,1,0,'21046;23052','1;1',0,0),
	(20304,'Agathion Seal Bracelet - Button-Eyed Bear Doll','Escape - 7 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_aga_toybear_i00',0,1,0,'21046;23052;23061','1;1;1',0,0),
	(20305,'Agathion Seal Bracelet - Button-Eyed Bear Doll','Resurrection - 7 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_aga_toybear_i00',0,1,0,'21046;23052;23062','1;1;1',0,0),
	(20306,'Agathion Seal Bracelet - Button-Eyed Bear Doll','Energy - 7 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_aga_toybear_i00',0,1,0,'21046;23052;23063','1;1;1',0,0),
	(20307,'Agathion Seal Bracelet - God of Fortune','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_wealth_god_i00',0,1,0,'21047;23053','1;1',0,0),
	(20308,'Agathion Seal Bracelet - God of Fortune','Energy - 7 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_aga_wealth_god_i00',0,1,0,'21047;23053;23064','1;1;1',0,0),
	(20309,'Agathion Seal Bracelet - Dryad','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_dryad_i00',0,1,0,'21048;23054','1;1',0,0),
	(20310,'Agathion Seal Bracelet - Wonboso','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_cashcow_i00',0,1,0,'21049;23055','1;1',0,0),
	(20311,'Agathion Seal Bracelet - Wonboso','Wind Walk - 7 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_aga_cashcow_i00',0,1,0,'21049;23055;23065','1;1;1',0,0),
	(20312,'Agathion Seal Bracelet - Daewoonso','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_luckycow_i00',0,1,0,'21050;23056','1;1',0,0),
	(20313,'Agathion Seal Bracelet - Daewoonso','New Year\'s Gift - 7 Day Expiration Period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_aga_luckycow_i00',0,1,0,'21050;23056;23066','1;1;1',0,0),
	(20321,'Goggle','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_goggles_i00',0,1,0,'0','0',0,0),
	(20322,'Napoleon Hat','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_napoleonic_cap_i00',0,1,0,'0','0',0,0),
	(20323,'Horn Hairband','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_horn_hairband_i00',0,1,0,'0','0',0,0),
	(20324,'Black Gem Mask','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_black_gem_mask_i00',0,1,0,'0','0',0,0),
	(20325,'Plastic Hair','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_plastic_hair_f_i00',0,1,0,'0','0',0,0),
	(20396,'Steam Beatle Mounting Bracelet','','lbracelet','false','none',NULL,30,'none',0,-1,0,0,0,0,0,0,'true','etc_rbracelet_aga_agit_i00',0,1,0,'8261','1',0,0),
	(20399,'Laborer Hat','Blessed Body - 7 day limited period','face','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'true','BranchSys.br_people_cap_i00',0,1,0,'21052','1',0,0),
	(20400,'Laborer Hat','Blessed Soul - 7 day limited period','face','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'true','BranchSys.br_people_cap_i00',0,1,0,'21053','1',0,0),
	(20401,'Laborer Hat','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_people_cap_i00',0,1,0,'0','0',0,0),
	(20405,'Agathion Seal Bracelet - Majo','Big Head - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_bracelet_aga_mazu_i00',0,1,0,'21000;23004','1;1',0,0),
	(20406,'Agathion Seal Bracelet - Gold Crown Majo','Resurrection - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_bracelet_aga_mazu_i00',0,1,0,'21001;23005','1;1',0,0),
	(20407,'Agathion Seal Bracelet - Black Crown Majo','Escape - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_bracelet_aga_mazu_i00',0,1,0,'21002;23006','1;1',0,0),
	(20408,'Agathion Seal Bracelet - Plaipitak','Big Head - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_bracelet_aga_pitak_i00',0,1,0,'21003;23007','1;1',0,0),
	(20409,'Agathion Seal Bracelet - Plaipitak','Resurrection - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_bracelet_aga_pitak_i00',0,1,0,'21003;23009','1;1',0,0),
	(20410,'Agathion Seal Bracelet - Plaipitak','Escape - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_bracelet_aga_pitak_i00',0,1,0,'21003;23008','1;1',0,0),
	(20411,'Agathion Seal Bracelet - Baby Panda','Big Head - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_baby_panda_i00',0,1,0,'21008;23013','1;1',0,0),
	(20412,'Agathion Seal Bracelet - Bamboo Panda','Resurrection - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_kunfu_panda_i00',0,1,0,'21009;23014','1;1',0,0),
	(20413,'Agathion Seal Bracelet - Sexy Panda','Escape - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_sexy_panda_i00',0,1,0,'21010;23015','1;1',0,0),
	(20414,'Horn Rimmed Glasses','Agility - 7 day limited period','face','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_Eye_Glasses_i00',0,1,0,'21056','3',0,0),
	(20415,'Afro Hair','Big Head, Firework - 7 day limited period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_Afro_hair_i00',0,1,0,'21007','1',0,0),
	(20416,'Afro Hair','Wind Walk - 7 day limited period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_Afro_hair_i00',0,1,0,'21063','1',0,0),
	(20417,'Uniform Hat','Blessed Resurrection - 7 day limited period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_Uniform_Hat_i00',0,1,0,'21095','1',0,0),
	(20418,'Assassin\'s Bamboo Hat','Wind Walk - 7 day limited period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_Bamboo_Hat_i00',0,1,0,'21063','1',0,0),
	(20419,'Ruthless Tribe Mask','Agility - 7 day limited period','face','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_mask_i00',0,1,0,'21056','3',0,0),
	(20420,'Ribbon Hairband','Reflect Damage - 7 day limited period','face','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_Ribbon_i00',0,1,0,'21057','1',0,0),
	(20421,'Visor','Mana Regeneration - 7 day limited period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_Eye_Visor_i00',0,1,0,'21058','1',0,0),
	(20422,'Kat the Cat Hat','Greater Heal - 7 day limited period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_cat_the_cat_cap_i00',0,1,0,'21075','1',0,0),
	(20423,'Skull Hat','Death Whisper - 7 day limited period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_skeleton_cap_i00',0,1,0,'21060','1',0,0),
	(20424,'Afro Hair - Gold','Agility - 7 day limited period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_Afro_hair_i00',0,1,0,'21056','3',0,0),
	(20425,'Afro Hair - Pink','Wild Magic - 7 day limited period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_Afro_hair_i00',0,1,0,'21062','1',0,0),
	(20426,'Goggles','Wind Walk - 7 day limited period','face','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_goggles_i00',0,1,0,'21063','1',0,0),
	(20427,'Napoleon Hat','Mana Regeneration - 7 day limited period','face','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_napoleonic_cap_i00',0,1,0,'21058','1',0,0),
	(20428,'Horn Hairband','Reflect Damage - 7 day limited period','face','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_horn_hairband_i00',0,1,0,'21057','1',0,0),
	(20429,'Black Gem Mask','Energy - 7 days limited time','face','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_black_gem_mask_i00',0,1,0,'21011','1',0,0),
	(20430,'Plastic Hair','Blessed Escape - 7 day limited period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_plastic_hair_f_i00',0,1,0,'21067','1',0,0),
	(20431,'Daisy Hairpin','Resist Unholy - 7 day limited period','hair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_daisy_hairpin_i00',0,1,0,'21068','1',0,0),
	(20432,'Forget-me-not Hairpin','Wind Walk - 7 day limited period','hair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_forget_me_not_hairpin_i00',0,1,0,'21063','1',0,0),
	(20433,'Outlaw\'s Eyepatch','Death Whisper - 7 day limited period','face','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_outlaw_eyepatch_i00',0,1,0,'21060','1',0,0),
	(20434,'Pirate\'s eyepatch','Agility - 7 day limited period','face','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_eye_bandage_i00',0,1,0,'21056','3',0,0),
	(20435,'Monocle','Wild Magic - 7 day limited period','face','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_glasses_i00',0,1,0,'21062','1',0,0),
	(20436,'Red Mask of Victory','Mana Regeneration - 7 day limited period','face','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_worldcup_mask_i00',0,1,0,'21058','1',0,0),
	(20437,'Red Horn of Victory','Reflect Damage - 7 day limited period','hair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_hair_cornu_i00',0,1,0,'21057','1',0,0),
	(20438,'Party Mask','Greater Heal - 7 day limited period','face','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','etc_party_mask_i00',0,1,0,'21075','1',0,0),
	(20439,'Red Party Mask','Resist Unholy - 7 day limited period','face','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','etc_party_mask_i01',0,1,0,'21068','1',0,0),
	(20440,'Cat Ear','Wind Walk - 7 day limited period','hair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_cat_ear_i00',0,1,0,'21063','1',0,0),
	(20441,'Noblewoman\'s hairpin','Death Whisper - 7 day limited period','hair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_hairpin_i00',0,1,0,'21060','1',0,0),
	(20442,'Raccoon Ear','Agility - 7 day limited period','hair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_racoon_ear_i00',0,1,0,'21056','3',0,0),
	(20443,'Rabbit Ear','Wild Magic - 7 day limited period','hair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_rabbit_ear_i00',0,1,0,'21062','1',0,0),
	(20444,'Little Angel Wings','Mana Regeneration - 7 day limited period','hair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_hair_ring_i00',0,1,0,'21058','1',0,0),
	(20445,'Fairy\'s Tentacle','Reflect Damage - 7 day limited period','hair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_hair_feeler_i00',0,1,0,'21057','1',0,0),
	(20446,'Dandy\'s Chapeau','Greater Heal - 7 day limited period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_archer_hat_i00',0,1,0,'21075','1',0,0),
	(20447,'Artisan\'s Goggles','Energy - 7 days limited time','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','accessory_dwarf_goggle_i00',0,1,0,'21011','1',0,0),
	(20448,'Light Purple Maned Horse Mounting Bracelet','7 day limited period','lbracelet','false','none',NULL,30,'none',0,10080,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8247','1',0,0),
	(20449,'Steam Beatle Mounting Bracelet','7 day limited period','lbracelet','false','none',NULL,30,'none',0,10080,1,0,0,0,0,0,'false','etc_rbracelet_aga_agit_i00',0,1,0,'8261','1',0,0),
	(20495,'Agathion Seal Bracelet - Pomona','','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_aga_pomona_i00',0,1,0,'21085;23067','1;1',0,0),
	(20496,'Agathion Seal Bracelet - Pomona','Mental Shield - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_aga_pomona_i00',0,1,0,'21085;23067;23068','1;1;4',0,0),
	(20499,'Feline Queen Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessory_queen_of_cat_cap_i00',0,1,0,'0','0',0,0),
	(20500,'Feline King Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessory_king_of_cat_cap_i00',0,1,0,'0','0',0,0),
	(20501,'Kai the Cat Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','accessory_chi_the_cat_cap_i00',0,1,0,'0','0',0,0),
	(20535,'Steam Sledge Mounting Bracelet','30 day limited period','lbracelet','false','none',NULL,150,'none',0,43200,1,0,0,0,0,0,'false','pi_high_agathion_bracelet_i00',0,1,0,'8261','1',0,0),
	(20536,'Tawny Maned Lion Mounting Bracelet','30 day limited period','lbracelet','false','none',NULL,150,'none',0,43200,1,0,0,0,0,0,'false','pi_high_agathion_bracelet_i00',0,1,0,'8262','1',0,0),
	(20537,'Afro Hair','Energy - 7 days limited time','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_Afro_hair_i00',0,1,0,'21011','1',0,0),
	(20538,'Horn Rimmed Glasses','Energy - 7 days limited time','face','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_Eye_Glasses_i00',0,1,0,'21011','1',0,0),
	(20539,'Assassin\'s Bamboo Hat','Energy - 7 days limited time','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_Bamboo_Hat_i00',0,1,0,'21011','1',0,0),
	(20567,'Eva\'s Circlet (event)','3 day limited time','dhair','false','none',NULL,10,'none',0,4320,1,0,0,0,0,0,'false','BranchSys.br_circlet_of_eva_i00',0,1,0,'0','0',0,0),
	(20568,'Eva\'s Circlet','7 day limited time','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_circlet_of_eva_i00',0,1,0,'0','0',0,0),
	(20569,'Eva\'s Circlet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','BranchSys.br_circlet_of_eva_i00',0,1,0,'0','0',0,0),
	(20591,'Agathion Seal Bracelet - Weaver','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'false','BranchSys.br_aga_womanweaver_i00',0,1,0,'21091;23076','1;1',0,0),
	(20592,'Agathion Seal Bracelet - Weaver','Power of the Golden Calf - 24 hours limited period','lbracelet','false','none',NULL,150,'none',0,1440,1,0,0,0,0,0,'false','BranchSys.br_aga_womanweaver_i00',0,1,0,'21091;23076;23077','1;1;1',0,0),
	(20593,'Agathion Seal Bracelet - Weaver','Power of the Golden Calf - 3 day limited period','lbracelet','false','none',NULL,150,'none',0,4320,1,0,0,0,0,0,'false','BranchSys.br_aga_womanweaver_i00',0,1,0,'21091;23076;23077','1;1;1',0,0),
	(20594,'Summon of Love Bracelet (event)','24 hours limited period','lbracelet','false','none',NULL,0,'none',0,1440,1,0,0,0,0,0,'false','BranchSys.br_ring_of_friendship_i00',0,1,0,'8245','1',0,0),
	(20601,'Anniversary Hat','Soul of Phoenix - 7 day limited period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_comfortspirit_hat_a_i00',0,1,0,'0','0',0,0),
	(20613,'Headphone','Town Theme','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','BranchSys.br_headphone_i00',0,1,0,'0','0',0,0),
	(20614,'Headphone','Hero Theme','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','BranchSys.br_headphone_i00',0,1,0,'0','0',0,0),
	(20615,'Headphone','Park Theme','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','BranchSys.br_headphone_i00',0,1,0,'0','0',0,0),
	(20616,'Headphone','Town Theme - 7 day limited period','face','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_headphone_i00',0,1,0,'0','0',0,0),
	(20617,'Headphone','Hero Theme - 7 day limited period','face','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_headphone_i00',0,1,0,'0','0',0,0),
	(20618,'Headphone','Park Theme - 7 day limited period','face','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_headphone_i00',0,1,0,'0','0',0,0),
	(20621,'Agathion Seal Bracelet - Female Weaver','Flute Sound - 24 hours limited time','lbracelet','false','none',NULL,150,'none',0,1440,1,0,0,0,0,0,'false','BranchSys.br_aga_womanweaver_i00',0,1,0,'21091;23076;23078','1;1;1',0,0),
	(20622,'Agathion Seal Bracelet - Female Weaver','Flute Sound - 3 day limited time','lbracelet','false','none',NULL,150,'none',0,4320,1,0,0,0,0,0,'false','BranchSys.br_aga_womanweaver_i00',0,1,0,'21091;23076;23078','1;1;1',0,0),
	(20626,'Anniversary Hat','Resurrection - 7 day limited period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_comfortspirit_hat_a_i00',0,1,0,'21095','1',0,0),
	(20628,'Summon of Love Bracelet','7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_ring_of_friendship_i00',0,1,0,'8245','1',0,0),
	(20633,'Watermelon Hat','Ability of a Cool Watermelon - 7 day limited period','dhair','false','none',NULL,10,'none',0,10080,1,0,0,0,0,0,'false','BranchSys.br_watermelon_cap_a_i00',0,1,0,'0','0',0,0),
	(20634,'Watermelon Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'false','BranchSys.br_watermelon_cap_a_i00',0,1,0,'0','0',0,0),
	(20642,'Standard Item - Mithril Gloves','','gloves','false','none',NULL,100,'d',0,-1,0,29,0,0,0,0,'false','armor_t46_g_i00',0,1,0,'0','0',0,0),
	(20643,'Standard Item - 	Plate Boots','','feet','false','none',NULL,100,'d',0,-1,0,29,0,0,0,0,'false','armor_t46_b_i00',0,1,0,'0','0',0,0),
	(20645,'Standard Item - Plate Helmet','','head','false','none',NULL,100,'d',0,-1,0,44,0,0,0,0,'false','armor_leather_helmet_i00',0,1,0,'0','0',0,0),
	(20646,'Standard Item - Plate Gaiters','','legs','false','heavy',NULL,100,'d',0,-1,0,70,0,0,0,0,'false','armor_t46_l_i00',0,1,0,'0','0',0,0),
	(20647,'Standard Item - Half Plate Armor','','chest','false','heavy',NULL,100,'d',0,-1,0,111,0,0,0,0,'false','armor_t46_u_i00',0,1,0,'0','0',0,0),
	(20648,'Standard Item - Salamander Skin Mail','','fullarmor','false','light',NULL,100,'d',0,-1,0,136,0,0,0,0,'false','armor_t45_ul_i00',0,1,0,'0','0',0,0),
	(20650,'Standard Item - Mithril Tunic','','chest','false','magic',NULL,100,'d',0,-1,0,52,0,169,0,0,'false','armor_t51_u_i00',0,1,0,'0','0',0,0),
	(20651,'Standard Item - Mithril Stockings','','legs','false','magic',NULL,100,'d',0,-1,0,32,0,105,0,0,'false','armor_t51_l_i00',0,1,0,'0','0',0,0),
	(20652,'Standard Item - Salamander Skin Boots','','feet','false','none',NULL,100,'d',0,-1,0,29,0,0,0,0,'false','armor_t45_b_i00',0,1,0,'0','0',0,0),
	(20653,'Standard Item - Ogre Power Gauntlet','','gloves','false','none',NULL,100,'d',0,-1,0,29,0,0,0,0,'false','armor_t45_g_i00',0,1,0,'0','0',0,0),
	(22154,'Shadow Weapon - Wolf Hat','Blessed Escape','dhair','false','none',NULL,10,'none',0,1440,0,0,0,0,0,0,'true','accessory_wolf_cap_i00',0,1,0,'0','0',0,0),
	(22155,'Shadow Weapon - Wolf Hat','Blessed Resurrection','dhair','false','none',NULL,10,'none',0,1440,0,0,0,0,0,0,'true','accessory_wolf_cap_i00',0,1,0,'0','0',0,0),
	(22156,'Daisy Hairpin','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_daisy_hairpin_i00',0,1,0,'0','0',0,0),
	(22157,'Forget-me-not Hairpin','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_forget_me_not_hairpin_i00',0,1,0,'0','0',0,0),
	(22158,'Outlaw\'s Eyepatch','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_outlaw_eyepatch_i00',0,1,0,'0','0',0,0),
	(22159,'Pirate\'s eyepatch','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_eye_bandage_i00',0,1,0,'0','0',0,0),
	(22160,'Monocle','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_glasses_i00',0,1,0,'0','0',0,0),
	(22161,'Red Mask of Victory','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_worldcup_mask_i00',0,1,0,'0','0',0,0),
	(22162,'Red Horn of Victory','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_hair_cornu_i00',0,1,0,'0','0',0,0),
	(22163,'Party Mask','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','etc_party_mask_i00',0,1,0,'0','0',0,0),
	(22164,'Red Party Mask','','face','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','etc_party_mask_i01',0,1,0,'0','0',0,0),
	(22165,'Cat Ear','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_cat_ear_i00',0,1,0,'0','0',0,0),
	(22166,'Noblewoman\'s hairpin','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_hairpin_i00',0,1,0,'0','0',0,0),
	(22167,'Raccoon Ear','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_racoon_ear_i00',0,1,0,'0','0',0,0),
	(22168,'Rabbit Ear','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_rabbit_ear_i00',0,1,0,'0','0',0,0),
	(22169,'Little Angel Wings','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_hair_ring_i00',0,1,0,'0','0',0,0),
	(22170,'Fairy\'s Tentacle','','hair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_hair_feeler_i00',0,1,0,'0','0',0,0),
	(22171,'Dandy\'s Chapeau','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_archer_hat_i00',0,1,0,'0','0',0,0),
	(22172,'Artisan\'s Goggles','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_dwarf_goggle_i00',0,1,0,'0','0',0,0),
	(14801,'Gludio Guard Earring','','rear,lear','true','none',NULL,150,'s80',0,-1,0,0,79,35,0,194,'true','accessory_earring_of_domi_protection_i00',0,1,0,'8348','1',0,0),
	(14802,'Dion Guard Earring','','rear,lear','true','none',NULL,150,'s80',0,-1,0,0,79,35,0,194,'true','accessory_earring_of_domi_protection_i00',0,1,0,'8349','1',0,0),
	(14803,'Giran Guard Earring','','rear,lear','true','none',NULL,150,'s80',0,-1,0,0,79,35,0,194,'true','accessory_earring_of_domi_protection_i00',0,1,0,'8350','1',0,0),
	(14804,'Oren Guard Earring','','rear,lear','true','none',NULL,150,'s80',0,-1,0,0,79,35,0,194,'true','accessory_earring_of_domi_protection_i00',0,1,0,'8351','1',0,0),
	(14805,'Aden Guard Earring','','rear,lear','true','none',NULL,150,'s80',0,-1,0,0,79,35,0,194,'true','accessory_earring_of_domi_protection_i00',0,1,0,'8352','1',0,0),
	(14806,'Innadril Guard Earring','','rear,lear','true','none',NULL,150,'s80',0,-1,0,0,79,35,0,194,'true','accessory_earring_of_domi_protection_i00',0,1,0,'8353','1',0,0),
	(14807,'Goddard Guard Earring','','rear,lear','true','none',NULL,150,'s80',0,-1,0,0,79,35,0,194,'true','accessory_earring_of_domi_protection_i00',0,1,0,'8354','1',0,0),
	(14808,'Rune Guard Earring','','rear,lear','true','none',NULL,150,'s80',0,-1,0,0,79,35,0,194,'true','accessory_earring_of_domi_protection_i00',0,1,0,'8355','1',0,0),
	(14809,'Schuttgart Guard Earring','','rear,lear','true','none',NULL,150,'s80',0,-1,0,0,79,35,0,194,'true','accessory_earring_of_domi_protection_i00',0,1,0,'8356','1',0,0),
	(14810,'Blue Talisman - Buff Cancel','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i01',0,1,0,'8331','1',0,0),
	(14811,'Blue Talisman - Buff Steal','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i01',0,1,0,'8332','1',0,0),
	(14812,'Red Talisman - Territory Guard','','talisman','false','none',NULL,150,'none',0,66,0,0,0,0,0,0,'true','etc_talisman_i00',0,1,0,'0','0',0,0),
	(14813,'Blue Talisman - Lord\'s Divine Protection','','talisman','false','none',NULL,150,'none',0,74,0,0,0,0,0,0,'true','etc_talisman_i01',0,1,0,'0','0',0,0),
	(14814,'White Talisman -  All Resistance','','talisman','false','none',NULL,150,'none',0,65,0,0,0,0,0,0,'true','etc_talisman_i06',1,1,1,'0','0',0,0),
	(14922,'Low-grade Magic Rune Clip Iron Belt','HP Recovery','belt','true','light',NULL,460,'a',0,-1,0,12,0,0,371300,30,'true','armor_magic_clip_belt_i00',1,1,1,'8338','1',0,0),
	(14923,'Ordinary Magic Rune Clip Iron Belt','HP Recovery','belt','true','light',NULL,460,'a',0,-1,0,12,0,0,371300,30,'true','armor_magic_clip_belt_i00',1,1,1,'8338','2',0,0),
	(14924,'High-grade Magic Rune Clip Iron Belt','HP Recovery','belt','true','light',NULL,460,'a',0,-1,0,12,0,0,371300,30,'true','armor_magic_clip_belt_i00',1,1,1,'8338','3',0,0),
	(14925,'Top-grade Magic Rune Clip Iron Belt','HP Recovery','belt','true','light',NULL,460,'a',0,-1,0,12,0,0,371300,30,'true','armor_magic_clip_belt_i00',1,1,1,'8338','4',0,0),
	(14926,'Low-grade Magic Rune Clip Mithril Belt','HP Recovery','belt','true','light',NULL,440,'s',0,-1,0,14,0,0,1917000,92,'true','armor_magic_clip_belt_i01',1,1,1,'8339','1',0,0),
	(14927,'Ordinary Magic Rune Clip Mithril Belt','HP Recovery','belt','true','light',NULL,440,'s',0,-1,0,14,0,0,1917000,92,'true','armor_magic_clip_belt_i01',1,1,1,'8339','2',0,0),
	(14928,'High-grade Magic Rune Clip Mithril Belt','HP Recovery','belt','true','light',NULL,440,'s',0,-1,0,14,0,0,1917000,92,'true','armor_magic_clip_belt_i01',1,1,1,'8339','3',0,0),
	(14929,'Top-grade Magic Rune Clip Mithril Belt','HP Recovery','belt','true','light',NULL,440,'s',0,-1,0,14,0,0,1917000,92,'true','armor_magic_clip_belt_i01',1,1,1,'8339','4',0,0),
	(14930,'Low-grade Magic Rune Clip Iron Belt','MP Recovery','belt','true','light',NULL,460,'a',0,-1,0,12,0,0,371300,30,'true','armor_magic_clip_belt_i00',1,1,1,'8340','1',0,0),
	(14931,'Ordinary Magic Rune Clip Iron Belt','MP Recovery','belt','true','light',NULL,460,'a',0,-1,0,12,0,0,371300,30,'true','armor_magic_clip_belt_i00',1,1,1,'8340','2',0,0),
	(14932,'High-grade Magic Rune Clip Iron Belt','MP Recovery','belt','true','light',NULL,460,'a',0,-1,0,12,0,0,371300,30,'true','armor_magic_clip_belt_i00',1,1,1,'8340','3',0,0),
	(14933,'Top-grade Magic Rune Clip Iron Belt','MP Recovery','belt','true','light',NULL,460,'a',0,-1,0,12,0,0,371300,30,'true','armor_magic_clip_belt_i00',1,1,1,'8340','4',0,0),
	(14934,'Low-grade Magic Rune Clip Mithril Belt','MP Recovery','belt','true','light',NULL,440,'s',0,-1,0,14,0,0,1917000,92,'true','armor_magic_clip_belt_i01',1,1,1,'8341','1',0,0),
	(14935,'Ordinary Magic Rune Clip Mithril Belt','MP Recovery','belt','true','light',NULL,440,'s',0,-1,0,14,0,0,1917000,92,'true','armor_magic_clip_belt_i01',1,1,1,'8341','2',0,0),
	(14936,'High-grade Magic Rune Clip Mithril Belt','MP Recovery','belt','true','light',NULL,440,'s',0,-1,0,14,0,0,1917000,92,'true','armor_magic_clip_belt_i01',1,1,1,'8341','3',0,0),
	(14937,'Top-grade Magic Rune Clip Mithril Belt','MP Recovery','belt','true','light',NULL,440,'s',0,-1,0,14,0,0,1917000,92,'true','armor_magic_clip_belt_i01',1,1,1,'8341','4',0,0),
	(14938,'Low-grade Magic Ornament Iron Belt','PvP Physical Attack','belt','true','light',NULL,440,'a',0,-1,0,12,0,0,371300,30,'true','armor_magic_deco_belt_i00',1,1,1,'8342','1',0,0),
	(14939,'Regular Magic Ornament Iron Belt','PvP Physical Attack','belt','true','light',NULL,440,'a',0,-1,0,12,0,0,371300,30,'true','armor_magic_deco_belt_i00',1,1,1,'8342','2',0,0),
	(14940,'High-grade Magic Ornament Iron Belt','PvP Physical Attack','belt','true','light',NULL,440,'a',0,-1,0,12,0,0,371300,30,'true','armor_magic_deco_belt_i00',1,1,1,'8342','3',0,0),
	(14941,'Top-grade Magic Ornament Iron Belt','PvP Physical Attack','belt','true','light',NULL,440,'a',0,-1,0,12,0,0,371300,30,'true','armor_magic_deco_belt_i00',1,1,1,'8342','4',0,0),
	(14942,'Low-grade Magic Ornament Iron Belt','PvP Skill Attack','belt','true','light',NULL,440,'a',0,-1,0,12,0,0,371300,30,'true','armor_magic_deco_belt_i00',1,1,1,'8343','1',0,0),
	(14943,'Regular Magic Ornament Iron Belt','PvP Skill Attack','belt','true','light',NULL,440,'a',0,-1,0,12,0,0,371300,30,'true','armor_magic_deco_belt_i00',1,1,1,'8343','2',0,0),
	(14944,'High-grade Magic Ornament Iron Belt','PvP Skill Attack','belt','true','light',NULL,440,'a',0,-1,0,12,0,0,371300,30,'true','armor_magic_deco_belt_i00',1,1,1,'8343','3',0,0),
	(14945,'Top-grade Magic Ornament Iron Belt','PvP Skill Attack','belt','true','light',NULL,440,'a',0,-1,0,12,0,0,371300,30,'true','armor_magic_deco_belt_i00',1,1,1,'8343','4',0,0),
	(14946,'Low-grade Magic Ornament Iron Belt','PVP Defense','belt','true','light',NULL,440,'a',0,-1,0,12,0,0,371300,30,'true','armor_magic_deco_belt_i00',1,1,1,'8344','1',0,0),
	(14947,'Regular Magic Ornament Iron Belt','PVP Defense','belt','true','light',NULL,440,'a',0,-1,0,12,0,0,371300,30,'true','armor_magic_deco_belt_i00',1,1,1,'8344','2',0,0),
	(14948,'High-grade Magic Ornament Iron Belt','PVP Defense','belt','true','light',NULL,440,'a',0,-1,0,12,0,0,371300,30,'true','armor_magic_deco_belt_i00',1,1,1,'8344','3',0,0),
	(14949,'Top-grade Magic Ornament Iron Belt','PVP Defense','belt','true','light',NULL,440,'a',0,-1,0,12,0,0,371300,30,'true','armor_magic_deco_belt_i00',1,1,1,'8344','4',0,0),
	(14950,'Low-grade Magic Ornament Mithril Belt','PvP Physical Attack','belt','false','light',NULL,440,'s',0,-1,0,14,0,0,1917000,92,'true','armor_magic_deco_belt_i01',1,1,1,'8345','1',0,0),
	(14951,'Regular Magic Ornament Mithril Belt','PvP Physical Attack','belt','false','light',NULL,440,'s',0,-1,0,14,0,0,1917000,92,'true','armor_magic_deco_belt_i01',1,1,1,'8345','2',0,0),
	(14952,'High-grade Magic Ornament Mithril Belt','PvP Physical Attack','belt','false','light',NULL,440,'s',0,-1,0,14,0,0,1917000,92,'true','armor_magic_deco_belt_i01',1,1,1,'8345','3',0,0),
	(14953,'Top-grade Magic Ornament Mithril Belt','PvP Physical Attack','belt','false','light',NULL,440,'s',0,-1,0,14,0,0,1917000,92,'true','armor_magic_deco_belt_i01',1,1,1,'8345','4',0,0),
	(14954,'Low-grade Magic Ornament Mithril Belt','PvP Skill Attack','belt','true','light',NULL,440,'s',0,-1,0,14,0,0,1917000,92,'true','armor_magic_deco_belt_i01',1,1,1,'8346','1',0,0),
	(14955,'Regular Magic Ornament Mithril Belt','PvP Skill Attack','belt','true','light',NULL,440,'s',0,-1,0,14,0,0,1917000,92,'true','armor_magic_deco_belt_i01',1,1,1,'8346','2',0,0),
	(14956,'High-grade Magic Ornament Mithril Belt','PvP Skill Attack','belt','true','light',NULL,440,'s',0,-1,0,14,0,0,1917000,92,'true','armor_magic_deco_belt_i01',1,1,1,'8346','3',0,0),
	(14957,'Top-grade Magic Ornament Mithril Belt','PvP Skill Attack','belt','true','light',NULL,440,'s',0,-1,0,14,0,0,1917000,92,'true','armor_magic_deco_belt_i01',1,1,1,'8346','4',0,0),
	(14958,'Low-grade Magic Ornament Mithril Belt','PVP Defense','belt','true','light',NULL,440,'s',0,-1,0,14,0,0,1917000,92,'true','armor_magic_deco_belt_i01',1,1,1,'8347','1',0,0),
	(14959,'Regular Magic Ornament Mithril Belt','PVP Defense','belt','true','light',NULL,440,'s',0,-1,0,14,0,0,1917000,92,'true','armor_magic_deco_belt_i01',1,1,1,'8347','2',0,0),
	(14960,'High-grade Magic Ornament Mithril Belt','PVP Defense','belt','true','light',NULL,440,'s',0,-1,0,14,0,0,1917000,92,'true','armor_magic_deco_belt_i01',1,1,1,'8347','3',0,0),
	(14961,'Top-grade Magic Ornament Mithril Belt','PVP Defense','belt','true','light',NULL,440,'s',0,-1,0,14,0,0,1917000,92,'true','armor_magic_deco_belt_i01',1,1,1,'8347','4',0,0),
	(14962,'Gold Skeleton Circlet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_golden_skeleton_circlet_i00',1,1,1,'0','0',0,0),
	(14963,'Silver Skeleton Circlet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_golden_skeleton_circlet_i02',1,1,1,'0','0',0,0),
	(14964,'Red Skeleton Circlet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_golden_skeleton_circlet_i01',1,1,1,'0','0',0,0),
	(14965,'Black Skeleton Circlet','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_golden_skeleton_circlet_i03',1,1,1,'0','0',0,0),
	(14966,'Majestic Earring of Friendship','30 day limited period','rear,lear','true','none',NULL,150,'a',0,43200,0,0,63,25,0,0,'true','accessary_inferno_earing_i00',0,1,0,'0','0',0,0),
	(14967,'Majestic Necklace of Friendship','30 day limited period','neck','true','none',NULL,150,'a',0,43200,0,0,85,33,0,0,'true','accessary_inferno_necklace_i00',0,1,0,'0','0',0,0),
	(14968,'Majestic Ring of Friendship','30 day limited period','rfinger,lfinger','true','none',NULL,150,'a',0,43200,0,0,42,17,0,0,'true','accessary_inferno_ring_i00',0,1,0,'0','0',0,0),
	(14969,'Friendship Earring of Black Ore','30 day limited period','rear,lear','true','none',NULL,150,'b',0,43200,0,0,54,0,0,0,'true','accessary_earing_of_black_ore_i00',0,1,0,'0','0',0,0),
	(14970,'Friendship Necklace of Black Ore','30 day limited period','neck','true','none',NULL,150,'b',0,43200,0,0,72,0,0,0,'true','accessary_necklace_of_black_ore_i00',0,1,0,'0','0',0,0),
	(14971,'Friendship Ring of Black Ore','30 day limited period','rfinger,lfinger','true','none',NULL,150,'b',0,43200,0,0,36,0,0,0,'true','accessary_ring_of_black_ore_i00',0,1,0,'0','0',0,0),
	(14972,'Friendship Earring of Binding','30 day limited period','rear,lear','true','none',NULL,150,'c',0,43200,0,0,45,0,0,0,'true','accessary_earing_of_binding_i00',0,1,0,'0','0',0,0),
	(14973,'Friendship Necklace of Binding','30 day limited period','neck','true','none',NULL,150,'c',0,43200,0,0,64,0,0,0,'true','accessary_necklace_of_binding_i00',0,1,0,'0','0',0,0),
	(14974,'Friendship Ring of Binding','30 day limited period','rfinger,lfinger','true','none',NULL,150,'c',0,43200,0,0,32,0,0,0,'true','accessary_ring_of_binding_i00',0,1,0,'0','0',0,0),
	(14975,'Elven Earring of Friendship','30 day limited period','rear,lear','true','none',NULL,150,'d',0,43200,0,0,34,0,0,0,'true','accessary_elven_earing_i00',0,1,0,'0','0',0,0),
	(14976,'Elven Earring of Friendship','30 day limited period','neck','true','none',NULL,150,'d',0,43200,0,0,45,0,0,0,'true','accessary_elven_necklace_i00',0,1,0,'0','0',0,0),
	(14977,'Elven Ring of Friendship','30 day limited period','rfinger,lfinger','true','none',NULL,150,'d',0,43200,0,0,22,0,0,0,'true','accessary_elven_ring_i00',0,1,0,'0','0',0,0),
	(14978,'Dark Crystal Robe of Friendship','30 day limited period','fullarmor','true','magic',NULL,2450,'a',0,43200,0,139,0,665,0,0,'true','armor_t76_ul_i00',0,1,0,'0','0',0,0),
	(14979,'Dark Crystal Helmet of Friendship','30 day limited period','head','true','none',NULL,570,'a',0,43200,0,69,0,0,0,0,'true','armor_helmet_i00',0,1,0,'0','0',0,0),
	(14980,'Dark Crystal Gloves of Friendship - Robe','30 day limited period','gloves','true','none',NULL,580,'a',0,43200,0,46,0,0,0,0,'true','armor_t76_g_i00',0,1,0,'0','0',0,0),
	(14981,'Dark Crystal Boots of Friendship - Robe','30 day limited period','feet','true','none',NULL,1110,'a',0,43200,0,46,0,0,0,0,'true','armor_t76_b_i00',0,1,0,'0','0',0,0),
	(14983,'Avadon Robe of Friendship','30 day limited period','fullarmor','true','magic',NULL,2540,'b',0,43200,0,127,0,561,0,0,'true','armor_t59_ul_i00',0,1,0,'0','0',0,0),
	(14984,'Avadon Circlet of Friendship','30 day limited period','head','true','none',NULL,590,'b',0,43200,0,62,0,0,0,0,'true','armor_leather_helmet_i00',0,1,0,'0','0',0,0),
	(14985,'Avadon Gloves of Friendship - Robe','30 day limited period','gloves','true','none',NULL,590,'b',0,43200,0,41,0,0,0,0,'true','armor_t59_g_i00',0,1,0,'0','0',0,0),
	(14986,'Avadon Boots of Friendship - Robe','30 day limited period','feet','true','none',NULL,1180,'b',0,43200,0,41,0,0,0,0,'true','armor_t59_b_i00',0,1,0,'0','0',0,0),
	(14988,'Karmian Tunic of Friendship','30 day limited period','chest','true','magic',NULL,1980,'c',0,43200,0,60,0,225,0,0,'true','armor_t53_u_i00',0,1,0,'0','0',0,0),
	(14989,'Karmian Stockings of Friendship','30 day limited period','legs','true','magic',NULL,970,'c',0,43200,0,37,0,141,0,0,'true','armor_t53_l_i00',0,1,0,'0','0',0,0),
	(14990,'Karmian Gloves of Friendship','30 day limited period','gloves','true','none',NULL,620,'c',0,43200,0,32,0,0,0,0,'true','armor_t53_g_i00',0,1,0,'0','0',0,0),
	(14991,'Karmian Boots of Friendship','30 day limited period','feet','true','none',NULL,1230,'c',0,43200,0,32,0,0,0,0,'true','armor_t53_b_i00',0,1,0,'0','0',0,0),
	(14992,'Mithril Tunic of Friendship','30 day limited period','chest','true','magic',NULL,2010,'d',0,43200,0,52,0,169,0,0,'true','armor_t51_u_i00',0,1,0,'0','0',0,0),
	(14993,'Mithril Stockings of Friendship','30 day limited period','legs','true','magic',NULL,980,'d',0,43200,0,32,0,105,0,0,'true','armor_t51_l_i00',0,1,0,'0','0',0,0),
	(14994,'Elven Mithril Gloves of Friendship','30 day limited period','gloves','true','none',NULL,640,'d',0,43200,0,27,0,0,0,0,'true','armor_t51_g_i00',0,1,0,'0','0',0,0),
	(14995,'Elven Mithril Boots of Friendship','30 day limited period','feet','true','none',NULL,1250,'d',0,43200,0,27,0,0,0,0,'true','armor_t51_b_i00',0,1,0,'0','0',0,0),
	(14996,'Dark Crystal Leather Armor of Friendship','30 day limited period','chest','true','light',NULL,4300,'a',0,43200,0,128,0,0,0,0,'true','armor_t75_u_i00',0,1,0,'0','0',0,0),
	(14997,'Dark Crystal Leggings of Friendship','30 day limited period','legs','true','light',NULL,1480,'a',0,43200,0,80,0,0,0,0,'true','armor_t75_l_i00',0,1,0,'0','0',0,0),
	(14998,'Dark Crystal Gloves of Friendship - Light Armor','30 day limited period','gloves','true','none',NULL,580,'a',0,43200,0,46,0,0,0,0,'true','armor_t75_g_i00',0,1,0,'0','0',0,0),
	(14999,'Dark Crystal Boots of Friendship - Light Armor','30 day limited period','feet','true','none',NULL,1110,'a',0,43200,0,46,0,0,0,0,'true','armor_t75_b_i00',0,1,0,'0','0',0,0),
	(15000,'Leather Armor of Doom of Friendship','30 day limited period','fullarmor','true','light',NULL,5500,'b',0,43200,0,202,0,0,0,0,'true','armor_t72_ul_i00',0,1,0,'0','0',0,0),
	(15001,'Doom Helmet of Friendship','30 day limited period','head','true','none',NULL,580,'b',0,43200,0,66,0,0,0,0,'true','armor_leather_helmet_i00',0,1,0,'0','0',0,0),
	(15002,'Doom Gloves of Friendship - Heavy Armor','30 day limited period','gloves','true','none',NULL,580,'b',0,43200,0,44,0,0,0,0,'true','armor_t71_g_i00',0,1,0,'0','0',0,0),
	(15003,'Doom Gloves of Friendship - Light Armor','30 day limited period','gloves','true','none',NULL,580,'b',0,43200,0,44,0,0,0,0,'true','armor_t72_g_i00',0,1,0,'0','0',0,0),
	(15004,'Doom Boots of Friendship - Heavy Armor','30 day limited period','feet','true','none',NULL,1130,'b',0,43200,0,44,0,0,0,0,'true','armor_t71_b_i00',0,1,0,'0','0',0,0),
	(15005,'Doom Boots of Friendship - Light Armor','30 day limited period','feet','true','none',NULL,1130,'b',0,43200,0,44,0,0,0,0,'true','armor_t72_b_i00',0,1,0,'0','0',0,0),
	(15006,'Doom Plate Armor of Friendship','30 day limited period','fullarmor','true','heavy',NULL,9980,'b',0,43200,0,270,0,0,0,0,'true','armor_t71_ul_i00',0,1,0,'0','0',0,0),
	(15008,'Plate Leather Armor of Friendship','30 day limited period','chest','true','light',NULL,4450,'c',0,43200,0,94,0,0,0,0,'true','armor_t47_u_i00',0,1,0,'0','0',0,0),
	(15009,'Plate Leather Gaiters of Friendship','30 day limited period','legs','true','light',NULL,1560,'c',0,43200,0,59,0,0,0,0,'true','armor_t47_l_i00',0,1,0,'0','0',0,0),
	(15010,'Plate Leather Boots of Friendship','30 day limited period','feet','true','none',NULL,1220,'c',0,43200,0,32,0,0,0,0,'true','armor_t47_b_i00',0,1,0,'0','0',0,0),
	(15011,'Plate Leather Gloves of Friendship','30 day limited period','gloves','true','none',NULL,610,'c',0,43200,0,33,0,0,0,0,'true','armor_t47_g_i00',0,1,0,'0','0',0,0),
	(15012,'Full Plate Helmet of Friendship','30 day limited period','head','true','none',NULL,600,'c',0,43200,0,58,0,0,0,0,'true','armor_leather_helmet_i00',0,1,0,'0','0',0,0),
	(15013,'Full Plate Armor of Friendship','30 day limited period','fullarmor','true','heavy',NULL,10480,'c',0,43200,0,239,0,0,0,0,'true','armor_t62_ul_i00',0,1,0,'0','0',0,0),
	(15014,'Full Plate Boots of Friendship','30 day limited period','feet','true','none',NULL,1200,'c',0,43200,0,39,0,0,0,0,'true','armor_t62_b_i00',0,1,0,'0','0',0,0),
	(15015,'Full Plate Gauntlet of Friendship','30 day limited period','gloves','true','none',NULL,600,'c',0,43200,0,39,0,0,0,0,'true','armor_t62_g_i00',0,1,0,'0','0',0,0),
	(15017,'Manticore Skin Shirt of Friendship','30 day limited period','chest','true','light',NULL,4520,'d',0,43200,0,77,0,0,0,0,'true','armor_t42_u_i00',0,1,0,'0','0',0,0),
	(15018,'Manticore Skin Gaiters of Friendship','30 day limited period','legs','true','light',NULL,1550,'d',0,43200,0,48,0,0,0,0,'true','armor_t42_l_i00',0,1,0,'0','0',0,0),
	(15019,'Manticore Skin Boots of Friendship','30 day limited period','feet','true','none',NULL,1260,'d',0,43200,0,27,0,0,0,0,'true','armor_t42_b_i00',0,1,0,'0','0',0,0),
	(15020,'Manticore Skin Gloves of Friendship','30 day limited period','gloves','true','none',NULL,630,'d',0,43200,0,27,0,0,0,0,'true','armor_t42_g_i00',0,1,0,'0','0',0,0),
	(15021,'Brigandine of Friendship','30 day limited period','chest','true','heavy',NULL,8320,'d',0,43200,0,103,0,0,0,0,'true','armor_t43_u_i00',0,1,0,'0','0',0,0),
	(15022,'Brigandine Gaiters of Friendship','30 day limited period','legs','true','heavy',NULL,3820,'d',0,43200,0,64,0,0,0,0,'true','armor_t43_l_i00',0,1,0,'0','0',0,0),
	(15023,'Brigandine Helmet of Friendship','30 day limited period','head','true','none',NULL,630,'d',0,43200,0,41,0,0,0,0,'true','armor_leather_helmet_i00',0,1,0,'0','0',0,0),
	(15024,'Brigandine Boots of Friendship','30 day limited period','feet','true','none',NULL,1250,'d',0,43200,0,27,0,0,0,0,'true','armor_t43_b_i00',0,1,0,'0','0',0,0),
	(15025,'Brigandine Gauntlet of Friendship','30 day limited period','gloves','true','none',NULL,630,'d',0,43200,0,27,0,0,0,0,'true','armor_t43_g_i00',0,1,0,'0','0',0,0),
	(15027,'Friendship Armor of Nightmare','30 day limited period','fullarmor','true','heavy',NULL,9580,'a',0,43200,0,293,0,0,0,0,'true','armor_t80_ul_i00',0,1,0,'0','0',0,0),
	(15028,'Friendship Helm of Nightmare','30 day limited period','head','true','none',NULL,560,'a',0,43200,0,73,0,0,0,0,'true','armor_leather_helmet_i00',0,1,0,'0','0',0,0),
	(15029,'Friendship Gauntlet of Nightmare - Heavy Armor','30 day limited period','gloves','true','none',NULL,550,'a',0,43200,0,49,0,0,0,0,'true','armor_t80_g_i00',0,1,0,'0','0',0,0),
	(15030,'Friendship Boots of Nightmare - Heavy Armor','30 day limited period','feet','true','none',NULL,1110,'a',0,43200,0,49,0,0,0,0,'true','armor_t80_b_i00',0,1,0,'0','0',0,0),
	(15080,'Majestic Earring of Friendship','10 day limited period','rear,lear','true','none',NULL,150,'a',0,14400,0,0,63,25,0,0,'true','accessary_inferno_earing_i00',0,1,0,'0','0',0,0),
	(15081,'Majestic Necklace of Friendship','10 day limited period','neck','true','none',NULL,150,'a',0,14400,0,0,85,33,0,0,'true','accessary_inferno_necklace_i00',0,1,0,'0','0',0,0),
	(15082,'Majestic Ring of Friendship','10 day limited period','rfinger,lfinger','true','none',NULL,150,'a',0,14400,0,0,42,17,0,0,'true','accessary_inferno_ring_i00',0,1,0,'0','0',0,0),
	(15083,'Friendship Earring of Black Ore','10 day limited period','rear,lear','true','none',NULL,150,'b',0,14400,0,0,54,0,0,0,'true','accessary_earing_of_black_ore_i00',0,1,0,'0','0',0,0),
	(15084,'Friendship Necklace of Black Ore','10 day limited period','neck','true','none',NULL,150,'b',0,14400,0,0,72,0,0,0,'true','accessary_necklace_of_black_ore_i00',0,1,0,'0','0',0,0),
	(15085,'Friendship Ring of Black Ore','10 day limited period','rfinger,lfinger','true','none',NULL,150,'b',0,14400,0,0,36,0,0,0,'true','accessary_ring_of_black_ore_i00',0,1,0,'0','0',0,0),
	(15086,'Friendship Earring of Binding','10 day limited period','rear,lear','true','none',NULL,150,'c',0,14400,0,0,45,0,0,0,'true','accessary_earing_of_binding_i00',0,1,0,'0','0',0,0),
	(15087,'Friendship Necklace of Binding','10 day limited period','neck','true','none',NULL,150,'c',0,14400,0,0,64,0,0,0,'true','accessary_necklace_of_binding_i00',0,1,0,'0','0',0,0),
	(15088,'Friendship Ring of Binding','10 day limited period','rfinger,lfinger','true','none',NULL,150,'c',0,14400,0,0,32,0,0,0,'true','accessary_ring_of_binding_i00',0,1,0,'0','0',0,0),
	(15089,'Elven Earring of Friendship','10 day limited period','rear,lear','true','none',NULL,150,'d',0,14400,0,0,34,0,0,0,'true','accessary_elven_earing_i00',0,1,0,'0','0',0,0),
	(15090,'Elven Earring of Friendship','10 day limited period','neck','true','none',NULL,150,'d',0,14400,0,0,45,0,0,0,'true','accessary_elven_necklace_i00',0,1,0,'0','0',0,0),
	(15091,'Elven Ring of Friendship','10 day limited period','rfinger,lfinger','true','none',NULL,150,'d',0,14400,0,0,22,0,0,0,'true','accessary_elven_ring_i00',0,1,0,'0','0',0,0),
	(15092,'Dark Crystal Robe of Friendship','10 day limited period','fullarmor','true','magic',NULL,2450,'a',0,14400,0,139,0,665,0,0,'true','armor_t76_ul_i00',0,1,0,'0','0',0,0),
	(15093,'Dark Crystal Helmet of Friendship','10 day limited period','head','true','none',NULL,570,'a',0,14400,0,69,0,0,0,0,'true','armor_helmet_i00',0,1,0,'0','0',0,0),
	(15094,'Dark Crystal Gloves of Friendship - Robe','10 day limited period','gloves','true','none',NULL,580,'a',0,14400,0,46,0,0,0,0,'true','armor_t76_g_i00',0,1,0,'0','0',0,0),
	(15095,'Dark Crystal Boots of Friendship - Robe','10 day limited period','feet','true','none',NULL,1110,'a',0,14400,0,46,0,0,0,0,'true','armor_t76_b_i00',0,1,0,'0','0',0,0),
	(15097,'Avadon Robe of Friendship','10 day limited period','fullarmor','true','magic',NULL,2540,'b',0,14400,0,127,0,561,0,0,'true','armor_t59_ul_i00',0,1,0,'0','0',0,0),
	(15098,'Avadon Circlet of Friendship','10 day limited period','head','true','none',NULL,590,'b',0,14400,0,62,0,0,0,0,'true','armor_leather_helmet_i00',0,1,0,'0','0',0,0),
	(15099,'Avadon Gloves of Friendship - Robe','10 day limited period','gloves','true','none',NULL,590,'b',0,14400,0,41,0,0,0,0,'true','armor_t59_g_i00',0,1,0,'0','0',0,0),
	(15100,'Avadon Boots of Friendship - Robe','10 day limited period','feet','true','none',NULL,1180,'b',0,14400,0,41,0,0,0,0,'true','armor_t59_b_i00',0,1,0,'0','0',0,0),
	(15102,'Karmian Tunic of Friendship','10 day limited period','chest','true','magic',NULL,1980,'c',0,14400,0,60,0,225,0,0,'true','armor_t53_u_i00',0,1,0,'0','0',0,0),
	(15103,'Karmian Stockings of Friendship','10 day limited period','legs','true','magic',NULL,970,'c',0,14400,0,37,0,141,0,0,'true','armor_t53_l_i00',0,1,0,'0','0',0,0),
	(15104,'Karmian Gloves of Friendship','10 day limited period','gloves','true','none',NULL,620,'c',0,14400,0,32,0,0,0,0,'true','armor_t53_g_i00',0,1,0,'0','0',0,0),
	(15105,'Karmian Boots of Friendship','10 day limited period','feet','true','none',NULL,1230,'c',0,14400,0,32,0,0,0,0,'true','armor_t53_b_i00',0,1,0,'0','0',0,0),
	(15106,'Mithril Tunic of Friendship','10 day limited period','chest','true','magic',NULL,2010,'d',0,14400,0,52,0,169,0,0,'true','armor_t51_u_i00',0,1,0,'0','0',0,0),
	(15107,'Mithril Stockings of Friendship','10 day limited period','legs','true','magic',NULL,980,'d',0,14400,0,32,0,105,0,0,'true','armor_t51_l_i00',0,1,0,'0','0',0,0),
	(15108,'Elven Mithril Gloves of Friendship','10 day limited period','gloves','true','none',NULL,640,'d',0,14400,0,27,0,0,0,0,'true','armor_t51_g_i00',0,1,0,'0','0',0,0),
	(15109,'Elven Mithril Boots of Friendship','10 day limited period','feet','true','none',NULL,1250,'d',0,14400,0,27,0,0,0,0,'true','armor_t51_b_i00',0,1,0,'0','0',0,0),
	(15110,'Dark Crystal Leather Armor of Friendship','10 day limited period','chest','true','light',NULL,4300,'a',0,14400,0,128,0,0,0,0,'true','armor_t75_u_i00',0,1,0,'0','0',0,0),
	(15111,'Dark Crystal Leggings of Friendship','10 day limited period','legs','true','light',NULL,1480,'a',0,14400,0,80,0,0,0,0,'true','armor_t75_l_i00',0,1,0,'0','0',0,0),
	(15112,'Dark Crystal Gloves of Friendship - Light Armor','10 day limited period','gloves','true','none',NULL,580,'a',0,14400,0,46,0,0,0,0,'true','armor_t75_g_i00',0,1,0,'0','0',0,0),
	(15113,'Dark Crystal Boots of Friendship - Light Armor','10 day limited period','feet','true','none',NULL,1110,'a',0,14400,0,46,0,0,0,0,'true','armor_t75_b_i00',0,1,0,'0','0',0,0),
	(15114,'Leather Armor of Doom of Friendship','10 day limited period','fullarmor','true','light',NULL,5500,'b',0,14400,0,202,0,0,0,0,'true','armor_t72_ul_i00',0,1,0,'0','0',0,0),
	(15115,'Doom Helmet of Friendship','10 day limited period','head','true','none',NULL,580,'b',0,14400,0,66,0,0,0,0,'true','armor_leather_helmet_i00',0,1,0,'0','0',0,0),
	(15116,'Doom Gloves of Friendship - Heavy Armor','10 day limited period','gloves','true','none',NULL,580,'b',0,14400,0,44,0,0,0,0,'true','armor_t71_g_i00',0,1,0,'0','0',0,0),
	(15117,'Doom Gloves of Friendship - Light Armor','10 day limited period','gloves','true','none',NULL,580,'b',0,14400,0,44,0,0,0,0,'true','armor_t72_g_i00',0,1,0,'0','0',0,0),
	(15118,'Doom Boots of Friendship - Heavy Armor','10 day limited period','feet','true','none',NULL,1130,'b',0,14400,0,44,0,0,0,0,'true','armor_t71_b_i00',0,1,0,'0','0',0,0),
	(15119,'Doom Boots of Friendship - Light Armor','10 day limited period','feet','true','none',NULL,1130,'b',0,14400,0,44,0,0,0,0,'true','armor_t72_b_i00',0,1,0,'0','0',0,0),
	(15120,'Doom Plate Armor of Friendship','10 day limited period','fullarmor','true','heavy',NULL,9980,'b',0,14400,0,270,0,0,0,0,'true','armor_t71_ul_i00',0,1,0,'0','0',0,0),
	(15122,'Plate Leather Armor of Friendship','10 day limited period','chest','true','light',NULL,4450,'c',0,14400,0,94,0,0,0,0,'true','armor_t47_u_i00',0,1,0,'0','0',0,0),
	(15123,'Plate Leather Gaiters of Friendship','10 day limited period','legs','true','light',NULL,1560,'c',0,14400,0,59,0,0,0,0,'true','armor_t47_l_i00',0,1,0,'0','0',0,0),
	(15124,'Plate Leather Boots of Friendship','10 day limited period','feet','true','none',NULL,1220,'c',0,14400,0,32,0,0,0,0,'true','armor_t47_b_i00',0,1,0,'0','0',0,0),
	(15125,'Plate Leather Gloves of Friendship','10 day limited period','gloves','true','none',NULL,610,'c',0,14400,0,33,0,0,0,0,'true','armor_t47_g_i00',0,1,0,'0','0',0,0),
	(15126,'Full Plate Helmet of Friendship','10 day limited period','head','true','none',NULL,600,'c',0,14400,0,58,0,0,0,0,'true','armor_leather_helmet_i00',0,1,0,'0','0',0,0),
	(15127,'Full Plate Armor of Friendship','10 day limited period','fullarmor','true','heavy',NULL,10480,'c',0,14400,0,239,0,0,0,0,'true','armor_t62_ul_i00',0,1,0,'0','0',0,0),
	(15128,'Full Plate Boots of Friendship','10 day limited period','feet','true','none',NULL,1200,'c',0,14400,0,39,0,0,0,0,'true','armor_t62_b_i00',0,1,0,'0','0',0,0),
	(15129,'Full Plate Gauntlet of Friendship','10 day limited period','gloves','true','none',NULL,600,'c',0,14400,0,39,0,0,0,0,'true','armor_t62_g_i00',0,1,0,'0','0',0,0),
	(15131,'Manticore Skin Shirt of Friendship','10 day limited period','chest','true','light',NULL,4520,'d',0,14400,0,77,0,0,0,0,'true','armor_t42_u_i00',0,1,0,'0','0',0,0),
	(15132,'Manticore Skin Gaiters of Friendship','10 day limited period','legs','true','light',NULL,1550,'d',0,14400,0,48,0,0,0,0,'true','armor_t42_l_i00',0,1,0,'0','0',0,0),
	(15133,'Manticore Skin Boots of Friendship','10 day limited period','feet','true','none',NULL,1260,'d',0,14400,0,27,0,0,0,0,'true','armor_t42_b_i00',0,1,0,'0','0',0,0),
	(15134,'Manticore Skin Gloves of Friendship','10 day limited period','gloves','true','none',NULL,630,'d',0,14400,0,27,0,0,0,0,'true','armor_t42_g_i00',0,1,0,'0','0',0,0),
	(15135,'Brigandine of Friendship','10 day limited period','chest','true','heavy',NULL,8320,'d',0,14400,0,103,0,0,0,0,'true','armor_t43_u_i00',0,1,0,'0','0',0,0),
	(15136,'Brigandine Gaiters of Friendship','10 day limited period','legs','true','heavy',NULL,3820,'d',0,14400,0,64,0,0,0,0,'true','armor_t43_l_i00',0,1,0,'0','0',0,0),
	(15137,'Brigandine Helmet of Friendship','10 day limited period','head','true','none',NULL,630,'d',0,14400,0,41,0,0,0,0,'true','armor_leather_helmet_i00',0,1,0,'0','0',0,0),
	(15138,'Brigandine Boots of Friendship','10 day limited period','feet','true','none',NULL,1250,'d',0,14400,0,27,0,0,0,0,'true','armor_t43_b_i00',0,1,0,'0','0',0,0),
	(15139,'Brigandine Gauntlet of Friendship','10 day limited period','gloves','true','none',NULL,630,'d',0,14400,0,27,0,0,0,0,'true','armor_t43_g_i00',0,1,0,'0','0',0,0),
	(15141,'Friendship Armor of Nightmare','10 day limited period','fullarmor','true','heavy',NULL,9580,'a',0,14400,0,293,0,0,0,0,'true','armor_t80_ul_i00',0,1,0,'0','0',0,0),
	(15142,'Friendship Helm of Nightmare','10 day limited period','head','true','none',NULL,560,'a',0,14400,0,73,0,0,0,0,'true','armor_leather_helmet_i00',0,1,0,'0','0',0,0),
	(15143,'Friendship Gauntlet of Nightmare - Heavy Armor','10 day limited period','gloves','true','none',NULL,550,'a',0,14400,0,49,0,0,0,0,'true','armor_t80_g_i00',0,1,0,'0','0',0,0),
	(15144,'Friendship Boots of Nightmare - Heavy Armor','10 day limited period','feet','true','none',NULL,1110,'a',0,14400,0,49,0,0,0,0,'true','armor_t80_b_i00',0,1,0,'0','0',0,0),
	(15208,'Bracelet of Friendship','30 day limited period','lbracelet','false','none',NULL,0,'none',0,43200,0,0,0,0,0,0,'true','accessory_ring_of_friendship_i00',0,1,0,'0','0',0,0),
	(15220,'Agathion Seal Bracelet - Oink Oink','10 day limited period','lbracelet','false','none',NULL,0,'none',0,14400,0,0,0,0,0,0,'true','accessory_pig_lbracelet_i00',0,1,0,'8328;6196;6197','1;1;1',0,0),
	(15221,'Puffy Hat of Friendship','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','accessory_globefish_cap_i00',0,1,0,'0','0',0,0),
	(15282,'Gludio Water Royal Guard Necklace','','neck','true','none',NULL,150,'s80',0,-1,0,0,106,46,0,258,'true','accessory_nectklace_of_domi_protection_i00',0,1,0,'8388','2',0,0),
	(15283,'Dion Divinity Royal Guard Necklace','','neck','true','none',NULL,150,'s80',0,-1,0,0,106,46,0,258,'true','accessory_nectklace_of_domi_protection_i00',0,1,0,'8389','2',0,0),
	(15284,'Giran Wind Royal Guard Necklace','','neck','true','none',NULL,150,'s80',0,-1,0,0,106,46,0,258,'true','accessory_nectklace_of_domi_protection_i00',0,1,0,'8390','2',0,0),
	(15285,'Oren Royal Guard Necklace of Darkness','','neck','true','none',NULL,150,'s80',0,-1,0,0,106,46,0,258,'true','accessory_nectklace_of_domi_protection_i00',0,1,0,'8391','2',0,0),
	(15286,'Aden Earth Royal Guard Necklace','','neck','true','none',NULL,150,'s80',0,-1,0,0,106,46,0,258,'true','accessory_nectklace_of_domi_protection_i00',0,1,0,'8392','2',0,0),
	(15287,'Innadril Water Royal Guard Necklace','','neck','true','none',NULL,150,'s80',0,-1,0,0,106,46,0,258,'true','accessory_nectklace_of_domi_protection_i00',0,1,0,'8393','2',0,0),
	(15288,'Goddard Fire Royal Guard Necklace','','neck','true','none',NULL,150,'s80',0,-1,0,0,106,46,0,258,'true','accessory_nectklace_of_domi_protection_i00',0,1,0,'8394','2',0,0),
	(15289,'Rune Fire Royal Guard Necklace','','neck','true','none',NULL,150,'s80',0,-1,0,0,106,46,0,258,'true','accessory_nectklace_of_domi_protection_i00',0,1,0,'8395','2',0,0),
	(15290,'Schuttgart Wind Royal Guard Necklace','','neck','true','none',NULL,150,'s80',0,-1,0,0,106,46,0,258,'true','accessory_nectklace_of_domi_protection_i00',0,1,0,'8396','2',0,0),
	(15291,'Gludio Earth Royal Guard Ring','','rfinger,lfinger','true','none',NULL,150,'s80',0,-1,0,0,60,23,0,129,'true','accessory_ring_of_domi_protection_i00',0,1,0,'8379','2',0,0),
	(15292,'Dion Water Royal Guard Ring','','rfinger,lfinger','true','none',NULL,150,'s80',0,-1,0,0,60,23,0,129,'true','accessory_ring_of_domi_protection_i00',0,1,0,'8380','2',0,0),
	(15293,'Giran Fire Royal Guard Ring','','rfinger,lfinger','true','none',NULL,150,'s80',0,-1,0,0,60,23,0,129,'true','accessory_ring_of_domi_protection_i00',0,1,0,'8381','2',0,0),
	(15294,'Oren Earth Royal Guard Ring','','rfinger,lfinger','true','none',NULL,150,'s80',0,-1,0,0,60,23,0,129,'true','accessory_ring_of_domi_protection_i00',0,1,0,'8382','2',0,0),
	(15295,'Aden Divinity Royal Guard Ring','','rfinger,lfinger','true','none',NULL,150,'s80',0,-1,0,0,60,23,0,129,'true','accessory_ring_of_domi_protection_i00',0,1,0,'8383','2',0,0),
	(15296,'Innadril Divinity Royal Guard Ring','','rfinger,lfinger','true','none',NULL,150,'s80',0,-1,0,0,60,23,0,129,'true','accessory_ring_of_domi_protection_i00',0,1,0,'8384','2',0,0),
	(15297,'Goddard Dark Royal Guard Ring','','rfinger,lfinger','true','none',NULL,150,'s80',0,-1,0,0,60,23,0,129,'true','accessory_ring_of_domi_protection_i00',0,1,0,'8385','2',0,0),
	(15298,'Rune Wind Royal Guard Ring','','rfinger,lfinger','true','none',NULL,150,'s80',0,-1,0,0,60,23,0,129,'true','accessory_ring_of_domi_protection_i00',0,1,0,'8386','2',0,0),
	(15299,'Schuttgart Dark Royal Guard Ring','','rfinger,lfinger','true','none',NULL,150,'s80',0,-1,0,0,60,23,0,129,'true','accessory_ring_of_domi_protection_i00',0,1,0,'8387','2',0,0),
	(15312,'Dawn\'s Bracelet','','lbracelet','true','none',NULL,15,'none',0,-1,0,0,0,0,0,0,'true','accessory_lbracelet_of_dawn',0,0,0,'8337','1',0,0),
	(15351,'Seal Removal Bracelet_Towbat','','lbracelet','false','none',NULL,5,'none',0,-1,0,0,0,0,0,0,'true','etc_rbracelet_aga_agit_i00',1,1,1,'0','0',0,0),
	(20654,'Agathion Seal Bracelet - Chon-chon','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_luckygirl_i00',0,1,0,'21105;23079','1;1',0,0),
	(20655,'Agathion Seal Bracelet - Chon-chon','Great Warrior\'s Soul Power - 7 days limited time','lbracelet','false','none',NULL,150,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_aga_luckygirl_i00',0,1,0,'21105;23079;23080','1;1;1',0,0),
	(20656,'Agathion Seal Bracelet - Tang-tang','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_luckyboy_i00',0,1,0,'21106;23081','1;1',0,0),
	(20657,'Agathion Seal Bracelet - Tang-tang','Great Wizard\'s Soul Power - 7 days limited time','lbracelet','false','none',NULL,150,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_aga_luckyboy_i00',0,1,0,'21106;23081;23082','1;1;1',0,0),
	(20658,'Agthion Seal Bracelet - Dancing Lucky Kid','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_dancingchild_i00',0,1,0,'21107;23083','1;1',0,0),
	(20659,'Agthion Seal Bracelet - Dancing Lucky Kid','Great Adventurer\'s Soul Power - 7 days limited time','lbracelet','false','none',NULL,150,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_aga_dancingchild_i00',0,1,0,'21107;23083;23084','1;1;1',0,0),
	(20660,'Agathion Seal Bracelet - Monkey King','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_sunwukong_i00',0,1,0,'21108;23085','1;1',0,0),
	(20661,'Agathion Seal Bracelet - Monkey King','Great Wizard\'s Soul Power - 7 days limited time','lbracelet','false','none',NULL,150,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_aga_sunwukong_i00',0,1,0,'21108;23085;23086','1;1;1',0,0),
	(20662,'Agathion Seal Bracelet - Utanka Agathion','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_uthanka_i00',0,1,0,'21109;23087','1;1',0,0),
	(20663,'Agathion Seal Bracelet - Utanka Agathion','Great Warrior\'s Soul Power - 7 days limited time','lbracelet','false','none',NULL,150,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_aga_uthanka_i00',0,1,0,'21109;23087;23088','1;1;1',0,0),
	(20664,'Agathion Seal Bracelet - Bonus B Agathion','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_bonus_i00',0,1,0,'21110;23089','1;1',0,0),
	(20665,'Agathion Seal Bracelet - Bonus B Agathion','Great Adventurer\'s Soul Power - 7 days limited time','lbracelet','false','none',NULL,150,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_aga_bonus_i00',0,1,0,'21110;23089;23090','1;1;1',0,0),
	(20666,'Valkyrie Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_valkyrie_cap_i00',0,1,0,'0','0',0,0),
	(20667,'Valkyrie Hat','Great Adventurer\'s Soul Power - 7 day limited time','dhair','false','none',NULL,10,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_valkyrie_cap_i00',0,1,0,'0','0',0,0),
	(20668,'Tiger Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_tiger_cap_i00',0,1,0,'0','0',0,0),
	(20669,'Tiger Hat','Great Warrior\'s Soul Power - 7 days limited time','dhair','false','none',NULL,10,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_tiger_cap_i00',0,1,0,'0','0',0,0),
	(20670,'Maid\'s Hairband','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_maid_hairband_i00',0,1,0,'0','0',0,0),
	(20671,'Maid Hairband','Great Wizard\'s Soul Power - 7 days limited time','dhair','false','none',NULL,10,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_maid_hairband_i00',0,1,0,'0','0',0,0),
	(20672,'Baby Panda Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_babypanda_cap_i00',0,1,0,'0','0',0,0),
	(20673,'Baby Panda Hat','Blessed Escape - 7 day limited period','dhair','false','none',NULL,10,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_babypanda_cap_i00',0,1,0,'21101','1',0,0),
	(20674,'Bamboo Panda Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_kungfupanda_cap_i00',0,1,0,'0','0',0,0),
	(20675,'Bamboo Panda Hat','Great Adventurer\'s Soul Power - 7 days limited time','dhair','false','none',NULL,10,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_kungfupanda_cap_i00',0,1,0,'0','0',0,0),
	(20676,'Sexy Panda Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_sexypanda_cap_i00',0,1,0,'0','0',0,0),
	(20677,'Sexy Panda Hat','Blessed Resurrection - 7 day limited period','dhair','false','none',NULL,10,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_sexypanda_cap_i00',0,1,0,'21102','1',0,0),
	(20678,'Gate Keeper Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_gatekeeper_of_hat_i00',0,1,0,'0','0',0,0),
	(20679,'Gate Keeper Hat','Destroy Instinct - 7 day limited period ','dhair','false','none',NULL,10,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_gatekeeper_of_hat_i00',0,1,0,'21104','1',0,0),
	(20711,'Jack O\'Lantern Mask - Event','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_jack0_mask_i00',0,1,0,'0','0',0,0),
	(20712,'Mask of Giant Hercules - Event','Blessing of Skooldy : Protection of Darkness - 2 Hour Limited Period','dhair','false','none',NULL,10,'none',0,120,0,0,0,0,0,0,'true','BranchSys.br_frankenstein_mask_i00',0,1,0,'21122','1',0,0),
	(20713,'Mask of Silent Scream - Event','Blessing of Skooldy : Protection of Darkness - 2 Hour Limited Period','dhair','false','none',NULL,10,'none',0,120,0,0,0,0,0,0,'true','BranchSys.br_scream_mask_i00',0,1,0,'21123','1',0,0),
	(20714,'Spirit of Wrath Mask - Event','Blessing of Skooldy : Protection of Darkness - 2 Hour Limited Period','dhair','false','none',NULL,10,'none',0,120,0,0,0,0,0,0,'true','BranchSys.br_doccabi_mask_i00',0,1,0,'21124','1',0,0),
	(20715,'Undecaying Corpse Mask - Event','Blessing of Skooldy : Protection of Darkness - 2 Hour Limited Period','dhair','false','none',NULL,10,'none',0,120,0,0,0,0,0,0,'true','BranchSys.br_mummy_mask_i00',0,1,0,'21125','1',0,0),
	(20716,'Planet X235 Alien Mask - Event','Blessing of Skooldy : Protection of Darkness - 2 Hour Limited Period','dhair','false','none',NULL,10,'none',0,120,0,0,0,0,0,0,'true','BranchSys.br_alien_mask_i00',0,1,0,'21126','1',0,0),
	(20718,'Shiny Mask of Giant Hercules - Event','Blessing of Halloween - 4 hours Limited Period','dhair','false','none',NULL,10,'none',0,240,0,0,0,0,0,0,'true','BranchSys.br_shiny_frankenstein_mask_i00',0,1,0,'21127','1',0,0),
	(20719,'Shiny Mask of Silent Scream - Event','Blessing of Halloween - 4 hours Limited Period','dhair','false','none',NULL,10,'none',0,240,0,0,0,0,0,0,'true','BranchSys.br_shiny_scream_mask_i00',0,1,0,'21128','1',0,0),
	(20720,'Shiny Spirit of Wrath Mask - Event','Blessing of Halloween - 4 hours Limited Period','dhair','false','none',NULL,10,'none',0,240,0,0,0,0,0,0,'true','BranchSys.br_shiny_doccabi_mask_i00',0,1,0,'21129','1',0,0),
	(20721,'Shiny Undecaying Corpse Mask - Event','Blessing of Halloween - 4 hours Limited Period','dhair','false','none',NULL,10,'none',0,240,0,0,0,0,0,0,'true','BranchSys.br_shiny_mummy_mask_i00',0,1,0,'21130','1',0,0),
	(20722,'Shiny Planet X235 Alien Mask - Event','Blessing of Halloween - 4 hours Limited Period','dhair','false','none',NULL,10,'none',0,240,0,0,0,0,0,0,'true','BranchSys.br_shiny_alien_mask_i00',0,1,0,'21131','1',0,0),
	(20723,'Golden Jack O\'Lantern Mask.','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_golden_jack0_mask_i00',0,1,0,'0','0',0,0),
	(20724,'Golden Jack O\'Lantern Mask.','Authority of Golden Jack O\'Lantern - 7 Days Limited Period','dhair','false','none',NULL,10,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_golden_jack0_mask_i00',0,1,0,'21136','1',0,0),
	(20725,'Red Flame of Valakas','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_valakas_the_flame_i00',0,1,0,'0','0',0,0),
	(20726,'Agathion Seal Bracelet - Zombie','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_gangsi_i00',0,1,0,'21133;23117','1;1',0,0),
	(20727,'Agathion Seal Bracelet - Zombie','Escape from Death - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_aga_gangsi_i00',0,1,0,'21133;23117;23118','1;1;1',0,0),
	(20732,'Agathion Seal Bracelet - Baekyi Hwamae','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_bluebird_i00',0,1,0,'21134;23119','1;1',0,0),
	(20733,'Agathion Seal Bracelet - Kwanwoo Hwamae','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_hatbird_i00',0,1,0,'21135;23120','1;1',0,0),
	(20743,'Shiny Mask of Giant Hercules.','Blessing of Halloween - 7 day limited period','dhair','false','none',NULL,10,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_shiny_frankenstein_mask_i00',0,1,0,'21137','1',0,0),
	(20744,'Shiny Mask of Silent Scream.','Blessing of Halloween - 7 day limited period','dhair','false','none',NULL,10,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_shiny_scream_mask_i00',0,1,0,'21138','1',0,0),
	(20745,'Shiny Spirit of Wrath Mast.','Blessing of Halloween - 7 day limited period','dhair','false','none',NULL,10,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_shiny_doccabi_mask_i00',0,1,0,'21139','1',0,0),
	(20746,'Shiny Undecaying Corpse Mask.','Blessing of Halloween - 7 day limited period','dhair','false','none',NULL,10,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_shiny_mummy_mask_i00',0,1,0,'21140','1',0,0),
	(20747,'Shiny Planet X235 Alien Mask.','Blessing of Halloween - 7 day limited period','dhair','false','none',NULL,10,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_shiny_alien_mask_i00',0,1,0,'21141','1',0,0),
	(20774,'Agathion Seal Bracelet - Guangong','Aura of Fury - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_aga_warriorgod_i00',0,1,0,'0','1',0,0),
	(20775,'Agathion Seal Bracelet - Gwanseum Nyang Nyang','Blessing of Mercy - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_aga_mercygod_i00',0,1,0,'0','1',0,0),
	(20776,'Agathion Seal Bracelet - Blue Opera','Sword of Recovery - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_aga_blue_pekingopera_i00',0,1,0,'0','1',0,0),
	(20777,'Agathion Seal Bracelet - Blue Opera','Sword of Lightning - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_aga_blue_pekingopera_i00',0,1,0,'0','1',0,0),
	(20778,'Agathion Seal Bracelet - Red Opera','Spear of Flames - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_aga_pekingopera_i00',0,1,0,'0','1',0,0),
	(20779,'Agathion Seal Bracelet - Opera','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_redblue_pekingopera_i00',0,1,0,'21147;23132','1;1',0,0),
	(20780,'Agathion Seal Bracelet - Opera','Sword of Life - 30 day limited period','lbracelet','false','none',NULL,150,'none',0,43200,0,0,0,0,0,0,'true','BranchSys.br_aga_redblue_pekingopera_i00',0,1,0,'21147;23132;23164','1;1;1',0,0),
	(20781,'Agathion Seal Bracelet - Miss Chipao','Miss Chipao\'s Blessing - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_aga_chinesedress_i00',0,1,0,'0','1',0,0),
	(20782,'Agathion Seal Bracelet - Nepal Snow','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_suno_trumpet_i00',0,1,0,'21149;23135','1;1',0,0),
	(20783,'Agathion Seal Bracelet - Round Ball Snow','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_suno_ball_i00',0,1,0,'21150;23137','1;1',0,0),
	(20784,'Agathion Seal Bracelet - Ladder Snow','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_suno_tall_i00',0,1,0,'21151;23139','1;1',0,0),
	(20785,'Agathion Seal Bracelet - Nepal Snow','Snow\'s Haste - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_aga_suno_trumpet_i00',0,1,0,'21149;23135;23136','1;1;1',0,0),
	(20786,'Agathion Seal Bracelet - Round Ball Snow','Snow\'s Acumen - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_aga_suno_ball_i00',0,1,0,'21150;23137;23138','1;1;1',0,0),
	(20787,'Agathion Seal Bracelet - Ladder Snow','Snow\'s Wind Walk - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_aga_suno_tall_i00',0,1,0,'21151;23139;23140','1;1;1',0,0),
	(20789,'Rocket Gun Hat','Continuous Fireworks','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_rocket_cap_i00',0,1,0,'21152','1',0,0),
	(20790,'Yellow Paper Hat','Blessed Body - 7 day limited period','dhair','false','none',NULL,10,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_party_hat_gold_i00',0,1,0,'21153','4',0,0),
	(20791,'Pink Paper Mask Set','Blessed Soul - 7 day limited period','dhair','false','none',NULL,10,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_party_hat_mask_i00',0,1,0,'21154','4',0,0),
	(20792,'Flavorful Cheese Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_bigrat_cap_i00',0,1,0,'0','0',0,0),
	(20793,'Sweet Cheese Hat','','dhair','false','none',NULL,10,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_goldrat_cap_i00',0,1,0,'0','0',0,0),
	(20794,'Flavorful Cheese Hat','Scent of Flavorful Cheese - 7 day limited period','dhair','false','none',NULL,10,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_bigrat_cap_i00',0,1,0,'21155','1',0,0),
	(20795,'Sweet Cheese Hat','Scent of Sweet Cheese - 7 day limited period','dhair','false','none',NULL,10,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_goldrat_cap_i00',0,1,0,'21156','1',0,0),
	(20818,'Agathion Seal Bracelet - Iken','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_local2009_b_i00',0,1,0,'21157;23141','1;1',0,0),
	(20819,'Agathion Seal Bracelet - Iken','Prominent Outsider Adventurer\'s Ability - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_aga_local2009_b_i00',0,1,0,'21157;23141;23153','1;1;1',0,0),
	(20820,'Agathion Seal Bracelet - Lana','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_local2009_a_i00',0,1,0,'21158;23142','1;1',0,0),
	(20821,'Agathion Seal Bracelet - Lana','Prominent Outsider Adventurer\'s Ability - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_aga_local2009_a_i00',0,1,0,'21158;23142;23153','1;1;1',0,0),
	(20822,'Agathion Seal Bracelet - Gnocian','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_local2009_f_i00',0,1,0,'21159;23143','1;1',0,0),
	(20823,'Agathion Seal Bracelet - Gnocian','Prominent Outsider Adventurer\'s Ability - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_aga_local2009_f_i00',0,1,0,'21159;23143;23153','1;1;1',0,0),
	(20824,'Agathion Seal Bracelet - Orodriel','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_local2009_e_i00',0,1,0,'21160;23144','1;1',0,0),
	(20825,'Agathion Seal Bracelet - Orodriel','Prominent Outsider Adventurer\'s Ability - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_aga_local2009_e_i00',0,1,0,'21160;23144;23153','1;1;1',0,0),
	(20826,'Agathion Seal Bracelet - Lakinos','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_local2009_d_i00',0,1,0,'21161;23145','1;1',0,0),
	(20827,'Agathion Seal Bracelet - Lakinos','Prominent Outsider Adventurer\'s Ability - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_aga_local2009_d_i00',0,1,0,'21161;23145;23153','1;1;1',0,0),
	(20828,'Agathion Seal Bracelet - Mortia','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_local2009_c_i00',0,1,0,'21162;23146','1;1',0,0),
	(20829,'Agathion Seal Bracelet - Mortia','Prominent Outsider Adventurer\'s Ability - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_aga_local2009_c_i00',0,1,0,'21162;23146;23153','1;1;1',0,0),
	(20830,'Agathion Seal Bracelet - Hayance','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_local2009_h_i00',0,1,0,'21163;23147','1;1',0,0),
	(20831,'Agathion Seal Bracelet - Hayance','Prominent Outsider Adventurer\'s Ability - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_aga_local2009_h_i00',0,1,0,'21163;23147;23153','1;1;1',0,0),
	(20832,'Agathion Seal Bracelet - Meruril','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_local2009_g_i00',0,1,0,'21164;23148','1;1',0,0),
	(20833,'Agathion Seal Bracelet - Meruril','Prominent Outsider Adventurer\'s Ability - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_aga_local2009_g_i00',0,1,0,'21164;23148;23153','1;1;1',0,0),
	(20834,'Agathion Seal Bracelet - Taman ze Lapatui','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_local2009_i_i00',0,1,0,'21165;23149','1;1',0,0),
	(20835,'Agathion Seal Bracelet - Taman ze Lapatui','Prominent Outsider Adventurer\'s Ability - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_aga_local2009_i_i00',0,1,0,'21165;23149;23153','1;1;1',0,0),
	(20836,'Agathion Seal Bracelet - Kaurin','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_local2009_j_i00',0,1,0,'21166;23150','1;1',0,0),
	(20837,'Agathion Seal Bracelet - Kaurin','Prominent Outsider Adventurer\'s Ability - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_aga_local2009_j_i00',0,1,0,'21166;23150;23153','1;1;1',0,0),
	(20838,'Agathion Seal Bracelet - Ahertbein','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_local2009_l_i00',0,1,0,'21167;23151','1;1',0,0),
	(20839,'Agathion Seal Bracelet - Ahertbein','Prominent Outsider Adventurer\'s Ability - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_aga_local2009_l_i00',0,1,0,'21167;23151;23153','1;1;1',0,0),
	(20840,'Agathion Seal Bracelet - Naonin','','lbracelet','false','none',NULL,150,'none',0,-1,0,0,0,0,0,0,'true','BranchSys.br_aga_local2009_k_i00',0,1,0,'21168;23152','1;1',0,0),
	(20841,'Agathion Seal Bracelet - Naonin','Prominent Outsider Adventurer\'s Ability - 7 day limited period','lbracelet','false','none',NULL,150,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_aga_local2009_k_i00',0,1,0,'21168;23152;23153','1;1;1',0,0),
	(20897,'Purple Paper Mask','Blessed Soul - 7 day limited period','face','false','none',NULL,10,'none',0,10080,0,0,0,0,0,0,'true','BranchSys.br_party_mask_purple_i00',0,1,0,'21154','1',0,0),
	(20900,'Santa Hat','14 day limited period','dhair','false','none',NULL,10,'none',0,20160,0,0,0,0,0,0,'true','BranchSys.br_xmas_gawibawibo_cap_i00',0,1,0,'0','0',0,0);

ALTER TABLE `armor`  ADD COLUMN `flags` INT(10) UNSIGNED NOT NULL DEFAULT '0' AFTER `tradeable`;
UPDATE `armor` SET `flags`='16' WHERE `item_id` IN (13293,13294,13295,13296);